Module xtasm {$v1,1 debugger inline assembler} ;
{$Itdbincl}  
{$j+}
type
  registers = (no_reg,d,x,y,u,s,pc,a,b,ccr,dpr) ;
  
  s_type = (absolute, relative) ;

  oper_group = (err_oper, inherent, extended, immediate, indexed,
                relad, reg_2, reg_list, ext_imm_ind, ext_ind, direct,
                psuedo) ;
              
  string80 = string[80] ;

var
  comment : boolean varib ;
  left_start : integer varib ;
  opcode_out, hex_value : hex varib ;
  addr_mode : oper_group varib ;
  aret_type : s_type varib ;
  after_post : (no_off, off_8, off_16) varib ;
  loc, oldloc : hex varib ;
  oplook : string[8] varib ;
  operation : string[10] varib ;
  leftover, operand, rex_string : string [120] varib ;
  field : string [80] varib ;
  
  reg_value : array [registers] of hex data const
              (0,0,1,2,3,4,5,8,9,$a,$b) ;
  push_pull : array [registers] of hex data const
              (0,6,$10,$20,$40,$40,$80,2,4,1,8) ;
              
  cr1 : comrec external ;
                
function find_op (var operation : string[8] ; var opcode : hex ;
                  var group : oper_group) : boolean ; external ;
                  
function parse_line (var inl, oprat, oprnd : string) : integer ; external ;

procedure get_ack ; external ;

function comma (var str : string[120]) : string ;
  var
    i : integer register ;
  begin
    i := index (str, ',') ;
    if i = 0
      then
        i := 120 ;
    comma := substr (str, 1, i - 1) ;
    str := substr (str, i + 1, 120)
  end ;
  
function issign (ch : char) : boolean ;
  begin
    issign := ch in ['+','-','!','*','/']
  end ;

function get_sign (var str : string) : integer ; entry ;
  var
    i : byte register ;
    ch : char register ;
    instr : boolean register ;
  begin
    get_sign := 0 ;
    instr := false ;
    if str[1] = '*'
      then
        if str[0] > #1
          then
            get_sign := 2
          else
      else
        for i := #1 to str[0] do
          begin
            ch := str[i] ;
            if instr {inside a string literal}
              then
                if ch = ''''
                  then
                    if i <> str[0]
                      then
                        if str[i + #1] = ''''
                          then
                            i := i + #1 {skip character}
                          else
                            instr := false
                      else
                        instr := false
                  else
              else
                if issign (ch)
                  then
                    begin
                      get_sign := ord (i) ;
                      exit
                    end
                  else
                    if ch = ''''
                      then
                        instr := true
          end
  end ;

procedure express (expr : string[60] ; var rex_type: s_type) ;
  var
    j : byte ;
    last_sign, curr_sign : char;
    i : integer; 
    ex_val, r_term : hex ;
    term : string[20] ; 
  begin
    ex_val := $0;
    last_sign := '+';
    rex_string := '' ;
    rex_type := absolute;
    while expr[0] <> 0 do
      begin
        r_term := $0;
        i := get_sign (expr);
        if i = 0
          then
            begin
              curr_sign := ' ';
              term := expr;
              expr[0] := 0
            end
          else
            begin
              term := substr (expr, 1, i-1);
              if term[#0] = #0
                then
                  term := '0' ;
              curr_sign := expr[i] ;
              if curr_sign = '!' { operator prefix }
                then
                  begin
                    i := succ (i) ;
                    case expr[i] of
                      '+' : curr_sign := '!' ;
                      '.' : curr_sign := '&' ;
                      'X' : curr_sign := '^' ;
                      '<', '>' : curr_sign := expr[i]
                    end
                  end ;
              expr := substr (expr, i + 1, 80)
            end;
        if term = '*'
          then 
            begin
              rex_type := relative ;
              r_term := hex(oldloc)
            end
          else { not valid symbol }
            {$c-}
            case term [1] of
              '$' : r_term := hex (substr(term,2,80)) ;
              '''' :
                begin
                  r_term := 0 ;
                  rex_string := '' ;
                  j := 2 ; {skip first character}
                  if j > term[0]
                    then
                      term := ''' ' ; {space}
                  while j <= term[0] do
                    begin
                      if term[j] <> ''''
                        then
                          begin
                            append (rex_string, term[j]) ;
                            r_term := r_term << $8 + hex(term[j])
                          end
                        else
                          if term[j + #1] = '''' {double '}
                            then
                              begin
                                j := j + #1 ; {skip '}
                                append (rex_string, '''') ;
                                r_term := r_term << $8 + $27
                              end
                            else
                              exit ;
                      j := j + 1
                    end
                end ;
              '%' :
                begin
                  r_term := $0 ;
                  for j := #2 to term[#0] do
                    case term[j] of
                      '0' : r_term := r_term << $1 ;
                      '1' : r_term := r_term << $1 + $1
                    end
                end
              else
                r_term := hex(integer(term))
            end; { of case }
            {$c+}
            case last_sign of
              ' ','+' : ex_val := ex_val + r_term ;
              '-' : ex_val := ex_val - r_term ;
              '<' : ex_val := ex_val << r_term ;
              '>' : ex_val := ex_val >> r_term ;
              '&' : ex_val := ex_val and r_term ;
              '!' : ex_val := ex_val or r_term ;
              '^' : ex_val := ex_val eor r_term ;
              '*' : ex_val := ex_val * r_term ;
              '/' : ex_val := ex_val div r_term
            end ;
            last_sign := curr_sign
      end ; { while length }
      hex_value := ex_val
  end ;
  
procedure emit_byte (value : byte) ;
  begin
    cr1.lth := #3 ;
    cr1.com := 'B' ;
    cr1.b_adr := loc ;
    cr1.b_dat[#1] := value ;
    get_ack ;
    loc := loc + $1
  end;
 
procedure emit_word (value : hex) ;
  begin
    emit_byte (chr(value >> $8)) ;
    emit_byte (chr(value))
  end ;
  
procedure comp_rel (var cr_str : string; long : boolean) ;
  var
    null_str : string [1] ;
  begin
    null_str[#0] := #0 ;
    express (cr_str, aret_type);
    if long
      then
        begin
          hex_value := hex_value - hex(loc) - $2 ;
          emit_word (hex_value) ;
        end
      else
        begin
          hex_value := hex_value - succ(hex(loc)) ;
          emit_byte (byte(hex_value))
        end
  end;
 
function find_reg (var ops : string) : registers ; entry ;
  begin
    find_reg := no_reg ;
    if ops[0] = 1
      then
        case upshift(ops[1]) of
          'D' : find_reg := d ;
          'X' : find_reg := x ;
          'Y' : find_reg := y ;
          'U' : find_reg := u ;
          'A' : find_reg := a ;
          'B' : find_reg := b ;
          'S' : find_reg := s
        end
    else if ops[0] = 2
      then
        case upshift(ops) of
          'PC' : find_reg := pc ;
          'CC' : find_reg := ccr ;
          'DP' : find_reg := dpr
        end
  end ;
      
function get_rr (var ops : string) : hex; entry ;
  var
    r : registers ;
  begin
    r := find_reg (ops);
    if r in [x..s]
      then
        get_rr := hex((ord(r) - ord(x)) << 5)
      else
        get_rr := $ffff
  end;
  
procedure addr_set ;
  var
    stemp : string[8] ;
  begin
    stemp := operand [1] ;
    if addr_mode = ext_imm_ind
      then
        if stemp = '#'
          then
            addr_mode := immediate
          else
            addr_mode := ext_ind ;
    if addr_mode = ext_ind
      then
        if (index (operand, ',') <> 0) or (stemp = '[')
          then
            addr_mode := indexed 
          else
            addr_mode := extended ;
    case addr_mode of
      indexed :
        opcode_out := opcode_out or $20 ;
      extended :
        if stemp = '<'
          then
            begin
              addr_mode := direct ;
              operand := substr (operand,2,80) ;
              if opcode_out and $80 = $0
                then
                  opcode_out := opcode_out and $ffbf
                else
                  opcode_out := opcode_out or $10
            end
          else
            opcode_out := opcode_out or $30
    end ; {case}
    if opcode_out > $ff
      then
        emit_word (opcode_out)
      else
        emit_byte (byte(opcode_out))
  end ;
 
procedure direct_addr ; entry ;
  begin
    express (operand, aret_type);
    emit_byte (byte(hex_value))
  end ;

procedure extended_addr ; entry ;
  begin
    express (operand, aret_type);
    emit_word (hex_value)
  end;
 
procedure indexed_addr ; entry ;
  var
    btemp : boolean ;
    indirect, post_byte, rr : hex ;
    strlen : byte ;
    reg : registers ;
    stemp : string[6] ;
 
  procedure accum_offset ;
    begin { accumulator offset from r }
      case reg of
        a : post_byte := $86 ;
        b : post_byte := $85 ;
        d : post_byte := $8b
      end ; { case }
      rr := get_rr (operand) ;
    end ;
 
  procedure constant_index ;
    begin { n,r }
      if ((hex_value < $10) or (hex_value >= $fff0))
             and (indirect = $0)
        then
          post_byte := hex_value and $1f
        else
          if ((hex_value < $80) or (hex_value >= $ff80))
            then
              begin
                post_byte := $88 ;
                after_post := off_8
              end
            else
              begin
                post_byte := $89 ;
                after_post := off_16
              end ;
          rr := get_rr (operand) ;
    end ;

  procedure auto_index ;
    begin
      if index (operand, '+') > 1
        then
          begin
            stemp := operand[1];
            rr := get_rr (stemp);
            operand := substr (operand, 2, 80);
            case operand of
              '+' : post_byte := $80 ;
              '++' : post_byte := $81
            end { of case }
          end
        else
          begin
            if substr (operand,1, 2) = '--'
              then
                begin
                  post_byte := $83 ;
                  operand := substr (operand,3,80)
                end
              else
                begin
                  post_byte := $82 ;
                  operand := substr (operand, 2, 80)
                end ;
            rr := get_rr (operand) ;
          end
    end ; { auto_indexed }

  begin { addr_indexed }
    btemp := substr (operand, 1, 1) <> '<';
    if not btemp
      then
        operand := substr (operand,2,80) ;
    if operand[#0] = #0
      then
        operand := ' ' ;
    strlen := operand[#0] ;
    if (operand[1] = '[') and (operand[strlen] = ']')
      then
        begin
          indirect := $10;
          operand := substr (operand, 2, ord(strlen) - 2);
          strlen := operand[#0]
        end
      else
        indirect := $0 ;
     if index (operand, ',') = 0
       then
         begin { mode = [n] }
           emit_byte ($9f) ;
           express (operand, aret_type) ;
           emit_word (hex_value)
         end
       else
         begin { ',' in operand }
           field := comma (operand) ;
           if upshift(operand) = 'PCR'
             then
               begin
                 emit_byte (byte($8c or hex(btemp) or indirect));
                 comp_rel (field,btemp)
               end
             else
               begin
                 after_post := no_off;
                 express (field, aret_type);
                 if (hex_value <> $0) or (aret_type <> absolute)
                   then
                     begin
                       reg := find_reg (field) ;
                       if reg <> no_reg
                         then
                           accum_offset
                         else
                           constant_index
                     end
                   else 
                     begin { field = '' }
                       rr := get_rr (operand) ;
                       if rr <> $ffff
                         then
                           post_byte := $84
                         else
                           auto_index
                     end ;
                 post_byte := post_byte or indirect or rr;
                 emit_byte (byte(post_byte));
                 case after_post of
                   off_8 : emit_byte (byte(hex_value));
                   off_16 : emit_word (hex_value)
                 end { of case }
               end { of operand <> 'pcr' }
         end { ',' in operand }
  end ; { addr_indexed }
 
procedure immediate_addr ; entry ;
  begin
    operand := substr (operand,2,80) ;
    express (operand, aret_type) ;
    case upshift(operation[length(operation)]) of
      'D','S','U','X','Y' :
        emit_word (hex_value)
      else
        emit_byte (byte(hex_value))
    end { case }
  end ; { addr_immediate }

procedure rel_addr ; entry ;
  begin
    comp_rel (operand, upshift(operation[1]) = 'L')
  end ;
 
procedure reg_2_addr ; entry ;
  var
    r1, r2 : registers ;
    post_byte : hex ;
  begin
    field := comma(operand);
    r1 := find_reg (field);
    r2 := find_reg (operand);
    post_byte := reg_value [r1] * $10 + reg_value [r2] ;
    emit_byte (byte(post_byte))
  end;
 
procedure reg_list_addr ; entry ;
  var
    reg : registers ;
    post_byte : hex ;
  begin
    post_byte := $00;
    while operand[#0] <> #0 do
      begin
        field := comma (operand);
        reg := find_reg (field);
        post_byte := post_byte or push_pull [reg]
      end;
    emit_byte (byte(post_byte))
  end ;
  
{ define constant block }
procedure bsz_psuedo ; entry ;
  var
    h, lnth : hex register ;
  begin
    begin
{ get length of block }
      express (operand, aret_type) ;
      lnth := hex_value ;
      for h := $1 to hex_value do
        emit_byte (0)
    end
  end ;
  
procedure fcb_psuedo ;
  begin
    repeat
      express (comma(operand), aret_type) ;
      emit_byte (byte(hex_value))
    until operand = ''
  end ;
  
procedure fdb_psuedo ; entry ;
  begin
    repeat
      express (comma(operand), aret_type) ;
      emit_word (hex_value)
    until operand = ''
  end ;
  
procedure fcc_psuedo ; entry ;
  var
    fcchar : char ;
    stop : boolean ;
    delim, i, strlen : byte ;
  begin
    operand := concat (operand, leftover) ;
    leftover := '' ;
    strlen := operand[#0] ;
    i := #1 ;
    stop := false ;
    delim := operand [1] ;
    while (i <= strlen) and not stop do
      begin
        fcchar := operand [i] ;
        if not (fcchar in ['0'..'9'])
          then
            begin
              stop := true ;
              if fcchar <> ','
                then
                  begin
                    i := #2 ;
                    while (operand[i] <> delim) and (i <strlen) do
                      begin
                        emit_byte (operand[i]) ;
                        i := succ (i)
                      end ;
                  end
                else
                  begin
                    operand := substr(operand,ord(i+#1),
                          integer(substr(operand,1,ord(i-#1)))) ;
                    for i := #1 to operand[#0] do
                      emit_byte (operand[i])
                  end
            end
          else
            i := succ (i)
      end
  end ;
  
procedure psuedoops ;
  begin
    case opcode_out of
      $1 : fcb_psuedo ;
      $2 : fdb_psuedo ;
      $3 : fcc_psuedo ;
      $4 : bsz_psuedo
    end
  end ;
  
procedure instructions ;
  begin
    if addr_mode = psuedo
      then
        psuedoops
      else
        begin
          addr_set ;
          case addr_mode of
            indexed : indexed_addr ;
            reg_list : reg_list_addr ;
            immediate : immediate_addr ;
            relad : rel_addr ;
            inherent : leftover := concat(' ',operand,leftover) ;
            direct : direct_addr ;
            extended : extended_addr ;
            reg_2 : reg_2_addr
          end
        end
  end ;
  
procedure asm (in_line : string ; var newloc : hex) ; entry ;
  begin
    loc := newloc ;
    oldloc := loc ;
    comment := (in_line[0] > #0) and (in_line[1] = '*') ;
    if not comment
      then
        begin
{ parse line into four fields, plus whatever is left }
          left_start := parse_line (in_line, operation, operand) ;
          leftover := substr (in_line, left_start, 60) ;
          oplook := upshift(operation) ;
          if oplook[0] <> #0
            then
              if find_op (oplook, opcode_out, addr_mode)
                then
                  instructions
        end ; { of not comment line }
    newloc := loc
  end ;
Modend.
