Module xtdis {$v1,3 debugger disassembler} ;
{
  Copyright (C) 1987 by Certified Software Corporation
  616 Camino Caballo Nipomo CA 93444
}
{$I/h/xtdb/tdbincl}
{$j+}
  type
    oper_group = (inherent, extend, imed1, imed2, indexed, srel, lrel,
                  reg_2, reg_list, direct, invalid, fcb) ;
  var
    oldloc, loc : hex varib ;
    dcaddr : hex varib entry ;
    dclth : hex varib entry ;
    opword : hex varib ;
    opcode : string[5] varib ;
    opmode : oper_group varib ;
    operand : string[40] varib ;
    i : integer varib ;
    
    stab : array [0..3] of record
                             name : array [1..4] of char ;
                             offset : hex
                           end data external ;
    cr1, cr2 : comrec external ;

    db_brk, db_ps, db_pe : hex data external ;
    t_ramstart : hex external ;
{
  this is a crude, but easy, way to disassemble. oplook1 takes care of
  all opcodes (except 10 and 11, which are prefixes) between 0 and $ff.
  Those opcodes that have a prefix byte are handled by a different table
}                        
    oplook1 : array [$0 .. $ff] of record
                                     name : string[5] ;
                                     mode : oper_group
                                   end data const
   (('neg', direct),('***', invalid),('***', invalid),        {0,1,2}
    ('com', direct),('lsr', direct),('***', invalid),         {3,4,5}
    ('ror', direct),('asr', direct),('lsl', direct),          {6,7,8}
    ('rol', direct),('dec', direct),('***', invalid),         {9,a,b}
    ('inc', direct),('tst', direct),('jmp', direct),          {c,d,e}
    ('clr', direct),('***', invalid),('***', invalid),        {f,10,11}
    ('nop', inherent),('sync', inherent),('***', invalid),    {12,13,14}
    ('***', invalid),('lbra', lrel),('lbsr', lrel),           {15,16,17}
    ('***', invalid),('daa', inherent),('orcc', imed1),       {18,19,1a}
    ('***', invalid),('andcc', imed1),('sex', inherent),      {1b,1c,1d}
    ('exg', reg_2),('tfr', reg_2),('bra', srel),              {1e,1f,20}
    ('brn', srel),('bhi', srel),('bls', srel),                {21,22,23}
    ('bcc', srel),('bcs', srel),('bne', srel),                {24,25,26}
    ('beq', srel),('bvc', srel),('bvs', srel),                {27,28,29}
    ('bpl', srel),('bmi', srel),('bge', srel),                {2a,2b,2c}
    ('blt', srel),('bgt', srel),('ble', srel),                {2d,2e,2f}
    ('leax', indexed),('leay', indexed),('leas', indexed),    {30,31,32}
    ('leau', indexed),('pshs', reg_list),('puls', reg_list),  {33,34,35}
    ('pshu', reg_list),('pulu', reg_list),('***', invalid),   {36,37,38}
    ('rts', inherent),('abx', inherent),('rti', inherent),    {39,3a,3b}
    ('cwai', imed1),('mul', inherent),('***', invalid),       {3c,3d,3e}
    ('swi', inherent),('nega', inherent),('***', invalid),    {3f,40,41}
    ('***', invalid),('coma', inherent),('lsra', inherent),   {42,43,44}
    ('***', invalid),('rora', inherent),('asra', inherent),   {45,46,47}
    ('lsla', inherent),('rola', inherent),('deca', inherent), {48,49,4a}
    ('***', invalid),('inca', inherent),('tsta', inherent),   {4b,4c,4d}
    ('***', invalid),('clra', inherent),('negb', inherent),   {4e,4f,50}
    ('***', invalid),('***', invalid),('comb', inherent),     {51,52,53}
    ('lsrb', inherent),('***', invalid),('rorb', inherent),   {54,55,56}
    ('asrb', inherent),('lslb', inherent),('rolb', inherent), {57,58,59}
    ('decb', inherent),('***', invalid),('incb', inherent),   {5a,5b,5c}
    ('tstb', inherent),('***', invalid),('clrb', inherent),   {5d,5e,5f}
    ('neg', indexed),('***', invalid),('***', invalid),       {60,61,62}
    ('com', indexed),('lsr', indexed),('***', invalid),       {63,64,65}
    ('ror', indexed),('asr', indexed),('lsl', indexed),       {66,67,68}
    ('rol', indexed),('dec', indexed),('***', invalid),       {69,6a,6b}
    ('inc', indexed),('tst', indexed),('jmp', indexed),       {6c,6d,6e}
    ('clr', indexed),('neg', extend),('***', invalid),        {6f,70,71}
    ('***', invalid),('com', extend),('lsr', extend),         {72,73,74}
    ('***', invalid),('ror', extend),('asr', extend),         {75,76,77}
    ('lsl', extend),('rol', extend),('dec', extend),          {78,79,7a}
    ('***', invalid),('inc', extend),('tst', extend),         {7b,7c,7d}
    ('jmp', extend),('clr', extend),('suba', imed1),          {7e,7f,80}
    ('cmpa', imed1),('sbca', imed1),('subd', imed2),          {81,82,83}
    ('anda', imed1),('bita', imed1),('lda', imed1),           {84,85,86}
    ('***', invalid),('eora', imed1),('adca', imed1),         {87,88,89}
    ('ora', imed1),('adda', imed1),('cmpx', imed2),           {8a,8b,8c}
    ('bsr', srel),('ldx', imed2),('***', invalid),            {8d,8e,8f}
    ('suba', direct),('cmpa', direct),('sbca', direct),       {90,91,92}
    ('subd', direct),('anda', direct),('bita', direct),       {93,94,95}
    ('lda', direct),('sta', direct),('eora', direct),         {96,97,98}
    ('adca', direct),('ora', direct),('adda', direct),        {99,9a,9b}
    ('cmpx', direct),('jsr', direct),('ldx', direct),         {9c,9d,9e}
    ('stx', direct),('suba', indexed),('cmpa', indexed),      {9f,a0,a1}
    ('sbca', indexed),('subd', indexed),('anda', indexed),    {a2,a3,a4}
    ('bita', indexed),('lda', indexed),('sta', indexed),      {a5,a6,a7}
    ('eora', indexed),('adca', indexed),('ora', indexed),     {a8,a9,aa}
    ('adda', indexed),('cmpx', indexed),('jsr', indexed),     {ab,ac,ad}
    ('ldx', indexed),('stx', indexed),('suba', extend),       {ae,af,b0}
    ('cmpa', extend),('sbca', extend),('subd', extend),       {b1,b2,b3}
    ('anda', extend),('bita', extend),('lda', extend),        {b4,b5,b6}
    ('sta', extend),('eora', extend),('adca', extend),        {b7,b8,b9}
    ('ora', extend),('adda', extend),('cmpx', extend),        {ba,bb,bc}
    ('jsr', extend),('ldx', extend),('stx', extend),          {bd,be,bf}
    ('subb', imed1),('cmpb', imed1),('sbcb', imed1),          {c0,c1,c2}
    ('addd', imed2),('andb', imed1),('bitb', imed1),          {c3,c4,c5}
    ('ldb', imed1),('***', invalid),('eorb', imed1),          {c6,c7,c8}
    ('adcb', imed1),('orb', imed1),('addb', imed1),           {c9,ca,cb}
    ('ldd', imed2),('***', invalid),('ldu', imed2),           {cc,cd,ce}
    ('***', invalid),('subb', direct),('cmpb', direct),       {cf,d0,d1}
    ('sbcb', direct),('addd', direct),('andb', direct),       {d2,d3,d4}
    ('bitb', direct),('ldb', direct),('stb', direct),         {d5,d6,d7}
    ('eorb', direct),('adcb', direct),('orb', direct),        {d8,d9,da}
    ('addb', direct),('ldd', direct),('std', direct),         {db,dc,dd}
    ('ldu', direct),('stu', direct),('subb', indexed),        {de,df,e0}
    ('cmpb', indexed),('sbcb', indexed),('addd', indexed),    {e1,e2,e3}
    ('andb', indexed),('bitb', indexed),('ldb', indexed),     {e4,e5,e6}
    ('stb', indexed),('eorb', indexed),('adcb', indexed),     {e7,e8,e9}
    ('orb', indexed),('addb', indexed),('ldd', indexed),      {ea,eb,ec}
    ('std', indexed),('ldu', indexed),('stu', indexed),       {ed,ee,ef}
    ('subb', extend),('cmpb', extend),('sbcb', extend),       {f0,f1,f2}
    ('addd', extend),('andb', extend),('bitb', extend),       {f3,f4,f5}
    ('ldb', extend),('stb', extend),('eorb', extend),         {f6,f7,f8}
    ('adcb', extend),('orb', extend),('addb', extend),        {f9,fa,fb}
    ('ldd', extend),('std', extend),('ldu', extend),          {fc,fd,fe}
    ('stu', extend)) ; {ff}

{
  this second opcode table is used for the opcodes with a 10 prefix
}
    oplook2 : array [1 .. 38] of record
                                   name : string[5] ;
                                   mode : oper_group ;
                                   op : byte
                                 end data const
   (('lbrn', lrel, $21),('lbhi', lrel, $22),('lbls', lrel, $23),
    ('lbcc', lrel, $24),('lbcs', lrel, $25),('lbne', lrel, $26),
    ('lbeq', lrel, $27),('lbvc', lrel, $28),('lbvs', lrel, $29),
    ('lbpl', lrel, $2a),('lbmi', lrel, $2b),('lbge', lrel, $2c),
    ('lblt', lrel, $2d),('lbgt', lrel, $2e),('lble', lrel, $2f),
    ('swi2', inherent, $3f),('cmpd', imed2, $83),('cmpy', imed2, $8c),
    ('ldy', imed2, $8e),('cmpd', direct, $93),('cmpy', direct, $9c),
    ('ldy', direct, $9e),('sty', direct, $9f),('cmpd', indexed, $a3),
    ('cmpy', indexed, $ac),('ldy', indexed, $ae),('sty', indexed, $af),
    ('cmpd', extend, $b3),('cmpy', extend, $bc),('ldy', extend, $be),
    ('sty', extend, $bf),('lds', imed2, $ce),('lds', direct, $de),
    ('sts', direct, $df),('lds', indexed, $ee),('sts', indexed, $ef),
    ('lds', extend, $fe),('sts', extend, $ff)) ;
{
  this third opcode table is used for the opcodes with a 11 prefix
}
    oplook3 : array [1 .. 9] of record
                                   name : string[5] ;
                                   mode : oper_group ;
                                   op : byte
                                 end data const
   (('swi3', inherent, $3f),('cmpu', imed2, $83),('cmps', imed2, $8c),
    ('cmpu', direct, $93),('cmps', direct, $9c),('cmpu', indexed, $a3),
    ('cmps', indexed, $ac),('cmpu', extend, $b3),('cmps', extend, $bc)) ;
    
  procedure response (expect : char) ; external ;
  
  function getbyte : hex ;
    begin
      cr1.lth := #3 ;
      cr1.com := 'D' ;
      cr1.d_adr := loc ;
      cr1.d_cnt := #1 ;
      response ('C') ;
      getbyte := hex(cr2.c_dat[1])
    end ;
    
  function getword : hex ;
    begin
      cr1.lth := #3 ;
      cr1.com := 'D' ;
      cr1.d_adr := loc ;
      cr1.d_cnt := #2 ;
      response ('C') ;
      getword := cr2.c_word
    end ;
    
  function hexout(l : hex) : string[6] ;
    var
      shead : string[2] ;
      s : string[8] ;
    begin
      if l > $9
        then
          shead := '$'
        else
          shead := '' ;
      s := string(l) ;
      while (s[0] > #1) and (s[1] = '0') do
        s := substr(s,2,7) ;
      hexout := concat(shead,s)
    end ;
    
  function shexout(l : hex) : string[6] ;
    begin
      if l >= $8000
        then
          shexout := concat('-',hexout(0 - l))
        else
          shexout := hexout(l)
    end ;
    
  procedure extended ;
    begin
      loc := loc + 1 ;
      operand := hexout (getword) ;
      loc := loc + 1
    end ;
    
  procedure direct_page ;
    begin
      loc := loc + 1 ;
      operand := concat('<',hexout(getbyte))
    end ;
    
  procedure immediate_1 ;
    begin
      loc := loc + 1 ;
      operand := concat('#',hexout(getbyte))
    end ;
    
  procedure immediate_2 ;
    begin
      loc := loc + 1 ;
      operand := concat('#',hexout(getword)) ;
      loc := loc + 1
    end ;
    
  procedure long_relative ;
    type
      runtab = array [0 .. 52] of record
                                    name : hex ;
                                    offset : hex
                                  end ;
    var
      h, offset : hex register ;
      found : boolean register ;
      p2 : ^runtab ;
      j, k : integer register ;
      stemp : string ;
      temp : hex ;
    begin
      loc := loc + 1 ;
      h := getword ;
      offset := h + loc + 2 - t_ramstart ;
      found := false ;
      for j := 0 to 3 do
        begin
          p2 := stab[j].offset + addr(stab[j]) ;
          for k := 0 to 52 do
            begin
              if p2^[k].name = $ffff
                then
                  exit ;
              if p2^[k].offset = offset
                then
                  begin
                    stemp := stab[j].name ;
                    stemp := concat(substr(stemp,2,3),
                             substr(string(p2^[k].name),3,2)) ;
                    operand := stemp ;
                    case stemp of
                      'int29', 'int28' :
                        begin
                          loc := loc + 1 ;
                          dcaddr := loc + 1 ;
                          dclth := $ffff {dynamic length}
                        end ;
                      'opr50' :
                        begin
                          loc := loc + 2 ;
                          dcaddr := loc ;
                          temp := getbyte ;
                          if (temp and 3 = 2) or (temp >> 2 and 3 = 2)
                            then
                              dclth := 3
                            else
                              dclth := 2 ;
                          loc := loc - 1
                        end ;
                      'int10','int37','int32' :
                        begin
                          loc := loc + 1 ;
                          dcaddr := loc + 1 ;
                          dclth := 3
                        end ;
                      'int25','int27','int20','int26','opr25',
                      'opr10','opr43','fnc09','prc11','prc33' :
                        begin
                          loc := loc + 1 ;
                          dcaddr := loc + 1 ;
                          dclth := 1
                        end ;
                      'into2','int30','int31' :
                        begin
                          loc := loc + 1 ;
                          dcaddr := loc + 1 ;
                          dclth := 2
                        end ;
                      'int03','int33' :
                        begin
                          loc := loc + 1 ;
                          dcaddr := loc + 1 ;
                          dclth := 4
                        end ;
                      'int38','int01' :
                        begin
                          loc := loc + 1 ;
                          dcaddr := loc + 1 ;
                          dclth := 6
                        end
                      else
                        loc := loc + 1
                    end ;
                    found := true ;
                    exit (2)
                  end
            end
        end ;
      if not found
        then
          if offset = db_brk
            then
              begin
                loc := loc + 1 ;
                operand := 'pascal statement start' 
              end
          else if offset = db_ps
            then
              begin
                loc := loc + 1 ;
                operand := 'procedure start';
              end
          else if offset = db_pe
            then
              begin
                loc := loc + 1 ;
                operand := 'procedure end'
              end
            else
              begin
                h := h + loc + 2 - oldloc ;
                if h > $7fff
                  then
                    operand := '*'
                  else
                    operand := '*+' ;
                operand := concat(operand,shexout(h),' ',hexout(oldloc + h)) ;
                loc := loc + 1
              end
    end ;
    
  procedure short_relative ;
    var
      h : hex register ;
    begin
      loc := loc + 1 ;
      h := hex(integer(byte(getbyte))) + 2 ;
      if h > $7fff
        then
          operand := '*'
        else
          operand := '*+' ;
      operand := concat(operand,shexout(h),' ',hexout(oldloc + h))
    end ;
    
  procedure two_registers ;
    var
      h : hex register ;
      reg2 : array [$0 .. $b] of string[3] data const
      ('d','x','y','u','s','pc','*','*','a','b','ccr','dpr') ;
    begin
      loc := loc + 1 ;
      h := getbyte ;
      operand := concat(reg2[h >> 4],',',reg2[h and $f])
    end ;
    
  procedure register_list ;
    var
      h, bit : hex register ;
      empty : boolean register ;
      list1 : array [$0 .. $7] of string[3] data const
      ('ccr','a','b','dpr','x','y','*','pc') ;
    begin
      loc := loc + 1 ;
      h := getbyte ;
      empty := true ;
      for bit := 0 to 7 do
        if h and (1 << bit) <> 0
          then
            begin
              if empty
                then
                  empty := false
                else
                  append (operand, ',') ;
              if bit = 6
                then
                  if opword <= $35
                    then
                      append (operand, 'u')
                    else
                      append (operand, 's')
                else
                  append (operand, list1[bit])
            end
    end ;
    
  procedure indexed_addr ;
    var
      h : hex register ;
      reg : string[3] ;
      indirect : boolean register ;
      reg1 : array [$0 .. $3] of char data const
      ('x', 'y', 'u', 's') ;
    begin
      loc := loc + 1 ;
      h := getbyte ;
      reg := reg1[h and $60 >> 5] ;
      if h and $80 = 0
        then
          begin
            h := h and $1f ;
            if h > $f
              then
                h := h or $fff0 ;
            operand := concat(shexout(h),',',reg)
          end
        else
          begin
            indirect := h and $10 <> 0 ;
            case h and $f of
              %0100 : operand := concat('0,',reg) ;
              %1000 :
                begin
                  loc := loc + 1 ;
                  operand := concat(shexout(hex(integer(byte(getbyte)))),',',reg)
                end ;
              %1001 :
                begin
                  loc := loc + 1 ;
                  operand := concat(shexout(getword),',',reg) ;
                  loc := loc + 1
                end ;
              %0100 : operand := concat('a,',reg) ;
              %0101 : operand := concat('b,',reg) ;
              %1011 : operand := concat('d,',reg) ;
              %0000 : operand := concat('0,',reg,'+') ;
              %0001 : operand := concat('0,',reg,'++') ;
              %0010 : operand := concat('0,-',reg) ;
              %0011 : operand := concat('0,--',reg) ;
              %1100 :
                begin
                  loc := loc + 1 ;
                  h := hex(integer(byte(getbyte))) + loc - oldloc + 1 ;
                  if h > $7fff
                    then
                      operand := '*'
                    else
                      operand := '*+' ;
                  operand := concat(operand,shexout(h),',pcr ',hexout(h + oldloc))
                end ;
              %1101 :
                begin
                  loc := loc + 1 ;
                  h := getword + loc - oldloc + 2 ;
                  if h > $7fff
                    then
                      operand := '*'
                    else
                      operand := '*+' ;
                  operand := concat(operand,shexout(h),',pcr ',hexout(h + oldloc)) ;
                  loc := loc + 1
                end ;
              %1111 :
                begin
                  loc := loc + 1 ;
                  operand := hexout(getword) ;
                  loc := loc + 1
                end
            end ;
            if indirect
              then
                operand := concat('[',operand,']')
          end
    end ;
  
  procedure do_fcb ;
    var
      lth : byte ;
      max : byte ;
      i : byte register ;
      stringok : boolean register ;
    begin
      if dclth = $ffff
        then
          begin
            lth := byte(getbyte) ;
            loc := loc + 1
          end 
        else
          lth := byte(dclth) ;
      cr1.lth := 3 ;
      cr1.com := 'D' ;
      cr1.d_adr := loc ;
      if lth <= #30
        then
          max := lth
        else
          max := #30 ;
      cr1.d_cnt := max ;
      response ('C') ;
      loc := loc + hex(lth) - 1 ;
      stringok := false ;
      if dclth = $ffff
        then
          begin
            stringok := true ;
            for i := #1 to max do
              if (cr2.c_dat[i] < ' ') or (cr2.c_dat[i] > '~')
                then
                  begin
                    stringok := false ;
                    exit
                  end ;
            if stringok
              then
                begin
                  operand := concat('$',string(ord(lth)),',''') ;
                  for i := 1 to max do
                    append (operand, cr2.c_dat[i]) ;
                  append (operand,'''')
                end
              else
                operand := concat('$',substr(string(hex(lth)),3,2))
          end
        else
          operand := '' ;
      if not stringok
        then
          begin
            for i := #1 to max do
              if operand[0] > 30
                then
                  exit
                else
                  begin
                    if operand <> ''
                      then
                        append (operand, ',') ;
                    operand := concat(operand,'$',substr(string(hex(cr2.c_dat[i])),3,2))
                  end
          end
    end ;
      
      
  function dis (var dloc : hex ; off : hex) : string ; entry ;
    var
      distemp : string ;
      i : byte register ;
      j : integer register ;
    begin
      loc := dloc ;
      oldloc := loc ;
      operand := '' ; {null fields}
      opword := getbyte ;
      opmode := invalid ;
      opcode := '***' ;
      if opword = $10
        then
          begin
            loc := loc + 1 ;
            opword := opword << 8 + getbyte ;
            for j := 1 to 38 do
              if byte(opword) = oplook2[j].op
                then
                  begin
                    opcode := oplook2[j].name ;
                    opmode := oplook2[j].mode ;
                    exit
                  end
          end
      else if opword = $11
        then
          begin
            loc := loc + 1 ;
            opword := opword << 8 + hex(getbyte) ;
            for j := 1 to 9 do
              if byte(opword) = oplook3[j].op
                then
                  begin
                    opcode := oplook3[j].name ;
                    opmode := oplook3[j].mode ;
                    exit
                  end
          end
        else
          begin
            opcode := oplook1[opword].name ;
            opmode := oplook1[opword].mode
          end ;
      if loc = dcaddr
        then
          begin
            opcode := 'fcb' ;
            opmode := fcb
          end ;
      case opmode of
        invalid, inherent : ;
        extend : extended ;
        imed1 : immediate_1 ;
        imed2 : immediate_2 ;
        indexed : indexed_addr ;
        srel : short_relative ;
        lrel : long_relative ;
        reg_2 : two_registers ;
        reg_list : register_list ;
        direct : direct_page ;
        fcb : do_fcb
      end ;
      distemp := concat(string(dloc),' ',string(hex(dloc-off)),' ') ;
      cr1.lth := #5 ;
      cr1.com := 'D' ;
      cr1.d_adr := dloc ;
      cr1.d_cnt := byte(loc + $1 - dloc) ;
      if cr1.d_cnt > #6
        then
          cr1.d_cnt := #6 ;
      response ('C') ;
      for i := #1 to cr1.d_cnt do
        if distemp[0] > 26
          then
            exit
          else
            distemp := concat(distemp,substr(string(hex(cr2.c_dat[i])),3,2)) ;
      distemp := substr(distemp, 1, 26) ;
      while distemp[0] < 28 do
        append(distemp,' ') ;
      append(distemp,opcode) ;
      while distemp[0] < 36 do
        append(distemp,' ') ;
      dis := concat(distemp, operand) ;
      dloc := loc + 1
    end ;
        
Modend.
