Program xlc {$v3,2 xlc} (input, output) ;
{
  6/6/89 : initial conversion to level 3
  6/7/89 : use straight load for vector file, put xrefs for vector
  file at end of list (easier for xps to modify)
}
  const
    dbopt = entry string[20] '' ;
    tdbopt = entry string[20] '' ;
    seopt = entry string[20] '' ;
    llopt = entry string[20] '' ;
    mapopt = entry string[20] 's' ;
    pcopts = entry array [1..10] of string[20] 
      ('-r', '-d', '-i', '-lp62ftw96 /p', '-rlp62ftw96 /p',
       '-dlp62ftw96 /p', '', '', '', '') ;
    raopts = entry array [1..10] of string[20] 
      ('-o', '-lp62ftw96 /p', '-olp62ftw96 /p', '', '',
       '', '', '', '', '') ;
  Type 
    File_type = (Comp_Output,Pre_after_assembly,vect_source,vect_after,
                 Final_Output,Pre_source,shell_file) ;
  const
    Suf = local array [File_type] of string [2] 
          ('r', 'pa', 'vs', 'va', '', 'ps', 'sf') ;
  var
    Auto, Kill, sizing : boolean ;
    upshell, upstack : boolean ;
    pc_opts, ra_opts : integer ;
    Start_loc, stack_high, heap_start, param, minimum, desired : hex ;
    stack_size, maxmem, padding, globaddr : hex ;
    sys_size : hex ;
    Pasc_name, File_name, Com_field : string [30] ;
    In_line : string ;
    Map_opt : string [10] ;
    iolib, libdir : string[30] ;
    vectnames : array [1 .. 8] of string[8] ;
    p_file, C_file, v_file : File of text ;
    def_db, def_tdb, def_ll, def_se : string ;
    def_pc, def_ra : array [1..10] of string[30] ;
 
  procedure parse (var cml, token : string) ; entry ;
  {
    This procedure will return a valid modifier in 'token' extracted
    from 'cml'. Leading and trailing delimiters (Space or Comma
    characters) are ignored and removed from 'cml'.
  }
    var
      phase : (delim1,xfer,delim2,term) ;
      toke : char ;
      delim : boolean ;
    begin
      token := '' ;
      phase := delim1 ;
      while (cml[0] > 0) and (phase <> term) do
        begin
          toke := cml [1] ;
          cml := substr (cml,2,250) ;
          delim := toke in [' ',','] ;
          case phase of
            delim1 :
              if not delim
                then
                  begin
                    phase := xfer ;
                    token := toke
                  end ;
            xfer :
              if delim
                then
                  phase := delim2
                else
                  token := concat (token, toke) ;
            delim2 :
              if not delim
                then
                  begin
                    phase := term ;
                    cml := concat (toke, cml)
                  end
          end
        end
    end ;
    
  Procedure Initialize ;
    var
      i : integer ;
    Begin
      Kill := false ;
      file_name := '' ;
      upshell := true ;
      upstack := true ;
      vectnames[1] := 'start' ;
      vectnames[8] := 'start' ;
      Writeln ('OmegaSoft 6809 Cross Linkage Creator Version 3.00') ;
      Writeln ('Copyright 1987-1990 by Certified Software Corporation')
    End ; { Initialize } 
                                              
  Function Read_hex : hex ;
    Begin
      Repeat
        {$C- turn off so we can use conversion}
        Readln (Read_hex) ;
        If Conversion
          then
            Write ('Incorrect entry - enter again : ') ;
      Until not Conversion
    End ; { Read_hex }
 
  Function Adjust (Sufi : File_type) : string ;
    Begin
      Adjust := Concat (File_name,'.',Suf[Sufi])
    End ; { Adjust }
 
  procedure write_startup ;
    begin { write_startup }
      writeln (p_file,'.start idnt 3,0') ;
      writeln (p_file,' xdef start,global') ;
      writeln (p_file,' xref .main,varibend') ;
      writeln (p_file,'global equ $',globaddr:4) ;
      writeln (p_file,'start lds #$',stack_high:4,' set system stack') ;
      writeln (p_file,' leau -$',sys_size-$a:4,'-varibend,s set data stack') ;
      writeln (p_file,' leay 10,u set global stack mark') ;
      writeln (p_file,' sty global') ;
      writeln (p_file,' leax varibend,y') ;
      writeln (p_file,' stx -4,y set system stack limit') ;
      writeln (p_file,' sty -6,y set global mark pointer') ;
      writeln (p_file,' clr -7,y disable errors') ;
      writeln (p_file,' stu 0,y set heap limit') ;
      writeln (p_file,' ldx #$',heap_start:4) ;
      writeln (p_file,' stx 2,y set heap start') ;
      writeln (p_file,' clr 4,y no conversion error yet') ;
      writeln (p_file,' lbsr .main') ;
      writeln (p_file,' bra start') ;
      writeln (p_file,' end start')
    end ; { write_startup }
 
  procedure write_auto_start ;
    begin
      writeln (p_file,'.start idnt 3,0') ;
      writeln (p_file,' xdef start') ;
      writeln (p_file,' xref .main,finish,varibend,negm$sz') ;
      writeln (p_file,'hdr fdb $87cd') ;
      writeln (p_file,' fdb finish-hdr') ;
      writeln (p_file,' fdb ofmod-hdr') ;
      writeln (p_file,' fcb $11,$80,0') ;
      writeln (p_file,' fdb start-hdr') ;
      if stack_size = 0
        then
          writeln (p_file,'min fdb varibend-negm$sz')
        else
          writeln (p_file,'min fdb $',stack_size:4) ;
      if length (pasc_name) > 1
        then
          writeln (p_file,'ofmod fcc /',substr(pasc_name,1,
                                          length(pasc_name)-1),'/') ;
      writeln (p_file,' fcb $',hex(pasc_name[length
               (pasc_name)]) << $8 + $8000:2) ;
      if sizing
        then
          begin
            writeln (p_file,'start stx <0 save command line start') ;
            writeln (p_file,' ldd #0') ;
            writeln (p_file,' swi2') ;
            writeln (p_file,' fcb 7 get current size') ;
            writeln (p_file,' pshs y,d save current top and size') ;
            writeln (p_file,'getmem std 0,s update maximum good size');
            writeln (p_file,' addd #512 try for more') ;
            writeln (p_file,' swi2') ;
            writeln (p_file,' fcb 7') ;
            if maxmem <> $0
              then
                begin
                  writeln (p_file,' bcs get1 ran out of memory') ;
                  writeln (p_file,' cmpd #$',maxmem:4) ;
                  writeln (p_file,' blo getmem haven''t hit max yet') ;
                  writeln (p_file,'get1 ldd 0,s get maximum size')
                end
              else
                begin
                  writeln (p_file,' bcc getmem') ;
                  writeln (p_file,' ldd 0,s get maximum size')
                end ;
            writeln (p_file,' cmpd <hdr+11,pcr see if improved') ;
            writeln (p_file,' bls get3 nope') ;
            writeln (p_file,' subd #$',padding:4) ;
            writeln (p_file,' swi2') ;
            writeln (p_file,' fcb 7 give back some room') ;
            writeln (p_file,' leax 0,y') ;
            writeln (p_file,' puls y,d get new top in x, old in y') ;
            writeln (p_file,'get2 lda 0,-y') ;
            writeln (p_file,' sta 0,-x move command line up') ;
            writeln (p_file,' cmpy <0') ;
            writeln (p_file,' bhi get2') ;
            writeln (p_file,' leas 0,x system stack at top') ;
            writeln (p_file,'get3 leau 1,u skip first location')
          end
        else
          writeln (p_file,'start leau 1,u skip first location') ;
      writeln (p_file,' tfr u,d save low memory value') ;
      writeln (p_file,' leau -$',sys_size+$a:4,'-varibend,s set data stack') ;
      writeln (p_file,' leay 10,u global stack mark') ;
      writeln (p_file,' stx 6,y start of parameter area') ;
      writeln (p_file,' std 2,y set heap start') ;
      writeln (p_file,' leax varibend,y') ;
      writeln (p_file,' stx -4,y set system stack limit') ;
      writeln (p_file,' sty -6,y set global mark pointer') ;
      writeln (p_file,' clr -7,y disable errors') ;
      writeln (p_file,' stu 0,y set heap limit') ;
      writeln (p_file,' clr 4,y no conversion error yet') ;
      writeln (p_file,' lbsr .main') ;
      writeln (p_file,' clrb') ;
      writeln (p_file,' swi2') ;
      writeln (p_file,' fcb 6') ;
      writeln (p_file,' end')
    end ; { write_auto_start }
    
  Procedure Write_shell ;
    var
      excnt : integer ;
    Begin
      writeln (c_file,'*mn:', pasc_name) ;
      writeln (c_file,'*cl:xtdb ',def_tdb) ;
      writeln (c_file,'*cl:xll ',def_ll) ;
      for excnt := 1 to pc_opts do
        writeln (c_file,'*cl:xpc ',def_pc[excnt]) ;
      for excnt := 1 to ra_opts do
        writeln (c_file,'*cl:xra ',def_ra[excnt]) ;
      writeln (c_file,'*cl:se ',def_se) ;
      if auto
        then
          writeln (c_file,'*ll:dos')
        else
          begin
            writeln (c_file,'*ll:start ',start_loc:4) ;
            writeln (c_file,'*ll:vect')
          end ;
      writeln (c_file,'*ll:v.start 10') ;
      Writeln (C_file,'*ll:load ',Adjust(Pre_after_assembly)) ;
      writeln (c_file,'*ll:loadp ',file_name) ;
      writeln (c_file,'*ll:lib ',libdir,'xrl ',iolib) ;
      if not auto
        then
          begin
            writeln (c_file,'*ll:align ',$fff0-start_loc:4) ;
            writeln (c_file,'*ll:load ',adjust(vect_after))
          end ;
      Writeln (C_file,'*ll:object ',file_name) ;
      Writeln (C_file,'*ll:map',Map_opt) ;
      Writeln (C_file,'*ll:exit') ;
      writeln (c_file,'*db:i ',file_name) ;
      writeln (c_file, '*db:t') ;
      writeln (c_file, '*db:l')
    End ; { Write_chain }
  
  procedure write_vectors ;
    var
      i : integer register ;
    begin
      writeln (v_file,'vects idnt 3,0 interrupt vectors') ;
      for i := 1 to 8 do
        writeln (v_file,' fdb ',vectnames[i]) ;
      write (v_file,' xref start') ;
      for i := 1 to 7 do
        if upshift(vectnames[i]) <> 'START'
          then
            write (v_file,',',vectnames[i]) ;
      writeln (v_file) ;
      writeln (v_file, ' end')
    end ;
      
  Procedure Get_file_name ;
    Begin
      if file_name = ''
        then
          begin
            Write ('Pascal compiler output file name : ') ;
            Readln (File_name) ;
          end ;
      pasc_name := file_name
    End ; { Get_file_name }
 
  Procedure Open_files ;
    Begin
      if upshell
        then
          Rewrite (C_file,Adjust(shell_file)) ;
      if upstack
        then
          begin
            Rewrite (p_file,Adjust(Pre_source)) ;
            rewrite (v_file,Adjust(vect_source)) ;
          end
    End ; { Open_files }
    
  procedure set_stacks ;
    var
      i : integer register ;
    const
      vecttype = local array [2 .. 7] of string[4] 
                 ('SWI3','SWI2','FIRQ','IRQ','SWI','NMI') ;
    begin
      repeat
        write ('Ram start (heap start) : ') ;
        heap_start := read_hex ;
        write ('Ram end (stack upper limit) : ') ;
        stack_high := read_hex ;
        if stack_high <= heap_start
          then
            writeln ('Stack upper limit must exceed heap start')
      until stack_high > heap_start ;
      write ('System stack size : ') ;
      sys_size := read_hex ;
      write ('Parameter list address (enter 0 if none) : ') ;
      param := read_hex ;
      write ('Global stack mark save address : ') ;
      globaddr := read_hex ;
      for i := 2 to 7 do
        begin
          write (vecttype[i],' vector handler : ') ;
          readln (vectnames[i]) ;
          if vectnames[i] = ''
            then
              vectnames[i] := 'start'
        end
    end ;
    
  procedure set_stack_size ;
    begin
      write ('Auto memory sizing ? ') ;
      readln (sizing) ;
      writeln ('Enter zero to use compiler generated default') ;
      if sizing
        then
          write ('Minimum Stack, Heap, and Varib size : ')
        else
          write ('Stack, heap, and Varib size : ') ;
      stack_size := read_hex ;
      if sizing
        then
          begin
            write ('Maximum memory to use : ') ;
            maxmem := read_hex ;
            write ('Amount to give back : ') ;
            padding := read_hex
          end ;
      write ('System stack size : ') ;
      sys_size := read_hex
    end ;

  procedure default_comlines ;
    var
      i : integer register ;
    begin
      def_ll := llopt ;
      i := index(def_ll, '*') ;
      if i <> 0
        then
          def_ll := concat(substr(def_ll, 1, i - 1),file_name,
                           substr(def_ll, i + 1, 80)) ;
      map_opt := mapopt ;
      def_db := dbopt ;
      def_tdb := tdbopt ;
      def_se := seopt ;
      pc_opts := 0 ;
      for i := 1 to 10 do
        if pcopts[i] <> ''
          then
            begin
              def_pc[i] := pcopts[i] ;
              pc_opts := i
            end
          else
            exit ;
      ra_opts := 0 ;
      for i := 1 to 10 do
        if raopts[i] <> ''
          then
            begin
              def_ra[i] := raopts[i] ;
              ra_opts := i
            end 
          else
            exit
    end ;
 
  Procedure Load_info ;
    var
      x : integer ;
      b : boolean ;
    Begin
      if not auto
        then
          begin
            Write ('Starting load location : ') ;
            Start_loc := Read_hex
          end ;
      write ('Library directory name : ') ;
      readln (libdir) ;
      if (libdir[0] > 1) and (libdir[libdir[0]] <> '/')
        then
          libdir := concat (libdir,'/') ;
      iolib := concat(libdir, 'xos9io') ;
      if not auto
        then
          begin
            write ('Use default I/O library (',iolib,') ? ') ;
            readln (b) ;
            if not b
              then
                begin
                  write ('I/O library to use : ') ;
                  readln (iolib)
                end
          end ;
      default_comlines
    End ; { Load_info }
 
  Procedure Close_files ;
    Begin
      Close (p_file) ;
      Close (C_file) ;
      close (v_file) ;
    End ; { Close_files }
 
{$I/dd/defs/os9traps}

  procedure assemble_ps (opt : string) ;
    var
      type_id, err, cerr, dead_id : integer ;
      param : string ;
      shell : boolean ;
      i : integer register ;
      modname : string[32] ;
    begin
      param := concat('xra -o ', opt) ;
      type_id := 0 ;
      shell := false ;
      modname := 'shell' ;
      for i := 101 to 127 do
        if cline(i) = ''
          then
            exit
        else if substr(cline(i),1,6) = 'SHELL='
          then
            begin
              modname := substr(cline(i),7,32) ;
              exit
            end ;
      err := os9exec (param, cline(100), modname, 0, 3, 0, type_id) ;
      if err <> 0
        then
          begin
            f_perr (err, 0) ;
            shell := true
          end
        else
          begin
            repeat
              err := f_wait (cerr, dead_id)
            until type_id = dead_id ;
            if err <> 0
              then
                begin
                  f_perr (err, 0) ;
                  shell := true
                end
            else if cerr <> 0
              then
                begin
                  f_perr (cerr, 0) ;
                  shell := true
                end
          end ;
      if shell
        then
          begin
            writeln ('Assembly failed') ;
            halt (22)
          end
        else
          writeln ('Code assembled')
    end ;
    
  Procedure Kill_files ;
    Var
      Count : File_type ;
    Begin
      {$i- in case file isn't there}
      For Count := Comp_output to shell_file do
        if count <> final_output
          then
            Del (C_file,Adjust(Count))
    End ;
    
  Procedure Comopt ;
    Begin
      writeln ('Command line error, format is :') ;
      writeln ('xlc [-opt] [file name]') ;
      writeln ('Valid options are :') ;
      writeln ('D       - delete files') ;
      writeln ('F       - update only front end (.ps) and file') ;
      writeln ('S       - update only shell (.sf) file') ;
      halt (255)
    End ;
  
  Procedure Setup ;
    var
      i, temp2 : byte ;
      offset : byte ;
      copt : string[120] ;
      sname : string ;
    begin
      repeat
        offset := 2 ;
        copt := cline(1) ;
        if copt[0] = 0
          then
            exit ;
        if copt[1] = '-'
          then
            begin
              i := 2 ;
              while i <= copt[0] do
                begin
                  case upshift(copt[i]) of
                    'D' : kill := true ;
                    'F' : upshell := false ;
                    'S' : upstack := false
                    else
                      comopt
                  end ;
                  i := i + 1
                end
            end
          else
            offset := 1
      until true ;
      file_name := cline(offset)
    end ;

  Begin { Link }
    {$I+,C+}
    Initialize ;
    Setup ;
    Get_file_name ;
    If Kill
      then
        Kill_files
      else
        begin
          Open_files ;
          write ('Program to run on OS9/6809 (Y/N) ? ') ;
          readln (auto) ;
          if upstack
            then
              if auto
                then
                  begin
                    set_stack_size ;
                    write_auto_start
                  end
                else
                  begin
                    set_stacks ;
                    Write_startup ;
                    write_vectors
                  end ;
          if upshell
            then
              begin
                load_info ;
                Write_shell
              end ;
          Close_files  ;
          if upstack
            then
              begin
                assemble_ps (concat(adjust(pre_source),' ',adjust(pre_after_assembly))) ;
                if not auto
                  then
                    assemble_ps (concat(adjust(vect_source),' ',adjust(vect_after))) ;
              end
        end
  End . { Link }
