{$l-}
  type
    tcb = record
            id          : byte ;
            timeslice   : byte ;
            status      : byte ;
            priority    : #1 .. #255 ;
            prior_count : byte ;
            stack_ptr   : hex ;
            task_bos    : hex ;
            task_tos    : hex ;
            task_bou    : hex ;
            task_tou    : hex ;
            next_event  : ^tcb ;
            prev_event  : ^tcb ;
            count       : ^byte ;
            timeout     : 0 .. maxint ;
            next_time   : ^tcb ;
            prev_time   : ^tcb ;
            msg_id      : byte ;
            msg_ret_id  : byte ;
            message     : hex 
          end ;

  function self : byte ; external ;
  procedure swap ; external ;
  procedure schedule (enable : boolean) ; external ;
  procedure taskinit (task1_priority : byte ; task1_timeslice : byte ;
                      tcbtables : hex ; num_tasks : byte) ; external ;
  procedure taskterm ; external ;
  procedure cause (var event : ^tcb ; swap_it : boolean) ; external ;
  function wait (var event : ^tcb ; var count : byte ;
                 timeout : integer) : boolean ; external ;
  procedure block (task_id : byte) ; external ;
  procedure unblock (task_id : byte) ; external ;
  procedure timeslice (task_id : byte ; new_timeslice : byte) ; external ;
  procedure priority (task_id  : byte ; new_priority : byte) ; external ;
  procedure status (task_id : byte ; var ready : boolean ;
                    var cur_priority : byte ; var cur_timeslice : byte) ; external ;
  function tas (var region : boolean) : boolean ; external ;
  procedure clear (var region : boolean) ; external ;
  procedure delay (timeout : integer) ; external ;
  procedure msg_send (message : hex ; id : byte) ; external ;
  procedure msg_read (var message : hex ; var id : byte) ; external ;
  function msg_wait (timeout : integer) : boolean ; external ;
  function msg_asend (message : hex ; id : byte ;
                      timeout : integer) : boolean ; external ;
  procedure kill (id : byte) ; external ;
  procedure stackleft (id : byte ; var sysleft, dataleft : hex) ; external ;
{$l+}
