 nolist
*
global equ $0 start of global section
*
* this is the normal start of the base page multi-tasking
* global variables. If there is a change needed, then you
* must also re-assemble file sp13.a since it needs to know
* the location of the tcb tables. Global must be between
* 0 and $f0, if there is some reason not to have base page
* then that is accomplished by changing the stack setup (.ps)
* file to move the new page into the dp register (global
* only signifies the lower 8 bits of address).
*
check equ 1 checking on
single equ 1 single timer
*
*  equates for the task control block (tcb)
*
 abs 0
*
id rmb 1 task id number
timslc rmb 1 task's time slice in ticks
stat rmb 1 status of task
prior rmb 1 priority of task (1- highest)
pricnt rmb 1 priority counter (#0..prior)
stkptr rmb 2 location to save the stack pointer
tbos rmb 2 bottom of system stack for this task
ttos rmb 2 top of system stack for this task
tbou rmb 2 bottom of user stack for this task
ttou rmb 2 top of user stack for this task
nxtevt rmb 2 pointer to provide an event chain
preevt rmb 2 pointer to previous link in chain
count rmb 2 pointer to counter byte
timout rmb 2 timeout in ticks for the await
nxttim rmb 2 pointer next tcb in timer chain
pretim rmb 2 pointer previous link in timer chain
msgid rmb 1 id of task that send message
msgrid rmb 1 id of task that wants acknowledgement of message rec.
msg rmb 2 message
tcblen rmb 1 length of the task control block in bytes
*
* the following are equates for status bits
*
tactiv equ $80 active - ready to run
twait equ $40 waiting for event
tblock equ $20 blocked
tdelay equ $10 delay active
firawt equ $8 first in event chain
firtim equ $4 first in timeout chain
trec equ $2 waiting for message
tack equ $1 waiting for message rec. ack
*
* error message codes for tasking
*
 abs 30
*
tcberr rmb 1 id does not have a valid tcb
invpri rmb 1 invalid priority number
notask rmb 1 invalid call to primitive
initer rmb 1 must have at least one task
nocnt rmb 1 zero await count
srnger rmb 1 task system stack range error
urnger rmb 1 task user stack range error
*
* register equates for stack offsets from interupt
*
 abs 0
*
ccreg rmb 1 condition code register
areg rmb 1 a register
breg rmb 1 b register
dpreg rmb 1 direct page register
xreg rmb 2 x register
yreg rmb 2 y register
ureg rmb 2 u register
pcreg rmb 2 program counter register
*
* base page global variables
*
 abs global
*
curtcb rmb 2 address of current tcb
tcbtab rmb 2 address of start of tcbtable
tcbend rmb 2 address of end of tcbtable
timchn rmb 2 first tcb in timeout chain
schflg rmb 1 if true, scheduling is enabled
lstpri rmb 1 in scheduler flag
*
 ifne single
slice rmb 1 timeslice register
delays rmb 2 wait and timeout register
 endc
*
globen rmb 1 to get address
*
globsz equ globen-global
*
 code
*
 list
