module access {$v3,0 access variables} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  function labout (h : hex) : string [4] ; external ;
  
  procedure emitoffset (op : code_type ; reg : byte ; value : hex) ;
    begin
      opcode (op) ;
      post1 (p_idx + p_ixfx + reg) ;
      codet_word (value) ;
      {ldx offset,xx or leax offset,xx}
    end ;
    
  procedure push_pointer (p : ^symhead) ; entry ;
    var
      store : storage_type register ;
      real_lex : byte register ;
      p2 : ^token_type register ;
      temp : hex register ;
      p3 : ^longhex ;
      p4 : ^proc_head ;
      temp_lex : byte ;
      instruct : code_type ;
      reg : byte ;
  
    procedure push_lea ;
      begin
        if indirect
          then
            emitoffset (c_ldx, p_ixrx, 0 - record_offset)
          else
            if record_offset <> 0
              then
                begin
                  opcode (c_leax) ;
                  post1 (p_idx + p_ixrx + p_ixfx) ;
                  codet_word (0 - record_offset) ;
                  {leax offset,x}
                end ;
        indirect := false ;
      end ;
      
    function getoff : hex ;
      begin
        if record_flag
          then
            getoff := record_offset
          else
            getoff := p^.offset
      end ;
      
    begin
      if array_lea or with_lea
        then
          if with_lea and not array_lea
            then
              if (record_offset = 0) and indirect
                then
                  emitoffset (c_ldx, p_ixry + p_idxi, 0 - with_offset)
                else
                  begin
                    emitoffset (c_ldx, p_ixry, 0 - with_offset) ;
                    push_lea
                  end
            else
              push_lea
        else
          begin
            if record_flag
              then
                begin
                  real_lex := record_head^.lexlev ;
                  store := record_head^.storage ;
                  if store <> s_stack
                    then
                      record_offset := 0 - record_offset
                end
              else
                begin
                  real_lex := p^.lexlev ;
                  store := p^.storage
                end ;
            case store of
              s_stack :
                begin
                  if (real_lex <> lex) and (real_lex <> 1)
                    then
                      if lex - real_lex > 3
                        then
                          begin
                            opcode (c_lda) ;
                            post2t (p_imm, lex - real_lex) ;
                            {lda #lexdif}
                            hand (int, $23)
                          end
                        else
                          begin
                            opcode (c_ldx) ;
                            post1 (p_idx + p_ixry + p_ixfx) ;
                            codet_word (-2) ; {ldx -2,y}
                            temp_lex := succ (real_lex) ;
                            while temp_lex <> lex do
                              begin
                                opcode (c_ldx) ;
                                post1 (p_idx + p_ixrx + p_ixfx) ;
                                codet_word (-2) ; {ldx -2,x}
                                temp_lex := succ (temp_lex)
                              end ;
                          end ;
                  if (real_lex <> lex) and (real_lex = 1)
                    then
                      eminln (128) ;
                  p2 := p + align(sizeof(symhead)) ;
                  instruct := c_leax ;
                  if p2^ in [valuepar .. funcret]
                    then
                      begin {parameter}
                        p3 := (p2 + 2) and $fffffffe ;
                        p4 := p3^ + align(sizeof(symhead)) ;
                        {address of proc header}
                        if p2^ = funcret
                          then
                            if real_lex = lex
                              then
                                begin
                                  opcode (c_leax) ;
                                  post1t (p_idx + p_ixry + p_ixz)
                                  {leax 0,y}
                                end ;
                        if p2^ = varibpar
                          then
                            instruct := c_ldx
                          else
                            if indirect
                              then
                                begin
                                  instruct := c_ldx ;
                                  indirect := false
                                end ;
                        temp := p4^.param_size - getoff
                      end
                    else
                      begin
                        temp := 0 - getoff ;
                        if indirect
                          then
                            instruct := c_ldx ;
                        indirect := false
                      end ;
                  if p2^ <> funcret
                    then
                      begin
                        if real_lex = lex
                          then
                            reg := p_ixry
                          else
                            reg := p_ixrx ;
                        if indirect
                          then
                            reg := reg + p_idxi ;
                        indirect := false ;
                        emitoffset (instruct, reg, temp)
                      end
                end ;
              s_absolute :
                begin
                  opcode (c_ldx) ;
                  if indirect
                    then
                      post1 (p_abs)
                    else
                      post1 (p_imm) ;
                  codet_word (p^.offset) ;
                  {ldx #addr or ldx $addr}
                  indirect := false
                end ;
              s_direct :
                begin
                  if indirect
                    then
                      begin
                        opcode (c_ldx) ;
                        post1 (p_abs + p_dir) ;
                        codet_word (p^.offset) ;
                        indirect := false
                        {ldx <addr}
                      end
                    else
                      begin
                        hand (int, $26) ;
                        datat_byte (byte(p^.offset))
                      end
                end ;
              s_external, s_pcr, s_data, s_data_ext, s_varib,
              s_varib_ext :
                begin
                  if indirect
                    then
                      instruct := c_ldx
                    else
                      instruct := c_leax ;
                  case p^.storage of
                    s_pcr, s_data, s_data_ext : 
                      begin
                        opcode (instruct) ;
                        post1 (p_ixrp + p_ixex + p_idx)
                      end
                    else
                      begin
                        if lex <> 1
                          then
                            begin
                              eminln (128) ; {ldx -6,y}
                              opcode (instruct) ;
                              post1 (p_idx + p_ixex + p_ixrx)
                            end
                          else
                            begin
                              opcode (instruct) ;
                              post1 (p_idx + p_ixex + p_ixry)
                            end
                      end
                  end ;
                  if record_flag
                    then
                      begin
                        if ((store = s_data) or (store = s_varib))
                            and (record_head^.intname <> 0)
                          then
                            labt (concat('..',labout(record_head^.
                                   intname)))
                          else
                            labt (record_head^.nameptr^) ;
                        {ldx or leax ext,xx}
                        if record_offset <> 0
                          then
                            begin
                              opcode (c_leax) ;
                              post1 (p_idx + p_ixrx + p_ixfx) ;
                              codet_word (record_offset) ;
                              {leax offset,x}
                            end
                      end
                    else
                      begin
                        if ((store = s_data) or (store = s_varib))
                           and (p^.intname <> 0)
                          then
                            labt (concat('..',labout(p^.intname)))
                          else
                            labt (p^.nameptr^) ;
                        {ldx or leax ext,x}
                      end
                end ;
              s_stddev :
                begin
                  if lex <> 1
                    then
                      eminln (128) ;
                  opcode (c_ldx) ;
                  if lex <> 1
                    then
                      post1 (p_idx + p_ixrx + p_ixfx)
                    else
                      post1 (p_idx + p_ixry + p_ixfx) ;
                  codet_word (p^.offset) ;
                  {ldx offset,y or ldx offset,x}
                end
            end
          end ;
      indirect := false
    end ;
    
modend.
