module alloc {$v3,0 allocate types and variables} ;
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
  var
    last_idx : hex varib external ;
    inited : boolean varib external ;
{$I/r0/codeproc}

  function labout (h : hex) : string[4] ; external ;
  function get_next (p1 : ^token_type ; first : boolean) : ^token_type ; external ;
  function module_check : boolean ; external ;
  
  function debtype (sympt : ^symhead ; p : manypt ; 
                    nflag, rflag : boolean) : longhex ; entry ;
    var
      ttemp : token_type register ;
      flag : boolean register ;
    begin
      if nflag
        then
          with sympt^ do
            begin
              flag := false ;
              debname (nameptr^) ;
              data_long (sympt) ;
              code_word (block_name) ;
              post1 (byte(idgroup)) ;
              if rflag
                then
                  post1 (byte(s_recoff))
                else
                  post1 (byte(storage)) ;
              case storage of
                s_stack : code_word (0 - offset) ; 
                s_stddev, s_absolute, s_direct : code_word (offset) ;
                s_data, s_varib : 
                  if intname <> 0
                    then
                      begin
                        code_word(intname) ;
                        flag := true
                      end
                    else
                      code_word (0) 
                else
                  code_word (0)
              end ;
              code_byte (byte(flag)) ;
              p.ch := sympt + align(sizeof(symhead)) ;
            end ;
      post1 (p.ch^) ;
      if p.tk^ in [valuepar .. funcret]
        then
          begin
            p.tk := align(p.tk + 1) + 4 ;
            post1 (p.ch^)
          end ;
      ttemp := p.tk^ ;
      p.tk := p.tk + 1 ;
      case ttemp of
        deferred :
          begin
            p.lx := align(p.lx) ;
            data_long (p.lx^) ;
            p.lx := p.lx + 4
          end ;
        hexvar :
          begin
            p.pt := align (p.pt) ;
            post1 (2 - p.ch^) ; {change nonstd to #0 deference}
            case p.en^ of
              nonptr : p.lx := p.lx + 1 ;
              stand :
                begin
                  p.en := p.en + 1 ;
                  post1 (p.ch^) ;
                  p.ch := p.ch + 1
                end ;
              nonstd :
                begin
                  p.lx := p.lx + 2 ;
                  data_long (p.lx) ;
                  p.lx := p.lx + 4
                end
            end
          end ;
        enumvar, subbool, subchar :
          begin
            p.ch := align(p.ch) ;
            post1 (p.ch^) ;
            p.ch := p.ch + 1 ;
            post1 (p.ch^) ;
            p.ch := p.ch + 1
          end ;
        subinteg, subhex :
          begin
            p.hx := align(p.hx) ;
            code_word (p.hx^) ;
            p.hx := p.hx + 2 ;
            code_word (p.hx^) ;
            p.hx := p.hx + 2
          end ;
        sublhex, sublint :
          begin
            p.lx := align(p.lx) ;
            data_long (p.lx^) ;
            p.lx := p.lx + 4 ;
            data_long (p.lx^) ;
            p.lx := p.lx + 4
          end ;
        stringvar :
          begin
            post1 (p.ch^) ;
            p.ch := p.ch + 1
          end ;
        setvar :
          begin
            post1 (p.ch^) ;
            p.ch := p.ch + 1 ;
            p.ch := debtype(sympt, p, false, rflag)
          end ;
        arrayvar :
          begin
            repeat {indices}
              p.lx := align(p.lx) ;
              code_word (p.hx^) ;
              p.lx := p.lx + 2 ;
              p.lx := debtype(sympt, p, false, rflag) ;
              if p.tk^ = arrayvar
                then
                  begin
                    post1 (p.ch^) ;
                    p.ch := p.ch + 1
                  end
                else
                  exit
            until false ;
            p.lx := debtype (sympt, p, false, rflag) {base type}
          end ;
        devicevar :
          begin
            p.lx := align(p.lx) ;
            code_word (p.hx^) ;
            p.lx := p.lx + longhex(sizeof(type_device_head)) ;
            p.lx := debtype (sympt, p, false, rflag)
          end ;
        recordvar :
          begin
            p.lx := align (p.lx) ;
            code_word (p.hx^) ; {record size}
            p.lx := p.lx + 2 ;
            data_long (p.lx^) ; {last in this record}
            p.lx := p.lx + 4 ;
            while p.tk^ <> termit do
              begin
                outterm ;
                debug (3) ;
                p.lx := align(p.lx + longhex(p.ch^ + 1)) ; {skip name}
                p.lx := align(debtype(p.lx, p, true, true) + 1)
              end
          end
      end ;
      debtype := p.tk
    end ;

  function allocate (st : storage_type) : error_type ; entry ;
    var
      global_error : error_type ;
      actual : hex register ;
      p : manypt ;
      special : token_type ;
      nested_device : boolean ;
      last_temp : ^symhead ;
      
    function get_size : hex ;
      var
        p1 : ^hex register ;
        p2 : ^byte ;
        range : hex register ;
        base_size : hex register ;
        ptdh : ^type_device_head ;
        file_size : hex register ;
      begin
        case p.tk^ of
          boolvar, charvar, subbool, subchar, enumvar : get_size := 1 ;
          integvar, hexvar, subinteg, subhex : get_size := 2 ;
          lhexvar, lintvar, realvar, sublhex, sublint : get_size := 4 ;
          arrayvar :
            repeat
              p1 := align(p.tk + 1) ; {point to size}
              p.tk := p1 + 2 ;
              p.tk := get_next (p.tk, false) ;
              if p.tk = nil
                then
                  begin
                    global_error := e_bte ;
                    exit
                  end ;
              case p.tk^ of {index type}
                subbool, subchar, enumvar :
                  begin
                    p.ch := align(p.tk + 1) + 1 ;
                    range := hex(p.ch^) ;
                    p.ch := p.ch + 1
                  end ;
                subinteg, subhex :
                  begin
                    p.hx := align(p.tk + 1) + 2 ;
                    range := hex(p.hx^) ;
                    p.hx := p.hx + 2
                  end ;
                sublhex, sublint :
                  begin
                    p.lx := align(p.tk + 1) + 4 ;
                    range := hex(p.lx^) ;
                    p.lx := p.lx + 4
                  end ;
                boolvar :
                  begin
                    range := 1 ;
                    p.tk := p.tk + 1
                  end ;
                charvar :
                  begin
                    range := $FF ;
                    p.tk := p.tk + 1
                  end
                else
                  begin
                    global_error := e_iidx ;
                    exit
                  end
              end ; {case}
              p.tk := get_next (p.tk, false) ; {get base type}
              if p.tk = nil
                then
                  begin
                    global_error := e_bte ;
                    exit
                  end ;
              if p.tk^ = devicevar {nested device}
                then
                  nested_device := true ;
              base_size := get_size ;
              p1^ := base_size * (range + 1) ;
              get_size := p1^
            until true ;
          stringvar :
            begin
              dyno := true ;
              p.ch := p.tk + 1 ;
              get_size := hex(p.ch^) ;
              p.ch := p.ch + 1
            end ;
          setvar :
            repeat
              dyno := true ;
              p2 := p.tk + 1 ; {location of size}
              p.tk := p2 + 1 ;
              p.tk := get_next (p.tk, false) ; {get base type}
              if p.tk = nil
                then
                  begin
                    global_error := e_bte ;
                    exit
                  end ;
              case p.tk^ of
                boolvar :
                  begin
                    p.tk := p.tk + 1 ;
                    range := 1
                  end ;
                charvar :
                  begin
                    p.tk := p.tk + 1 ;
                    range := $FF
                  end ;
                subchar, subbool, enumvar :
                  begin
                    p.ch := align(p.tk + 1) ;
                    range := hex(p.ch^) ;
                    p.ch := p.ch + 1 ;
                    range := hex(p.ch^) + range ;
                    p.ch := p.ch + 1
                  end ;
                subhex, subinteg :
                  begin
                    p.hx := align(p.tk + 1) ;
                    range := hex(p.hx^) ;
                    p.hx := p.hx + 2 ;
                    range := hex(p.hx^) + range ;
                    p.hx := p.hx + 2
                  end ;
                sublhex, sublint :
                  begin
                    p.lx := align (p.tk + 1) ;
                    range := hex(p.lx^) ;
                    p.lx := p.lx + 4 ;
                    range := hex(p.lx^) + range ;
                    p.lx := p.lx + 4
                  end
                else
                  begin
                    global_error := e_ibt ;
                    exit
                  end
              end ; {case}
              range := range >> 3 + 2 ;
              if range > longhex(127)
                then
                  begin
                    global_error := e_tmse ;
                    exit
                  end ;
              p2^ := byte(range) ;
              get_size := range
            until true ;
          recordvar :
            begin
              p.lx := align(p.tk + 1) ;
              get_size := p.hx^ ;
              p.lx := p.lx + 2
            end ;
          devicevar :
            repeat
              ptdh := align(p.tk + 1) ;
              p.tk := ptdh + longhex(sizeof(type_device_head)) ;
              p.tk := get_next (p.tk, false) ;
              if not nested_device and (special <> varibpar)
                 and (st <> s_nospace) and not record_flag
                 and module_check
                then
                  begin {put in init queue}
                    if device_active >= size_deviceq
                      then
                        begin
                          global_error := e_fqf ;
                          exit
                        end ;
                    device_active := succ (device_active) ;
                    with deviceq[device_active] do
                      begin
                        devpt := last_temp ;
                        headpt := ptdh
                      end
                  end ;
              with ptdh^ do
                begin
                  if mode = nor_file
                    then
                      begin
                        file_size := size_file ;
                        if p.tk^ = textvar
                          then
                            begin
                              p.tk := p.tk + 1 ;
                              size := size_text
                            end
                          else
                            size := file_size + get_size
                      end
                    else
                      begin
                        file_size := size_device + extra ;
                        if p.tk^ = textvar
                          then
                            begin
                              p.tk := p.tk + 1 ;
                              size := file_size + 1
                            end
                          else
                            size := file_size + get_size
                      end ;
                  get_size := size ;
                  if size > $7fe0
                    then
                      begin
                        global_error := e_sao ;
                        exit
                      end
                end
            until true
        end
      end ;
      
    begin
      repeat
        if record_flag or (lex <> 1)
          then
            last_temp := last_sym
          else
            last_temp := hash_tab[last_idx] ;
        allocate := undef ;
        dyno := false ;
        nested_device := false ;
        global_error := undef ;
        special := deferred ;
        last_temp^.storage := st ;
        p.tk := last_temp + align(sizeof(symhead)) ;
        repeat
          p.tk := get_next (p.tk, true) ;
          if p.tk = nil
            then
              begin
                allocate := e_bte ;
                exit (2)
              end ;
          if p.tk^ in [valuepar, varibpar, funcret]
            then
              begin
                special := p.tk^ ;
                p.tk := align(p.tk + 1) + 4 {move to real token}
              end
            else
              exit
        until false ;
        actual := get_size ;
        if global_error <> undef
          then
            begin
              allocate := global_error ;
              exit
            end ;
        case special of
          varibpar : actual := 2 ; {is pointer}
          valuepar, funcret : actual := actual
        end ;
        if record_flag
          then
            begin
              last_temp^.offset := record_size ;
              record_size := record_size + actual
            end
          else
            begin
              case st of
                s_stack :
                  begin
                    alloc := alloc + actual ;
                    last_temp^.offset := alloc
                  end ;
                s_absolute, s_direct :
                  begin
                    last_temp^.offset := varib_address ;
                    varib_address := varib_address + actual
                  end ;
                s_data, s_varib :
                  begin
                    override := true ;
                    if st = s_data
                      then
                        opcodet (cd_data)
                      else
                        opcodet (cd_varib) ;
                    opcode (c_equ) ;
                    post1 (p_imm + p_eqep) ;
                    if last_temp^.intname = 0
                      then
                        labt (last_temp^.nameptr^)
                      else
                        labt (concat('..',labout(last_temp^.intname))) ;
                    if not inited
                      then
                        begin
                          opcode (c_rmb) ;
                          post1 (p_abs) ;
                          codet_word (actual) ;
                          opcodet (cd_code)
                        end ;
                    override := false
                  end
              end ;
              if debug_opt and debug_en
                then
                  begin
                    override := true ;
                    debug (3) ;
                    p.lx := debtype (last_temp, p, true, false) ;
                    if icode_buf[0] < 120
                      then
                        outterm
                      else
                        icode_buf[0] := 0 ;
                    override := false
                  end
            end ;
        if alloc > $7F80
          then
            begin
              alloc := 0 ;
              allocate := e_sao
            end ;
        exit
      until false
    end ;
    
modend.
