{$l-}
{ 5/16/89 : initial conversion to version 3 }
{ 7/22/89 : firq/irq procedures added }
  type
{
  opcodes
}
                {opcode        function            postbytes}
    code_type = (
                  c_pass,     {pass record              0}
                  c_inline,   {inline reocrd            0}
                  c_data,     {data record              0}
                  c_bug,      {debug record             0}
                  c_line,     {line number              0}
                  c_purge,    {purge debugger symbol    0}
                  c_equ,      {symbol equate            1}
                  c_abx,      {abx                      0}
                  c_addb,     {addb                     1}
                  c_addd,     {addd                     1}
                  c_anda,     {anda                     1}
                  c_andb,     {andb                     1}
                  c_andcc,    {andcc                    1}
                  c_asla,     {asla                     0}
                  c_aslb,     {aslb                     0}
                  c_asra,     {asra                     0}
                  c_asrb,     {asrb                     0}
                  c_clra,     {clra                     0}
                  c_clrb,     {clrb                     0}
                  c_clr,      {clr                      1}
                  c_cmpb,     {cmpb                     1}
                  c_cmpd,     {cmpd                     1}
                  c_coma,     {coma                     0}
                  c_comb,     {comb                     0}
                  c_deca,     {deca                     0}
                  c_decb,     {decb                     0}
                  c_dec,      {dec                      1}
                  c_eora,     {eora                     1}
                  c_eorb,     {eorb                     1}
                  c_inca,     {inca                     0}
                  c_incb,     {incb                     0}
                  c_inc,      {inc                      1}
                  c_irq,      {irq/firq/nmi handler     1}
                  c_jsr,      {jsr                      1}
                  c_lda,      {lda                      1}
                  c_ldb,      {ldb                      1}
                  c_ldd,      {ldd                      1}
                  c_ldx,      {ldx                      1}
                  c_leax,     {leax                     1}
                  c_leau,     {leau                     1}
                  c_lsra,     {lsra                     0}
                  c_lsrb,     {lsrb                     0}
                  c_mul,      {mul                      0}
                  c_negb,     {negb                     0}
                  c_ora,      {ora                      1}
                  c_orb,      {orb                      1}
                  c_orcc,     {orcc                     1}
                  c_pshu,     {pshu                     1}
                  c_pulu,     {pulu                     1}
                  c_rola,     {rola                     0}
                  c_rolb,     {rolb                     0}
                  c_rora,     {rora                     0}
                  c_rorb,     {rorb                     0}
                  c_rts,      {rts                      0}
                  c_sex,      {sex                      0}
                  c_stb,      {stb                      1}
                  c_std,      {std                      1}
                  c_stx,      {stx                      1}
                  c_subb,     {subb                     1}
                  c_subd,     {subd                     1}
                  c_tfr,      {tfr                      1}
                  c_tsta,     {tsta                     0}
                  c_tstb,     {tstb                     0}
                  c_xbxx,     {bxx                      1}
                  c_rmb,      {rmb                      1}
                  c_zap,      {zap (optimizer)          0}
                  cd_code,    {code directive           0}
                  cd_data,    {data directive           0}
                  cd_varib,   {varib directive          0}
                  cd_end      {end directive            0}
                ) ;
{
  operand modification flags
}
    mod_type = (
                modnon,     {modifies no registers}
                moda,       {modifies a register}
                modb,       {modifies b register}
                modd,       {modifies d register}
                modx,       {modifies x register}
                modall,     {modifies all registers}
                modata,     {data}
                mpull,      {pull value}
                mtfr,       {transfer value}
                mxbxx,      {branch}
                mclra,      {lda #0}
                mclrb,      {ldb #0}
                mlda,
                mldb,
                mldd,
                mldx,
                minca,
                mincb,
                mdeca,
                mdecb
               ) ;
                
  const
{
  post byte format
}
    p_imm = $00 ;    {immediate/equ}
    p_abs = $08 ;    {absolute}
    p_idx = $40 ;    {indexed}
    p_rel = $00 ;    {relative}
{
  formats for push/pull
}
    p_ipa = 1 ; {a register}
    p_ipb = 2 ; {b register}
    p_ipd = 3 ; {d register}
    p_ipx = 4 ; {x register}
    p_ipy = 8 ; {y register}
    p_ips = $10 ; {s register}

{
  formats for tfr
}
    p_itba = 0 ; {b -> a}
    p_itab = 1 ; {a -> b}
    p_itdx = 2 ; {d -> x}
    p_itxd = 3 ; {x -> d}
{
  formats for equ
}
    p_eqlp = $00 ;   {lbxxxx equ *}
    p_eqep = $02 ;   {xxxx equ *}
    p_eqea = $03 ;   {xxxx equ $yyyy}
{
  immediate/absolute direct page
}
    p_dir = 1 ; {direct page}
{
  indexed indirect bit
}
    p_idxi = $20 ; 
{
  absolute external flag
}
    p_ae = 1 ;       {external if set}
{
  indexed registers
}
    p_ixrx = 0 ;      {,x}
    p_ixry = 8 ;      {,y}
    p_ixru = $10 ;    {,u}
    p_ixrp = $18 ;    {,pcr}
{
  indexed offset types
}
    p_ixfx = 0 ;    {fixed offset}
    p_ixex = 1 ;    {external offset}
    p_ixb  = 2 ;    {b,r}
    p_ixd  = 3 ;    {d,r}
    p_ixp  = 4 ;    {0,r+}
    p_ixpp = 5 ;    {0,r++}
    p_ixm  = 6 ;    {0,-r}
    p_ixz  = 7 ;    {0,r}
{
  relative external name flag
}
    p_reex = $20 ;   {external if set}
{
  relative long/short flag
}
    p_rell = $10 ;   {long if set}
{
  conditional types
}
    p_bra = $0 ;     {bra}
    p_bsr = $1 ;     {bsr}
    p_bhi = $2 ;     {bhi or shi}
    p_bls = $3 ;     {bls or sls}
    p_bcc = $4 ;     {bcc or scc}
    p_bhs = $4 ;     {bhs or shs}
    p_bcs = $5 ;     {bcs or scs}
    p_blo = $5 ;     {blo or slo}
    p_bne = $6 ;     {bne or sne}
    p_beq = $7 ;     {beq or seq}
    p_bvc = $8 ;     {bvc or svc}
    p_bvs = $9 ;     {bvs or svs}
    p_bpl = $A ;     {bpl or spl}
    p_bmi = $B ;     {bmi or smi}
    p_bge = $C ;     {bge or sge}
    p_blt = $D ;     {blt or slt}
    p_bgt = $E ;     {bgt or sgt}
    p_ble = $F ;     {ble or sle}
    p_bnd = $10 ;    {not defined}
    p_bb  = $11 ;    {value is in b}
{
  formats for irq instructions
}
    p_save = 1 ; {pshs u,y,x,d}
    p_ldy  = 2 ; {ldy global}
    p_rest = 3 ; {puls u,y,x,d}
    p_rti  = 4 ; {rti}
    p_leay = 5 ; {leay 10,u}
{$l+}
