module express {$v3,0 expression syntax} ;
{
  5/19/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function simple (var serror : error_type ;
                   var lp : labpack) : ^packet ; external ;
  procedure uncon (p : ^packet) ; external ;
  function maycon (p : ^packet) : boolean ; external ;
  procedure replace (e : error_type ; t : token_type) ; external ;
  procedure push (p : ^packet) ; external ;
  procedure error (errnum : error_type) ; external ;
  function get_internal : hex ; external ;
  function revpost (post : byte) : byte ; external ;
  procedure out_false (level : byte) ; external ;
  procedure out_true (level : byte) ; external ;
  procedure out_branch (post : byte ; pname : hex) ; external ;
  function toamd (r : real) : real ; external ;
  
  procedure warning ; entry ;
    begin
      if wopt
        then
          error (e_warn)
    end ;
    
  procedure compat (lpac, rpac : ^packet ; var cerror : error_type ; 
                    var reverse : boolean) ; entry ;
    begin
      if lpac^.conflag
        then
          case lpac^.token of
            integvar :
              case rpac^.token of
                charvar :
                  begin
                    lpac^.pvc_char := byte(lpac^.pvc_integer) ;
                    lpac^.token := charvar ;
                    warning
                  end ;
                hexvar :
                  begin
                    lpac^.pvc_hex := hex(lpac^.pvc_integer) ;
                    lpac^.token := hexvar ;
                    warning
                  end ;
                lhexvar :
                  begin
                    lpac^.pvc_longhex := longhex(lpac^.pvc_integer) ;
                    lpac^.token := lhexvar ;
                    warning
                  end ;
              end ;
            lintvar :
              if rpac^.token = lhexvar
                then
                  begin
                    lpac^.pvc_longhex := longhex(lpac^.pvc_longinteger) ;
                    lpac^.token := lhexvar ;
                    warning
                  end ;
            hexvar :
              if rpac^.token = charvar
                then
                  begin
                    lpac^.pvc_char := byte(lpac^.pvc_hex) ;
                    lpac^.token := charvar ;
                    warning
                  end
          end ;
      if rpac^.conflag
        then
          case lpac^.token of
            hexvar :
              if rpac^.token = integvar
                then
                  begin
                    rpac^.pvc_hex := hex(rpac^.pvc_integer) ;
                    rpac^.token := hexvar ;
                    warning
                  end ;
            lhexvar :
              case rpac^.token of
                integvar :
                  begin
                    rpac^.pvc_longhex := longhex(rpac^.pvc_integer) ;
                    rpac^.token := lhexvar ;
                    warning
                  end ;
                lintvar :
                  begin
                    rpac^.pvc_longhex := longhex(rpac^.pvc_longinteger) ;
                    rpac^.token := lhexvar ;
                    warning
                  end
              end ;
            charvar :
              case rpac^.token of
                integvar :
                  begin
                    rpac^.pvc_char := byte(rpac^.pvc_integer) ;
                    rpac^.token := charvar ;
                    warning
                  end ;
                hexvar :
                  begin
                    rpac^.pvc_char := byte(rpac^.pvc_hex) ;
                    rpac^.token := charvar ;
                    warning
                  end
              end
          end ;
      if lpac^.token <> rpac^.token
        then
          begin
            if not (lpac^.conflag and rpac^.conflag)
              then
                begin
                  if rpac^.conflag
                    then
                      uncon (rpac) ;
                  if lpac^.conflag
                    then
                      begin
                        reverse := true ;
                        uncon (lpac)
                      end
                end ;
            case lpac^.token of
              integvar :
                case rpac^.token of
                  lintvar :
                    begin
                      if lpac^.conflag
                        then
                          lpac^.pvc_longinteger :=
                              longinteger(lpac^.pvc_integer)
                        else
                          if reverse
                            then
                              hand (int, $40)
                            else
                              hand (int, $41) ;
                      lpac^.token := lintvar
                    end ;
                  realvar :
                    begin
                      if lpac^.conflag
                        then
                          lpac^.pvc_real := toamd(real(lpac^.pvc_integer))
                        else
                          if reverse
                            then
                              hand(int, 6)
                            else
                              hand(int, 7) ;
                      lpac^.token := realvar
                    end
                  else
                    cerror := e_tc
                end ;
              lintvar :
                case rpac^.token of
                  integvar :
                    begin
                      if rpac^.conflag
                        then
                          rpac^.pvc_longinteger := 
                             longinteger(rpac^.pvc_integer)
                          else
                            if reverse
                              then
                                hand (int, $41)
                              else
                                hand (int, $40) ;
                      rpac^.token := lintvar
                    end ;
                  realvar :
                    begin
                      if lpac^.conflag
                        then
                          lpac^.pvc_real := toamd(real(lpac^.pvc_longinteger))
                        else
                          if reverse
                            then
                              hand (int, $42)
                            else
                              hand (int, $43) ;
                      lpac^.token := realvar
                    end
                  else
                    cerror := e_tc
                end ;
              realvar :
                case rpac^.token of
                  integvar :
                    begin
                      if rpac^.conflag
                        then
                          rpac^.pvc_real := toamd(real(rpac^.pvc_integer))
                        else
                          if reverse
                            then
                              hand (int, 7)
                            else
                              hand (int, 6) ;
                      rpac^.token := realvar
                    end ;
                  lintvar :
                    begin
                      if rpac^.conflag
                        then
                          rpac^.pvc_real := toamd(real(rpac^.pvc_longinteger))
                        else
                          if reverse
                            then
                              hand (int, $43)
                            else
                              hand(int, $42) ;
                      rpac^.token := realvar
                    end
                  else
                    cerror := e_tc
                end ;
              hexvar :
                case rpac^.token of
                  lhexvar :
                    begin
                      if lpac^.conflag
                        then
                          lpac^.pvc_longhex := longhex(lpac^.pvc_hex)
                        else
                          if reverse
                            then
                              hand (int, $45)
                            else
                              hand (int, $44) ;
                      lpac^.token := lhexvar
                    end
                  else
                    cerror := e_tc
                end ;
              lhexvar :
                case rpac^.token of
                  hexvar :
                    begin
                      if rpac^.conflag
                        then
                          rpac^.pvc_longhex := longhex(rpac^.pvc_hex)
                        else
                          if reverse
                            then
                              hand (int, $44)
                            else
                              hand (int, $45) ;
                      rpac^.token := lhexvar
                    end
                  else
                    cerror := e_tc
                end
              else
                cerror := e_tc
            end
          end
    end ;
    
  procedure opdot (pac : ^packet) ; entry ;
    begin
      post1 (p_imm) ;
      if pac^.token in [integvar, hexvar]
        then
          codet_word (pac^.pvc_hex)
        else
          codet_byte (pac^.pvc_char)
      {finish xxx #yyy}
    end ;

  procedure new_false (lev : byte ; num : hex) ; entry ;
    begin
      false_depth := succ(false_depth) ;
      false_tab[false_depth].lev := lev ;
      false_tab[false_depth].num := num
    end ;
    
  procedure new_true (lev : byte ; num : hex) ; entry ;
    begin
      true_depth := succ(true_depth) ;
      true_tab[true_depth].lev := lev ;
      true_tab[true_depth].num := num
    end ;
    
  procedure make_boolean (var lp : labpack) ; entry ;
    var
      labl : hex ;
    begin
      if ((false_depth = 0) or (false_tab[false_depth].lev < level)) and
         ((true_depth = 0) or (true_tab[true_depth].lev < level))
        then
          if lp.branch and (lp.post <> p_bb)
            then
              begin
                labl := get_internal ;
                opcode (c_xbxx) ;
                post1 (p_rel + lp.post) ;
                codet_word (labl) ;
                {bxx labl}
                ldbim (1) ;
                {ldb #1}
                labl := get_internal ;
                opcode (c_xbxx) ;
                post1 (p_rel + p_bra) ;
                codet_word (labl) ;
                {bra lab2}
                opcode (c_equ) ;
                post1 (p_eqlp) ;
                codet_word (labl - 1) ;
                {labl equ *}
                purge (labl - 1) ;
                opcodet (c_clrb) ;
                {clrb}
                opcode (c_equ) ;
                post1 (p_eqlp) ;
                codet_word (labl) ;
                {lab2 equ *}
                purge (labl)
              end
            else
        else
          begin
            labl := 0 ;
            if (false_depth = 0) or (false_tab[false_depth].lev < level)
              then
                new_false (level, get_internal) ;
            out_branch (lp.post, false_tab[false_depth].num) ;
            out_true (level) ;
            if lp.branch
              then
                begin
                  ldbim (1) ;
                  {ldb #1}
                  labl := get_internal ;
                  out_branch (p_bra, labl)
                end ;
            out_false (level) ;
            if lp.branch
              then
                opcodet (c_clrb) ; {clrb}
            if labl <> 0
              then
                begin
                  opcode (c_equ) ;
                  post1 (p_eqlp) ;
                  codet_word (labl) ;
                  purge (labl)
                end ;
          end ;
      lp.post := p_bb
    end ;
    
  function express (var xerror : error_type ;
                    var lp : labpack) : ^packet ; entry ;
    var
      lpac, rpac, tpac : ^packet ;
      eop, br : token_type ;
      reverse, signed : boolean ;
      asize, labl : hex ;
      arrflag, post : byte ;
      compit, two : boolean ;
      
    function revbr : token_type ;
      begin
        if reverse
          then
            case eop of
              lt : revbr := gt ;
              gt : revbr := lt ;
              lteq : revbr := gteq ;
              gteq : revbr := lteq
              else
                revbr := eop
            end
          else
            revbr := eop
      end ;
      
    procedure bcheck ;
      begin
        if lp.branch
          then
            if lpac^.conflag and (level = 1)
              then
                if lpac^.pvc_boolean
                  then
                    lpac^.token := true_
                  else
                    begin
                      lp.post := p_bra ;
                      lpac^.token := boolvar
                    end
              else
                lpac^.token := boolvar
          else
            lpac^.token := boolvar
      end ;
      
    procedure do_sub (num : byte) ;
      var
        cond : byte register ;
      begin
        cond := 1 << (byte(revbr) - byte(lt)) ;
        hand (oper, num) ;
        case num of
          $40 :
            begin {array, record}
              if lpac^.size <> rpac^.size
                then
                  xerror := e_tc ;
              data_word (lpac^.size) ;
              datat_byte (cond)
            end ;
          $50 :
            begin {string}
              data_byte (arrflag) ;
              data_byte (cond) ;
              if asize <> 0
                then
                  data_byte (byte(asize)) ;
              outterm
            end
          else
            datat_byte (cond)
        end ; {case}
        lp.post := p_bb ;
        lpac^.token := boolvar
      end ;

    begin {express}
      xerror := undef ;
      lp.post := p_bnd ;
      compit := false ;
      repeat
        lpac := simple (xerror, lp) ;
        if xerror <> undef
          then
            exit ;
        eop := lastpack^.token ;
        case eop of
          in_ :
            begin
              if lpac^.conflag
                then
                  begin
                    uncon (lpac) ;
                    if lpac^.token = boolvar
                      then
                        begin
                          lp.post := p_bb ;
                          make_boolean (lp)
                        end
                  end ;
              case lpac^.token of
                enumvar, charvar, boolvar :
                  begin
                    if lpac^.token = boolvar
                      then
                        make_boolean (lp) ;
                    opcodet (c_clra) ; {clra}
                    lpac^.token := integvar
                  end ;
                integvar, hexvar :
                else
                  begin
                    xerror := e_tc ;
                    exit
                  end
              end
            end ;
          lt .. notequal : 
            if lpac^.token = boolvar
              then
                begin
                  compit := true ;
                  if lpac^.conflag
                    then
                      begin
                        uncon (lpac) ;
                        lp.post := p_bb
                      end ;
                  make_boolean (lp)
                end ;
          assign : replace (e_equal, equal)
          else
            begin
              if lp.branch and (lpac^.token = boolvar)
                then
                  bcheck ;
              express := lpac ;
              exit
            end
        end ; {case eop of}
        if lpac^.conflag
          then
            if maycon (lpac)
              then
                push (lpac)
              else
          else
            push (lpac) ;
        scan ;
        lp.post := p_bnd ;
        rpac := simple (xerror, lp) ;
        if xerror <> undef
          then
            exit ;
        if compit and (rpac^.token = boolvar)
          then
            begin
              if rpac^.conflag
                then
                  begin
                    uncon (rpac) ;
                    lp.post := p_bb
                  end ;
              make_boolean (lp)
            end ;
        if maycon (rpac)
          then ;
        reverse := false ;
{
  intercept all that array, character, string mixture stuff
}
        if (lpac^.token = stringvar) and
           (rpac^.token = stringvar) or
          ((lpac^.token <> rpac^.token) and
           ((lpac^.token in [arrayvar, stringvar]) or
            (rpac^.token in [arrayvar, stringvar])))
          then
            begin {array, char, string stuff}
              asize := 0 ;
              arrflag := 0 ;
              case rpac^.token of
                stringvar : ;
                charvar :
                  begin
                    arrflag := 1 ;
                    uncon (rpac) ;
                    push (rpac)
                  end ;
                arrayvar :
                  begin
                    arrflag := 2 ;
                    if rpac^.size > 126
                      then
                        begin
                          xerror := e_tc ;
                          exit
                        end
                      else
                        asize := rpac^.size
                  end
                else
                  begin
                    xerror := e_tc ;
                    exit
                  end
              end ;
              case lpac^.token of
                stringvar : ;
                charvar : arrflag := arrflag + 4 ;
                arrayvar :
                  begin
                    arrflag := arrflag + 8 ;
                    if lpac^.size > 126
                      then
                        begin
                          xerror := e_tc ;
                          exit
                        end
                      else
                        asize := lpac^.size
                  end
                else
                  begin
                    xerror := e_tc ;
                    exit
                  end
              end ;
              do_sub ($50)
            end
          else
            begin {not array, char, string stuff}
              if lpac^.token <> rpac^.token
                then
                  begin
                    compat (lpac, rpac, xerror, reverse) ;
                    if xerror <> undef
                      then
                        if (eop = in_) and (rpac^.token = setvar) and
                           (lpac^.token in [enumvar, boolvar .. hexvar])
                          then
                            begin
                              xerror := undef ;
                              hand (oper, $35) ;
                              lp.post := p_bb ;
                              bcheck ;
                              exit
                            end
                          else
                            begin
                              xerror := e_tc ;
                              exit
                            end
                  end ;
              two := lpac^.token in [integvar, hexvar] ;
              case lpac^.token of
                realvar : do_sub ($25) ;
                lintvar : do_sub ($10) ;
                lhexvar : do_sub ($43) ;
                setvar : do_sub ($33) ;
                arrayvar, recordvar : do_sub ($40) ;
                enumvar, boolvar .. hexvar :
                  begin
                    if lpac^.conflag
                      then
                        begin
                          lpac^.conflag := false ;
                          if rpac^.conflag
                            then
                              begin {con - con}
                                if two
                                  then
                                    lddim (lpac^.pvc_hex)
                                  else
                                    ldbim (lpac^.pvc_char) ;
                                tpac := rpac
                              end
                            else
                              begin {con - expr}
                                reverse := not reverse ;
                                tpac := lpac
                              end ;
                          if two
                            then
                              opcode (c_subd)
                            else
                              opcode (c_subb) ;
                          opdot (tpac)
                        end
                      else
                        if rpac^.conflag
                          then
                            begin {exp - con}
                              opcode (c_pulu) ;
                              if two
                                then
                                  begin
                                    post1t (p_ipd) ;
                                    opcode (c_subd)
                                  end
                                else
                                  begin
                                    post1t (p_ipb) ;
                                    opcode (c_subb)
                                  end ;
                              opdot (rpac)
                            end
                          else
                            begin {expr - expr}
                              reverse := not reverse ;
                              if two
                                then
                                  begin
                                    opcode (c_subd) ;
                                    post1t (p_idx + p_ixru + p_ixpp)
                                    {subd 0,u++}
                                  end
                                else
                                  begin
                                    opcode (c_subb) ;
                                    post1t (p_idx + p_ixru + p_ixp)
                                    {subb 0,u+}
                                  end
                            end ;
                    br := revbr ;
                    signed := lpac^.token = integvar ;
                    if lp.branch
                      then
                        case br of
                          lt : br := gteq ;
                          gt : br := lteq ;
                          equal : br := notequal ;
                          lteq : br := gt ;
                          gteq : br := lt ;
                          notequal : br := equal
                        end ;
                    case br of
                      lt :
                        if signed
                          then
                            post := p_bge
                          else
                            post := p_bhs ;
                      gt :
                        if signed
                          then
                            post := p_ble
                          else
                            post := p_bls ;
                      equal : post := p_bne ;
                      lteq :
                        if signed
                          then
                            post := p_bgt
                          else
                            post := p_bhi ;
                      gteq :
                        if signed
                          then
                            post := p_blt
                          else
                            post := p_blo ;
                      notequal : post := p_beq
                    end ;
                    post := revpost (post) ;
                    if lp.branch
                      then
                        lp.post := post
                      else
                        begin
                          labl := get_internal ;
                          opcode (c_xbxx) ;
                          post1 (p_rel + revpost(post)) ;
                          codet_word (labl) ;
                          {bxx labl}
                          ldbim (1) ;
                          {ldb #1}
                          labl := get_internal ;
                          opcode (c_xbxx) ;
                          post1 (p_rel + p_bra) ;
                          codet_word (labl) ;
                          {bra lab2}
                          opcode (c_equ) ;
                          post1 (p_eqlp) ;
                          codet_word (labl - 1) ;
                          {labl equ *}
                          purge (labl - 1) ;
                          opcodet (c_clrb) ;
                          {clrb}
                          opcode (c_equ) ;
                          post1 (p_eqlp) ;
                          codet_word (labl) ;
                          {lab2 equ *}
                          purge (labl) ;
                          lp.post := p_bb
                        end ;
                    lpac^.token := boolvar ;
                    lpac^.size := 0
                  end {enumvar .. lintvar}
                else
                  begin
                    xerror := e_itoo ;
                    exit
                  end
              end {case}
            end {else}
      until true ;
      express := lpac
    end ; 
    
  function outexp (var oerror : error_type) : ^packet ; entry ;
    var
      lp1 : labpack ;
      i : integer register ;
    begin
      lp1.branch := false ;
      lp1.post := p_bb ;
      outexp := express (oerror, lp1) ;
      out_true (level) ;
      out_false (level)
    end ;
    
modend.
