module factor {$v3,0 factor syntax} (output) ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function get_internal : hex ; external ;
  function labout (h : hex) : string[4] ; external ;
  function constant (var cerror : error_type) : ^packet ; external ;
  function getheap (size : longinteger) : ^packet ; external ;
  procedure errorpt (errnum : error_type) ; external ;
  procedure opdot (pac : ^packet) ; external ;
  function express (var xerror : error_type ; var lp : labpack) 
                                               : ^packet ; external ;
  function outexp (var oerror : error_type) : ^packet ; external ;
  function func_call (var gerror : error_type ; p : ^symhead) : ^packet ; external ;
  function varib (vpac : ^packet ; var verror : error_type ;
                  getdata : boolean ; outer : boolean) : ^packet ; external ;
  procedure uncon (p : ^packet) ; external ;
  function stand_func (var gerror : error_type) : ^packet ; external ;
  function revpost (post : byte) : byte ; external ;
  procedure out_false (level : byte) ; external ;
  procedure out_true (level : byte) ; external ;
  procedure new_false (lev : byte ; num : hex) ; external ;
  procedure new_true (lev : byte ; num : hex) ; external ;
  procedure make_boolean (var lp : labpack) ; external ;
  function toamd (r : real) : real ; external ;
  
  function factor (var ferror : error_type ; var lp : labpack) : ^packet ; entry ;
    var
      p1 : ^packet ;
      lp1 : labpack ;
      oldlp : labpack ;
      willfact : ^packet ;

    procedure vdata ;
      var
        p2 : ^symhead register ;
        p3 : ^token_type register ;
        p4 : ^longhex register ;
      begin
        if lastpack^.token = vardef
          then
            begin
              p2 := lastpack^.pointr ;
              p3 := p2 + align(sizeof(symhead)) ;
              if p3^ = funcret {see if accessing function variable}
                then
                  begin
                    p4 := align (p3 + 1) ;
                    p1 := func_call (ferror, p4^) {call function}
                  end
                else
                  p1 := varib (lastpack, ferror, true, true)
            end
          else
            p1 := func_call (ferror, lastpack^.pointr) ;
        if ferror = undef
          then
            begin
              if p1^.token in [subbool .. sublint]
                then
                  p1^.token := enum(byte(p1^.token) - sub_offset) ;
              if p1^.token = boolvar
                then
                  lp.post := p_bb
            end ;
        willfact := p1
      end ;

    procedure make_set ;
      var
        serror : error_type ;
        temp : integer ;
        addop, con_sum, exp_stack : boolean ;
        lpac, rpac : ^packet register ;
        low, high : hex register ;
        sum : record
                case boolean of
                  false : (a : set of 0 .. 2015) ;
                  true  : (b : string[252])
              end ;
        two : boolean ;
      begin
        repeat
          serror := undef ;
          addop := false ;
          con_sum := false ;
          exp_stack := false ;
          sum.a := [] ;
          repeat
            scan ;
            if lastpack^.token = rightbracket
              then
                begin
                  opcode (c_clr) ;
                  post1t (p_idx + p_ixru + p_ixm) ;
                  {clr -0,u}
                  lpac := lastpack ;
                  exit
                end ;
            lpac := outexp (serror) ;
            if serror <> undef
              then
                exit (2) ;
            case lpac^.token of
              boolvar, charvar, enumvar : 
                low := hex(lpac^.pvc_char) ;
              integvar, hexvar :
                low := lpac^.pvc_hex ;
              lhexvar, lintvar :
                low := hex(lpac^.pvc_longhex)
              else
                begin
                  serror := e_itoo ;
                  exit (2)
                end
            end ;
            if not lpac^.conflag
              then
                begin
                  opcode (c_pshu) ;
                  if lpac^.token in [boolvar, charvar, enumvar]
                    then
                      post1t (p_ipb) {pshu b}
                    else
                      post1t (p_ipd) ; {pshu d}
                end ;
            two := lpac^.token in [integvar, hexvar] ;
            if lastpack^.token = subrange
              then
                begin {x .. y}
                  scan ;
                  rpac := outexp (serror) ;
                  if serror <> undef
                    then
                      exit (2) ;
                  if lpac^.token <> rpac^.token
                    then
                      begin
                        serror := e_ist ;
                        exit (2)
                      end ;
                  case rpac^.token of
                    boolvar, charvar, enumvar :
                      high := hex(rpac^.pvc_char) ;
                    integvar, hexvar :
                      high := hex(rpac^.pvc_hex) ;
                    lhexvar, lintvar :
                      high := hex(rpac^.pvc_longhex)
                  end ;
                  if rpac^.conflag
                    then
                      if not lpac^.conflag
                        then
                          uncon (rpac)
                        else
                    else
                      if lpac^.conflag
                        then {const .. expr}
                          begin
                            lpac^.conflag := false ;
                            if two
                              then
                                begin
                                  opcode (c_ldx) ;
                                  opdot (lpac) ;
                                  {ldx #low}
                                  opcode (c_pshu) ;
                                  post1t (p_ipx)
                                  {pshu }
                                end
                              else
                                begin
                                  opcode (c_lda) ;
                                  opdot (lpac) ;
                                  {lda #low}
                                  opcode (c_pshu) ;
                                  post1t (p_ipa)
                                  {pshu a}
                                end
                          end
                end
              else {x}
                high := low ;
            if lpac^.conflag
              then
                if (low <= $7df) and (high <= $7df)
                  then
                    begin
                      sum.a := sum.a + [low .. high] ;
                      con_sum := true
                    end  
                  else
                    errorpt (e_wcor)
              else
                begin {expression}
                  if lpac^.token in [boolvar, charvar, enumvar]
                    then
                      hand (int, $34)
                    else
                      hand (int, 4) ;
                  exp_stack := true ;
                  if addop
                    then
                      begin
                        hand (oper, $30) ;
                        addop := false
                      end
                end ;
            if lastpack^.token = rightbracket
              then
                exit ;
            if lastpack^.token <> comma
              then
                begin
                  serror := e_rbrk ;
                  exit (2)
                end ;
            if not lpac^.conflag
              then
                addop := true
          until false ;
          if con_sum
            then
              with lpac^ do
                begin
                  hand (int, $29) ;
                  low := get_internal ;
                  datat_byte (sum.b[0]) ;
                  while sum.b[0] <> 0 do
                    begin
                      if sum.b[0] > 84
                        then
                          temp := 84
                        else
                          temp := ord(sum.b[0]) ;
                      datast (substr(sum.b,1,temp)) ;
                      sum.b := substr(sum.b, temp + 1, 252 - temp)
                    end ;
                  if exp_stack
                    then
                      hand (oper, $30)
                end
        until true ;
        if serror = undef
          then
            begin
              scan ;
              lpac^.token := setvar ;
              lpac^.conflag := false ;
              willfact := lpac
            end
          else
            ferror := serror
      end ;

    procedure type_change ;
      var
        terror : error_type ;
        restyp : token_type ;
        p2 : ^packet ;
        p3 : ^anystring ;
        s : string[120] ;

      procedure setstring ;
        var
          p3 : ^anystring register ;
        begin
          p3 := getheap (length(s) + 1) ;
          p3^ := s ;
          p2^.pvc_string := p3
        end ;

      procedure exp1 ; {convert real to integer}
        var
          sel : byte register ;
        begin
          sel := $21 ; {assume round}
          if lastpack^.token = comma
            then
              begin
                scan ;
                case lastpack^.token of
                  trunc_ : sel := $20 ;
                  floor_ : sel := $22
                end ;
                scan
              end ;
          uncon (p2) ;
          hand (func, sel)
        end ;

      procedure exp2 ; {convert real to longinteger}
        var
          sel : byte register ;
        begin
          sel := $24 ; {assume round}
          if lastpack^.token = comma
            then
              begin
                scan ;
                case lastpack^.token of
                  trunc_ : sel := $23 ;
                  floor_ : sel := $25
                end ;
                scan
              end ;
          uncon (p2) ;
          hand (func, sel)
        end ;

      procedure exp18 ; {real to string}
        var
          sel : byte register ;
          p4 : ^packet register ;
        begin
          if p2^.conflag
            then
              uncon (p2) ;
          if lastpack^.token = comma
            then
              begin
                scan ;
                p4 := outexp (terror) ;
                if p4^.token in [integvar, charvar]
                  then
                    uncon (p4)
                  else
                    terror := e_integ
              end
            else
              ldbim (-1) ; {ldb #-1}
          hand (func, $64)
        end ; {exp18}

      procedure exp5 (con : boolean) {string to character} ;
        var
          sel : byte register ;
          p3 : ^anystring register ;
          p4 : ^packet register ;
        begin
          sel := 1 ;
          if lastpack^.token = comma
            then
              begin
                p4 := constant(terror) ;
                if (p4^.token in [charvar, integvar]) and
                   (terror = undef)
                  then
                    if p4^.token = charvar
                      then
                        sel := p4^.pvc_char
                      else
                        sel := byte(p4^.pvc_integer)
                  else
                    terror := e_integ
              end ;
          if con
            then
              begin
                p3 := p2^.pvc_string ;
                p2^.pvc_char := p3^[sel]
              end
            else
              begin
                opcode (c_lda) ;
                post1 (p_idx + p_ixru + p_ixrx) ;
                codet_word (hex(sel)) ;
                {lda n,u}
                eminln (126)
              end
      end ; {exp5}

      begin {type_change}
        terror := undef ;
        repeat
          case lastpack^.token of
            boolean_ .. real_ :
              restyp := enum(byte(lastpack^.token) - name_offset) ;
            enum_ : restyp := enumvar ;
            string_ : restyp := stringvar
          end ;
          scan ;
          if lastpack^.token <> leftparen
            then
              begin
                terror := e_lpar ;
                exit
              end ;
          scan ;
          p2 := outexp (terror) ;
          if terror <> undef
            then
              exit ;
          if not (p2^.token in [boolvar .. realvar, enumvar, stringvar])
            then
              begin
                terror := e_esfp ;
                exit
              end ;
{
  main conversion area : ordered by result type then by
  expression type
}
          with p2^ do
            case restyp of
              boolvar :
                begin
                  lp.post := p_bb ;
                  case token of
                    enumvar, charvar :
                      if conflag
                        then
                          pvc_boolean := boolean(pvc_char)
                        else
                          eminln (125) ;
                    integvar, hexvar :
                      if conflag
                        then
                          pvc_boolean := boolean(pvc_hex)
                        else
                          eminln (125) ;
                    lhexvar, lintvar :
                      if conflag
                        then
                          pvc_boolean := boolean(pvc_longhex)
                        else
                          begin
                            eminln (124) ;
                            eminln (125)
                          end ;
                    realvar :
                      begin
                        exp1 ; {convert to integer}
                        if conflag
                          then
                            pvc_boolean := boolean (pvc_hex)
                          else
                            eminln (125)
                      end ;
                    stringvar :
                      if conflag
                        then
                          pvc_boolean := boolean(pvc_string^)
                        else
                          hand (func, $67)
                  end
                end ; {boolean result}
              enumvar :
                case token of
                  integvar, hexvar :
                    if conflag
                      then
                        pvc_enum := enum(pvc_hex) ;
                  lhexvar, lintvar :
                    if conflag
                      then
                        pvc_enum := enum(pvc_longhex)
                      else
                        eminln (124) ;
                  realvar :
                    begin
                      exp1 ; {convert to integer}
                      if conflag
                        then
                          pvc_enum := enum(pvc_hex)
                    end ;
                  stringvar :
                    if conflag
                      then
                        pvc_enum := enum(pvc_string^)
                      else
                        hand (func, $61)
                end ; {enum}
              charvar :
                case token of
                  hexvar, integvar :
                    if conflag
                      then
                        pvc_char := char(pvc_hex) ;
                  lhexvar, lintvar :
                    if conflag
                      then
                        pvc_char := char(pvc_longhex)
                      else
                        eminln (124) ;
                  realvar :
                    begin
                      exp1 ; {convert to integer}
                      if conflag
                        then
                          pvc_char := char(pvc_hex)
                    end ;
                  stringvar :
                    if conflag
                      then
                        exp5 (true)
                      else
                        exp5 (false)
                end ; {charvar}
              integvar :
                case token of
                  enumvar, charvar, boolvar :
                    if conflag
                      then
                        pvc_integer := integer(pvc_char)
                      else
                        eminln (113) ;
                  lhexvar :
                    if conflag
                      then
                        pvc_integer := integer(pvc_longhex)
                      else
                        eminln (124) ;
                  lintvar :
                    if conflag
                      then
                        pvc_integer := integer(pvc_longinteger)
                      else
                        hand (func, $26) ;
                  realvar :
                    exp1 ; {convert to integer}
                  stringvar :
                    if conflag
                      then
                        pvc_integer := integer(pvc_string^)
                      else
                        hand (func, $61)
                end ; {integvar}
              hexvar :
                case token of
                  enumvar, charvar, boolvar :
                    if conflag
                      then
                        pvc_hex := hex(pvc_char)
                      else
                        eminln (115) ;
                  lhexvar, lintvar :
                    if conflag
                      then
                        pvc_hex := hex(pvc_longhex)
                      else
                        eminln (124) ;
                  realvar :
                    exp1 ;
                  stringvar :
                    if conflag
                      then
                        pvc_hex := hex(pvc_string^)
                      else
                        hand (func, $63)
                end ; {hexvar}
              lhexvar :
                case token of
                  boolvar, enumvar, charvar :
                    if conflag
                      then
                        pvc_longhex := longhex(pvc_char)
                      else
                        eminln (127) ;
                  integvar, hexvar :
                    if conflag
                      then
                        pvc_longhex := longhex(pvc_hex)
                      else
                        eminln (123) ;
                  realvar :
                    exp2 ; {convert to longinteger}
                  stringvar :
                    if conflag
                      then
                        pvc_longhex := longhex(pvc_string^)
                      else
                        hand (func, $73)
                end ; {lhexvar}
              lintvar :
                case token of
                  boolvar, enumvar, charvar :
                    if conflag
                      then
                        pvc_longinteger := longinteger(pvc_char)
                      else
                        begin
                          eminln (113) ;
                          hand (int, $40)
                        end ;
                  integvar, hexvar :
                    if conflag
                      then
                        pvc_longinteger := longinteger(pvc_hex)
                      else
                        hand (int, $40) ;
                  realvar :
                    exp2 ; {convert to longinteger}
                  stringvar :
                    if conflag
                      then
                        pvc_longinteger := longinteger(pvc_string^)
                      else
                        hand (func, $69)
                end ; {lintvar}
              realvar :
                case token of
                  enumvar, boolvar, charvar :
                    if conflag
                      then
                        pvc_real := toamd(real (pvc_char))
                      else
                        begin
                          eminln (113) ;
                          hand (int, 6)
                        end ;
                  hexvar, integvar :
                    if conflag
                      then
                        pvc_real := toamd(real (pvc_hex))
                      else
                        hand (int, 6) ;
                  lhexvar, lintvar :
                    if conflag
                      then
                        pvc_real := toamd(real (pvc_longhex))
                      else
                        hand (int, $42) ;
                  stringvar :
                    if conflag
                      then
                        pvc_real := toamd(real(pvc_string^))
                      else
                        hand (func, $65)
                end ; {realvar}
              stringvar :
                case token of
                  boolvar :
                    if conflag
                      then
                        begin
                          s := string(pvc_boolean) ;
                          setstring
                        end
                      else
                        hand (func, $66) ;
                  enumvar :
                    if conflag
                      then
                        begin
                          s := string(integer(pvc_enum)) ;
                          setstring
                        end
                      else
                        begin
                          eminln (113) ;
                          hand (func, $60)
                        end ;
                  charvar :
                    if conflag
                      then
                        begin
                          s := string(pvc_char) ;
                          setstring
                        end
                      else
                        eminln (101) ;
                  integvar :
                    if conflag
                      then
                        begin
                          s := string(pvc_integer) ;
                          setstring
                        end
                      else
                        hand (func, $60) ;
                  hexvar :
                    if conflag
                      then
                        begin
                          s := string (pvc_hex) ;
                          setstring
                        end
                      else
                        hand (func, $62) ;
                  lhexvar :
                    if conflag
                      then
                        begin
                          s := string (pvc_longhex) ;
                          setstring
                        end
                      else
                        hand (func, $74) ;
                  lintvar :
                    if conflag
                      then
                        begin
                          s := string (pvc_longinteger) ;
                          setstring
                        end
                      else
                        hand (func, $68) ;
                  realvar :
                    exp18
                end {stringvar}
            end ;
          if lastpack^.token <> rightparen
            then
              begin
                terror := e_rpar ;
                exit
              end ;
          scan ;
          p2^.token := restyp
        until true ;
        if terror <> undef
          then
            ferror := terror
          else
            begin
              willfact := p2
            end
      end ; {type_change}

    procedure do_swap ;
      var
        swap_tab : array [0 .. 20] of record
                                        lev : byte ;
                                        num : hex
                                      end ;
        i, swap_depth : integer register ;
      begin
        swap_depth := 0 ;
        for i := true_depth downto 1 do
          if true_tab[i].lev > level
            then
              begin
                swap_depth := succ(swap_depth) ;
                swap_tab[swap_depth] := true_tab[i] ;
                true_depth := pred(true_depth)
              end
            else
              exit ;
        for i := false_depth downto 0 do
          if false_tab[i].lev <= level
            then
              exit ;
        for i := i + 1 to false_depth do
          with false_tab[i] do
            begin
              new_true (lev, num) ;
              false_depth := pred(false_depth)
            end ;
        for i := 1 to swap_depth do
          with swap_tab[i] do
            new_false (lev, num)
      end ;

    begin {factor}
      ferror := undef ;
      lp1.branch := false ;
      lp1.post := p_bnd ;
      repeat
        case lastpack^.token of
          leftbracket : make_set ;
          leftparen :
            begin
              scan ;
              level := level + 1 ;
              willfact := express (ferror, lp) ;
              level := level - 1 ;
              if ferror <> undef
                then
                  exit ;
              if lastpack^.token <> rightparen
                then
                  begin
                    ferror := e_rpar ;
                    exit
                  end ;
              scan
            end ;
          not_ :
            begin
              scan ;
              level := level + 1 ;
              p1 := factor (ferror, lp) ;
              level := level - 1 ;
              if ferror <> undef
                then
                  exit ;
              with p1^ do
                if p1^.conflag
                  then
                    case token of
                      boolvar : pvc_boolean := not pvc_boolean ;
                      charvar : pvc_char := not pvc_char ;
                      integvar .. lintvar :
                        pvc_longhex := not pvc_longhex
                      else
                        begin
                          ferror := e_itoo ;
                          exit
                        end
                    end
                  else
                    case token of
                      boolvar :
                        if lp.branch
                          then
                            begin
                              lp.post := revpost (lp.post) ;
                              do_swap
                            end 
                          else
                            begin
                              level := level + 1 ;
                              make_boolean (lp) ;
                              level := level - 1 ;
                              opcode (c_eorb) ;
                              post2t (p_imm, 1)
                              {eorb #1}
                            end ;
                      charvar : opcodet (c_comb) ;
                      hexvar, integvar :
                        begin
                          opcodet (c_comb) ;
                          opcodet (c_coma)
                        end ;
                      lhexvar, lintvar : hand (oper, $49)
                      else
                        begin
                          ferror := e_itoo ;
                          exit
                        end
                    end ;
              willfact := p1
            end ;
          nil_ :
            begin
              p1 := lastpack ;
              with p1^ do
                begin
                  token := hexvar ;
                  conflag := true ;
                  pointr := nil ;
                  pvc_hex := 0 ;
                  scan ;
                  willfact := p1
                end
            end ;
          false_ .. pi_ :
            begin
              p1 := lastpack ;
              with p1^ do
                begin
                  conflag := true ;
                  pointr := nil ;
                  case lastpack^.token of
                    false_ :
                      begin
                        token := boolvar ;
                        pvc_boolean := false
                      end ;
                    true_ :
                      begin
                        token := boolvar ;
                        pvc_boolean := true
                      end ;
                    maxint_ :
                      begin
                        token := integvar ;
                        pvc_integer := maxint
                      end ;
                    minint_ :
                      begin
                        token := integvar ;
                        pvc_integer := minint
                      end ;
                    maxlint_ :
                      begin
                        token := lintvar ;
                        pvc_longinteger := maxlint
                      end ;
                    minlint_ :
                      begin
                        token := lintvar ;
                        pvc_longinteger := minlint
                      end ;
                    e_ :
                      begin
                        token := realvar ;
                        pvc_longhex := $02adf852
                      end ;
                    pi_ :
                      begin
                        token := realvar ;
                        pvc_longhex := $02c90fda
                      end
                  end ;
                  willfact := p1 ;
                  scan
                end
            end ;
          vardef, funcdef : 
            begin
              level := level + 1 ;
              vdata ;
              level := level - 1
            end ;
          boolean_ .. real_, string_, enum_ : 
            begin
              level := level + 1 ;
              type_change ;
              level := level - 1
            end ;
          abs_ .. upshift_ : 
            begin
              level := level + 1 ;
              p1 := stand_func(ferror) ;
              if (ferror = undef) and (p1^.token = boolvar)
                then
                  lp.post := p_bb ;
              level := level - 1 ;
              willfact := p1
            end
          else
            if lastpack^.conflag
              then
                begin
                  willfact := lastpack ;
                  scan
                end
              else
                begin
                  willfact := lastpack ;
                  ferror := e_ui
                end
        end
      until true ;
      factor := willfact
    end ;

modend.
