module igen {$v3,1 generate icode} ;
{
  5/17/89 : initial conversion to level 3
  7/22/89 : debugger names stripped to 80 char, not 16
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/varib}

  const
    emtab = external array [#101 .. #127] of hex ;
    
  procedure optin ; external ;
    
  function module_check : boolean ; entry ;
    begin
      module_check := not (c_module and (lex = 1) 
                           and not override)
    end ;
    
  procedure outterm ; entry ;
    begin
      if icode_buf[0] <> 0
        then
          begin
            optin ;
            icode_buf[0] := 0
          end
    end ;

  procedure pass (s : string [120]) ; entry ;
    begin
      if icode_buf[0] = 0
        then
          icode_buf := char(c_pass) ;
      append(icode_buf, s)
    end ;
    
  procedure passt (s : string[120]) ; entry ;
    begin
      pass (s) ;
      outterm
    end ;
  
  procedure opcode (op : code_type) ; entry ;
    begin
      icode_buf[0] := 1 ;
      icode_buf[1] := char(op) ;
    end ;
    
  procedure opcodet (op : code_type) ; entry ;
    begin
      icode_buf[0] := 1 ;
      icode_buf[1] := char(op) ;
      outterm
    end ;
    
  procedure post1 (p1 : byte) ; entry ;
    begin
      append(icode_buf,p1) ;
    end ;
    
  procedure post2 (p1, p2 : byte) ; entry ;
    begin
      append(icode_buf,p1,p2)
    end ;
    
  procedure post1t (p1 : byte) ; entry ;
    begin
      append (icode_buf,p1) ;
      outterm
    end ;
    
  procedure post2t (p1, p2 : byte) ; entry ;
    begin
      append (icode_buf,p1,p2) ;
      outterm
    end ;
    
  procedure code_byte (c1 : byte) ; entry ;
    begin
      post1 (c1)
    end ;
    
  procedure codet_byte (c1 : byte) ; entry ;
    begin
      post1 (c1) ;
      outterm
    end ;
    
  procedure code_word (h : hex) ; entry ;
    begin
      post2 (byte(h >> $8), byte(h))
    end ;
    
  procedure codet_word (h : hex) ; entry ;
    begin
      code_word (h) ;
      outterm
    end ;
    
  procedure lab (s : string[120]) ; entry ;
    begin
      if s[0] > 8
        then
          s[0] := 8 ;
      pass (concat(s[0],s))
    end ;
    
  procedure labt (s : string[120]) ; entry ;
    begin
      if s[0] > 8
        then
          s[0] := 8 ;
      passt (concat(s[0],s))
    end ;
    
  procedure data_byte (b : byte) ; entry ;
    begin
      if icode_buf[0] = 0
        then
          icode_buf := char(c_data) ;
      append(icode_buf,b)
    end ;
    
  procedure datat_byte (b : byte) ; entry ;
    begin
      data_byte (b) ;
      outterm
    end ;
    
  procedure data_word (h : hex) ; entry ;
    begin
      data_byte (byte(h >> $8)) ;
      data_byte (byte(h))
    end ;
    
  procedure datat_word (h : hex) ; entry ;
    begin
      data_word (h) ;
      outterm
    end ;
    
  procedure data_long (l : longhex) ; entry ;
    begin
      data_word (hex(l >> $10L)) ;
      data_word (hex(l))
    end ;
    
  procedure datat_long (l : longhex) ; entry ;
    begin
      data_long (l) ;
      outterm
    end ;
    
  procedure datas (s : string[120]) ; entry ;
    begin
      if icode_buf[0] = 0
        then
          icode_buf := char(c_data) ;
      append(icode_buf,s)
    end ;
    
  procedure datast (s : string[120]) ; entry ;
    begin
      if icode_buf[0] = 0
        then
          icode_buf := char(c_data) ;
      append(icode_buf,s) ;
      outterm
    end ;
    
  procedure debname (s : string[120]) ; entry ;
    begin
      if s[0] > 80
        then
          s[0] := 80 ;
      pass (concat(s[0],s))
    end ;
    
  procedure debug (dtype : byte) ; entry ;
    begin
      icode_buf[0] := 2 ;
      icode_buf[1] := byte(c_bug) ;
      icode_buf[2] := dtype
    end ;
    
  procedure purge (labl : hex) ; entry ;
    begin
      icode_buf := concat(byte(c_purge),
                          byte(labl >> $8), byte(labl)) ;
      outterm
    end ;
    
  procedure line ; entry ;
    begin
      if not include_active
        then
          begin
            neststring[1] := '*' ;
            if debug_opt and new_num and debug_en
              then
                begin
                  icode_buf := concat(byte(c_line),
                     byte(line_number >> 8), byte(line_number)) ;
                  outterm ;
                  new_num := false
                end
          end
    end ;
    
  procedure hand (h : hand_type ; num : byte) ; entry ;
    type
      hand_array = array [#1..#52] of hand_entry ;
    var
      j : byte register ;
      p1 : ^hand_array register ;
    begin
      if module_check
        then
          begin
            opcode (c_xbxx) ;
            if h = ibra
              then
                post1 (p_rel + p_rell + p_reex + p_bra)
              else
                post1 (p_rel + p_rell + p_reex + p_bsr) ;
            case h of
              proc : 
                begin
                  p1 := addr (h_tab.prc) ;
                  append(icode_buf,#5,'prc')
                end ;
              oper : 
                begin
                  p1 := addr (h_tab.opr) ;
                  append(icode_buf,#5,'opr')
                end ;
              func : 
                begin
                  p1 := addr (h_tab.fnc) ;
                  append(icode_buf,#5,'fnc')
                end ;
              dev : 
                begin
                  p1 := addr (h_tab.dev) ;
                  case num of
                    0 : append(icode_buf,#6,'.input') ;
                    1 : append(icode_buf,#7,'.output') ;
                    2 : append(icode_buf,#7,'.auxout') ;
                    3 : append(icode_buf,#8,'.keyboar')
                    else append(icode_buf,#5,'.disk')
                  end
                end
              else 
                begin
                  p1 := addr (h_tab.int) ;
                  append(icode_buf,#5,'int')
                end
            end ;
            for j := 1 to 52 do
              if p1^[j].numb = num
                then
                  exit ;
            with p1^[j] do
              begin
                used := true ; {has now been called}
                if h <> dev
                  then
                    icode_buf := concat(icode_buf, 
                                        substr(string(hex(numb)),3,2)) ;
                outterm
              end
          end
    end ;
    
  procedure xclean ; entry ;
    type
      dummy = array [#1 .. #52] of hand_entry ;
    var
      h : hand_type ;
      max : byte register ;
      i : byte register ;
      count : byte register ;
      s : string[20] ;
      p1 : ^dummy register ;
    begin
      count := 0 ;
      for h := proc to dev do
        begin
          case h of
            proc : 
              begin
                p1 := addr (h_tab.prc) ;
                s := 'prc' ;
                max := 52
              end ;
            oper : 
              begin
                p1 := addr (h_tab.opr) ;
                s := 'opr' ;
                max := 48
              end ;
            func : 
              begin
                p1 := addr (h_tab.fnc) ;
                s := 'fnc' ;
                max := 52
              end ;
            dev : 
              begin
                p1 := addr (h_tab.dev) ;
                max := 8
              end
            else 
              begin
                p1 := addr (h_tab.int) ;
                s := 'int' ;
                max := 48
              end
          end ;
          for i := 1 to max do
            with p1^[i] do
              if used = true {has been called}
                then
                  begin
                    if count = 0
                      then
                        pass (' xref ')
                      else
                        pass (',') ;
                    if h = dev
                      then
                        begin
                          case numb of
                            0 : s := '.input' ;
                            1 : s := '.output' ;
                            2 : s := '.auxout' ;
                            3 : s := '.keyboar' ;
                            else s := '.disk'
                          end ;
                          pass (s)
                        end
                      else
                        pass (concat(s,
                           substr(string(hex(numb)),3,2))) ;
                    count := count + 1 ;
                    if count = 5
                      then
                        begin
                          outterm ;
                          count := 0
                        end
                  end
        end ;
      if count <> 0
        then
          outterm
    end ;
    
  procedure eminln (a : byte) ; entry ;
    type
      codegroup = string[20] ;
    var
      p1 : ^codegroup ;
    begin
      p1 := addr(emtab) + longhex(emtab[a]) ;
      while p1^[0] <> 0 do
        begin
          icode_buf := p1^ ;
          outterm ;
          p1 := p1 + longhex(p1^[0] + 1)
        end
    end ;
    
  procedure ldaim (v : byte) ; entry ;
    begin
      if v = 0
        then
          opcodet (c_clra)
        else
          begin
            opcode (c_lda) ;
            post2t (p_imm, v)
          end
    end ;
    
  procedure ldbim (v : byte) ; entry ;
    begin
      if v = 0
        then
          opcodet (c_clrb)
        else
          begin
            opcode (c_ldb) ;
            post2t (p_imm, v)
          end
    end ;
    
  procedure lddim (v : hex) ; entry ;
    begin
      if v = 0
        then
          begin
            opcodet (c_clra) ;
            opcodet (c_clrb)
          end
        else
          begin
            opcode (c_ldd) ;
            post1 (p_imm) ;
            codet_word (v)
          end
    end ;
modend.
