module labcon {$v3,0 labels and constants} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function enter_symbol (s : string[120] ; restrict : boolean ;
                         var headaddr : ^symhead) : boolean ; external ;
  procedure skiperror (e : error_type ; toke : tokes) ; external ;
  procedure semilook (e : error_type) ; external ;
  function simple (var serror : error_type ; var lp : labpack) : ^packet ; external ;
  procedure replace (e : error_type ; t : token_type) ; external ;
  procedure symdone (p : ^symhead) ; external ;
  function labout (h : hex) : string[4] ; external ;
  procedure out_false (level : byte) ; external ;
  procedure out_true (level : byte) ; external ;
  
{
  return next internal name
}
  function get_internal : hex ; entry ;
    begin
      get_internal := internal_name ;
      internal_name := succ (internal_name)
    end ;
{
  convert integer to 5 digit label
}
  function digit5 (i : integer) : string[5] ; entry ;
    var
      s : string[5] ;
    begin
      s := string(i) ;
      while s[0] <> 5 do
        s := concat ('0',s) ;
      digit5 := s
    end ;
{
  handle label declarations
}
  procedure label_decl ; entry ;
    var
      p1 : ^symhead ;
      p2 : ^token_type register ;
    begin
      scan ;
      nesting := succ (nesting) ;
      repeat
        if lastpack^.token = integvar
          then
            if enter_symbol (digit5(lastpack^.pvc_integer),true,p1)
              then
                begin
                  semilook (e_iddt) ;
                  exit
                end
              else
                begin
                  with p1^ do
                    begin
                      intname := get_internal ;
                      idgroup := labeldef ;
                      p2 := p1 + align(sizeof(symhead)) ;
                      p2^ := termit ;
                      symdone(p1) ;
                      next_sym := p2 + 2
                    end ;
                  scan ;
                  case lastpack^.token of
                    comma : scan ;
                    semicolon : exit ;
                    else
                      begin
                        semilook (e_semi) ;
                        exit
                      end
                  end
                end
          else
            begin
              semilook (e_integ) ;
              exit
            end
      until false ;
      scan ; {get reserved word after ;}
      nesting := pred (nesting)
    end ;
{
  return a constant, assumes start of constant is
  already in lastpack.
}
  function aconstant (var cerror : error_type) : ^packet ; entry ;
    var
      p1 : ^packet register ;
      lp1 : labpack ;
    begin
      lp1.branch := false ;
      lp1.post := p_bnd ;
      p1 := simple (cerror, lp1) ;
      if (cerror = undef) and not p1^.conflag
        then
          cerror := e_icon ;
      aconstant := p1
    end ;
{
  return a constant, fetches the first token of the
  constant from the scanner.
}
  function constant (var cerror : error_type) : ^packet ; entry ;
    begin
      scan ;
      constant := aconstant (cerror)
    end ;
{
  handle constant declarations
}
  procedure const_decl ; entry ;
    var
      p1 : ^symhead ;
      p2 : ^packet register ;
      p3 : ^anystring register ;
      p : manypt ;
      lerror : error_type ;
      i : byte register ;
    begin
      scan ;
      nesting := succ (nesting) ;
      repeat
        if ident_flag
          then
            if enter_symbol (last_ident, true, p1)
              then
                semilook (e_iddt)
              else
                begin
                  scan ; {get equal}
                  if not (lastpack^.token in [equal, colon, assign])
                    then
                      semilook (e_equal)
                    else
                      begin
                        if lastpack^.token <> equal
                          then
                            replace (e_equal, equal) ;
                        p2 := constant (lerror) ;
                        if lerror = undef
                          then
                            with p1^, p2^ do
                              begin
                                idgroup := constdef ;
                                p.tk := p1 + align(sizeof(symhead)) ;
                                p.tk^ := token ; {put type in}
                                p.bl := p.tk + 1 ;
                                if token in [integvar .. realvar]
                                  then
                                    p.bl := p.bl + 1 ; {align to word}
                                case token of
                                  boolvar, charvar, enumvar :
                                    begin
                                      p.bl^ := pvc_boolean ;
                                      p.bl := p.bl + 1
                                    end ;
                                  integvar, hexvar :
                                    begin
                                      p.int^ := pvc_integer ;
                                      p.int := p.int + 2
                                    end ;
                                  lhexvar, lintvar, realvar :
                                    begin
                                      p.li^ := pvc_longinteger ;
                                      p.li := p.li + 4
                                    end ;
                                  stringvar :
                                    begin
                                      for i := 0 to pvc_string^[0] do
                                        begin
                                          p.ch^ := pvc_string^[i] ;
                                          p.ch := p.ch + 1
                                        end ;
                                      pointr := nil
                                    end
                                end ;
                                p.tk^ := termit ;
                                symdone(p1) ;
                                next_sym := (p.tk + 2) and $FFFFFFFE ;
                                heapptr := heapstart ;
                                if lastpack^.token <> semicolon
                                  then
                                    semilook (e_semi)
                              end
                          else
                            semilook (lerror)
                      end
                end
          else
            semilook (e_id) ;
        scan {get token after ;}
      until lastpack^.token in [array_ .. with_] ;
      nesting := pred (nesting)
    end ;
    
modend.
