module opt (output) {$v3,0 optimize icode} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
  const
    size_opt = 20 ;
  type
    status = record
               rchng : byte ;
               rset : byte ;
               aval, bval : byte ;
               loc : hex
             end ;

    code_tab_entry = record
                       regmod : mod_type ;
                       routine : byte ;
                       name : array[#1 .. #4] of char
                     end ;

    opt_type = record
                 next : ^opt_type ;
                 rec_id : longhex ;
                 icode : anystring
               end ;
              
  const
    codetab = external array[code_type] of code_tab_entry ;
    op_flag = external boolean ;
  var varib
    opt_change : boolean  ;
    opt_vptr : ^anystring  ;
    opt_base, opt_free, opt_1, opt_2, opt_3 : ^opt_type  ;
    optq : array [0 .. size_opt] of opt_type  ;
    rec_id : longhex  ;
    alternate : array [0 .. size_opt] of record
                                           rec_id : longhex ;
                                           icode : anystring
                                         end  ;
    altin, altout, altcount : integer  ;
    now : status  ;

  procedure native ; external ;
  function module_check : boolean ; external ;
  procedure error (errnum : error_type) ; external ;
  procedure icodeout ; external ;
  procedure terminate ; external ;
  
  procedure remove (p : ^opt_type) ;
    var
      x, y : ^opt_type register ;
    begin
      opt_change := true ;
      x :=opt_base ;
      if p = opt_base {if first record, special handling}
        then
          opt_base := x^.next
        else
          begin
            while x^.next <> p do {move until correct record}
              x := x^.next ;
            y := x^.next ; {put forward line in previous record}
            x^.next := y^.next ;
            x := p
          end ;
      y := opt_free ; {put record in free list}
      opt_free := x ;
      x^.next := y
    end ;
    
  procedure altdump ;
    begin
      icode_buf := alternate[altout].icode ;
      if out_opt
        then
          native
        else
          icodeout ;
      icode_buf := '' ;
      altout := altout + 1 ;
      if altout > size_opt
        then
          altout := 0 ;
      altcount := altcount - 1
    end ;

  procedure action (var sp : status ; rp : ^opt_type) ;
    type
      extname = string[5] ;
    var
      p1 : ^extname ;
    const
      tfrtab = local array [#0 .. #3] of byte (1, 2, 4, 3) ;
    begin
      sp.loc := sp.loc + 4 ;
      case codetab[enum(rp^.icode[1])].regmod of
        moda :
          begin
            sp.rchng := sp.rchng or %001 ;
            sp.rset := sp.rset and %110
          end ;
        modb :
          begin
            sp.rchng := sp.rchng or %010 ;
            sp.rset := sp.rset and %101
          end ;
        modd :
          begin
            sp.rchng := sp.rchng or %011 ;
            sp.rset := sp.rset and %100
          end ;
        modx :
          begin
            sp.rchng := sp.rchng or %100 ;
            sp.rset := sp.rset and %011
          end ;
        modall :
          begin
            sp.rchng := sp.rchng or %111 ;
            sp.rset := sp.rset and %000
          end ;
        modata :
          sp.loc := sp.loc + hex(rp^.icode[0]) - 5 ;
        mpull :
          begin
            sp.rchng := sp.rchng or rp^.icode[2] ;
            sp.rset := sp.rset and not rp^.icode[2]
          end ;
        mtfr :
          begin
            sp.rchng := sp.rchng or tfrtab[rp^.icode[2]] ;
            sp.rset := sp.rset and not tfrtab[rp^.icode[2]]
          end ;
        mxbxx :
          if rp^.icode[2] and $f = p_bsr
            then
              begin
                p1 := addr(rp^.icode[3]) ;
                if (rp^.icode[2] = p_bsr + p_rell + p_reex) and
                   (rp^.icode[3] = 5) and (p1^ = 'int26')
                  then
                    begin
                      sp.rchng := sp.rchng or %100 ;
                      sp.rset := sp.rset and %011
                    end
                  else
                    begin
                      sp.rchng := sp.rchng or %111 ;
                      sp.rset := sp.rset and  %000
                    end
              end ;
        mclra :
          begin
            sp.rchng := sp.rchng or 1 ;
            sp.rset := sp.rset or 1 ;
            sp.aval := 0
          end ;
        mclrb :
          begin
            sp.rchng := sp.rchng or 2 ;
            sp.rset := sp.rset or 2 ;
            sp.bval := 0
          end ;
        mlda :
          begin
            sp.rchng := sp.rchng or 1 ;
            if rp^.icode[2] = p_imm
              then
                begin
                  sp.rset := sp.rset or 1 ;
                  sp.aval := rp^.icode[3]
                end
              else
                sp.rset := sp.rset and %110
          end ;
        mldb :
          begin
            sp.rchng := sp.rchng or 2 ;
            if rp^.icode[2] = p_imm
              then
                begin
                  sp.rset := sp.rset or 2 ;
                  sp.bval := rp^.icode[3]
                end
              else
                sp.rset := sp.rset and %101
          end ;
        mldd :
          begin
            sp.rchng := sp.rchng or 3 ;
            if rp^.icode[2] = p_imm
              then
                begin
                  sp.rset := sp.rset or 3 ;
                  sp.aval := rp^.icode[3] ;
                  sp.bval := rp^.icode[4]
                end
              else
                sp.rset := sp.rset and %100
          end ;
        mldx :
          begin
            sp.rchng := sp.rchng or 4 ;
            if (rp^.icode[2] = p_idx + p_ixry + p_ixfx) and
               (rp^.icode[3] = $ff) and (rp^.icode[4] = $fa)
              then
                sp.rset := sp.rset or 4
              else
                sp.rset := sp.rset and %011
          end ;
        minca :
          if sp.rset and 1 <> 0
            then
              sp.aval := sp.aval + 1
            else
              sp.rchng := sp.rchng or 1 ;
        mincb :
          if sp.rset and 2 <> 0
            then
              sp.bval := sp.bval + 1
            else
              sp.rchng := sp.rchng or 2 ;
        mdeca :
          if sp.rset and 1 <> 0
            then
              sp.aval := sp.aval - 1
            else
              sp.rchng := sp.rchng or 1 ;
        mdecb :
          if sp.rset and 2 <> 0
            then
              sp.bval := sp.bval - 1
            else
              sp.rchng := sp.rchng or 2
      end
    end ;
    
{
  dump first output record as either icode or
  native code
}
  procedure dump1 ;
    begin
      while (altcount <> 0) and (alternate[altout].rec_id <= opt_base^.rec_id) do
        altdump ;
      action (now, opt_base) ;
      icode_buf := opt_base^.icode ;
      remove (opt_base) ;
      if out_opt
        then
          native
        else
          icodeout ;
      icode_buf[0] := 0
    end ;
    
  procedure pushpull ;
    var
      st1 : status ;
    begin
      opt_2 := opt_1 ;
      st1.rchng := 0 ;
      repeat
        if opt_2^.next = nil
          then
            exit ;
        opt_2 := opt_2^.next ;
        if (opt_2^.icode[1] = byte(c_pulu)) and 
           (opt_1^.icode[2] = opt_2^.icode[2])
          then
            if opt_1^.icode[2] and st1.rchng = 0
              then
                begin
                  remove (opt_2) ;
                  remove (opt_1) ;
                  opt_1 := opt_base ;
                  exit
                end
              else
                exit ;
        action (st1, opt_2)
      until false
    end ;

  procedure addoff ;
    var
      h1, h2 : hex ;
    begin
      if (opt_1^.icode[1] = byte(c_leax)) and
         (opt_1^.icode[2] and 7 = 0)
        then
          begin
            opt_2 := opt_1 ;
            repeat
              if opt_2^.next = nil
                then
                  exit ;
              opt_2 := opt_2^.next ;
              if opt_2^.icode[1] > byte(c_purge)
                then
                  if ((opt_2^.icode[1] = byte(c_leax)) or
                     (opt_2^.icode[1] = byte(c_ldx))) and
                     (opt_2^.icode[2] = p_idx + p_ixfx)
                    then
                      begin
                        h1 := hex(opt_1^.icode[3]) << 8 + hex(opt_1^.icode[4]) ;
                        h2 := hex(opt_2^.icode[3]) << 8 + hex(opt_2^.icode[4]) ;
                        h1 := h1 + h2 ;
                        opt_1^.icode[3] := byte(h1 >> 8) ;
                        opt_1^.icode[4] := byte(h1) ;
                        opt_1^.icode[1] := opt_2^.icode[1] ;
                        remove (opt_2) ;
                        if opt_1^.icode[1] <> byte(c_ldx)
                          then
                            opt_2 := opt_1
                          else
                            exit
                      end
                    else
                      exit
            until false
          end
    end ;

  procedure fold ;
    type
      extname = string[5] ;
    var
      tflag, val : byte ;
      p1 : ^extname ;
      temp : hex ;
    begin
      repeat
        tflag := 0 ;
        if opt_1 = nil
          then
            exit ;
        opt_2 := opt_1 ;
        repeat
          if opt_1^.icode[1] = byte(c_leax)
            then
              exit ;
          tflag := 1 ;
          if opt_1^.icode[1] = byte(c_ldx)
            then
              begin
                if opt_1^.icode[2] and (p_idx + p_idxi) = p_idx
                  then
                    exit ;
                tflag := 2 ;
                if opt_1^.icode[2] = p_imm
                  then
                    exit
                  else
                    exit (2)
              end
            else
              begin
                tflag := 3 ;
                p1 := addr(opt_1^.icode[3]) ;
                if (opt_1^.icode[2] = p_rell + p_reex + p_bsr) and
                   (opt_1^.icode[3] = 5) and (p1^ = 'int26')
                  then
                    begin
                      opt_2 := opt_1^.next ;
                      if opt_2 = nil
                        then
                          exit (2) ;
                      val := opt_2^.icode[2] ;
                      opt_3 := opt_2 ;
                      exit
                    end
                  else
                    exit (2)
              end
        until true ;    
        repeat
          if opt_2^.next = nil
            then
              exit (2) ;
          opt_2 := opt_2^.next ;
          if (opt_2^.icode[2] = p_idx + p_ixrx + p_ixz) and
             (opt_2^.icode[1] in [c_lda..c_ldx,c_stb..c_stx])
            then
              begin
                opt_1^.icode[1] := opt_2^.icode[1] ;
                case tflag of
                  1 : opt_1^.icode[2] := opt_1^.icode[2] or p_idxi ;
                  2 : opt_1^.icode[2] := opt_1^.icode[2] or p_abs ;
                  3 :
                    begin
                      opt_1^.icode[2] := p_abs + p_dir ;
                      opt_1^.icode[3] := 0 ;
                      opt_1^.icode[4] := val ;
                      opt_1^.icode[0] := 4 ;
                      remove (opt_3)
                    end
                end ;
                remove (opt_2) ;
                exit
              end
          else if (tflag = 2) and (opt_2^.icode[2] = p_idx + p_ixrx + p_ixfx)
                  and (opt_2^.icode[1] in [c_lda .. c_ldd, c_stb .. c_std])
            then
              begin
                opt_1^.icode[1] := opt_2^.icode[1] ;
                opt_1^.icode[2] := opt_1^.icode[2] or p_abs ;
                temp := hex(opt_1^.icode[3]) << 8 + hex(opt_1^.icode[4]) ;
                temp := hex(opt_2^.icode[3]) << 8 + hex(opt_2^.icode[4]) + temp ;
                opt_1^.icode[3] := byte(temp >> 8) ;
                opt_1^.icode[4] := byte(temp) ;
                remove (opt_2) ;
                exit
              end
            else
              exit (2)
        until false
      until true
    end ;

  procedure regman ;
    var
      st1, st2 : status ;
      mask : byte ;
    begin
      repeat
        opt_1 := opt_base ;
        st1 := now ;
        if opt_1 = nil
          then
            exit ;          
        repeat
          repeat
            st1.rchng := 0 ;
            st2 := st1 ;
            action (st2, opt_1) ;
            mask := st2.rchng and st2.rset and st1.rset ;
            if mask and 4 <> 0
              then
                begin {x register reset to -6,y}
                  remove (opt_1) ;
                  opt_1 := opt_base ;
                  exit (2)
                end
            else if mask and 3 = 3
              then
                begin {d register reset}
                  if (st1.aval = st2.aval) and (st1.bval = st2.bval)
                    then
                      begin {d register set to same value}
                        remove (opt_1) ;
                        opt_1 := opt_base ;
                        exit (2)
                      end
                  else if (st1.aval = st2.aval)
                    then
                      begin {a register change not needed, set to ldb}
                        opt_1^.icode[0] := 3 ;
                        opt_1^.icode[1] := byte(c_ldb) ;
                        opt_1^.icode[3] := opt_1^.icode[4] ;
                        opt_change := true ;
                        exit
                      end
                  else if (st1.bval = st2.bval)
                    then
                      begin {b register change not needed, set to lda}
                        opt_1^.icode[0] := 3 ;
                        opt_1^.icode[1] := byte(c_lda) ;
                        opt_change := true ;
                        exit
                      end
                    else
                      exit
                end
              else
                begin
                  mask := st2.rchng and st2.rset and 3 ;
                  if mask = 1
                    then
                      if st1.rset and mask <> 0
                        then
                          if st1.aval = st2.aval
                            then
                              begin {already set to that value}
                                remove (opt_1) ;
                                opt_1 := opt_base ;
                                exit (3)
                              end
                          else if st2.aval <> 0
                            then
                              if st2.aval - st1.aval = 1
                                then
                                  begin {change to inca}
                                    opt_1^.icode[0] := 1 ;
                                    opt_1^.icode[1] := byte(c_inca) ;
                                    opt_change := true ;
                                    exit
                                  end
                              else if st1.aval - st2.aval = 1
                                then
                                  begin {change to deca}
                                    opt_1^.icode[0] := 1 ;
                                    opt_1^.icode[1] := byte(c_deca) ;
                                    opt_change := true ;
                                    exit
                                  end
                                else
                                  exit ;
                  if mask = 2
                    then
                      if st1.rset and mask <> 0
                        then
                          if st1.bval = st2.bval
                            then
                              begin {already set to that value}
                                remove (opt_1) ;
                                opt_1 := opt_base ;
                                exit (3)
                              end
                          else if st2.bval <> 0
                            then
                              if st2.bval - st1.bval = 1
                                then
                                  begin {change to incb}
                                    opt_1^.icode[0] := 1 ;
                                    opt_1^.icode[1] := byte(c_incb) ;
                                    opt_change := true ;
                                    exit
                                  end
                              else if st1.bval - st2.bval = 1
                                then
                                  begin {change to decb}
                                    opt_1^.icode[0] := 1 ;
                                    opt_1^.icode[1] := byte(c_decb) ;
                                    opt_change := true ;
                                    exit
                                  end
                                else
                                  exit ;
                end
          until true ;
          st1 := st2 ;
          if opt_1 = nil
            then
              exit (2) ;
          opt_1 := opt_1^.next ;
          if opt_1 = nil
            then
              exit (2)
        until false
      until false
    end ;

  procedure long ;
    var
      equfirst : boolean ;
      lab1, lab2 : byte ;
      st1 : status ;
    begin
      repeat
        if (opt_1^.icode[1] = byte(c_equ)) and (opt_1^.icode[2] = p_eqlp)
          then
            equfirst := true
        else if (opt_1^.icode[1] = byte(c_xbxx)) and (opt_1^.icode[2] and $f0 = p_rell)
          then
            equfirst := false
          else
            exit ;
        lab1 := opt_1^.icode[3] ;
        lab2 := opt_1^.icode[4] ;
        st1.loc := 0 ;
        opt_2 := opt_1 ;
        repeat
          opt_2 := opt_2^.next ;
          if opt_2 = nil
            then
              exit (2) ;
          if st1.loc > 120
            then
              exit (2) ;
          if (equfirst and (opt_2^.icode[1] = byte(c_xbxx)) and
             (opt_2^.icode[2] and $f0 = p_rell) or
             not equfirst and (opt_2^.icode[1] = byte(c_equ)) and
             (opt_2^.icode[2] = p_eqlp)) and
             (lab1 = opt_2^.icode[3]) and (lab2 = opt_2^.icode[4])
            then
              begin
                if equfirst
                  then
                    opt_2^.icode[2] := opt_2^.icode[2] and ($ff - p_rell)
                  else
                    opt_1^.icode[2] := opt_1^.icode[2] and ($ff - p_rell) ;
                opt_change := true
              end ;
          action (st1, opt_2)
        until false
      until true
    end ;

  procedure stack ;
    var
      temp0, temp3, temp5, temp7, temp9 : ^opt_type ;
      op : byte ;
      sizeflag : boolean register ;
      
    procedure chgcmp ;
      const
        newbr = local array [p_bra .. p_ble] of byte 
          (p_bra, p_bsr, p_blo, p_bhs, p_bls, p_bhi, p_bne, p_beq,
           p_bvc, p_bvs, p_bpl, p_bmi, p_ble, p_bgt, p_blt, p_bge) ;
      begin
        temp7 := temp5^.next ;
        if (temp7 <> nil) and (temp7^.icode[1] = byte(c_xbxx))
          then
            begin
              temp7^.icode[2] := temp7^.icode[2] and $f0 or
                    newbr[hex(temp7^.icode[2] and $f)] ; {reverse branch}
              op := temp5^.icode[1] ;
              remove (temp5) ;
              remove (temp0) ;
              temp3^.icode[1] := op ;
              opt_1 := opt_base
            end
      end ;
      
    procedure finish (t1 : ^opt_type ; opr : byte) ;
      begin
        remove (t1) ;
        remove (temp5) ;
        remove (temp0) ;
        temp3^.icode[1] := opr ;
        opt_1 := opt_base
      end ;
      
    begin {stack}
      temp0 := opt_1 ;
      repeat
        if opt_1^.icode[1] <> byte(c_pshu)
          then
            exit ;
        if opt_1^.icode[2] = p_ipb
          then
            sizeflag := false
        else if opt_1^.icode[2] = p_ipd
          then
            sizeflag := true
          else
            exit ;
        opt_2 := opt_1 ;
        repeat
          opt_2 := opt_2^.next ;
          if opt_2 = nil
            then
              exit (2) ;
          if (opt_2^.icode[1] >= byte(c_purge)) and
             (opt_2^.icode[1] <> byte(c_ldx))
            then
              exit
        until false ;
        if sizeflag and (opt_2^.icode[1] = byte(c_ldd)) or
           not sizeflag and (opt_2^.icode[1] = byte(c_ldb))
          then
            begin
              temp3 := opt_2 ;
              temp5 := opt_2^.next ;
              if temp5 = nil
                then
                  exit ;
              if sizeflag
                then
                  if temp5^.icode[2] = p_idx + p_ixru + p_ixpp
                    then
                      if temp5^.icode[1] = byte(c_addd)
                        then
                          begin
                            remove (temp5) ;
                            remove (temp0) ;
                            temp3^.icode[1] := byte(c_addd) ;
                            opt_1 := opt_base ;
                            exit
                          end
                      else if temp5^.icode[1] = byte(c_subd)
                        then
                          begin
                            chgcmp ;
                            exit
                          end
                        else
                          exit
                    else
                      exit
                else
                  if temp5^.icode[1] = byte(c_coma)
                    then
                      begin
                        temp7 := temp5^.next ;
                        if (temp7 = nil) or (temp7^.icode[1] <> byte(c_comb))
                          then
                            exit ;
                        temp9 := temp7^.next ;
                        if temp9 = nil
                          then
                            exit ;
                        opt_3 := temp9^.next ;
                        if opt_3 = nil
                          then
                            exit ;
                        if (temp9^.icode[1] = byte(c_addd)) and (temp9^.icode[2] = p_imm) and
                           (temp9^.icode[3] = 0) and (temp9^.icode[4] = 1) and
                           (opt_3^.icode[1] = byte(c_addd)) and (opt_3^.icode[2] = p_idx + p_ixru + p_ixpp)
                          then
                            begin
                              remove (opt_3) ;
                              remove (temp9) ;
                              finish (temp7, byte(c_subd))
                            end
                          else
                            exit
                      end
                    else if (temp5^.icode[0] > 1) and (temp5^.icode[2] = p_idx + p_ixru + p_ixp)
                      then
                        if temp5^.icode[1] in [c_andb, c_eorb, c_orb, c_addb]
                          then
                            begin
                              op := temp5^.icode[1] ;
                              remove (temp5) ;
                              remove (temp0) ;
                              temp3^.icode[1] := op ;
                              opt_1 := opt_base ;
                              exit
                            end
                        else if temp5^.icode[1] = byte(c_subb)
                          then
                            chgcmp
                          else
                            exit
                      else if temp5^.icode[1] = byte(c_negb)
                        then
                          begin
                            opt_3 := temp5^.next ;
                            if opt_3 = nil
                              then
                                exit ;
                            if (opt_3^.icode[1] = byte(c_addb)) and
                               (opt_3^.icode[2] = p_idx + p_ixru + p_ixp)
                              then
                                finish (opt_3, byte(c_subb))
                              else
                                exit
                          end
            end
      until true
    end ;
    
  procedure optit ;
    var
      count : integer ;
    begin
      regman ;
      repeat
        opt_change := false ;
        opt_1 := opt_base ;
        count := 0 ;
        repeat
          if opt_1 <> nil
            then
              case enum(opt_1^.icode[1]) of
                c_pshu :
                  if odd(count)
                    then
                      pushpull
                    else
                      stack ;
                c_leax :
                  if odd(count)
                    then
                      addoff
                    else
                      fold ;
                c_ldx : fold ;
                c_xbxx :
                  if odd(count)
                    then
                      fold
                    else
                      long ;
                c_equ : long ;
                else
                  exit
              end
            else
              exit ;
          count := count + 1
        until count > 3 ;
        count := 0 ;
        repeat
          count := count + 1 ;
          if opt_1 = nil
            then
              exit ;
          opt_1 := opt_1^.next ;
          if opt_1 <> nil
            then
              case enum(opt_1^.icode[1]) of
                c_pshu :
                  if odd(count)
                    then
                      pushpull
                    else
                      stack ;
                c_leax :
                  if odd(count)
                    then
                      addoff
                    else
                      fold ;
                c_ldx : fold
              end
            else
              exit (2)
        until count > 3
      until not opt_change
    end ;
{
  dump all records
}
  procedure dump ; entry ;
    begin
      while opt_base <> nil do
        begin
          if op_flag
            then
              repeat
                opt_change := false ;
                optit
              until not opt_change ;
          dump1
        end ;
      while altcount <> 0 do
        altdump ;
      now.rset := 0
    end ;
{
  optimize, first put new record in table at end
}
  procedure optimize ;
    var
      x, y : ^opt_type register ;
    begin
      repeat
        if not debug_opt and (icode_buf[1] in [c_bug,c_line])
          then
            exit ;
        if include_active and (icode_buf[1] = byte(c_line))
          then
            exit ;
        if icode_buf[1] <> byte(c_pass)
          then
            begin
              y := opt_free ;
              opt_free := opt_free^.next ;
              if opt_base = nil
                then
                  opt_base := y
                else
                  begin
                    x := opt_base ;
                    while x^.next <> nil do
                      x := x^.next ; {find last one}
                    x^.next := y {extend link}
                  end ;
              y^.next := nil ; {end of table}
              y^.icode := icode_buf ;
              y^.rec_id := rec_id ;
              rec_id := rec_id + 1 ;
              now.loc := 0 ;
              if op_flag
                then
                  while opt_free = nil do
                    begin
                      opt_change := false ;
                      optit ;
                      if not opt_change
                        then
                          begin
                            if opt_free = nil
                              then
                                dump1 ;
                            exit
                          end
                    end
                else
                  dump1
            end
          else
            begin {pass record, store elsewhere}
              alternate[altin].icode := icode_buf ;
              alternate[altin].rec_id := rec_id ;
              altin := altin + 1 ;
              if altin > size_opt
                then
                  altin := 0 ;
              altcount := altcount + 1 ;
              while altcount = size_opt do
                altdump
            end
      until true
    end ;
{
  setup linkages within table and set optimizer
  variables
}
  procedure opset ; entry ;
    var
      i : integer register ;
    begin
      opt_vptr := addr (vbuf) ;
      opt_free := addr (optq[0]) ;
      opt_base := nil ;
      for i := 0 to size_opt-1 do
        optq[i].next := addr (optq[i+1]) ;
      optq[size_opt].next := nil ;
      altin := 0 ;
      altout := 0 ;
      altcount := 0 ;
      rec_id := 0 ;
      now.rset := 0 ;
    end ;
{
  put record in icode_buf into optimizer or variable
  buffer
}
  procedure optin ; entry ;
    begin
      if (out_opt or debug_opt or icode_opt or relo_opt) and module_check
        then
          if var_access
            then
              begin
                opt_vptr^ := icode_buf ;
                opt_vptr := opt_vptr + longhex(icode_buf[0]+1) ;
                if integer(opt_vptr - addr(vbuf)) >= size_vbuf
                  then
                    begin
                      error (e_vbo) ;
                      terminate
                    end
              end
            else
              optimize
    end ;
{
  get records out of vbuf and optimize them
}    
  procedure vget ; entry ;
    var
      p1 : ^anystring register ;
    begin
      p1 := addr (vbuf) ;
      while p1 < opt_vptr do
        begin
          icode_buf := p1^ ;
          p1 := p1 + longhex(icode_buf[0]+1) ;
          optin
        end ;
      opt_vptr := addr (vbuf)
    end ;
{$d-}    
  procedure dumpq ; entry ;
    begin
      opt_3 := opt_base ;
      while opt_3 <> nil do
        begin
          icode_buf := opt_3^.icode ;
          native ;
          opt_3 := opt_3^.next
        end
    end ;
    
modend.
