module parse {$v3,2 program parse} ;
{
  5/16/89 : initial conversion to level 3
  6/7/89 : put out stack/heap sizes in object code
  7/22/89 : icode version number changed. changes for
  multi-tasking procedures.
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  const
    xpcvers = external string[5] ;
    oldtask = external boolean ;

  procedure xclean ; external ;
  procedure dump ; external ;
  procedure scan ; external ;
  function debtype (sympt : ^symhead ; p : manypt ;
                   nflag, rflag : boolean) : longhex ; external ;
  procedure symdone (p : ^symhead) ; external ;
  
  procedure syserror (errnum : error_type ; chk : boolean) ; external ;
  procedure error (errnum : error_type) ; entry ;
    begin
      syserror (errnum, true)
    end ;

  procedure syserrorpt (errnum : error_type ; offset : integer) ; external ;
  procedure errorpt (errnum : error_type) ; entry ;
    begin
      syserrorpt (errnum, integer(start_token - addr(input_buf))) ;
    end ;
    
  procedure up_line ; external ;
  procedure skiperror (e : error_type ; toke : tokes) ; external ;
  function module_check : boolean ; external ;
  function enter_symbol (s : string[120] ; restrict : boolean ;
                         var headaddr : ^symhead) : boolean ; external ;
  function sym_search (s : string[120] ; restrict : boolean) : ^packet ;
                                                          external ;
  procedure listout (s : string[120]) ; external ;
  procedure push_pointer (p : ^symhead) ; external ;
  procedure label_decl ; external ;
  procedure const_decl ; external ;
  procedure type_decl ; external ;
  procedure var_decl (reccall : boolean) ; external ;
  procedure proc_decl (var blk : hex ; var jump_flag : boolean ;
                                    func_flag : boolean) ; external ;
  procedure statements (var gerror : error_type) ; external ;
  
  procedure init_device (p1: ^type_device_head; s : string[8]) ; entry ;
    begin
      with p1^ do
        begin
          ldaim (attr) ; {lda #mode}
          case mode of
            nor_file : hand (dev, #4) ;
            nor_dev :
              begin
                passt (concat(' xref ',s)) ;
                opcode (c_xbxx) ;
                post1 (p_bsr + p_rel + p_rell + p_reex) ;
                labt (s) {lbsr name}
              end ;
            abs_dev :
              begin
                opcode (c_jsr) ;
                post1 (p_abs) ;
                codet_word (init) {jsr $address}
              end
          end
        end
    end ;
{
  allocate standard i/o devices, move user stack pointer
  if needed, initialize standard i/o devices if needed,
  initialize devices if neccessary.
}
  procedure varib_set (prc : ^symhead) ; 
    var
      p1 : ^packet ;
      p2 : ^type_device_head ;
      p3 : ^symhead ;
      loc : hex register ;
      s : string[12] ;
      k : token_type register ;
      i : integer register ;
      p4 : ^byte ;
      p5 : manypt ;
      p6 : ^proc_head ;
      b : byte ;
      temp : hex ;
      
    procedure set_std_name (k : token_type) ;
      begin
        case k of
          input_ : s := 'input' ;
          output_ : s := 'output' ;
          auxout_ : s := 'auxout' ;
          keyboard_ : s := 'keyboard'
        end ;
        p1 := sym_search (s, false) ;
        p2 := p1^.pv_device ;
        p3 := p1^.pointr
      end ;
      
    begin
      var_occured := true ;
      if (lex = #1) and not c_module
        then
          for k := input_ to keyboard_ do
            if k in stddev
              then
                begin
                  set_std_name (k) ;
                  alloc := p2^.size + alloc ;
                  p3^.offset := alloc
                end ;
      if lex = #1 {global}
        then
          if alloc <> local_size
            then
              begin
                opcode (c_leau) ;
                post1 (p_idx + p_ixru + p_ixfx) ;
                codet_word (local_size - alloc) ; {leau offset,u}
                hand (int, #5) {bsr int05}
              end
            else
        else
          if prc <> nil
            then
              begin
                p6 := prc + align(sizeof(symhead)) ;
                if p6^.func_size <> 0
                  then
                    begin
                      opcode (c_leau) ;
                      post1 (p_idx + p_ixru + p_ixfx) ;
                      if p6^.func_size > $7fff
                        then
                          codet_word (p6^.func_size)
                        else
                          codet_word (0 - p6^.func_size)
                      {leau $offset,u}
                    end ;
                if p6^.comp_status = proc_exc_in
                  then
                    begin
                      if alloc <> local_size
                        then
                          begin
                            opcode (c_leau) ;
                            post1 (p_idx + p_ixru + p_ixfx) ;
                            codet_word (local_size - alloc) ; {leau offset,u}
                          end
                    end
                  else if intask and (lex = 2)
                    then
                      begin
                        lddim (p6^.param_size - p6^.func_size) ;
                        {ldd #param}
                        opcode (c_ldx) ;
                        post1 (p_imm) ;
                        codet_word (alloc) ;
                        {ldx #local}
                        hand (int, $52)
                      end
                  else if intask and (lex <> 2) and oldtask
                    then
                      begin
                        hand (int, $54) ;
                        if alloc <> local_size
                          then
                            begin
                              opcode (c_leau) ;
                              post1 (p_idx + p_ixru + p_ixfx) ;
                              codet_word (local_size - alloc) ; {leau offset,u}
                            end
                      end
                  else 
                    begin
                      if lex = 2
                        then
                          if ovf_opt
                            then
                              hand (int, $50)
                            else
                              hand (int, $51)
                        else
                          hand (int, $21) ;
                      if alloc <> local_size
                        then
                          begin
                            opcode (c_leau) ;
                            post1 (p_idx + p_ixru + p_ixfx) ;
                            codet_word (local_size - alloc) ; {leau offset,u}
                            if ovf_opt and not intask
                              then
                                hand (int, 5)
                          end
                    end
              end ;
      if lex <= size_static
        then
          begin
            static[lex] := alloc ;
            temp := $0 ;
            for b := #1 to lex do
              temp := temp + static[b] ;
            if temp > max_static
              then
                max_static := temp
          end ;
      if lex = #1
        then {initialize standard devices}
          for k := input_ to keyboard_ do
            if k in stddev
              then
                begin
                  case k of
                    input_ : loc := r_inp ;
                    output_ : loc := r_out ;
                    auxout_ : loc := r_aux ;
                    keyboard_ : loc := r_key
                  end ;
                  set_std_name (k) ;
                  if not c_module
                    then
                      begin
                        push_pointer (p3) ; {get address}
                        opcode (c_stx) ;
                        post1 (p_idx + p_ixry + p_ixfx) ;
                        codet_word (loc) ; {stx offset,y}
                        ldaim (p2^.attr) ;
                        {lda #mode}
                        if p2^.name_flag <> #0
                          then
                            begin
                              ldbim (byte(k) - byte(input_)) ;
                              {ldb #dev}
                              hand (proc, #$60)
                            end
                          else
                            hand (dev, byte(k) - byte(input_)) ;
                        if debug_opt and debug_en
                          then
                            begin
                              override := true ;
                              debug (#3) ;
                              p4 := debtype (p3, p5, true, false) ;
                              outterm ;
                              override := false
                            end ;
                        opcode (c_equ) ;
                        post1 (p_eqea) ;
                        lab (s) ; {device equ $xxxx}
                        codet_word (0 - p3^.offset)
                      end ;
                  p3^.storage := s_stddev ;
                  p3^.offset := loc
                end ;
      if module_check
        then {initialize non-standard devices}
          for i := 1 to device_active do
            with deviceq[i] do
              begin
                push_pointer (devpt) ;
                init_device (headpt,concat('.',
                            substr(devpt^.nameptr^,1,7)))
              end
    end ;

  procedure goto_check ; entry ;
    var
      i, j : integer register ;
      found : boolean register ;
    begin
      for i := 1 to forward_goto do
        with gotoq[i] do
          with labpt^ do
            begin
              opcode (c_equ) ;
              post1 (p_eqlp) ;
              codet_word (auxlabel) ; {lbxxxx equ *}
              purge (auxlabel) ;
              if (offset = $0L) or (offset > gotooff)
                then
                  begin
                    error (e_igtl) ;
                    listout (nameptr^)
                  end
                else
                  begin
                    if offset <> gotooff
                      then
                        begin
                          opcode (c_leau) ;
                          post1 (p_idx + p_ixru + p_ixfx) ;
                          codet_word (gotooff - offset) {leau offset,u}
                        end ;
                    opcode (c_xbxx) ;
                    post1 (p_bra + p_rel + p_rell) ;
                    codet_word (intname) ; {bra lbxxxx}
                    found := false ;
                    for j := i + 1 to forward_goto do
                      if gotoq[j].labpt^.intname = intname
                        then
                          found := true ;
                    if not found
                      then
                        purge (intname)
                  end
            end ;
      forward_goto := 0
    end ;
{
  block handling, dispatch for const, type, var, procedure,
  function, and begin. modend is also handled for modules.
}
  procedure block (prc : ^symhead) ; entry ;
    var
      jump_flag : boolean ;
      current_block : hex ;
      past_var : boolean ;
    
{
  call statement syntax
}
    procedure begin_statements ;
      var
        dummy : error_type ;
        p6 : ^proc_head ;
      begin
        if jump_flag
          then
            begin
              opcode (c_equ) ;
              post1 (p_eqlp) ;
              codet_word (current_block) {lbxxxx equ *}
            end ;
        if debug_opt and (prc <> nil) and debug_en
          then
            begin
              p6 := prc + align(sizeof(symhead)) ;
              debug (#0) ; {procedure start}
              code_word (prc^.intname + $1) ;
              if p6^.func_size > $8000
                then
                  code_word(p6^.param_size + p6^.func_size)
                else
                  code_word(p6^.param_size - p6^.func_size) ;
              debname (prc^.nameptr^) ;
              outterm
            end ;
        line ;
        with_depth := 0 ;
        nesting := pred (nesting) ;
        statements (dummy) ;
        line
      end ;

    begin {block}
{
  initialize buffers to empty, block variables set
}
      var_occured := false ;
      alloc := local_size ;
      level := 1 ;
      register_count := #0 ;
      device_active := 0 ;
      pointer_active := addr (ptrq) ;
      var_active := addr (varq) ;
      var_start := addr (varq) ;
      enum_active := addr (enumbuf) ;
      exit_active := 0 ;
      nesting := succ (nesting) ;
      jump_flag := false ;
      current_block := block_name ;
      past_var := false ;
{
  block dispatch loop
}
      repeat
        if lastpack^.token = modend_
          then
            begin
              scan ;
              exit
            end ;
        if (lastpack^.token in [procedure_,function_,begin_]) 
             and not past_var and not var_occured
          then
            begin
              past_var := true ;
              varib_set (prc)
            end ;
        if (lastpack^.token in [label_,const_,type_,var_])
           and past_var
          then
            lastpack^.token := undef ; {force error and scan}
        case lastpack^.token of
          label_ : label_decl ;
          const_ : const_decl ;
          type_ : type_decl ;
          var_ : var_decl (false) ;
          procedure_ : proc_decl (current_block, jump_flag, false) ;
          function_ : proc_decl (current_block, jump_flag, true) ;
          begin_ :
            begin
              begin_statements ;
              exit
            end
          else
            skiperror (e_begn, [label_,const_,type_,var_,procedure_,
                                 function_,begin_])
        end
      until false
    end ;
{
  top of program parsing, handle program parameters, main block,
  and end of program
}  
  procedure parse ; entry ;
    var
      p1 : ^symhead ;
      p2 : ^token_type register ;
      p3 : ^type_device_head register ;
      k : token_type register ;
      stackout : boolean ;
    begin
{
  setup buffers as empty, set block, set lex level, set stack allocation
}
      prog_param := addr (paramq) ;
      forward_goto := 0 ;
      lex := #1 ;
      level := 1 ;
      block_name := $ffff ;
      internal_name := $1 ;
      alloc := local_size ;
      scan ;
      if not (lastpack^.token in [program_,module_])
        then
          skiperror (e_prog, [program_,module_]) ;
      passt ('* Icode version 1.DA') ;
      passt (concat('* Compiled using OmegaSoft 6809 Cross Pascal version ',
             xpcvers)) ;
      if lastpack^.token = module_
        then
          begin
            c_module := true ;
            idnt := '1,0 support module'
          end
        else
          idnt := '1,0 main program' ;
      scan ;
      if ident_flag
        then {program name}
          begin
            prog_name := substr (last_ident, 1, 20) ;
            scan ; {scan for $v directive}
            override := true ;
            passt (concat('.',substr(prog_name,1,7),' idnt ',idnt)) ;
            if debug_opt and debug_en
              then
                begin
                  if c_module
                    then
                      debug (#5) 
                    else
                      debug (#6) ;
                  debname (prog_name) ;
                  outterm
                end ;
            override := false ;
            passt (' xdef .main') ;
            opcode (c_equ) ;
            post1 (p_imm + p_eqep) ;
            labt ('.main') {.main equ *}
          end
        else
          skiperror (e_id, [semicolon,leftparen]) ;
      if lastpack^.token = leftparen
        then {has parameter list}
          repeat
            scan ;
            if lastpack^.token in [input_ .. keyboard_]
              then {have standard device}
                if enter_symbol (upshift(last_ident), false, p1)
                  then
                    errorpt (e_iddt)
                  else
                    begin
                      p2 := p1 + align(sizeof(symhead)) ;
                      p2^ := devicevar ;
                      p3 := (p2 + $2L) and $FFFFFFFE ;
                      p2 := p3 + longhex(sizeof(type_device_head)) ;
                      symdone(p1) ;
                      next_sym := (p2 + $3L) and $FFFFFFFE ;
                      with p1^,p3^ do
                        begin
                          override := true ;
                          if c_module
                            then
                              begin
                                storage := s_external ;
                                pass (' xref ')
                              end
                            else
                              begin
                                storage := s_stack ;
                                pass (' xdef ')
                              end ;
                          passt (last_ident) ;
                          override := false ;
                          idgroup := vardef ;
                          mode := nor_dev ;
                          extra := 0 ;
                          init := 0 ;
                          if (lastpack^.token <> keyboard_) and auto_opt
                            then
                              size := size_text
                            else
                              case lastpack^.token of
                                input_ : size := size_input ;
                                output_ : size := size_output ;
                                auxout_ : size := size_auxout ;
                                keyboard_ : size := size_keyboard
                              end ;
                          case lastpack^.token of
                            input_ :
                              begin
                                attr := m_text + m_int ;
                                if break_opt
                                  then
                                    attr := attr or m_bk ;
                                name_flag := #$fd ; {-3}
                                p2^ := textvar
                              end ;
                            output_ :
                              begin
                                attr := m_text ;
                                name_flag := #$fe ; {-2}
                                p2^ := textvar
                              end ;
                            auxout_ :
                              begin
                                attr := m_text ;
                                name_flag := #$ff ; {-1}
                                p2^ := textvar
                              end ;
                            keyboard_ :
                              begin
                                attr := m_int ;
                                name_flag := #0 ;
                                p2^ := charvar
                              end
                          end ;
                          if not auto_opt
                            then
                              name_flag := #0 ;
                          p2 := p2 + $1L ;
                          p2^ := termit ;
                          stddev := stddev + [lastpack^.token]
                        end
                    end
              else {not standard device}
                if lastpack^.token = vardef
                  then {device already in table}
                    errorpt (e_iddt)
                  else
                    if prog_param + longhex(last_ident[0] + #2)
                                    - addr(paramq) > longhex(size_paramq)
                      then
                        errorpt (e_ppqf)
                      else
                        begin
                          prog_param^ := last_ident ;
                          prog_param := prog_param +
                                            longhex(last_ident[0] + #1)
                        end ;
            scan ;
            case lastpack^.token of
              comma : ; {continue in loop}
              rightparen : 
                begin
                  scan ;
                  exit
                end ;
              semicolon : exit
              else 
                begin
                  skiperror (e_rpar, [semicolon]) ;
                  exit
                end
            end
          until false ;
      if lastpack^.token <> semicolon
        then
          skiperror (e_semi, [semicolon]) ;
      scan ;
      block (nil) ; {handle outer block}
      nesting := pred (nesting) ;
      if lastpack^.token <> period
        then
          skiperror (e_period, [period]) ;
{
  finish up - list last line, put in return to caller, put in end,
  put in xrefs
}
      up_line ;
      opcodet (c_rts) ;
      stackout := not c_module ;
      c_module := false ;
      goto_check ;
      dump ;
      xclean ;
      if stackout
        then
          begin
            passt (' xdef stack$sz,heap$sz,negm$sz') ;
            opcode (c_equ) ;
            post1 (p_eqea) ;
            lab ('stack$sz') ;
            codet_word (max_static) ;
            opcode (c_equ) ;
            post1 (p_eqea) ;
            lab ('heap$sz') ;
            codet_word (heapsize) ;
            opcode (c_equ) ;
            post1 (p_eqea) ;
            lab ('negm$sz') ;
            codet_word (0 - (max_static + max_static >> 2 + 300 + heapsize)) ;
          end ;
      opcodet (cd_end) ;
      dump ;
    end ;
    
modend.
