module pushpull {$v3,0 misc. data movement} ;
{
  5/17/89 :initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  function labout (h : hex) : string [4] ; external ;
  function get_internal : hex ; external ;
  
  procedure uncon (p : ^packet) ; entry ;
    var
      temp1 : hex register ;
      i : byte register ;
      p1 : ^anystring register ;
    begin
      if p^.conflag
        then
          with p^ do
            begin
              conflag := false ;
              case p^.token of
                boolvar, charvar, enumvar :
                  ldbim (pvc_char) ;
                integvar, hexvar :
                  lddim (pvc_hex) ;
                  {ldd #x}
                lintvar, lhexvar, realvar :
                  begin
                    opcode (c_ldx) ;
                    post1 (p_imm) ;
                    codet_word (hex(pvc_longhex)) ;
                    {ldx #ls}
                    lddim (hex(pvc_longhex >> 16)) ;
                    {ldd #ms}
                    opcode (c_pshu) ;
                    post1t (p_ipd + p_ipx)
                    {pshu d,x}
                  end ;
                stringvar, setvar :
                  begin
                    p1 := pvc_string ;
                    if p1^[0] <= 1
                      then
                        begin
                          if p1^[0] = 0
                            then
                              begin
                                opcode (c_clr) ;
                                post1t (p_idx + p_ixru + p_ixm)
                                {clr 0,-u}
                              end
                            else
                              begin
                                opcode (c_ldd) ;
                                post1 (p_imm) ;
                                codet_word ($100 + hex(p1^[1])) ;
                                {ldd #$1xx}
                                opcode (c_pshu) ;
                                post1t (p_ipd)
                                {pshu d}
                              end
                        end
                      else
                        begin
                          hand (int, $29) ;
                          data_byte (p1^[0]) ;
                          datast (p1^)
                        end
                  end
              end
            end
    end ;
    
  procedure push (p : ^packet) ; entry ;
    begin
      case p^.token of
        boolvar, charvar, enumvar :
          begin
            opcode (c_pshu) ;
            post1t (p_ipb)
            {pshu b}
          end ;
        integvar, hexvar :
          begin
            opcode (c_pshu) ;
            post1t (p_ipd)
            {pshu d}
          end
      end
    end ;
    
  procedure pull (p : ^packet) ; entry ;
    begin
      case p^.token of
        enumvar, boolvar, charvar :
          begin
            opcode (c_pulu) ;
            post1t (p_ipb)
            {pulu b}
          end ;
        integvar, hexvar :
          begin
            opcode (c_pulu) ;
            post1t (p_ipd)
            {pulu d}
          end
      end
    end ;
    
  procedure xdat (p : ^packet) ; entry ;
    begin
      case p^.token of
        enumvar, boolvar, charvar, subbool, subchar : eminln (102) ;
        integvar, hexvar, subhex, subinteg : eminln (103) ;
        lintvar, lhexvar, realvar, sublhex, sublint : hand (int, $36) ;
        stringvar, setvar :
          begin
            hand (int, $25) ;
            datat_byte (byte(p^.size))
          end
      end
    end ;
    
  procedure pshdat (p : ^packet) ; entry ;
    begin
      case p^.token of
        enumvar, boolvar, charvar, textvar, subbool, subchar :
          begin
            opcode (c_ldb) ;
            post1t (p_idx + p_ixrx + p_ixz)
            {ldb 0,x}
          end ;
        integvar, hexvar, subhex, subinteg :
          begin
            opcode (c_ldd) ;
            post1t (p_idx + p_ixrx + p_ixz)
            {ldd 0,x}
          end ;
        lintvar, lhexvar, realvar, sublint, sublhex : hand (int, $35) ;
        stringvar, setvar : hand (int, $24)
      end
    end ;
    
  function maycon (pac : ^packet) : boolean ; entry ;
    begin
      if not (pac^.token in [boolvar .. hexvar, enumvar])
        then
          begin
            uncon (pac) ;
            maycon := true
          end
        else
          maycon := false
    end ;
    
modend.
