module relogen {$v3,0 icode to relo convertor} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/varib}
  type
    blkbuffer = array [1..4096] of char ;
    sect = (abs, relo, dat, varb) ;
    int_type = record
                 active, define : boolean ;
                 intname : hex ;
                 modoff : hex ;
                 roaddr : longhex
               end ;
    ext_type = record
                 active, defined : boolean ;
                 value : hex ;
                 section : sect ;
                 esd : byte ;
                 name : string[9]
               end ;
    adrtype = record
                b1, b2 : byte
              end ;
  var
    output_f : text varib external ;
    int_start, int_cur, int_max : ^int_type varib entry ;
    ext_start, ext_cur, ext_max : ^ext_type varib entry ;
    cur_adr, cur_rec, cur_max : ^hex varib entry ;
    rel_start, rel_adr : ^byte varib entry ;
    cur_sect : sect varib entry ;
    loc : array [abs..varb] of hex varib entry ;
    rec_lth, rel_lth : byte varib entry ;
    rec_off : longhex varib entry ;
    nextesd : byte varib entry ;
    bufsize, extsize, intsize : longhex varib ;
    bufstart : ^hex varib entry ;
    oblkbuf : ^blkbuffer varib external ;
    oblkmax, oblkcur : ^byte varib external ;
    opath : integer varib external ;
    
  procedure initrelo (rbstart, rbsize : longhex) ; entry ;
    begin
      extsize := rbsize div 8 ;
      intsize := rbsize div $A ;
      bufsize := rbsize - extsize - intsize - $400 ;
      bufstart := rbstart ;
      int_start := align(bufstart + bufsize) ;
      int_cur := int_start ;
      ext_start := align(int_start + intsize) ;
      cur_adr := bufstart ;
      cur_rec := bufstart ;
      ext_cur := ext_start ;
      rel_start := align(ext_start + extsize) ;
      cur_sect := relo ;
      int_max := int_start + intsize - $10 ;
      ext_max := ext_start + extsize - $10 ;
      cur_max := bufstart + bufsize - $100 ;
      loc[abs] := 0 ;
      loc[relo] := 0 ;
      loc[dat] := 0 ;
      loc[varb] := 0 ;
      rec_lth := 0 ;
      rel_lth := 0 ;
      rel_adr := rel_start ;
      rec_off := 0 ;
      nextesd := 4
    end ;

  procedure blkwrite (path : hex ; b : ^blkbuffer ;
                      count : longhex) ; external ;
    
  procedure codeout ; external ;
  
  procedure writerelo ; entry ;
    var
      p : ^hex ;
      p1 : ^ext_type ;
      p2 : ^adrtype ;
      s : string ;
      btemp : byte ;
      ntemp : string[8] ;
      vers, rev : byte ;
      i, j : integer register ;
    begin
      icode_buf := ' ' ;
      icode_buf[1] := 0 ; {header}
      i := index(idnt, ',') ;
      vers := 0 ;
      rev := 0 ;
      ntemp := upshift(concat('.',substr(prog_name,1,7))) ;
      s := '' ;
      if i <> 0
        then
          begin
            vers := byte(integer(substr(idnt,1, i - 1))) ;
            j := index(idnt,' ') ;
            if j <> 0
              then
                begin
                  rev := byte(integer(substr(idnt, i + 1, j - i - 1))) ;
                  s := substr(idnt, j + 1,40)
                end
          end ;
      append (icode_buf,vers,rev,ntemp[0],ntemp,s[0],s) ;
      codeout ;
{ put out size record }
      icode_buf[0] := 9 ;
      icode_buf[1] := 1 ;
      p := addr(icode_buf[2]) ;
      p^ := loc[relo] ;
      p := p + 2 ;
      p^ := loc[dat] ;
      p := p + 2 ;
      p^ := loc[varb] ;
      p := p + 2 ;
      p^ := max_static ;
      codeout ;
{ put out xref records }
      p1 := ext_start ;
      icode_buf := ' ' ;
      icode_buf[1] := 2 ;
      while p1 < ext_cur do
        begin
          if not p1^.defined
            then
              with p1^ do
                begin
                  ntemp := upshift(name) ;
                  append (icode_buf, ntemp[0], ntemp) ;
                  if icode_buf[0] > 230
                    then
                      begin
                        codeout ;
                        icode_buf[0] := 1
                      end
                end ;
          p1 := p1 + longhex(sizeof(ext_type))
        end ;
      if icode_buf[0] > 1
        then
          codeout ;
{ put out xdef records }
      p1 := ext_start ;
      icode_buf := ' ' ;
      icode_buf[1] := 3 ;
      while p1 < ext_cur do
        begin
          if p1^.defined
            then
              with p1^ do
                if substr(name, 1, 2) <> '..'
                  then
                    begin
                      p2 := addr(value) ;
                      btemp := byte(section) ;
                      ntemp := upshift(name) ;
                      append (icode_buf, btemp, p2^.b1, p2^.b2, ntemp[0], ntemp) ;
                      if icode_buf[0] > 230
                        then
                          begin
                            codeout ;
                            icode_buf[0] := 1
                          end
                    end ;
          p1 := p1 + longhex(sizeof(ext_type))
        end ;
      if icode_buf[0] > 1
        then
          codeout ;
      blkwrite (opath, oblkbuf, oblkcur - oblkbuf) ;
{ put out code and relocation records }
      blkwrite (opath, bufstart, cur_rec - bufstart) ;
{ put out terminator record }
      icode_buf[0] := 1 ;
      icode_buf[1] := 6 ;
      blkwrite (opath, addr(icode_buf), 2) ;
      oblkcur := oblkbuf {no more to write}
    end ;
    
modend.
