module scan {$v3,1 convert source code to tokens} ;
{
  5/16/89 : initial conversion to level 3
  6/7/89 : parsing for heapsize option added
}
{$I/r0/token}
{$I/r0/error}
{$I/r0/code}
{$I/r0/varib}

  const
    restab = external array [#1 .. #12] of hex ;
    idntab = external array [#1 .. #12] of hex ;
    punct = external token_type ;
    dpunct = external token_type ;
    maxdepth = external integer ;
    
  var
    actual_symtab : longhex varib external ;
    actual_memavail : longhex varib external ;
  
{$I/r0/codeproc}

  function module_check : boolean ; external ;
  procedure sym_dump ; external ;
  function sym_search (s : string[120] ; restrict : boolean) : ^packet ; external ;
{
  communication with main task
}    
  procedure terminate ; external ;
  procedure error (errnum : error_type) ; external ;
  procedure errorpt (errnum : error_type) ; external ;
  procedure listout (s : string[120]) ; external ;
  procedure tof ; external ;
  procedure include_set ; external ;
  procedure nextline ; external ;
  function compare : boolean ; external ;
    
  function toamd (r : real) : real ; entry ;
    var
      x : record
            case integer of
              1 : (rl : real) ;
              2 : (lx : longhex)
          end ;
      l1, l2, l3 : longhex ;
    begin
      x.rl := r ;
      if r = 0
        then
          toamd := 0
        else
          begin
            l1 := x.lx and $80000000 ; {sign}
            l2 := x.lx and $7f800000 ; {exponent}
            l3 := x.lx and $007fffff ; {mantissa}
            l2 := ((l2 << 1) - $7E000000) and $7f000000 ;
            l3 := l3 or $00800000 ;
            x.lx := l1 or l2 or l3 ;
            toamd := x.rl
          end
    end ;
{
  character clasification routines
}
  function punctuation (ch : char) : boolean ;
    begin
      punctuation := ch in ['!'..'/',':'..'@','[',']','^','{','}']
    end ;
{
  look in reserved word table or standard identifier table
  for the name specified, return undef if not found
}
  function table_search (s : string[120] ; 
             var t : array [#1 .. #12] of hex) : token_type ; external ;

  function not_ident (ch : char) : boolean ; external ;
  
{
  return pointer to internal heap, size is round up to
  next even address to avoid address errors
}
  function getheap (size : longinteger) : ^packet ; entry ;
    begin
      getheap := heapptr ;
      heapptr := heapptr + align(longhex(size))
    end ;
{
  send input line plus line number to output file if needed
}
  procedure scanf ; entry ;
    var
      i : integer register ;
      s : string[120] ;
    begin
      if module_check and (list_count >= 0) and source_opt
        then
          begin
            for i := 1 to length(input_buf) - 1 do
              if input_buf[i] <> ' '
                then
                  exit ;
            s := substr(input_buf,i,120) ;
            s[0] := pred(s[0]) ; {purge carriage return}
            if icode_buf[0] <> 0
              then
                outterm ;
            if include_active
              then
                passt (concat('* ', string(include_line), ' ', s))
              else
                passt (concat('* ', string(line_number), ' ', s))
          end
    end ;
{
  inscan returns the next character in the input stream. It will
  also list the line if needed, and echo it to the output file
  if needed.
}
  function inscan : char ;
{
  list old input line, get new line, increment line number, form
  line number string, and clear flags
}
    begin
      while (input_buf[0] = 255) or (inptr^ = $D) do
        begin
          nextline ;
          if include_active
            then
              begin
                include_line := succ (include_line) ;
                linestring := string(include_line)
              end
            else
              begin
                line_number := succ (line_number) ;
                linestring := string(line_number)
              end ;
          while length(linestring) < 4 do
            linestring := concat (' ',linestring) ;
          if include_active
            then
              linestring[1] := 'I' ;
          page_it := false ;
          error_up := false ;
          nest_up := false ;
          new_num := true ;
          scanf
        end ;
      inscan := inptr^ ;
      inptr := inptr + 1
    end ;

{
  main scanning action, returns pointer to packet
}
  function subscan : ^packet ;
    var
      double : boolean register ;
      subpt : ^packet ;
      ch : char ;
      p2 : ^symname ;
{
  handle compiler control toggles - special comments
}
    procedure comment_syntax ;
      var
        mask : hex register ;
        ch2 : char register ;
        sense : boolean register ;
        depth : integer ;
        
      function depthup : boolean ;
        begin
          if depth < maxdepth
            then
              begin
                depth := depth + 1 ;
                depthup := true
              end
            else
              depthup := false
        end ;
{
  conditional compilation - turns off compilation if condition
  not met. re-enables compilation if end of conditional, if
  condition is met, or invalid conditional
}
      procedure conditionals ;
        var
          convalue : integer register ;
          conpt : ^packet register ;
          cond : string[2] ;
        begin
          cond[0] := 2 ;
          cond[1] := upshift(inscan) ;
          cond[2] := upshift(inscan) ;
          if cond = 'EN'
            then
              begin
                if cond_depth <> 0
                  then
                    cond_depth := cond_depth - 1 ;
                cond_flag := cond_stack[cond_depth]
              end
          else if cond = 'EL'
            then
              begin
                if cond_depth <> 0
                  then
                    if not cond_stack[cond_depth - 1]
                      then
                        begin
                          cond_stack[cond_depth] := not cond_flag ;
                          cond_flag := not cond_flag
                        end
              end
            else
              begin
                cond_depth := cond_depth + 1 ;
                conpt := subscan ;
                with conpt^ do
                  begin
                    if token = program_
                      then
                        convalue := integer(not(c_module))
                    else if token = in_
                      then
                        convalue := integer(compare)
                    else if conflag and (token in [boolvar..hexvar])
                      then
                        begin
                          if token in [boolvar..charvar]
                            then
                            convalue := integer(pvc_char)
                          else
                            convalue := integer(pvc_hex)
                        end
                      else
                        convalue := 0 ;
{
  note that the comparisons set the opposite condition
  into cond_flag as is required, this is for clarity
  in the comparisons, cond_flag is then reversed
}
                    case cond of
                      'EQ' : cond_flag := convalue = 0 ;
                      'GE' : cond_flag := convalue >= 0 ;
                      'GT' : cond_flag := convalue > 0 ;
                      'LE' : cond_flag := convalue <= 0 ;
                      'LT' : cond_flag := convalue < 0 ;
                      'NE' : cond_flag := convalue <> 0
                      else   cond_flag := true
                    end ;
                    if not cond_stack[cond_depth - 1]
                      then
                        cond_stack[cond_depth] := not cond_flag
                      else
                        cond_stack[cond_depth] := true ;
                    cond_flag := cond_stack[cond_depth]
                  end
              end ;
          if cond_flag
            then
              begin
                repeat
                  repeat
                    ch := inscan ;
                    case ch of
                      '}' : 
                        if depth > 0
                          then
                            depth := depth - 1 ;
                      '*' :
                        if inptr^ = ')'
                          then
                            begin
                              inptr := inptr + 1 ;
                              if depth > 0
                                then
                                  depth := depth - 1
                            end
                    end ;
                  until (ch = '{') or ((ch = '(') and (inptr^ = '*')) ;
                  if ch = '('
                    then
                      inptr := inptr + 1 ;
                  if depthup
                    then ;
                  if inscan = '$'
                    then
                      if (upshift(inscan) = 'C') and (depth = 1)
                        then
                          begin
                            conditionals ;
                            exit
                          end
                until false
              end
        end ;
{
  change field for idnt version, revision, and description,
  must occur before program parameter list to be effective
}
      procedure version_opt ;
        begin
          idnt[0] := 0 ;
          while not (inptr^ in ['*','}',#$D]) do
            begin
              if idnt[0] >= 40
                then
                  exit ;
              idnt := concat(idnt,inptr^) ;
              inptr := inptr + 1
            end
        end ;
        
      procedure heap_opt ;
        var
          heapt : ^packet ;
        begin
          heapt := subscan ;
          with heapt^ do
            if conflag and (token in [integvar, hexvar])
              then
                heapsize := pvc_hex
        end ;

      begin {comment_syntax}
        depth := 1 ;
        ch := inscan ;
        if (ch = '*') or (ch = '}')
          then
            inptr := inptr - 1 ;
        if ch = '$'
          then
            begin
              mask := 7 ;
              repeat
                ch := upshift(inscan) ;
                case ch of
                  'P' : page_it := true ;
                  'I' :
                    begin
                      case inptr^ of
                        '+' : mask := mask or $10 ;
                        '-' : mask := mask and $FD
                        else 
                          begin
                            include_set ;
                            inptr := inptr - 1
                          end
                      end ;
                      inptr := inptr + 1
                    end ;
                  'C' :
                    begin
                      case inptr^ of
                        '+' : mask := mask or $20 ;
                        '-' : mask := mask and $FB
                        else 
                          begin
                            conditionals ;
                            inptr := inptr - 1
                          end ;
                      end ;
                      inptr := inptr + 1
                    end ;
                  'V' : version_opt ;
                  'H' : heap_opt ;
                  'D' : 
                    begin
                      case inptr^ of
                        '+' : debug_en := true ;
                        '-' : debug_en := false
                        else
                          begin
                            sym_dump ;
                            inptr := inptr - 1
                          end
                      end ;
                      inptr := inptr + 1
                    end
                  else
                    begin
                      ch2 := inscan ;
                      if ch2 in ['+','-']
                        then
                          begin
                            sense := ch2 = '+' ;
                            case ch of
                              'L' :
                                begin
                                  override := true ;
                                  if sense
                                    then
                                      begin
                                        list_count := succ (list_count);
                                        passt (' list')
                                      end
                                    else
                                      begin
                                        list_count := pred (list_count);
                                        passt (' nolist')
                                      end ;
                                  override := false
                                end ;
                              'R' :
                                if sense
                                  then
                                    mask := mask or 8
                                  else
                                    mask := mask and $FE ;
                              'A' : auto_opt := sense ;
                              'S' : subrange_opt := sense ;
                              'B' : break_opt := sense ;
                              'O' : ovf_opt := sense
                              else exit
                            end
                          end
                        else
                          exit
                    end
                end ;
                ch := inscan ;
              until ch <> ',' ;
{
  if mask has been change, emit code to do it at runtime
}
              if mask <> 7
                then
                  begin
                    hand (int, $20) ; {lbsr int20}
                    datat_byte (byte(mask)) {fcb mask}
                  end ;
              inptr := inptr - 1
            end
        else if ch = '{'
          then
            sense := depthup
        else if (ch = '(') and (inptr^ = '*')
          then
            if depthup
              then
                inptr := inptr + 1 ;
        repeat
          ch := inscan ;
          case ch of
            '{' : sense := depthup ;
            '(' : 
              if inptr^ = '*'
                then
                  if depthup
                    then
                      inptr := inptr + 1 ;
            '}' :
              begin
                depth := depth - 1 ;
                if depth <= 0
                  then
                    exit
              end ;
            '*' :
              if inptr^ = ')'
                then
                  begin
                    inptr := inptr + 1 ;
                    depth := depth - 1 ;
                    if depth <= 0
                      then
                        exit
                  end
          end
        until false
      end ;
{
  handle string constants, processing double quotes as needed.
  string constants of one byte are converted to character constants
}
    procedure string_constant (cphase : boolean) ;
      var
        p2 : ^symname register ;
        tempstring : string[120] ;
        tempt : token_type ;
      begin
        tempstring[0] := 0 ;
        while inptr^ <> $D do
          begin
            if cphase
              then
                begin
                  subpt := subscan ;
                  with subpt^ do
                    if token in [charvar, integvar, hexvar]
                      then
                        begin
                          tempstring[0] := tempstring[0] + 1 ;
                          if token = charvar
                            then
                              tempstring[tempstring[0]] := pvc_char
                            else
                              tempstring[tempstring[0]] := char(pvc_hex)
                        end
                      else
                        begin
                          tempt := charvar ;
                          token := enum(byte(tempt) + $f0) ;
                          exit
                        end ;
                  if inptr^ = ''''
                    then
                      cphase := false
                    else
                      if inptr^ <> '#'
                        then
                          exit
                end
              else
                if inptr^ <> ''''
                  then
                    append(tempstring,inptr^)
                  else
                    begin
                      inptr := inptr + 1 ;
                      if inptr^ = '''' {double '}
                        then
                          append(tempstring,'''')
                        else
                          if inptr^ = '#'
                            then
                              cphase := true
                            else
                              exit
                    end ;
            inptr := inptr + 1
          end ;
        with subpt^ do
          begin
            if tempstring[0] <> 1
              then
                begin
                  pvc_string := getheap(ord(tempstring[0]) + 1) ;
                  size := hex(tempstring[0]) ;
                  p2 := pvc_string ;
                  p2^ := tempstring ;
                  token := stringvar
                end
              else
                begin
                  size := 1 ;
                  pvc_char := tempstring[1] ;
                  token := charvar
                end ;
            conflag := true
          end
      end ;

{
  hex and longhex numbers preceeded by a $
}
    procedure hex_number ;
      var
        longflag : boolean register ;
        temp : char register ;
        numstring : string[120] ;
        tempt : token_type ;
      begin
        {$c-}
        longflag := false ;
        numstring[0] := 0 ;
        with subpt^ do
          begin
            temp := upshift(inptr^) ;
            while ((temp >= '0') and (temp <= '9')) or
                  ((temp >= 'A') and (temp <= 'F')) do
              begin
                append(numstring,inptr^) ;
                inptr := inptr + 1 ;
                temp := upshift(inptr^)
              end ;
            if upshift(inptr^) = 'L'
              then
                begin
                  inptr := inptr + 1 ;
                  longflag := true
                end ;
            pvc_longhex := longhex(numstring) ;
            if conversion
              then
                begin
                  if longflag
                    then
                      tempt := lhexvar
                    else
                      tempt := hexvar ;
                  token := enum(byte(tempt) + $f0)
                end
              else
                if longflag or (pvc_longhex > $FFFF)
                  then
                    begin
                      size := 4 ;
                      token := lhexvar
                    end
                  else
                    begin
                      size := 2 ;
                      token := hexvar ;
                      pvc_hex := hex(pvc_longhex)
                    end ;
            conflag := true
          end
      end ;
{
  hex and longhex number preceeded by a %
}
    procedure binary_hex ;
      var
        overflow, longflag : boolean register ;
        temphex : longhex register ;
        tempt : token_type ;
      begin
        longflag := false ;
        overflow := false ;
        temphex := 0 ;
        with subpt^ do
          begin
            while (inptr^ = '0') or (inptr^ = '1') do
              begin
                if temphex > $7fffffff
                  then
                    overflow := true ;
                temphex := temphex << 1 + longhex(inptr^ - '0') ;
                inptr := inptr + 1
              end ;
            if upshift(inptr^) = 'L'
              then
                begin
                  inptr := inptr + 1 ;
                  longflag := true
                end ;
            if overflow
              then
                begin
                  if longflag
                    then
                      tempt := lhexvar
                    else
                      tempt := hexvar ;
                  token := enum(byte(tempt) + $f0)
                end
              else
                if (temphex > $ffff) or longflag
                  then
                    begin
                      pvc_longhex := temphex ;
                      token := lhexvar ;
                      size := 4
                    end
                  else
                    begin
                      pvc_hex := hex(temphex) ;
                      token := hexvar ;
                      size := 2
                    end ;
            conflag := true
          end
      end ;
{
  identifiers - look in reserved word table, then in symbol
  table, then in standard identifiers.
}
    procedure is_ident ;
      var
        identpt : ^packet register ;
        nametemp : string[126] ;
      begin
        last_ident[0] := 0 ;
        with subpt^ do
          begin
            repeat
              last_ident[0] := last_ident[0] + 1 ;
              last_ident[last_ident[0]] := ch ;
              ch := inptr^ ;
              inptr := inptr + 1
            until not_ident (ch) ;
            inptr := inptr - 1 ;
            size := hex(last_ident[0]) ;
            nametemp := upshift(last_ident) ;
            token := table_search (nametemp, restab) ;
            if token = undef
              then
                begin
                  identpt := sym_search (nametemp, false) ;
                  if identpt^.token = undef
                    then
                      token := table_search (nametemp, idntab)
                    else
                      subpt := identpt
                end
          end
      end ;
{
  process integers, longintegers, and real numbers
}
    procedure get_numb ;
      var
        longflag, realflag : boolean register ;
        numstring : string [120] ;
        p1 : ^byte ;
        tempt : token_type ;
      begin
        {$c-}
        longflag := false ;
        realflag := false ;
        with subpt^ do
          begin
            numstring[0] := 0 ;
            inptr := inptr - 1 ;
            while (inptr^ >= '0') and (inptr^ <= '9') do
              begin
                numstring[0] := succ(numstring[0]) ;
                numstring[numstring[0]] := inptr^ ;
                inptr := inptr + 1
              end ;
            if inptr^ = '.'
              then
                begin
                  p1 := inptr + 1 ;
                  if p1^ <> '.'
                    then
                      begin
                        realflag := true ;
                        numstring := concat(numstring,'.') ;
                        inptr := p1 ;
                        while inptr^ in ['0' .. '9'] do
                          begin
                            numstring[0] := succ(numstring[0]) ;
                            numstring[numstring[0]] := inptr^ ;
                            inptr := inptr + 1
                          end
                      end
                end ;
            if upshift(inptr^) = 'E'
              then
                begin
                  realflag := true ;
                  numstring := concat(numstring,'E') ;
                  inptr := inptr + 1 ;
                  if inptr^ in ['+', '-']
                    then
                      begin
                        numstring := concat(numstring,inptr^) ;
                        inptr := inptr + 1 ;
                      end ;
                  while inptr^ in ['0' .. '9'] do
                    begin
                      numstring[0] := succ(numstring[0]) ;
                      numstring[numstring[0]] := inptr^ ;
                      inptr := inptr + 1
                    end
                end ;
            if upshift(inptr^) = 'L'          
              then
                begin
                  inptr := inptr + 1 ;
                  longflag := true
                end ;
            if not realflag
              then
                pvc_longinteger := longinteger(numstring) ;
            if conversion or realflag
              then
                begin
                  range := false ;
                  pvc_real := real(numstring) ;
                  if conversion
                    then
                      begin
                        if realflag
                          then
                            tempt := realvar
                          else
                            tempt := integvar ;
                        token := enum(byte(tempt) + $f0)
                      end
                    else
                      begin
                        token := realvar ;
                        pvc_real := toamd(pvc_real)
                      end
                end
              else
                if longflag or (pvc_longinteger > maxint) or
                               (pvc_longinteger < minint)
                  then
                    token := lintvar
                  else
                    begin
                      token := integvar ;
                      pvc_integer := integer(pvc_longinteger)
                    end ;
            case token of
              integvar : size := 2
              else size := 4
            end ;
            conflag := true 
          end
      end ;
{
  process punctuation marks, both double and single. dispatch
  to correct handler for $, %, ', #, {, and (*
}
    procedure get_punc ;
      var
        p1 : ^token_type register ;
        p2, p3 : ^char register ;
        is_double : boolean ;
        temp : token_type register ;
      begin
        is_double := false ;
        if punctuation (inptr^)
          then
            begin
              p1 := addr(dpunct) ;
              while p1^ <> enum(0) do
                begin
                  p2 := p1 + 1 ;
                  p3 := p1 + 2 ;
                  if (p2^ = ch) and (p3^ = inptr^)
                    then
                      begin
                        is_double := true ;
                        temp := p1^ ;
                        exit
                      end
                    else
                      p1 := p1 + 3
                end ;
              if is_double
                then
                  inptr := inptr + 1
            end ;
        if not is_double
          then
            begin
              temp := undef ;
              p1 := addr(punct) ;
              while p1^ <> enum(0) do
                begin
                  p2 := p1 + 1 ;
                  if p2^ = ch
                    then
                      begin
                        temp := p1^ ;
                        exit
                      end
                    else
                      p1 := p1 + 2
                end ;
            end ;
        subpt^.token := temp ;
        case temp of
          startcomment : 
            begin
              comment_syntax ;
              subpt := subscan
            end ;
          pound : string_constant (true) ;
          apost : string_constant (false) ;
          dollar : hex_number ;
          percent : binary_hex
        end
      end ;
{
  get packet, clear packet, get next non space, dispatch to
  correct routine based on character type
}
    begin {subscan}
      subpt := getheap (sizeof(packet)) ;
      ident_flag := false ;
      with subpt^ do
        begin
          token := deferred ; {use to signal invalid token error}
          token := pred(token) ;
          conflag := false ;
          size := 0 ;
          pointr := nil ;
          subtoken := undef ;
          pvc_longhex := 0 ;
          repeat
            ch := inscan
          until ch <> ' ' ; {skip spaces}
          start_token := inptr - 1 ;
          if ch = '!'
            then
              begin
                pointr := getheap(122) ;
                p2 := pointr ;
                p2^ := '' ;
                while inptr^ <> $D do
                  begin
                    ch := inptr^ ;
                    p2^ := concat(p2^, ch) ;
                    inptr := inptr + 1 ;
                    size := size + 1 ;
                  end ;
                if ch = ';'
                  then
                    begin
                      size := size - 1 ;
                      p2^[0] := p2^[0] - 1 ;
                      inptr := inptr - 1 {backup to ;}
                    end ;
                token := inline
              end
            else
              begin
                pointr := inptr - 1 ;
                if ((ch >= 'A') and (ch <= 'Z')) or
                   ((ch >= 'a') and (ch <= 'z'))
                  then
                    is_ident
                  else                  
                    if (ch >= '0') and (ch <= '9')
                      then
                        get_numb
                      else
                        if punctuation (ch)
                          then
                            get_punc
              end
        end ;
      subscan := subpt
    end ;
{
  outer scanner - set nesting string, check internal heap
  and symbol table (main heap), get tokens from scanner, 
  skipping those that occur while conditional compilation
  is off, generate invalid token error and correct token
  type if needed
}
  procedure scan ; entry ;
    var
      packpt : ^packet register ;
    begin
      if not nest_up
        then
          begin
            case nesting of
              80 .. 255 : neststring[2] := '-' ;
              0 .. 9 : neststring[2] := nesting + '0'
              else neststring[2] := nesting + 7 + '0'
            end ;
            nest_up := true
          end ;
      if heapptr > (heapstart + (internal_size - $80))
        then
          begin
            error (e_heap) ;
            terminate
          end ;
      if (actual_memavail < $200) or (next_sym + $80 > sym_bottom +
                                actual_symtab)
        then
          begin
            error (e_sto) ;
            terminate
          end ;
      repeat
        packpt := subscan ;
        with packpt^ do
          begin
            if byte(token) >= $f0
              then
                if byte(token) <> $ff
                  then
                    begin
                      token := enum(byte(token) and $f) ;
                      errorpt (enum(byte(token) + byte(undef)))
                    end
                  else
                    errorpt (e_it)
          end
      until packpt^.token <> enum($ff) ;
      lastpack := packpt ;
    end ;
modend.
