module sfunc {$v3,1 standard functions} ;
{
  5/17/89 : initial conversion to level 3
  7/22/89 : oldtask handling for memavail
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}

  type
    rptype = (rpar, com, nopar) ;
  const
    oldtask = external boolean ;
    
{$I/r0/codeproc}

  procedure scan ; external ;
  procedure uncon (p : ^packet) ; external ;
  function outexp (var error : error_type) : ^packet ; external ;
  function varib (vpac : ^packet ; var verror : error_type ;
                  getdata : boolean ; outer : boolean) : ^packet ; external ;
  function fetch_packet (sympt : ^symhead) : ^packet ; external ;
  function get_packet (t : ^token_type) : ^packet ; external ;
  function retpac (t : token_type) : ^packet ; external ;
  procedure push (p : ^packet) ; external ;
  procedure init_device (p1 : ^type_device_head) ; external ;
  function slpar (var lerror : error_type) : boolean ; external ;
  function srpar : rptype ; external ;
  function lpars : boolean ; external ;
  function giveit (req : tokes ; var gerror : error_type ;
                   gpac : ^packet) : ^packet ; external ;
  function gimme (req : tokes ; var gerror : error_type) : ^packet ; external ;
  function sub3 (var gerror : error_type ; var ftype : token_type ;
                 var file_spec : boolean ; var fsize : hex ;
                 var devname : byte) : boolean ; external ;
  function labout (h : hex) : string[4] ; external ;

  function stand_func (var gerror : error_type) : ^packet ; entry ;
    var
      msel, ftype : token_type ;
      ssize : integer register ;
      fpac, tpac : ^packet register ;
      file_spec : boolean ;
      fsize : hex ;
      devname, catcnt : byte ;
      i : integer register ;
      p4 : ^proc_head ;
      p : ^symhead ;
    begin
      gerror := undef ;
      msel := lastpack^.token ;
      repeat
        case msel of
          sizeof_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              case lastpack^.token of
                boolean_, char_ : ssize := 1 ;
                integer_, hex_ : ssize := 2 ;
                longhex_, longinteger_, real_ : ssize := 4 ;
                typedef, vardef : ssize := integer(lastpack^.size)
                else
                  begin
                    gerror := e_inac ;
                    exit
                  end
              end ;
              scan ;
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end ;
              fpac := retpac(integvar) ;
              fpac^.conflag := true ;
              fpac^.pvc_integer := ssize
            end ; {sizeof}
          addr_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              fpac := varib(lastpack,gerror,false,true) ;
              if gerror <> undef
                then
                  if lastpack^.token in [procdef, funcdef]
                    then
                      begin
                        gerror := undef ;
                        p := lastpack^.pointr ;
                        p4 := p + align(sizeof(symhead)) ;
                        case p4^.comp_status of
                          proc_absolute :
                            begin
                              opcode (c_ldx) ;
                              post1 (p_imm) ;
                              codet_word (p^.offset)
                              {ldx #addr}
                            end ;
                          else
                            begin
                              opcode (c_leax) ;
                              post1 (p_idx + p_ixrp + p_ixex) ;
                              labt (p^.nameptr^)
                              {leax name,pcr}
                            end
                        end ;
                        scan
                      end
                    else
                      exit ;
              opcode (c_tfr) ;
              post1t (p_itxd) ;
              {tfr x,d}
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end ;
              fpac := retpac(hexvar) ;
              fpac^.pv_pointer.ptrf := nonptr
            end ; {addr}
          break_, eof_, eoln_, deverr_ :
            begin
              if lpars
                then
                  begin {have parameter list}
                    if sub3(gerror, ftype, file_spec, fsize, devname)
                      then
                        exit ;
                    if not file_spec
                      then
                        begin
                          gerror := e_esfp ;
                          exit
                        end ;
                    if srpar <> rpar
                      then
                        begin
                          gerror := e_rpar ;
                          exit
                        end ;
                  end
                else
                  begin {no parameter list}
                    if input_ in stddev
                      then
                        begin
                          if lex = 1
                            then
                              begin
                                opcode (c_ldx) ;
                                post1 (p_idx + p_ixry + p_ixfx)
                              end
                            else
                              begin
                                eminln (128) ;
                                opcode (c_ldx) ;
                                post1 (p_idx + p_ixrx + p_ixfx)
                              end ;
                          codet_word (r_inp) ;
                          {ldx n,y or ldx n,x}
                          ftype := textvar
                        end
                      else
                        begin
                          gerror := e_usio ;
                          exit
                        end
                  end ; {no parameter list}
              if msel = deverr_
                then
                  begin
                    eminln (122) ;
                    fpac := retpac(charvar)
                  end
                else
                  begin
                    if (msel <> eof_) and (ftype <> textvar)
                      then
                        begin
                          gerror := e_esfp ;
                          exit
                        end ;
                    case msel of
                      break_ : hand(func, $53) ;
                      eof_   : hand(func, $50) ;
                      eoln_  : hand(func, $51)
                    end ;
                    fpac := retpac(boolvar)
                  end
            end ; {break,eof,eoln,deverr}
          cline_ :
            begin
              if slpar(gerror)
                then
                  begin
                    gerror := undef ;
                    opcodet (c_clrb)
                  end
                else
                  begin
                    fpac := gimme([charvar, integvar], gerror) ;
                    if gerror <> undef
                      then
                        exit ;
                    uncon (fpac) ;
                    if srpar <> rpar
                      then
                        begin
                          gerror := e_rpar ;
                          exit
                        end ;
                  end ;
              hand (func, $70) ;
              fpac := retpac(stringvar) ;
              fpac^.size := $40
            end ; {cline}
          conversion_, range_ :
            begin
              if lex <> 1
                then
                  begin
                    eminln (128) ;
                    opcode (c_ldb) ;
                    post1 (p_idx + p_ixrx + p_ixfx)
                  end
                else
                  begin
                    opcode (c_ldb) ;
                    post1 (p_idx + p_ixry + p_ixfx)
                  end ;
              if msel = range_
                then
                  codet_word (5)
                else
                  codet_word (4) ;
              scan ;
              fpac := retpac (boolvar)
            end ;
          concat_ :
            begin
              catcnt := 0 ;
              if slpar (gerror)
                then
                  exit ;
              repeat
                fpac := gimme([stringvar], gerror) ;
                if gerror <> undef
                  then
                    exit ;
                uncon (fpac) ;
                catcnt := succ(catcnt) ;
                case srpar of
                  rpar : exit ;
                  nopar :
                    begin
                      gerror := e_rpar ;
                      exit (2)
                    end
                end
              until false ;
              hand (func, 9) ;
              datat_byte (catcnt) ;
              fpac := retpac(stringvar) ;
              fpac^.size := $40
            end ; {concat}
          substr_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              fpac := gimme([stringvar], gerror) ;
              if gerror <> undef
                then
                  exit ;
              uncon(fpac) ;
              if srpar <> com
                then
                  begin
                    gerror := e_comma ;
                    exit
                  end ;
              tpac := gimme([charvar, integvar],gerror) ;
              if gerror <> undef
                then
                  exit ;
              if tpac^.token = charvar
                then
                  if tpac^.conflag
                    then
                      begin
                        tpac^.pvc_integer := ord(tpac^.pvc_char) ;
                        tpac^.token := integvar ;
                        uncon (tpac)
                      end
                    else
                      begin
                        uncon (tpac) ;
                        tpac^.token := integvar ;
                        opcodet (c_clra)
                      end
                else
                  uncon (tpac) ;
              push (tpac) ;
              if srpar <> com
                then
                  begin
                    gerror := e_comma ;
                    exit
                  end ;
              tpac := gimme([charvar, integvar],gerror) ;
              if gerror <> undef
                then
                  exit ;
              if tpac^.token = charvar
                then
                  if tpac^.conflag
                    then
                      begin
                        tpac^.pvc_integer := ord(tpac^.pvc_char) ;
                        tpac^.token := integvar ;
                        uncon (tpac)
                      end
                    else
                      begin
                        uncon (tpac) ;
                        tpac^.token := integvar ;
                        opcodet (c_clra)
                      end
                else
                  uncon (tpac) ;
              hand (func, $11) ;
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end ;
              fpac := retpac(stringvar) ;
              fpac^.size := $40
            end ; {substr}
          index_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              fpac := gimme([stringvar],gerror) ;
              if gerror <> undef
                then
                  exit ;
              uncon(fpac) ;
              if srpar <> com
                then
                  begin
                    gerror := e_comma ;
                    exit
                  end ;
              fpac := gimme([stringvar],gerror) ;
              if gerror <> undef
                then
                  exit ;
              uncon (fpac) ;
              hand (func, $12) ;
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end ;
              fpac := retpac(integvar)
            end ; {index}
          length_ :
            begin
              if slpar (gerror)
                then
                  exit ;
              if lastpack^.token = vardef
                then
                  begin
                    fpac := varib(lastpack,gerror,false,true) ;
                    if gerror <> undef
                      then
                        exit ;
                    if fpac^.token in [setvar, stringvar]
                      then
                        begin
                          opcode (c_ldb) ;
                          post1t (p_idx + p_ixrx + p_ixz) ;
                          {ldb 0,x}
                          opcodet (c_clra)
                        end
                      else
                        begin
                          gerror := e_tc ;
                          exit
                        end
                  end
                else
                  begin
                    fpac := gimme([setvar,stringvar], gerror) ;
                    if gerror <> undef
                      then
                        exit ;
                    uncon(fpac) ;
                    hand(func, $10)
                  end ;
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end ;
              fpac := retpac(integvar)
            end ; {length}
          upshift_ :
            begin
              if slpar (gerror)
                then
                  exit ;
              fpac := gimme([charvar,stringvar],gerror) ;
              if gerror <> undef
                then
                  exit ;
              uncon(fpac) ;
              if fpac^.token = charvar
                then
                  hand (func,$72)
                else
                  hand (func,$71) ;
              if srpar <> rpar
                then
                  gerror := e_rpar
            end ; {upshift}
          random_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              fpac := varib(lastpack,gerror,false,true) ;
              if gerror <> undef
                then
                  exit ;
              if fpac^.token <> realvar
                then
                  begin
                    gerror := e_tc ;
                    exit
                  end ;
              hand (func, $41) ;
              if srpar <> rpar
                then
                  gerror := e_rpar
            end ; {random}
          memavail_ :
            begin
              scan ;
              if intask and oldtask
                then
                  hand (func, 6)
                else
                  hand (func, $13) ;
              fpac := retpac(hexvar)
            end ; {memavail}
          chr_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              fpac := gimme([integvar, hexvar], gerror) ;
              if gerror <> undef
                then
                  exit ;
              if fpac^.conflag
                then
                  begin
                    fpac^.pvc_char := chr(fpac^.pvc_hex) ;
                    fpac^.token := charvar
                  end
                else
                  begin
                    uncon (fpac) ;
                    fpac:= retpac(charvar)
                  end ;
              if srpar <> rpar
                then
                  gerror := e_rpar
            end ; {chr}
          ord_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              fpac := gimme([boolvar .. hexvar, enumvar], gerror) ;
              if gerror <> undef
                then
                  exit ;
              if fpac^.conflag
                then
                  begin
                    if fpac^.token in [boolvar, charvar, enumvar]
                      then
                        fpac^.pvc_integer := ord(fpac^.pvc_char) ;
                    fpac^.token := integvar
                  end
                else
                  begin
                    uncon(fpac) ;
                    if fpac^.token in [boolvar, charvar, enumvar]
                      then
                        opcodet (c_clra) ;
                    fpac := retpac(integvar)
                  end ;
              if srpar <> rpar
                then
                  gerror := e_rpar
            end {ord}
          else
            begin {simple function}
              if slpar(gerror)
                then
                  exit ;
              tpac := outexp(gerror) ;
              if gerror <> undef
                then
                  exit ;
              for i := 1 to 34 do
                with functab^[i] do
                  begin
                    if routine = deferred
                      then
                        begin
                          gerror := e_esfp ;
                          exit (2)
                        end ;
                    if routine = msel
                      then
                        begin
                          fpac := giveit([par],gerror,tpac) ;
                          if gerror = undef
                            then
                              exit
                        end
                  end ;
              uncon (fpac) ;
              with functab^[i] do
                begin
                  if num >= 116
                    then
                      eminln(num)
                    else
                      hand(func,num) ;
                  fpac := retpac(res) ;
                  if srpar <> rpar
                    then
                      gerror := e_rpar ;
                end
            end {simple function}
        end {case}
      until true ;
      stand_func := fpac
    end ;
    
modend.
