module sproc {$v3,2 standard procedures} ;
{
  5/17/89 : initial conversion to level 3
  7/22/89 : add irq/firq stuff and change new/dispose/mark,
  release stuff for tasking
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}

  type
    rptype = (rpar, com, nopar) ;
  const
    oldtask = external boolean ;
    
{$I/r0/codeproc}

  procedure scan ; external ;
  procedure uncon (p : ^packet) ; external ;
  function outexp (var error : error_type) : ^packet ; external ;
  function varib (vpac : ^packet ; var verror : error_type ;
                  getdata : boolean ; outer : boolean) : ^packet ; external ;
  function fetch_packet (sympt : ^symhead) : ^packet ; external ;
  function get_packet (t : ^token_type) : ^packet ; external ;
  procedure push (p : ^packet) ; external ;
  procedure init_device (p1 : ^type_device_head ; s : string[8]) ; external ;
  function labout (h : hex) : string[4] ; external ;
  function get_internal : hex ; external ;
  procedure warning ; external ;
  function toamd (r : real) : real ; external ;
  
  function slpar (var lerror : error_type) : boolean ; entry ;
    begin
      lerror := undef ;
      scan ;
      if lastpack^.token = leftparen
        then
          begin
            slpar := false ;
            scan
          end
        else
          begin
            slpar := true ;
            lerror := e_lpar
          end
    end ;
    
  function srpar : rptype ; entry ;
    begin
      case lastpack^.token of
        rightparen :
          begin
            srpar := rpar ;
            scan
          end ;
        comma :
          begin
            srpar := com ;
            scan
          end
        else
          srpar := (nopar)
      end
    end ;
    
  function lpars : boolean ; entry ;
    begin
      scan ;
      lpars := lastpack^.token = leftparen
    end ;

  function giveit (req : tokes ; var gerror : error_type ;
                   gpac : ^packet) : ^packet ; entry ;
    begin
      gerror := undef ;
      repeat
        if gpac^.token in req
          then
            exit ; {is ok, correct type}
        if (gpac^.token = charvar) and (stringvar in req)
          then
            begin
              if gpac^.conflag
                then
                  begin
                    opcode (c_ldd) ;
                    post1 (p_imm) ;
                    codet_word ($100 + hex(gpac^.pvc_char)) ;
                    {ldd #$1xx}
                    opcode (c_pshu) ;
                    post1t (p_ipd) ;
                    {pshu d}
                    gpac^.conflag := false
                  end
                else
                  begin
                    uncon (gpac) ;
                    eminln (101) {convert character to string}
                  end ;
              gpac^.token := stringvar ;
              exit
            end ;
        if (gpac^.token = integvar) and (lintvar in req)
          then
            begin
              if gpac^.conflag
                then
                  gpac^.pvc_longinteger := longinteger(gpac^.pvc_integer)
                else
                  hand (int, $40) ; {convert integer to longinteger}
              gpac^.token := lintvar ;
              exit
            end ;
        if (gpac^.token = integvar) and (realvar in req)
          then
            begin
              if gpac^.conflag
                then
                  gpac^.pvc_real := toamd(real(gpac^.pvc_integer))
                else
                  hand (int, 6) ; {convert integer to real}
              gpac^.token := realvar ;
              exit
            end ;
        if (gpac^.token = lintvar) and (realvar in req)
          then
            begin
              if gpac^.conflag
                then
                  gpac^.pvc_real := toamd(real(gpac^.pvc_longinteger))
                else
                  hand (int, $42) ; {convert longinteger to real}
              gpac^.token := realvar ;
              exit
            end ;
        if (gpac^.token = hexvar) and (lhexvar in req)
          then
            begin
              if gpac^.conflag
                then
                  gpac^.pvc_longhex := longhex(gpac^.pvc_hex)
                else
                  eminln (123) ; {convert hex to longhex}
              gpac^.token := lhexvar ;
              exit
            end ;
        if gpac^.conflag
          then
            begin
              if (gpac^.token in [integvar,hexvar]) and (charvar in req)
                then
                  begin
                    gpac^.pvc_char := byte(gpac^.pvc_integer) ;
                    gpac^.token := charvar ;
                    warning ;
                    exit
                  end ;
              if gpac^.token = integvar
                then
                  if hexvar in req
                    then
                      begin
                        gpac^.pvc_hex := hex(gpac^.pvc_integer) ;
                        gpac^.token := hexvar ;
                        warning ;
                        exit
                      end
                    else if lhexvar in req
                      then
                        begin
                          gpac^.pvc_longhex := longhex(gpac^.pvc_integer) ;
                          gpac^.token := lhexvar ;
                          warning ;
                          exit
                        end
            end ;
        gerror := e_tc
      until true ;
      giveit := gpac
    end ;
    
  function gimme (req : tokes ; var gerror : error_type) : ^packet ;
                                                            entry ;
    var
      gpac : ^packet register ;
    begin
      gpac := outexp (gerror) ;
      if gerror = undef
        then
          gimme := giveit(req, gerror, gpac)
    end ;

  procedure sub5 (vpac : ^packet ; var ftype : token_type ;
                  var file_spec : boolean ; var fsize : hex ;
                  var devname : byte) ;
    var
      p1 : ^type_device_head register ;
      p2, p4 : ^token_type register ;
      p3 : ^longhex ;
      bpac : ^packet register ;
    begin
      file_spec := true ;
      p1 := vpac^.pv_device ;
      p2 := align (p1 + longhex(sizeof(type_device_head))) ;
      p4 := p2 ;
      while p4^ = deferred do
        begin
          p3 := align(p4 + 1L) ;
          p4 := p3^ + align(sizeof(symhead))
        end ;
      ftype := p4^ ;
      bpac := get_packet (p2) ;
      fsize := bpac^.size ;
      devname := p1^.name_flag
    end ;
    
  function sub3 (var gerror : error_type ; var ftype : token_type ;
                 var file_spec : boolean ; var fsize : hex ;
                 var devname : byte) : boolean ; entry ;
    var
      pac : ^packet ;
    begin
      scan ;
      file_spec := false ;
      pac := varib(lastpack, gerror, false, true) ;
      if gerror = undef
        then
          if pac^.token = devicevar
            then
              begin
                sub3 := false ;
                sub5 (pac, ftype, file_spec, fsize, devname)
              end
            else
              begin
                sub3 := true ;
                gerror := e_espp
              end
    end ;

  procedure stand_proc (var gerror : error_type) ; entry ;
    const
      rdone = 1 ;
      rdln = 2 ;
      ckdev = 3 ;
      wdone = 4 ;
      wrln = 5 ;
      wckdev = 6 ;
      isstand = 7 ;
    label
      rdone, rdln, ckdev, wdone, wrln, wckdev, isstand ;
    var
      lerror : error_type ;
      msel, ftype : token_type ;
      vpac, epac : ^packet register ;
      newsize, fsize : hex ;
      default, file_spec, field, first : boolean ;
      devname, psel : byte ;
      p3 : ^type_device_head ;
      dev_ident : string[8] ;
      temp1, appmask, appcount : hex ;
      p1 : ^anystring ;
      
    procedure setup (devnum : device_mod ; subrut : boolean) ;
      begin
        default := false ;
        if devnum in stddev
          then
            begin
              if subrut
                then
                  if devnum = input_
                    then
                      hand (proc, $61)
                    else
                      hand (proc, $62)
                else
                  begin
                    if lex <> 1
                      then
                        begin
                          eminln (128) ;
                          opcode (c_ldx) ;
                          post1 (p_idx + p_ixfx + p_ixrx)
                        end
                      else
                        begin
                          opcode (c_ldx) ;
                          post1 (p_idx + p_ixfx + p_ixry)
                        end ;
                    case devnum of
                      input_ : codet_word (hex(r_inp)) ;
                      output_ : codet_word (hex(r_out))
                    end ;
                    {ldx n,x or ldx n,y}
                  end ;
              default := true ;
              ftype := textvar ;
              fsize := 1
            end
      end ;
      
    function sub8 : boolean ;
      begin
        sub8 := default or file_spec
      end ;
      
    function sub7 (pac : ^packet) : token_type ;
      var
        s : string ;
      begin
        s := upshift(pac^.pointr^.nameptr^) ;
        case s of
          'INPUT' : sub7 := input_ ;
          'OUTPUT' : sub7 := output_ ;
          'AUXOUT' : sub7 := auxout_ ;
          'KEYBOARD' : sub7 := keyboard_
          else
            sub7 := pac^.token
        end
      end ;
      
    procedure get_field ;
      var
        fpac : ^packet register ;
      begin
        scan ;
        fpac := gimme([charvar, integvar, hexvar], gerror) ;
        if gerror = undef
          then
            begin
              if (fpac^.token <> charvar) and fpac^.conflag
                then
                  begin
                    fpac^.pvc_char := byte(fpac^.pvc_hex) ;
                    fpac^.token := charvar
                  end ;
              uncon (fpac)
            end
      end ;
      
    begin
      gerror := undef ;
      msel := lastpack^.token ;
      repeat
        case msel of
          new_, dispose_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              vpac := varib (lastpack, gerror, false, true) ;
              opcode (c_pshu) ;
              post1t (p_ipx) ; {pshu x}
              if gerror <> undef
                then
                  exit ;
              if (vpac^.token <> hexvar) or
                 (vpac^.pv_pointer.ptrf = nonptr)
                then
                  begin
                    gerror := e_tc ;
                    exit
                  end ;
              if vpac^.pv_pointer.ptrf = stand
                then
                  case vpac^.pv_pointer.base_type of
                    boolvar, charvar, enumvar .. subchar :
                      newsize := 1 ;
                    integvar .. hexvar, subinteg .. subhex :
                      newsize := 2 ;
                    lhexvar .. realvar, sublhex .. sublint :
                      newsize := 4
                  end
                else
                  begin
                    vpac := fetch_packet(vpac^.pv_pointer.base_ptr) ;
                    newsize := vpac^.size
                  end ;
              repeat {look for end, new size, or variants}
                case srpar of
                  rpar :
                    begin
                      lddim (newsize) ;
                      {ldd #size}
                      exit
                    end ;
                  com : scan
                  else
                    if lastpack^.token = colon
                      then
                        begin
                          scan ;
                          epac := outexp (gerror) ;
                          if not (epac^.token in [integvar, hexvar, lintvar, lhexvar])
                            then
                              begin
                                gerror := e_tc ;
                                exit (2)
                              end ;
                          if gerror <> undef
                            then
                              exit(2) ;
                          uncon (epac) ;
                          if epac^.token > hexvar
                            then
                              eminln (124) ;
                          if srpar = rpar
                            then
                              exit
                            else
                              begin
                                gerror := e_rpar ;
                                exit (2)
                              end
                        end {colon}
                      else
                        scan
                end {case}
              until false ;
              if msel = new_
                then
                  if intask and oldtask
                    then
                      hand (proc, $70)
                    else
                      hand (proc, $36)
                else
                  if intask and oldtask
                    then
                      hand (proc, $71)
                    else
                      hand (proc, $39)
            end ; {new/dispose}
          mark_, release_ :
            begin
              if slpar(gerror)
                then
                  exit ;
              vpac := varib(lastpack,gerror,false,true) ;
              if gerror <> undef
                then
                  exit ;
              if vpac^.token in [hexvar, integvar]
                then
                  begin
                    if msel = mark_
                      then
                        if intask and oldtask
                          then
                            hand (proc, $72)
                          else
                            hand (proc, $37)
                      else
                        if intask and oldtask
                          then
                            hand (proc, $73)
                          else
                            hand (proc, $38) ;
                    if srpar <> rpar
                      then
                        gerror := e_rpar
                  end
                else
                  gerror := e_tc
            end ; {mark/release}
          halt_ :
            begin
              if slpar (gerror)
                then
                  exit ;
              epac := gimme ([charvar .. hexvar], gerror) ;
              if gerror <> undef
                then
                  exit ;
              uncon (epac) ;
              hand (int, $fc) ;
              if srpar <> rpar
                then
                  gerror := e_rpar
            end ;
          read_, readln_ :
            begin
              default := false ;
              file_spec := false ;
              if slpar(lerror)
                then
                  if msel = read_
                    then
                      exit
                    else
rdone :
                      if sub8
                        then
rdln :
                          if msel = readln_
                            then
                              hand (proc, $32)
                            else
                        else
                          begin
                            setup (input_, true) ;
                            if sub8
                              then
                                goto rdln
                              else
                                begin
                                  gerror := e_usio ;
                                  exit
                                end
                          end
                else
                  begin {parameter list}
                    vpac := varib(lastpack, gerror, false, true) ;
                    if gerror <> undef
                      then
                        exit ;
                    if vpac^.token <> devicevar
                      then
                        goto ckdev ;
                    eminln (112) ; {put in -10,y}
                    sub5 (vpac, ftype, file_spec, fsize, devname) ;
                    if (msel = readln_) and (ftype <> textvar)
                      then
                        begin
                          gerror := e_espp ;
                          exit
                        end ;
                    repeat {parameter}
                      case srpar of
                        rpar : goto rdone ;
                        nopar :
                          begin
                            gerror := e_comma ;
                            exit (2)
                          end
                      end ;
                      vpac := varib(lastpack,gerror,false,true) ;
                      if gerror <> undef
                        then
                          exit (2) ;
ckdev :
                      if not sub8
                        then
                          begin
                            setup (input_, true) ;
                            if not sub8
                              then
                                begin
                                  gerror := e_usio ;
                                  exit(2)
                                end
                          end ;
                      if ftype = textvar
                        then
                          begin
                            case vpac^.token of
                              boolvar : hand(proc, 7) ;
                              charvar : hand(proc, 9) ;
                              integvar : hand(proc, 1) ;
                              hexvar : hand(proc, 3) ;
                              lhexvar, sublhex : hand(proc,$65) ;
                              lintvar, sublint : hand(proc,$55) ;
                              realvar : hand (proc, 5) ;
                              stringvar :
                                begin
                                  hand (proc, $11) ;
                                  datat_byte (byte(vpac^.size))
                                end ;
                              subbool, subchar :
                                begin
                                  if vpac^.token = subbool
                                    then
                                      hand (proc, 7)
                                    else
                                      hand (proc, 9) ;
                                  if subrange_opt
                                    then
                                      begin
                                        hand (int, 2) ;
                                        data_byte (byte(vpac^.pv_subbool.offset)) ;
                                        datat_byte (byte(vpac^.pv_subbool.range))
                                      end
                                end ;
                              subhex, subinteg :
                                begin
                                  if vpac^.token = subhex
                                    then
                                      hand (proc, 3)
                                    else
                                      hand (proc, 1) ;
                                  if subrange_opt
                                    then
                                      begin
                                        if vpac^.token = subhex
                                          then
                                            hand (int, $33)
                                          else
                                            hand (int, 3) ;
                                        data_word(vpac^.pv_subhex.range);
                                        datat_word(vpac^.pv_subhex.offset)
                                      end
                                end
                              else
                                begin
                                  gerror := e_espp ;
                                  exit (2)
                                end
                            end {case}
                          end {text}
                        else
                          begin {non-text}
                            if vpac^.token <> ftype
                              then
                                begin
                                  gerror := e_tc ;
                                  exit (2)
                                end ;
                            case vpac^.token of
                              arrayvar, recordvar :
                                if vpac^.size <> fsize
                                  then
                                    begin
                                      gerror := e_tc ;
                                      exit (2)
                                    end ;
                              stringvar, setvar :
                                if fsize < vpac^.size
                                  then
                                    begin
                                      gerror := e_tc ;
                                      exit (2)
                                    end
                            end ; {case}
                            hand (proc, $25)
                        end {non text}
                    until false
                  end {parameter list}
            end ; {read_, readln_}
          write_, writeln_ :
            begin
              default := false ;
              file_spec := false ;
              if slpar(lerror)
                then
                  if msel = write_
                    then
                      exit
                    else
wdone :
                      if sub8
                        then
wrln :
                          if msel = writeln_
                            then
                              hand (proc, $35)
                            else
                        else
                          begin
                            setup (output_, true) ;
                            if sub8
                              then
                                goto wrln
                              else
                                begin
                                  gerror := e_usio ;
                                  exit
                                end
                          end
                else
                  begin {parameter list}
                    epac := outexp (gerror) ;
                    if gerror <> undef
                      then
                        exit ;
                    if epac^.token <> devicevar
                      then
                        goto wckdev ;
                    eminln (112) ; {put in -10,y}
                    sub5 (epac, ftype, file_spec, fsize, devname) ;
                    if (msel = writeln_) and (ftype <> textvar)
                      then
                        begin
                          gerror := e_espp ;
                          exit
                        end ;
                    repeat {parameter}
                      case srpar of
                        rpar : goto wdone ;
                        nopar :
                          begin
                            gerror := e_comma ;
                            exit (2)
                          end
                      end ;
                      epac := outexp (gerror) ;
                      if gerror <> undef
                        then
                          exit (2) ;
wckdev :
                      if epac^.token <> stringvar
                        then
                          uncon (epac) ;
                      if not sub8
                        then
                          begin
                            setup (output_, true) ;
                            if not sub8
                              then
                                begin
                                  gerror := e_usio ;
                                  exit(2)
                                end
                          end ;
                      if ftype = textvar
                        then
                          begin
                            case epac^.token of
                              boolvar : psel := 6 ;
                              charvar : psel := 8 ;
                              integvar : psel := 0 ;
                              hexvar : psel := 2 ;
                              lhexvar : psel := $64 ;
                              lintvar : psel := $54 ;
                              realvar : psel := 4 ;
                              stringvar : 
                                begin
                                  if epac^.conflag
                                    then
                                      uncon (epac) ;
                                  psel := $10
                                end ;
                              arrayvar :
                                if epac^.size > 127
                                  then
                                    begin
                                      gerror := e_tc ;
                                      exit (2)
                                    end
                                  else
                                    begin
                                      ldbim (byte(epac^.size)) ;
                                      {ldb #size}
                                      opcode (c_pshu) ;
                                      post1t (p_ipb) ;
                                      {pshu b}
                                      psel := $10
                                    end
                              else
                                begin
                                  gerror := e_espp ;
                                  exit(2)
                                end
                            end ; {case}
                            field := false ;
                            if lastpack^.token <> colon
                              then
                                begin
                                  case psel of
                                    4 : psel := $44 ;
                                    $64 : psel := $63 ;
                                    $54 : psel := $52 ;
                                    $41 : psel := $43
                                    else
                                      psel := psel + $40
                                  end ;
                                end
                              else
                                begin {has field}
                                  push (epac) ;
                                  field := true ;
                                  get_field ;
                                  if gerror <> undef
                                    then
                                      exit(2) ;
                                  if epac^.token = realvar
                                    then
                                      begin
                                        opcode (c_pshu) ;
                                        post1t (p_ipb) ;
                                        {pshu b}
                                        if lastpack^.token = colon
                                          then
                                            begin
                                              get_field ;
                                              if gerror <> undef
                                                then
                                                  exit (2)
                                            end
                                          else
                                            begin
                                              opcode (c_ldb) ;
                                              post2t (p_imm, -1)
                                              {ldb #-1}
                                            end
                                      end
                                end ; {has field}
                            hand (proc, psel)
                          end {text}
                        else
                          begin {not text}
                            if epac^.token <> ftype
                              then
                                begin
                                  gerror := e_tc ;
                                  exit(2)
                                end ;
                            push(epac) ;
                            case epac^.token of
                              arrayvar, recordvar :
                                if epac^.size <> fsize
                                  then
                                    begin
                                      gerror := e_tc ;
                                      exit(2)
                                    end ;
                              stringvar, setvar :
                                begin
                                  hand (int, $27) ;
                                  datat_byte (byte(fsize))
                                end
                            end ;
                            hand (proc, $26)
                          end {non text}
                    until false
                  end {parameter list}
            end ; {write, writeln}
          page_ :
            begin
              if lpars
                then
                  begin
                    if sub3(gerror, ftype, file_spec, fsize, devname)
                      then
                        exit ;
                    if ftype <> textvar
                      then
                        begin
                          gerror := e_espp ;
                          exit
                        end ;
                    if srpar <> rpar
                      then
                        begin
                          gerror := e_rpar ;
                          exit
                        end
                  end
                else
                  begin
                    setup (output_,false) ;
                    if not default
                      then
                        begin
                          gerror := e_usio ;
                          exit
                        end
                  end ;
              hand (proc, $23)
            end ; {page_}
          open_, create_, reset_, rewrite_ :
            begin
              if not lpars
                then
                  begin
                    gerror := e_lpar ;
                    exit
                  end ;
              if sub3(gerror, ftype, file_spec, fsize, devname)
                then
                  exit ;
              opcode (c_pshu) ;
              post1t (p_ipx) ;
              {pshu x}
              lddim (fsize) ;
              {ldd #size} ;
              opcode (c_pshu) ;
              post1t (p_ipd) ;
              {pshu d}
              case srpar of
                nopar :
                  begin
                    gerror := e_rpar ;
                    exit
                  end ;
                rpar :
                  begin {use default name}
                    if devname = 0
                      then
                        begin
                          opcode (c_clr) ;
                          post1t (p_idx + p_ixru + p_ixm)
                          {clr -0,u}
                        end
                      else
                        begin
                          opcode (c_ldb) ;
                          post2t (p_imm, devname) ;
                          {ldb #num}
                          hand (func, $70)
                        end ;
                    if msel in [open_, create_]
                      then
                        begin
                          gerror := e_comma ;
                          exit
                        end
                  end ; {default name}
                com :
                  begin {filename specified}
                    case lastpack^.token of
                      stringvar :
                        begin
                          uncon (lastpack) ;
                          scan
                        end ;
                      input_ .. keyboard_ :
isstand :
                        if ftype <> textvar
                          then
                            begin
                              gerror := e_espp ;
                              exit
                            end
                          else
                            begin
                              opcode (c_pulu) ;
                              post1t (p_ipx) ;
                              opcode (c_pulu) ;
                              post1t (p_ipd) ; {pulu x  pulu d}
                              case lastpack^.token of
                                input_ : psel := m_text + m_int ;
                                output_, auxout_ : psel := m_text ;
                                keyboard_ : psel := m_int
                              end ;
                              if break_opt
                                then
                                  psel := psel + m_bk ;
                              ldaim (psel) ;
                              {lda #mode}
                              hand (dev, byte(lastpack^.token) -
                                         byte(input_)) ;
                              scan ;
                              if srpar <> rpar
                                then
                                  gerror := e_rpar ;
                              exit 
                            end ;
                      vardef :
                        begin
                          lastpack^.token := sub7(lastpack) ;
                          if lastpack^.token in [input_ .. keyboard_]
                            then
                              goto isstand
                            else
                              begin
                                epac := gimme([stringvar],gerror) ;
                                if gerror <> undef
                                  then
                                    exit ;
                                uncon (epac)
                              end
                        end
                      else
                        begin
                          epac := gimme([stringvar],gerror) ;
                          if gerror <> undef
                            then
                              exit ;
                          uncon (epac)
                        end
                    end ; {case}
                    case srpar of
                      nopar :
                        begin
                          gerror := e_rpar ;
                          exit
                        end ;
                      rpar :
                        if msel in [open_, create_]
                          then
                            begin
                              gerror := e_comma ;
                              exit
                            end ;
                      com :
                        begin {get direction}
                          if not(lastpack^.token in [input_, output_,
                                                     update_])
                            then
                              if lastpack^.token = vardef
                                then
                                  lastpack^.token := sub7(lastpack) ;
                          if not (lastpack^.token in [input_, output_,
                                                      update_])
                            then
                              begin
                                gerror := e_espp ;
                                exit
                              end ;
                          opcode (c_lda) ;
                          post1 (p_imm) ;
                          case lastpack^.token of
                            input_ : post1t(1) ;
                            output_ : post1t(2) ;
                            update_ : post1t(3)
                          end ;
                          {lda #mode}
                          opcode (c_pshu) ;
                          post1t (p_ipa) ; {pshu a}
                          scan ;
                          case srpar of
                            rpar : opcodet (c_clrb) ; {clrb}
                            nopar :
                              begin
                                gerror := e_rpar ;
                                exit
                              end ;
                            com :
                              begin
                                epac := gimme([charvar .. hexvar],
                                              gerror) ;
                                if gerror <> undef
                                  then
                                    exit ;
                                uncon (epac) ;
                                if srpar <> rpar
                                  then
                                    begin
                                      gerror := e_rpar ;
                                      exit
                                    end
                              end
                          end {case}
                        end {comma}
                    end {case}
                  end {filename specified}
              end ; {case}
              if msel in [reset_, rewrite_]
                then
                  begin
                    ldaim (byte(msel) - byte(reset_) + 1) ;
                    {lda #Mode}
                    opcode (c_pshu) ;
                    post1t (p_ipa) ; {pshu a}
                    opcodet (c_clrb)
                  end ;
              if msel in [open_, reset_]
                then
                  hand (proc, $18)
                else
                  hand (proc, $19)
            end ; {open, create, reset, rewrite}
          del_, seek_ :
            begin
              if not lpars
                then
                  begin
                    gerror := e_lpar ;
                    exit
                  end ;
              if sub3(gerror, ftype, file_spec, fsize, devname)
                then
                  exit ;
              if srpar <> com
                then
                  begin
                    gerror := e_comma ;
                    exit
                  end ;
              opcode (c_pshu) ;
              post1t (p_ipx) ;
              {pshu x}
              if msel = del_
                then
                  begin
                    epac := gimme([stringvar], gerror) ;
                    if gerror <> undef
                      then
                        exit ;
                    uncon (epac) ;
                    if srpar <> rpar
                      then
                        begin
                          gerror := e_rpar ;
                          exit
                        end ;
                    hand (proc, $22)
                  end
                else
                  begin {seek}
                    epac := outexp (gerror) ;
                    if not (epac^.token in [integvar, hexvar, lintvar, lhexvar])
                      then
                        begin
                          gerror := e_tc ;
                          exit
                        end ;
                    if gerror <> undef
                      then
                        exit ;
                    if epac^.token in [integvar, hexvar]
                      then
                        if epac^.conflag
                          then
                            begin
                              epac^.pvc_longhex := longhex(epac^.pvc_hex) ;
                              epac^.token := lhexvar ;
                              uncon (epac)
                            end
                          else
                            begin
                              uncon (epac) ;
                              opcode (c_pshu) ;
                              post1t (p_ipd) ;
                              {pshu d}
                              opcodet (c_clra) ;
                              opcodet (c_clrb) ;
                              opcode (c_pshu) ;
                              post1t (p_ipd)
                            end
                      else
                        uncon (epac) ;
                    if srpar <> rpar
                      then
                        begin
                          gerror := e_rpar ;
                          exit
                        end ;
                    hand (proc, $21)
                  end
            end ; {del, seek}
          close_, get_, put_ :
            begin
              if not lpars
                then
                  begin
                    gerror := e_lpar ;
                    exit
                  end ;
              if sub3(gerror, ftype, file_spec, fsize, devname)
                then
                  exit ;
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end ;
              case msel of
                close_ : hand (proc, $20) ;
                get_   : hand (proc, $15) ;
                put_   : hand (proc, $16)
              end
            end ; {close, get, put}
          devinit_ :
            begin
              if not lpars
                then
                  begin
                    gerror := e_lpar ;
                    exit
                  end ;
              scan ;
              dev_ident := concat('.',substr(last_ident,1,7)) ;
              vpac := varib(lastpack, gerror, false, true) ;
              if gerror <> undef
                then
                  exit ;
              if vpac^.token <> devicevar
                then
                  begin
                    gerror := e_espp ;
                    exit
                  end ;
              p3 := vpac^.pv_device ;
              init_device (p3, dev_ident) ;
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end
            end ; {devinit}
          devstat_ :
            begin
              if not lpars
                then
                  begin
                    gerror := e_lpar ;
                    exit
                  end ;
              scan ;
              vpac := varib(lastpack, gerror, false, true) ;
              if gerror <> undef
                then
                  exit ;
              if vpac^.token <> devicevar
                then
                  begin
                    gerror := e_espp ;
                    exit
                  end ;
              opcode (c_pshu) ;
              post1t (p_ipx) ;
              {pshu x}
              if srpar <> com
                then
                  begin
                    gerror := e_comma ;
                    exit
                  end ;
              vpac := varib(lastpack, gerror, false, true) ;
              if gerror <> undef
                then
                  exit ;
              hand (proc, $24) ;
              if srpar <> rpar
                then
                  begin
                    gerror := e_rpar ;
                    exit
                  end
            end ; {devstat}
          append_ :
            begin
              first := true ;
              appmask := 0 ;
              appcount := 0 ;
              if slpar(gerror)
                then
                  exit ;
              repeat
                if (lastpack^.token in [charvar, stringvar]) and
                   lastpack^.conflag and not first
                  then {char/string constant}
                    with lastpack^ do
                      begin
                        p1 := pvc_string ;
                        vpac := lastpack ;
                        temp1 := get_internal ;
                        opcodet (cd_data) ;
                        opcode (c_equ) ;
                        post1 (p_imm + p_eqep) ;
                        labt(concat('..',labout(temp1))) ;
                        if token = charvar
                          then
                            datat_byte(pvc_char)
                          else
                            begin
                              data_byte(p1^[0]) ;
                              datast (p1^)
                            end ;
                        opcodet (cd_code) ;
                        opcode (c_leax) ;
                        post1 (p_idx + p_ixrp + p_ixex) ;
                        labt (concat('..',labout(temp1))) ;
                        {leax ..xx,pcr}
                        purge (temp1) ;
                        scan
                      end
                  else
                    begin
                      vpac := varib(lastpack, gerror, false, true) ;
                      if gerror <> undef
                        then
                          exit ;
                      if not (vpac^.token in [charvar, stringvar])
                        then
                          begin
                            gerror := e_espp ;
                            exit
                          end ;
                    end ;
                opcode (c_pshu) ;
                post1t (p_ipx) ;
                {pshu x}
                if first
                  then
                    first := false
                  else
                    begin
                      appmask := appmask << 1 ;
                      if vpac^.token = charvar
                        then
                          appmask := appmask or 1 ;
                      appcount := appcount + 1 ;
                      if appcount > $F
                        then
                          begin
                            gerror := e_rpar ;
                            exit
                          end
                    end ;
                case srpar of
                  rpar : exit ;
                  nopar :
                    begin
                      gerror := e_rpar ;
                      exit (2)
                    end
                end
              until false ;
              lddim (appmask) ;
              {ldd #appmask}
              hand (proc, $33) ;
              datat_byte (byte(appcount))
            end ;
          firqon_ :
            begin
              opcode (c_andcc) ;
              post2t (p_imm, $bf) ;
              scan
            end ;
          irqon_ :
            begin
              opcode (c_andcc) ;
              post2t (p_imm, $ef) ;
              scan
            end ;
          firqoff_ :
            begin
              opcode (c_orcc) ;
              post2t (p_imm, $40) ;
              scan
            end ;
          irqoff_ :
            begin
              opcode (c_orcc) ;
              post2t (p_imm, $10) ;
              scan
            end ;
        end
      until true
    end ;
    
modend.
