module state {$v3,0 statements} (output) ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function get_packet (t : ^token_type) : ^packet ; external ;
  procedure errorpt (errnum : error_type) ; external ;
  procedure error (errnum : error_type) ; external ;
  procedure end_statement (e : error_type ; toke : tokes) ; external ;
  procedure replace (e : error_type ; t : token_type) ; external ;
  procedure insert (e : error_type ; t : token_type) ; external ;
  function sym_search (s : string[120] ; restrict : boolean) : ^packet ; external ;
  function digit5 (i : integer) : string[5] ; external ;
  function get_internal : hex ; external ;
  procedure dump ; external ;
  procedure vget ; external ;
  function varib (vpac : ^packet ; var verror : error_type ; 
                  getdata : boolean ; outer : boolean) : ^packet ; external ;
  function outexp (var oerror : error_type) : ^packet ; external ;
  procedure uncon (p : ^packet) ; external ;
  procedure push (p : ^packet) ; external ;
  procedure xdat (p : ^packet) ; external ;
  procedure if_state (var gerror : error_type) ; external ;
  procedure repeat_state (var gerror : error_type) ; external ;
  procedure while_state (var gerror : error_type) ; external ;
  procedure for_state (var gerror : error_type) ; external ;
  procedure case_state (var gerror : error_type) ; external ;
  procedure with_state (var gerror : error_type) ; external ;
  procedure exit_state (var gerror : error_type) ; external ;
  procedure proc_call (var gerror : error_type ; p : ^symhead) ; external ;
  procedure stand_proc (var gerror : error_type) ; external ;
  function giveit (req : tokes ; var gerror : error_type ;
                   gpac : ^packet) : ^packet ; external ;
  
{
  return packet for a token type
}
  function retpac (t : token_type) : ^packet ; entry ;
    begin
      retpac := get_packet (addr(t))
    end ;
    
  procedure labeled (var lerror : error_type) ;
    var
      p1 : ^packet register ;
      p2 : ^symhead register ;
    begin
      lerror := undef ;
      p1 := sym_search (digit5(lastpack^.pvc_integer),true) ;
      if p1^.token <> undef
        then
          begin
            p2 := p1^.pointr ;
            p2^.offset := alloc ; {now defined - set in stack}
            opcode (c_equ) ;
            post1 (p_imm + p_eqlp) ;
            codet_word (p2^.intname) ; {lbxxxx equ *}
            scan ;
            if lastpack^.token = colon
              then
                scan {skip colon}
              else
                lerror := e_colon
          end
        else
          begin
            end_statement (e_ui, [colon]) ;
            if lastpack^.token = colon
              then
                scan
              else
                lerror := e_colon
          end
    end ;
    
  procedure goto_state (var terror : error_type) ;
    var
      p1 : ^packet register ;
      temp : hex register ;
    begin
      repeat
        scan ;
        if lastpack^.token <> integvar
          then
            begin
              terror := e_integ ;
              exit
            end ;
        p1 := sym_search (digit5(lastpack^.pvc_integer),true) ;
        if p1^.token = undef
          then
            begin
              terror := e_ui ;
              exit
            end ;
        if p1^.pv_label.offset = 0
          then
            begin {forward}
              if forward_goto >= size_gotoq
                then
                  begin
                    terror := e_fqf ;
                    exit
                  end ;
              forward_goto := forward_goto + 1 ;
              with gotoq[forward_goto] do
                begin
                  auxlabel := get_internal ;
                  opcode (c_xbxx) ;
                  post1 (p_rel + p_rell + p_bra) ;
                  codet_word (auxlabel) ; {bra lbxxx}
                  gotooff := alloc ;
                  labpt := p1^.pointr ;
                  scan
                end
            end
          else
            begin
              if alloc < p1^.pv_label.offset
                then
                  begin
                    terror := e_igtl ;
                    exit
                  end ;
              temp := alloc - p1^.pv_label.offset ;
              if temp <> 0
                then
                  begin
                    opcode (c_leau) ;
                    post1 (p_idx + p_ixru + p_ixfx) ;
                    codet_word (temp)
                  end ;
              opcode (c_xbxx) ;
              post1 (p_rel + p_rell + p_bra) ;
              codet_word (p1^.pv_label.internal) ; {bra lbxxxx}
              scan
            end
      until true
    end ;
            
  procedure inline_state ;
    var
      i : byte register ;
      p : ^symname register ;
      s : string[120] ;
    begin
      dump ;
      repeat
        p := lastpack^.pointr ;
        icode_buf := char(c_inline) ;
        passt (p^) ;
        heapptr := heapstart ; {release buffer}
        scan
      until lastpack^.token <> inline ;
      dump
    end ;
  
  procedure var_assign (var verror : error_type ; rangev : boolean) ;
    var
      varpac : ^packet register ;
      expac : ^packet register ;
      con_exp : boolean register ;
      ps : ^anystring register ;
      vari : byte ;
      temp : hex ;
    begin
      repeat
        line ;
        var_access := true ;
        if rangev
          then
            begin
              if lex = 1
                then
                  begin
                    opcode (c_leax) ;
                    post1 (p_idx + p_ixry + p_ixfx)
                  end
                else
                  begin
                    eminln (128) ; {ldx -6,y}
                    opcode (c_leax) ;
                    post1 (p_idx + p_ixrx + p_ixfx)
                  end ;
              codet_word (5) ; {leax 5,x or leax 5,y}
              scan ;
              varpac := retpac (boolvar)
            end
          else
            begin
              varpac := varib (lastpack, verror, false, true) ;
              if verror <> undef
                then
                  if verror <> e_iurv
                    then
                      begin
                        var_access := false ;
                        exit
                      end
            end ;
        var_access := false ;
        case lastpack^.token of
          assign : scan ;
          equal, colon :
            begin
              replace (e_assign, assign) ;
              scan
            end
          else insert (e_assign, assign)
        end ;
        expac := outexp (verror) ;
        if verror <> undef
          then
            exit ;
        con_exp := expac^.conflag ; {save constant status}
        if expac^.token = devicevar
          then
            begin
              verror := (e_tc) ;
              exit
            end ;
        if (varpac^.token <> expac^.token) and
           (byte(varpac^.token) - sub_offset <> byte(expac^.token))
          then
            if expac^.token in [integvar .. lintvar]
              then
                if varpac^.token in [charvar .. realvar]
                  then
                    expac := giveit([varpac^.token], verror, expac)
                  else if varpac^.token in [subchar .. sublint]
                    then
                      expac := giveit([byte(varpac^.token) - sub_offset],
                                      verror, expac) ;
        if verror <> undef
          then
            exit ;
        if (varpac^.token <> expac^.token) and
           (byte(varpac^.token) - sub_offset <> byte(expac^.token))
          then
            case hex(varpac^.token) << 8 + hex(expac^.token) of
              hex(stringvar) << 8 + hex(charvar) :
                begin
                  if expac^.conflag
                    then
                      begin
                        expac^.token := hexvar ;
                        varpac^.token := hexvar ;
                        expac^.pvc_hex := hex(expac^.pvc_char) + $100
                      end
                    else
                      begin
                        uncon (expac) ;
                        eminln (101) ; {convert char to string}
                        expac^.token := stringvar ;
                        expac^.size := $40
                      end
                end ;
              hex(arrayvar) << 8 + hex(charvar) :
                varpac^.token := charvar ;
              hex(arrayvar) << 8 + hex(stringvar) :
                begin
                  uncon (expac) ;
                  if varpac^.size > longhex(126)
                    then
                      begin
                        verror := e_tc ;
                        exit
                      end ;
                  hand (int, $27) ;
                  datat_byte (byte(varpac^.size + 1)) ;
                  opcode (c_leau) ;
                  post1 (p_idx + p_ixru + p_ixfx) ;
                  codet_word (1) ; {leau 1,u}
                  expac^.token := arrayvar ;
                  expac^.size := varpac^.size
                end ;
              hex(stringvar) << 8 + hex(arrayvar) :
                begin
                  uncon (expac) ;
                  if expac^.size > longhex(126)
                    then
                      begin
                        verror := e_tc ;
                        exit
                      end ;
                  ldaim (byte(expac^.size)) ;
                  {lda #size}
                  opcode (c_pshu) ;
                  post1t (p_imm + p_ipa) ;
                  {pshu a}
                  expac^.token := stringvar ;
                  expac^.size := expac^.size + 1
                end
              else
                begin
                  verror := e_tc ;
                  exit
                end
            end ;
        if (expac^.token = stringvar) and expac^.conflag
          then
            begin
              ps := expac^.pvc_string ;
              if ps^[0] = 0 {null string}
                then
                  begin {just clear dynamic length}
                    expac^.token := charvar ;
                    varpac^.token := charvar ;
                    expac^.pvc_char := 0
                  end
            end ;
        uncon (expac) ; {make sure in primary}
        if subrange_opt
          then
            case varpac^.token of
              subbool, subchar, enumvar :
                if con_exp
                  then
                    if (expac^.pvc_char < varpac^.pv_subchar.offset) or
                       (expac^.pvc_char - varpac^.pv_subchar.offset >
                                          varpac^.pv_subchar.range)
                      then
                        errorpt (e_wcor)
                      else
                  else
                    begin
                      hand (int, 2) ;
                      datat_word (hex(varpac^.pv_subchar.offset) << 8 +
                                  hex(varpac^.pv_subchar.range))
                    end ;
              subhex :
                if con_exp
                  then
                    if (expac^.pvc_hex < varpac^.pv_subhex.offset) or
                       (expac^.pvc_hex - varpac^.pv_subhex.offset >
                                         varpac^.pv_subhex.range)
                      then
                        errorpt (e_wcor)
                      else
                  else
                    begin
                      hand (int, $33) ;
                      data_word (varpac^.pv_subhex.offset) ;
                      datat_word (varpac^.pv_subhex.range)
                    end ;
              subinteg :
                if con_exp
                  then
                    if (expac^.pvc_integer < 
                       varpac^.pv_subinteger.offset)
                       or (expac^.pvc_integer - 
                       varpac^.pv_subinteger.offset
                       >  varpac^.pv_subinteger.range)
                      then
                        errorpt (e_wcor)
                      else
                  else
                    begin
                      hand (int, 3) ;
                      data_word (varpac^.pv_subhex.offset) ;
                      datat_word (varpac^.pv_subhex.range) ;
                    end
            end ;
        push (expac) ; {put primary on stack}
        vget ; {retrieve variable access code}
        case varpac^.token of
          arrayvar, recordvar :
            begin
              if varpac^.size <> expac^.size
                then
                  begin
                    verror := e_tc ;
                    exit
                  end ;
              hand (int, $31) ;
              datat_word (varpac^.size)
            end ;
          else
            xdat (varpac)
        end
      until true
    end ;
  
  procedure statements (var gerror : error_type) ; entry ;
    var
      state_type : token_type register ;
      
    procedure compound (var cerror : error_type) ;
      begin
        repeat
          scan ;
          repeat
            statements (cerror) ;
            repeat
              if lastpack^.token = end_
                then
                  begin
                    scan ;
                    exit (3) {done with compound}
                  end ;
              if lastpack^.token = semicolon
                then
                  exit (2) ; {get another statement}
              if (cerror <> undef) or null_state
                then
                  begin
                    end_statement (e_se, []) ;
                    cerror := undef
                  end
                else
                  begin
                    insert (e_semi, semicolon) ;
                    exit {try statements again}
                  end
            until false
          until false
        until false
      end ;
      
    begin {statements}
      nesting := succ (nesting) ;
      repeat
        heapptr := heapstart ;
        false_depth := 0 ;
        level := 1 ;
        true_depth := 0 ;
        null_state := false ;
        opcodet (c_zap) ;
        gerror := undef ;
        state_type := lastpack^.token ;
        if state_type in [if_,repeat_,while_,for_,case_,goto_,
                          with_,exit_]
          then
            line ;
        case state_type of
          begin_ : compound (gerror) ;
          if_ : if_state (gerror) ;
          repeat_ : repeat_state (gerror) ;
          while_ : while_state (gerror) ;
          for_ : for_state (gerror) ;
          case_ : case_state (gerror) ;
          goto_ : goto_state (gerror) ;
          with_ : with_state (gerror) ;
          exit_ : exit_state (gerror) ;
          vardef : var_assign (gerror, false) ;
          range_ : var_assign (gerror, true) ;
          procdef :
            begin
              line ;
              proc_call (gerror, lastpack^.pointr)
            end ;
          integvar : labeled (gerror) ;
          inline : inline_state ;
          append_ .. writeln_ :
            begin
              line ;
              stand_proc (gerror)
            end
          else
            null_state := true
        end ;
        if gerror <> undef
          then
            begin
              end_statement (gerror, []) ;
              exit
            end ;
        gerror := undef ;
        if state_type <> integvar
          then
            exit
      until false ;
      nesting := pred (nesting)
    end ;
    
modend.
