module symbol {$v3,0 symbol table management} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/error}
{$I/r0/code}
{$I/r0/varib}
  var
    last_idx : hex varib entry ;
    
  procedure listout (s : string[120]) ; external ;
  
  function getheap (size : longinteger) : ^packet ; external ;
  
  function symlook (restrict : boolean ; curlex : byte ;
                    var start : longhex ; finish : longhex ;
                    var s : string) : boolean ; external ;

  function hash_srch (s : string ; var hidx : hex ;
               var htab : array [$0 .. $216] of ^symhead) : ^symhead ; external ;

{
  Get_entry will fill in the packet for the token pointed
  to by the second parameter
}
  procedure get_entry (pak : ^packet ; pt : ^token_type) ;
    var
      p1 : ^type_ptr register ;
      p2 : ^type_subchar ;
      p3 : ^type_subhex ;
      p4 : ^type_sublhex ;
      p5 : ^type_device_head ;
      p6 : ^longhex register ;
      p7 : ^byte register ;
      p8 : ^type_record_head register ;
      p9 : ^hex ;
    begin
      while (pt^ = deferred) or (pt^ > valuepar) do
        if pt^ = deferred
          then
            begin
              p6 := align(pt + 1) ;
              pt := p6^ ;
              pt := pt + align(sizeof(symhead))
            end
          else
            pt := (pt + 6) and $FFFFFFFE ;
      with pak^ do
        begin
          subtoken := pt^ ;
          case subtoken of
            boolvar, charvar :
              size := 1 ;
            integvar :
              size := 2 ;
            hexvar :
              begin
                size := 2 ;
                p1 := align(pt + 1) ;
                pv_pointer := p1^
              end ;
            lhexvar, lintvar, realvar :
              size := 4 ;
            subbool, subchar, enumvar :
              begin
                size := 1 ;
                p2 := align(pt + 1) ;
                pv_subchar := p2^
              end ;
            subinteg, subhex :
              begin
                size := 2 ;
                p3 := align(pt + 1) ;
                pv_subhex := p3^
              end ;
            sublint, sublhex :
              begin
                size := 4 ;
                p4 := align(pt + 1) ;
                pv_sublhex := p4^
              end ;
            devicevar :
              begin
                p5 := align(pt + 1) ;
                pv_device := p5 ;
                size := p5^.size
              end ;
            arrayvar :
              begin
                p9 := align(pt + 1) ;
                size := p9^
              end ;
            stringvar, setvar :
              begin
                p7 := pt + 1 ;
                size := hex(p7^)
              end ;
            recordvar :
              begin
                p8 := align(pt + 1) ;
                size := p8^.size
              end ;
            textvar :
              begin
                subtoken := charvar ;
                size := 1
              end
          end
        end
    end ;
{
  Fetch_packet will take the address of the symbol header
  specified and return a packet for it.
}
  function fetch_packet (sympt : ^symhead) : ^packet ; entry ;
    var
      p1 : ^packet register ;
      p3 : ^token_type register ;
      p4 : ^byte register ;
      p5 : ^hex register ;
      p6 : ^longhex ;
      p7 : ^longreal ;
    begin
      p1 := getheap (sizeof(packet)) ;
      with p1^, sympt^ do
        begin
          conflag := false ;
          size := 0 ;
          pointr := sympt ;
          token := idgroup ;
          case token of
            labeldef :
              begin
                pv_label.internal := sympt^.intname ;
                pv_label.offset := sympt^.offset
              end ;
            constdef :
              begin
                conflag := true ;
                p3 := sympt + align(sizeof(symhead)) ;
                token := p3^ ;
                case token of
                  boolvar, charvar, enumvar :
                    begin
                      p4 := p3 + 1 ;
                      size := 1 ;
                      pvc_char := p4^
                    end ;
                  integvar, hexvar :
                    begin
                      p5 := p3 + 2 ;
                      size := 2 ;
                      pvc_hex := p5^
                    end ;
                  lhexvar, lintvar, realvar :
                    begin
                      p6 := p3 + 2 ;
                      size := 4 ;
                      pvc_longhex := p6^
                    end ;
                  stringvar :
                    begin
                      size := offset ;
                      p6 := p3 + 1 ;
                      pvc_string := p6
                    end
                  else 
                    listout ('Compiler error symbol/fetch_packet')
                end
              end ;
            typedef, vardef :
              begin
                p3 := sympt + align(sizeof(symhead)) ;
                get_entry (p1, p3)
              end
          end
        end ;
      fetch_packet := p1
    end ;
{
  Get_packet will take the address of the start of the
  extension, and return a packet for it.
}
  function get_packet (t : ^token_type) : ^packet ; entry ;
    var
      p1 : ^packet ;
    begin
      p1 := getheap (sizeof(packet)) ;
      with p1^ do
        begin
          conflag := false ;
          size := 0 ;
          pointr := nil ;
          get_entry (p1, t) ;
          token := subtoken
        end ;
      get_packet := p1
    end ;
{
  Sym_search is used to search the symbol table. If the restrict
  flag is true then only the current lexical level will be searched,
  if it is false then all lexical levels will be searched. If the
  symbol is found then a packet is returned for the symbol.
}
  function sym_search (s : string[120] ; restrict : boolean) : ^packet ;
                                                                entry ;
    var
      p3 : ^type_record_head ;
      search : ^symhead ;
      x : integer ;
      t : token_type ;
      last : longhex ;
      
    procedure set_with ;
      begin
        search := with_tab[x].headpt ;
        with_offset := with_tab[x].frame_offset ;
        with_lea := true ;
        p3 := search + align(sizeof(symhead)) ;
        last := p3^.last
      end ;
      
    begin
      x := 0 ;
      last := nil ;
      sym_search := addr(t) ;
      t := undef ; {default is name not found}
      with_lea := false ;
      ident_flag := true ;
      if record_search <> nil
        then
          begin
            search := record_search ;
            p3 := search + align(longhex(sizeof(symhead)) + 1) ;
            last := p3^.last
          end
        else
          if with_depth <> 0
            then
              begin
                x := with_depth ;
                set_with
              end
            else
              search := last_sym ;
      repeat
        if symlook (restrict, lex, search, last, s)
          then
            begin
              if with_lea
                then
                  record_offset := 0 ;
              sym_search := fetch_packet (search) ;
              exit {found symbol}
            end ;
        case x of
          0 :
            if not (restrict and ((lex <> 1) or record_flag))
              then
                begin
                  search := hash_srch(upshift(s), hash_idx, hash_tab) ;
                  if search <> nil
                    then
                      begin
                        if with_lea
                          then
                            record_offset := 0 ;
                        sym_search := fetch_packet(search)
                      end ;
                  exit {this was last chance}
                end
              else
                exit ;
          1 :
            begin {no withs left, do normal}
              last := nil ;
              search := last_sym ;
              x := 0 ;
              with_lea := false
            end
          else
            begin {search next outer with}
              x := x - 1 ;
              set_with
            end
        end
      until false
    end ;
{
  enter_symbol is used to enter a symbol into the symbol table.
  It only sets in the external name, the lexical level, and the
  next and external name pointer into the symbol header. it will
  return true if the symbol already exists. the restrict flag
  is set if the symbol cannot exist at a lower lex level. Headaddr
  will be set to the address of the symbol header upon return
}
  function enter_symbol (s : string[120] ; restrict : boolean ; 
                         var headaddr : ^symhead) : boolean ; entry ;
    var
      p : ^packet register ;
      p2 : ^symname register ;
      p3 : ^symhead register ;
    begin
      enter_symbol := true ;
      p := sym_search (s, restrict) ;
      if p^.token = undef
        then
          begin
            p2 := next_sym ;
            p2^ := s ;
            p3 := (p2 + longhex(s[0] + 2)) and $FFFFFFFE ; {skip name}
            with p3^ do
              begin
                nameptr := p2 ;
                offset := 0 ;
                intname := 0 ;
                lexlev := lex ;
                storage := s_nospace ;
                if record_flag or (lex <> 1)
                  then
                    nextptr := last_sym
                  else
                    begin
                      nextptr := hash_tab[hash_idx] ;
                      last_idx := hash_idx
                    end
              end ;
            enter_symbol := false ;
            headaddr := p3
          end
        else
          headaddr := p^.pointr
    end ;
    
  procedure symdone (p : ^symhead) ; entry ;
    begin
      if record_flag or (lex <> 1)
        then
          last_sym := p
        else
          hash_tab[last_idx] := p
    end ;
    
modend.
