module tilt {$v3,0 error recovery} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/error}
{$I/r0/varib}

  const
    restab = external array [#1 .. #12] of hex ;
    punct = external token_type ;
    dpunct = external token_type ;
    
{$cne erecov}

  procedure scan ; external ;
{
  communication with main task
}
  procedure listout (s : string [120]) ; external ;
{
  error routines
}
  procedure error (errnum : error_type) ; external ;
  
  procedure errorpt (errnum : error_type) ; external ;
{
  return string corresponding to input token, either
  reserved word or punctuation.
}
  function getequiv (t : token_type) : string[12] ;
    var
      i, j : byte register ;
      p1 : ^token_type register ;
      p2 : ^char register ;
      s : string[12] ;
    begin
      s := '' ;
      if t > or_
        then
          begin
            p1 := addr (punct) ;
            while p1^ <> enum(0) do
              if p1^ = t
                then
                  begin
                    p2 := p1 + $1L ;
                    s := p2^ ;
                    exit
                  end
                else
                  p1 := p1 + $2L ;
            if s <> ''
              then
                begin
                  p1 := addr (dpunct) ;
                  while p1^ <> enum(0) do
                    if p1^ = t
                      then
                        begin
                          p2 := p1 + $1L ;
                          s := p2^ ;
                          p2 := p1 + $2L ;
                          s := concat (s,p2^) ;
                          exit
                        end
                      else
                        p1 := p1 + $3L
                end
          end
        else
          for i := 1 to 12 do
            begin
              p1 := addr(restab) + longhex(restab[i]) ;
              while p1^ <> enum(0) do
                if p1^ = t
                  then
                    begin
                      p2 := p1 + $1L ;
                      for j := 1 to i do
                        begin
                          s := concat (s,p2^) ;
                          p2 := p2 + $1L
                        end ;
                      exit (2)
                    end
                  else
                    p1 := p1 + longhex(i + 1)
            end ;
      getequiv := s
    end ;
{
  skip forward looking for one of the tokens supplied or
  semicolon or end.
}
  procedure endsta (toke : tokes) ;
    begin
      while not (lastpack^.token in toke + [semicolon,end_]) do
        scan ;
      listout (concat('Compiler action : Compilation resumed at ',
                    getequiv (lastpack^.token)))
    end ;
{
  skip forward looking for semicolon or end
}
  procedure semi_end ; entry ;
    begin
      endsta ([])
    end ;
{
  skip forward looking for end of statement or one of the tokens
  supplied. It also prints the error message
}
  procedure end_statement (e : error_type ; toke : tokes) ; entry ;
    begin
      errorpt (e) ;
      endsta (toke)
    end ;
{
  print the error message, prints the token expected replaces
  the last token from the scanner. the last packet is updated
  to reflect the new token
}
  procedure replace (e : error_type ; t : token_type) ; entry ;
    begin
      errorpt (e) ;
      listout (concat('Compiler action : "',getequiv(lastpack^.token),
                '" replaced by "',getequiv(t),'"')) ;
      lastpack^.token := t
    end ;
{
  print the error message and print that the expected token
  is inserted before the current token. the last packet is
  not modified.
}
  procedure insert (e : error_type ; t : token_type) ; entry ;
    begin
      errorpt (e) ;
      listout (concat('Compiler action : "',getequiv(t),'" inserted'))
    end ;
{
  print error message and skip looking for tokens supplied. if no
  tokens are supplied just get the next token.
}
  procedure skiperror (e : error_type ; toke : tokes) ; entry ;
    begin
      errorpt (e) ;
      if toke = []
        then
          scan
        else
          begin
            while not (lastpack^.token in toke) do
              scan ;
            if lastpack^.token in [array_ .. percent]
              then
                listout (concat(
                    'Compiler action : Compilation resumed at ',
                           getequiv (lastpack^.token)))
          end
    end ;
{
  put up error message and skip until a semicolon is found
}
  procedure semilook (e : error_type) ; entry ;
    begin
      skiperror (e, [semicolon])
    end ;

modend.
