{$l-}
{ 5/16/89 : initial conversion to version 3 }
{ 7/23/89 : irq/firq procedures added }
  const
    erecov = true ;
    m_text = #4 ;
    m_bk = #$10 ;
    m_int = #$80 ;
    r_inp = $8 ;
    r_out = r_inp + 2 ;
    r_aux = r_out + 2 ;
    r_key = r_aux + 2 ;

  type
    enum_value = (enumvalue) ;

    tokens = (
              deferred,  {0}
              boolvar,   {1}
              charvar,   {2}
              integvar,  {3}
              hexvar,    {4}
              lhexvar,   {5}
              lintvar,   {6}
              realvar,   {7}
              enumvar,   {8}
              subbool,   {9}
              subchar,   {A}
              subinteg,  {B}
              subhex,    {C}
              sublhex,   {D}
              sublint,   {E}
              arrayvar,  {F}
              stringvar, {10}
              setvar,    {11}
              recordvar, {12}
              devicevar, {13}
              textvar,   {14}
              valuepar,  {15}
              varibpar,  {16}
              funcret,   {17}
              ident,     {18}
              constdef,  {19}
              typedef,   {1A}
              vardef,    {1B}
              labeldef,  {1C}
              funcdef,   {1D}
              procdef,   {1E}
              undef      {1F}
             ) ;

    reserv = (:undef,
              array_, 
              begin_, 
              case_, 
              const_, 
              do_, 
              downto_, 
              else_,
              end_,
              file_,
              for_,
              function_,
              goto_,
              if_,
              label_,              
              nil_,
              of_,
              packed_,
              procedure_,
              program_,
              record_,
              repeat_,
              set_,
              then_,
              to_,
              type_,
              until_,
              var_,
              while_,
              with_
             ) ;

    reservops = (:with_,
                  and_,
                  div_,
                  eor_,
                  in_,
                  mod_,
                  not_,
                  or_
                ) ;

    symbolops = (:or_,
                  plus,
                  minus,
                  times,
                  divide,
                  power,
                  lt,
                  gt,
                  equal,
                  lteq,
                  gteq,
                  notequal,
                  shift_left,
                  shift_right
                ) ;

    puncts  = (:shift_right,
                assign,
                comma,
                semicolon,
                colon,
                apost,
                period,
                subrange,
                pointer,
                leftparen,
                rightparen,
                leftbracket,
                rightbracket,
                startcomment,
                endcomment,
                dollar,
                pound,
                percent
              ) ;

    standconst  = (:percent,
                    false_,
                    true_,
                    maxint_,
                    maxlint_,
                    minint_,
                    minlint_,
                    e_,
                    pi_
                  ) ;

    non_res_types = (:pi_,
                      boolean_,
                      char_,
                      integer_,
                      hex_,
                      longhex_,
                      longinteger_,
                      real_,
                      text_,
                      interactive_,
                      device_,
                      string_
                    ) ;

    device_mod  = (:string_,
                    input_,
                    output_,
                    auxout_,
                    keyboard_,
                    update_
                  ) ;

    directives  = (:update_,
                    entry_,
                    exit_,
                    external_,
                    firq_,
                    forward_,
                    interrupt_,
                    modend_,
                    module_,
                    otherwise_,
                    pcr_,
                    at_,
                    data_,
                    varib_,
                    task_
                  ) ;

    stand_procs = (:task_,
                    append_,
                    close_,
                    create_,
                    del_,
                    devinit_,
                    devstat_,
                    dispose_,
                    firqon_,
                    firqoff_,
                    irqon_,
                    irqoff_,
                    get_,
                    halt_,
                    mark_,
                    new_,
                    open_,
                    page_,
                    put_,
                    read_,
                    readln_,
                    release_,
                    reset_,
                    rewrite_,
                    seek_,
                    write_,
                    writeln_
                  ) ;

    stand_funcs = (:writeln_,
                    abs_,
                    addr_,
                    arccos_,
                    arcsin_,
                    arctan_,
                    break_,
                    chr_,
                    cline_,
                    concat_,
                    conversion_,
                    cos_,
                    deverr_,
                    enum_,
                    eof_,
                    eoln_,
                    exp_,
                    floor_,
                    index_,
                    length_,
                    ln_,
                    log_,
                    memavail_,
                    odd_,
                    ord_,
                    pred_,
                    random_,
                    range_,
                    round_,
                    sin_,
                    sizeof_,
                    sqr_,
                    sqrt_,
                    substr_,
                    succ_,
                    tan_,
                    trunc_,
                    upshift_
                  ) ;

    inline_mark = (:upshift_,
                    inline
                  ) ;

    termintor = (:inline,
                  termit
                ) ;

    token_type = deferred .. termit ;
    tokes = set of deferred .. inline ;

    type_subbool = record
                     offset, range : boolean
                   end ;

    type_subchar = record
                     offset, range : char
                   end ;

    type_subinteger = record
                        offset, range : integer
                      end ;

    type_subhex = record
                    offset, range : hex
                  end ;

    type_sublhex = record
                     offset, range : longhex
                   end ;

    type_sublint = record
                     offset, range : longinteger
                   end ;

    type_enum = record
                  offset, range : enum_value
                end ;

    ptr_type = (nonptr, stand, nonstd) ;

    type_ptr = record
                 case ptrf : ptr_type of
                   stand : (base_type : token_type) ;
                   nonstd : (base_ptr : ^symhead)
               end ;

    type_record_head = record
                         size : hex ;
                         last : ^symhead
                       end ;

    type_device_head = record
                         size : hex ;
                         attr : byte ;
                         mode : (nor_file, nor_dev, abs_dev) ;
                         name_flag : byte ;
                         extra : hex ;
                         init : hex
                       end ;

    type_label = record
                   internal : hex ;
                   offset : hex
                 end ;

    maxstring = string[252] ;
    
    packet =  record
                token : token_type ;
                conflag : boolean ;
                size : hex ;
                pointr : ^symhead ;
                subtoken : token_type ;
                case integer of
                  1 : (pvc_boolean : boolean) ;
                  2 : (pvc_char : char) ;
                  3 : (pvc_integer : integer) ;
                  4 : (pvc_hex : hex) ;
                  5 : (pvc_longhex : longhex) ;
                  6 : (pvc_longinteger : longinteger) ;
                  7 : (pvc_real : real) ;
                  8 : (pvc_enum : enum_value) ;
                  9 : (pv_pointer : type_ptr) ;
                 10 : (pv_subbool : type_subbool) ;
                 11 : (pv_subchar : type_subchar) ;
                 12 : (pv_enum : type_enum) ;
                 13 : (pv_subinteger : type_subinteger) ;
                 14 : (pv_subhex : type_subhex) ;
                 15 : (pv_sublhex : type_sublhex) ;
                 16 : (pv_sublint : type_sublint) ;
                 17 : (pv_device : ^type_device_head) ;
                 18 : (pv_label : type_label) ;
                 19 : (pvc_string : ^maxstring) ;
              end ;

    labpack = record
                branch : boolean ;
                post : byte
              end ;
              
    symname = string[120] ;
    
    storage_type = (
                    s_stack,      {fixed offset from stack mark}
                    s_external,   {offset from stack mark via xref}
                    s_absolute,   {at absolute address}
                    s_direct,     {at direct page absolute}
                    s_data_ext,   {in data section in another module}
                    s_data,       {in data section}
                    s_varib_ext,  {in varib section in another module}
                    s_varib,      {in varib section}
                    s_pcr,        {relative to PC via xref}
                    s_stddev,     {initialized standard device}
                    s_nospace,    {no space at all}
                    s_recoff      {record offset - debug only}
                   ) ;

    symhead = record
                nameptr : ^symname ;
                nextptr : ^symhead ;
                offset : hex ;
                intname : hex ;
                lexlev : byte ;
                storage : storage_type ;
                idgroup : token_type
              end ;

    type_comp = (
                  proc_in_comp,       {in compilation}
                  proc_absolute,      {absolute address}
                  proc_normal,        {normal procedure}
                  proc_external,      {external procedure}
                  proc_forward,       {forward procedure}
                  proc_exc_in,        {exception in compilation}
                  proc_except         {exception procedure}
                ) ;

    proc_head = record
                  param_size : hex ;
                  func_size : hex ;
                  comp_status : type_comp
                end ;

  const
    sub_offset = byte(subbool) - byte(boolvar) ;
    name_offset = byte(boolean_) - byte(boolvar) ;
    
{$l+}
