module types {$v3,0 type declaration} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function constant (var cerror : error_type) : ^packet ; external ;
  function aconstant (var cerror : error_type) : ^packet ; external ;
  function sym_search (s : string[120] ; restrict : boolean) : ^packet ;
                                                            external ;
  function enter_symbol (s : string[120] ; restrict : boolean ;
                         var headaddr : ^symhead) : boolean ; external ;
  procedure symdone (p : ^symhead) ; external ;
  procedure semilook (e : error_type) ; external ;
  procedure replace (e : error_type ; t : token_type) ; external ;
  function allocate (st : storage_type) : error_type ; external ;
  procedure error (e : error_type) ; external ;
  procedure var_decl (reccall : boolean) ; external ;
  procedure listout (s : string[120]) ; external ;
  
  function retadr (pin : ^packet) : ^packet ; entry ;
    begin
      if pin^.token < undef
        then
          case pin^.token of
            integvar, hexvar : pin^.token := hexvar
            else
              pin^.token := e_ita
          end ;
      retadr := pin
    end ;
                
  procedure enum_up ; entry ;
    var
      p1 : ^symname register ;
      p2 : ^symhead ;
      p3, p5 : ^byte register ;
      p4 : ^token_type register ;
    begin
      p1 := addr (enumbuf) ;
      while p1 < enum_active do
        begin
          if enter_symbol (p1^, true, p2)
            then
              begin
                error (e_iddt) ;
                listout (p1^) ;
                p1 := p1 + longhex(p1^[0] + 1) + 1 ;
              end
            else
              begin
                p3 := p1 + longhex(p1^[0] + 1) ;
                p2^.idgroup := constdef ;
                p4 := p2 + align(sizeof(symhead)) ;
                p4^ := enumvar ;
                p5 := p4 + 1 ;
                p5^ := p3^ ; {put in actual value}
                p1 := p3 + 1 ; {skip to next name in queue}
                p4 := p5 + 1 ;
                p4^ := termit ;
                symdone(p2) ;
                next_sym := align (p4 + 1)
              end
        end ;
      enum_active := addr(enumbuf)
    end ;

  procedure point_check ; entry ;
    type
      p4 = ^type_ptr ;
    var
      p1 : ^symname register ;
      p2 : ^packet register ;
      p3 : ^p4 register ;
    begin
      p1 := addr (ptrq) ;
      while p1 < pointer_active do
        begin
          p2 := sym_search (p1^, false) ;
          if p2^.token <> typedef
            then
              begin
                pointer_base := concat(' "',p1^,'"') ;
                error (e_fprd) ; {forward pointer error}
              end
            else
              begin
                p3 := align(p1 + longhex(p1^[0] + 1)) ;
                p3^^.base_ptr := p2^.pointr ;
                if debug_opt and debug_en
                  then
                    begin
                      override := true ;
                      debug (4) ;
                      data_long (addr(p3^^.base_ptr)) ;
                      data_long (p2^.pointr) ;
                      outterm ;
                      override := false
                    end
              end ;
          p1 := align(p1 + longhex(p1^[0] + 5))
        end ;
      pointer_active := addr (ptrq)
    end ;

  procedure typeit (var p : manypt ; var errcode : error_type) ; entry ;
    var
      int_flag : byte ;
      search_temp : ^symhead ;
      pd : ^type_device_head ;
      
    procedure simp ;
      var
        subtype : token_type ;
        p1 : ^symhead register ;
        p2 : ^token_type register ;
        p3 : ^longhex register ;
        
      procedure do_subrange ;
        var
          p4, p5 : ^packet register ;
          temp : longhex ;
        begin {subrange}
          p4 := aconstant (errcode) ;
          subtype := p4^.token ;
          temp := p.tk ;
          if errcode = undef
            then
              case p4^.token of
                boolvar, charvar, enumvar :
                  begin
                    if p4^.token = enumvar
                      then
                        p.tk^ := enumvar
                      else
                        p.ch^ := byte(p4^.token) + sub_offset ;
                    p.tk := align (p.tk + 1) ;
                    p.ch^ := p4^.pvc_char ;
                    p.ch := p.ch + 1
                  end ;
                integvar, hexvar :
                  begin
                    p.ch^ := byte(p4^.token) + sub_offset ;
                    p.tk := align (p.tk + 1) ;
                    p.int^ := p4^.pvc_integer ;
                    p.int := p.int + 2
                  end ;
                lhexvar, lintvar :
                  begin
                    p.ch^ := byte(p4^.token) + sub_offset ;
                    p.tk := align (p.tk + 1) ;
                    p.lx^ := p4^.pvc_longhex ;
                    p.lx := p.lx + 4
                  end
                else
                  errcode := e_inst
              end ;
          if errcode = undef
            then
              if lastpack^.token = subrange
                then
                  begin
                    p5 := constant (errcode) ;
                    if errcode = undef
                      then
                        if p5^.token = subtype
                          then
                            case p5^.token of
                              boolvar, charvar, enumvar :
                                begin
                                  p.ch^ := p5^.pvc_char - 
                                           p4^.pvc_char ;
                                  p.ch := p.ch + 1 ;
                                  if p5^.pvc_char < p4^.pvc_char
                                    then
                                      errcode := e_lbehb
                                end ;
                              integvar :
                                begin
                                  p.int^ := p5^.pvc_integer -
                                            p4^.pvc_integer ;
                                  p.int := p.int + 2 ;
                                  if p5^.pvc_integer < 
                                     p4^.pvc_integer
                                    then
                                      errcode := e_lbehb
                                end ;
                              hexvar :
                                begin
                                  p.hx^ := p5^.pvc_hex -
                                           p4^.pvc_hex ;
                                  p.hx := p.hx + 2 ;
                                  if p5^.pvc_hex < p4^.pvc_hex
                                    then
                                      errcode := e_lbehb
                                end ;
                              lintvar :
                                begin
                                  p.li^ := p5^.pvc_longinteger -
                                           p4^.pvc_longinteger ;
                                  p.li := p.li + 4 ;
                                  if p5^.pvc_longinteger <
                                     p4^.pvc_longinteger
                                    then
                                      errcode := e_lbehb
                                end ;
                              lhexvar :
                                begin
                                  p.lx^ := p5^.pvc_longhex -
                                           p4^.pvc_longhex ;
                                  p.lx := p.lx + 4 ;
                                  if p5^.pvc_longhex <
                                     p4^.pvc_longhex
                                    then
                                      errcode := e_lbehb
                                end
                            end
                          else
                            case hex(subtype) << 8 + hex(p5^.token) of
                              hex(hexvar) << 8 + hex(lhexvar) :
                                begin
                                  p.tk := temp ;
                                  p.tk^ := sublhex ;
                                  p.tk := align(p.tk + 1) ;
                                  p4^.pvc_longhex := longhex(p4^.pvc_hex) ;
                                  p.lx^ := p4^.pvc_longhex ;
                                  p.lx := p.lx + 4 ;
                                  p.lx^ := p5^.pvc_longhex - p4^.pvc_longhex ;
                                  p.lx := p.lx + 4 ;
                                  if p5^.pvc_longhex < p4^.pvc_longhex
                                    then
                                      errcode := e_lbehb
                                end ;
                              hex(integvar) << 8 + hex(lintvar) :
                                begin
                                  p.tk := temp ;
                                  p.tk^ := sublint ;
                                  p.tk := align(p.tk + 1) ;
                                  p4^.pvc_longinteger := longinteger(p4^.pvc_integer) ;
                                  p.li^ := p4^.pvc_longinteger ;
                                  p.li := p.li + 4 ;
                                  p.li^ := p5^.pvc_longinteger - p4^.pvc_longinteger ;
                                  p.li := p.li + 4 ;
                                  if p5^.pvc_longinteger < p4^.pvc_longinteger
                                    then
                                      errcode := e_lbehb
                                end ;
                              hex(lhexvar) << 8 + hex(hexvar) :
                                begin
                                  p5^.pvc_longhex := longhex(p5^.pvc_hex) ;
                                  p.lx^ := p5^.pvc_longhex - p4^.pvc_longhex ;
                                  p.lx := p.lx + 4 ;
                                  if p5^.pvc_longhex < p4^.pvc_longhex
                                    then
                                      errcode := e_lbehb
                                end ;
                              hex(lintvar) << 8 + hex(integvar) :
                                begin
                                  p5^.pvc_longinteger := longinteger(p5^.pvc_integer) ;
                                  p.li^ := p5^.pvc_longinteger - p4^.pvc_longinteger ;
                                  p.li := p.li + 4 ;
                                  if p5^.pvc_longinteger < p4^.pvc_longinteger
                                    then
                                      errcode := e_lbehb
                                end
                              else
                                errcode := e_ist
                            end
                        
                  end
                else
                  errcode := e_dtdt
        end ;
        
      procedure do_enum ;
        var
          p4 : ^packet register ;
          p5 : ^symname register ;
          p6 : ^byte register ;
          enum_value : byte register ;
        begin
          enum_value := 0 ;
          repeat
            scan ;
            if ident_flag
              then
                begin
                  enum_active^ := last_ident ;
                  p6 := enum_active + longhex(last_ident[0] + 1) ;
                  p6^ := enum_value ;
                  enum_active := p6 + 1 ;
                  enum_value := succ (enum_value) ;
                  scan ;
                end
              else
                if lastpack^.token = colon
                  then
                    begin
                      p4 := constant (errcode) ;
                      if errcode = undef
                        then
                          if p4^.token in [enumvar, charvar]
                            then
                              enum_value := p4^.pvc_char + 1
                          else if p4^.token in [integvar, hexvar]
                            then
                              enum_value := byte(p4^.pvc_hex) + 1
                            else
                              errcode := e_eist
                    end
                  else
                    errcode := e_eist ;
            if errcode <> undef
              then
                exit
              else
                case lastpack^.token of
                  rightparen : exit ;
                  comma :
                  else
                    begin
                      errcode := e_rpar ;
                      exit
                    end
                end
          until false ;
          if errcode = undef
            then
              begin
                p.tk^ := enumvar ;
                p.tk := align (p.tk + 1) ;
                p.ch^ := 0 ;
                p.ch := p.ch + 1 ;
                p.ch^ := enum_value - 1 ;
                p.ch := p.ch + 1 ;
                scan
              end
        end ;

      begin {simp}
        case lastpack^.token of
          typedef :
            begin {deferred type}
              p1 := lastpack^.pointr ;
              repeat
                p2 := p1 + align(sizeof(symhead)) ;
                if p2^ = deferred
                  then
                    begin
                      p3 := align (p2 + 1) ;
                      p1 := p3^
                    end
              until p2^ <> deferred ;
              p.tk^ := deferred ;
              p.tk := align (p.tk + 1) ;
              p.lx^ := p1 ;
              p.lx := p.lx + 4 ;
              scan
            end ;
          leftparen : do_enum ;
          boolean_ .. real_ :
            begin {simple types}
              p.tk^ := enum(byte(lastpack^.token) - name_offset) ;
              if p.tk^ = hexvar
                then
                  begin
                    p.tk := align (p.tk + 1) ;
                    p.pt^.ptrf := nonptr ;
                    p.pt := p.pt + 1
                  end
                else
                  p.tk := p.tk + 1 ;
              scan
            end ;
          undef : errcode := e_ui
          else
            do_subrange
        end
      end ;
 
    procedure type0 ; forward ;

    procedure tdef_pointer ;
      var
        ptemp : ^longhex register ;
      begin
        p.tk^ := hexvar ;
        p.pt := align (p.tk + 1) ;
        scan ;
        if lastpack^.token in [boolean_ .. real_]
          then
            begin {pointer to standard type}
              p.pt^.ptrf := stand ;
              p.pt^.base_type := enum(byte(lastpack^.token)
                                  - name_offset) ;
              p.pt := p.pt + 2
            end
          else
            if (lastpack^.token = undef) and ident_flag or
               (lastpack^.token = typedef)
              then
                begin {pointer to non-standard type}
                  if pointer_active + longhex(last_ident[0] + 5) >=
                     addr(ptrq) + longhex(size_ptrq)
                    then
                      errcode := e_fqf {forward queue full}
                    else
                      begin
                        pointer_active^ := last_ident ;
                        pointer_active := align(pointer_active + 
                              longhex(last_ident[0] + 1)) ;
                        ptemp := pointer_active ;
                        pointer_active := pointer_active + 4 ;
                        ptemp^ := p.pt ;
                        p.pt^.ptrf := nonstd ;
                        p.pt^.base_ptr := nil ;
                        p.pt := p.pt + 6
                      end
                end
              else
                errcode := e_ibt {invalid base type} ;
        if errcode = undef
          then
            scan
      end ;
      
    procedure tdef_set ;
      begin
        p.tk^ := setvar ;
        p.tk := p.tk + 1 ;
        p.ch^ := 0 ; {set length}
        p.ch := p.ch + 1 ;
        scan ;
        if lastpack^.token <> of_
          then
            errcode := e_of {of expected}
          else
            begin
              scan ;
              simp {handle base type}
            end
      end ;
      
    procedure fset ; {setup default device}
      begin
        pd := p.tk ;
        with pd^ do
          begin
            size := 0 ;
            attr := int_flag ;
            mode := nor_file ;
            name_flag := 0 ;
            extra := 0 ;
            init := 0
          end ;
        p.tk := pd + longhex(sizeof(type_device_head))
      end ;
      
    procedure set_text ;
      begin
        p.tk^ := textvar ;
        p.tk := p.tk + 1 ;
        pd^.attr := pd^.attr + m_text ;
        if break_opt
          then
            pd^.attr := m_text + m_bk ;
        scan
      end ;
      
    procedure file_stuff ;
      begin
        if lastpack^.token <> of_
          then
            errcode := e_of
          else
            begin
              scan ;
              if lastpack^.token = text_
                then
                  set_text
                else
                  type0
            end
      end ;
      
    procedure tdef_file ;
      begin
        p.tk^ := devicevar ;
        p.tk := align (p.tk + 1) ;
        fset ;
        scan ;
        file_stuff
      end ;

    procedure tdef_text ;
      begin
        p.tk^ := devicevar ;
        p.tk := align (p.tk + 1) ;
        fset ;
        set_text
      end ;

    procedure tdef_device ;
      var
        p2 : ^packet register ;
      begin
        p.tk^ := devicevar ;
        p.tk := align (p.tk + 1) ;
        fset ;
        with pd^ do
          begin
            mode := nor_dev ;
            scan ;
            if lastpack^.token = at_
              then
                begin
                  p2 := retadr(constant(errcode)) ;
                  if errcode = undef
                    then
                      begin
                        mode := abs_dev ;
                        init := p2^.pvc_hex
                      end
                    else
                      errcode := e_ita
                end
              else
                if lastpack^.token = leftbracket
                  then
                    begin
                      p2 := retadr(constant(errcode)) ;
                      if errcode = undef
                        then
                          extra := p2^.pvc_hex
                        else
                          errcode := e_integ ;
                      if (lastpack^.token = rightbracket) and
                         (errcode = undef)
                        then
                          begin
                            scan ;
                            if lastpack^.token = at_
                              then
                                begin
                                  p2 := retadr(constant(errcode)) ;
                                  if errcode = undef
                                    then
                                      begin
                                        mode := abs_dev ;
                                        init := p2^.pvc_hex
                                      end
                                    else
                                      errcode := e_ita
                                end
                          end
                        else
                          errcode := e_rbrk
                    end ;
            if errcode = undef
              then
                file_stuff
          end
      end ;
    
    procedure tdef_array ;
      begin
        scan ;
        if lastpack^.token = leftbracket
          then
            begin
              repeat
                p.tk^ := arrayvar ;
                p.tk := align (p.tk + 1) ;
                p.hx^ := 0 ; {size}
                p.lx := p.lx + 2 ;
                scan ;
                simp ;
                if errcode <> undef
                  then
                    exit ;
                if lastpack^.token = rightbracket
                  then
                    exit
                  else
                    if lastpack^.token <> comma
                      then
                        begin
                          errcode := e_rbrk ;
                          exit
                        end
              until false ;
              if errcode = undef
                then
                  begin
                    scan ;
                    if lastpack^.token <> of_
                      then
                        errcode := e_of
                      else
                        begin
                          scan ;
                          type0
                        end
                  end
            end
          else
            errcode := e_lbrk
      end ;
    
    procedure tdef_string ;
      var
        p2 : ^packet register ;
      begin
        p.tk^ := stringvar ;
        p.tk := p.tk + 1 ;
        scan ;
        if lastpack^.token = leftbracket
          then
            begin
              p2 := constant(errcode) ;
              if errcode = undef
                then
                  if p2^.token <> integvar
                    then
                      errcode := e_integ
                    else
                      if p2^.pvc_integer = 0
                        then
                          errcode := e_zsna
                        else
                          begin
                            if p2^.pvc_integer > 126
                              then
                                begin
                                  error (e_msl) ;
                                  p2^.pvc_integer := 126
                                end ;
                            p.ch^ := byte(p2^.pvc_integer) + 1 ;
                            p.ch := p.ch + 1
                          end ;
              if errcode = undef
                then
                  if lastpack^.token <> rightbracket
                    then
                      errcode := e_rbrk
                    else
                      scan
            end
          else
            begin
              p.ch^ := 81 ;
              p.ch := p.ch + 1
            end
      end ;
      
    procedure tdef_record ;
      var
        save_record_size : hex ;
        ptrh : ^type_record_head ;
        save_tpstart : longhex ;
        save_var_active : longhex ;
        save_var_start : longhex ;
        save_last_sym : longhex ;
        save_var_current : longhex ;
        
      procedure field_and_stream ;
        var
          temp1 : longhex register ;
          savepack : ^packet ;
          p3 : ^symhead ;
          p4 : ^packet register ;
          temp2 : token_type ;
          temp3 : symname ;
          p1 : ^longhex register ;
          p2 : ^token_type register ;
          start_record_size : hex ;
          max_record_size : hex ;
          type_encountered : byte ;
          lerror : error_type ;
        begin
          repeat
            var_decl (true) ;
            if lastpack^.token = case_
              then
                begin
                  start_record_size := record_size ;
                  max_record_size := record_size ;
                  type_encountered := 1 ;
                  repeat
                    temp1 := record_search ;
                    record_search := global_search ;
                    scan ;
                    record_search := temp1 ;
                    if not ident_flag
                      then
                        begin
                          errcode := e_id ;
                          exit (2)
                        end ;
                    savepack := lastpack ;
                    temp3 := last_ident ;
                    scan ;
                    if lastpack^.token <> colon
                      then
                        if savepack^.token <> typedef
                          then
                            begin
                              if savepack^.token in
                                  [boolean_ .. hex_]
                                then
                                  begin
                                    temp2 := enum(byte(savepack^.token)
                                              - name_offset) ;
                                    if type_encountered <> 0
                                      then
                                        exit ;
                                    p.tk^ := temp2 ;
                                    p.tk := p.tk + 1 ;
                                    p.tk^ := termit ;
                                    next_sym := align(p.tk + 1) ;
                                    p.tk := next_sym ;
                                    errcode := allocate (s_stack) ;
                                    if errcode <> undef
                                      then
                                        exit (2)
                                      else
                                        exit
                                  end
                                else
                                  begin
                                    errcode := e_inac ;
                                    exit (2)
                                  end
                            end
                          else
                            begin
                              p1 := savepack^.pointr ;
                              repeat
                                p2 := p1 + align(sizeof(symhead)) ;
                                if p2^ <> deferred
                                  then
                                    exit ;
                                p1 := align (p2 + 1) ;
                                p1 := p1^
                              until false ;
                              temp2 := p2^ ;
                              if type_encountered <> 0
                                then
                                  exit ;
                              p.tk^ := deferred ;
                              p.lx := align (p.tk + 1) ;
                              p.lx^ := p1 ;
                              p.lx := p.lx + 4 ;
                              p.tk^ := termit ;
                              next_sym := align(p.tk + 1) ;
                              p.tk := next_sym ;
                              errcode := allocate (s_stack) ;
                              if errcode <> undef
                                then
                                  exit (2)
                                else
                                  exit
                            end
                      else
                        begin
                          type_encountered := type_encountered - 1 ;
                          if type_encountered <> 0
                            then
                              begin
                                errcode := e_id ;
                                exit (2)
                              end ;
                          if enter_symbol (temp3, true, p3)
                            then
                              begin
                                errcode := e_iddt ;
                                exit (2)
                              end ;
                          symdone(p3) ;
                          p.tk := p3 + align(sizeof(symhead)) ;
                          p3^.idgroup := vardef
                        end
                  until false ;
                  start_record_size := record_size ;
                  if lastpack^.token <> of_
                    then
                      begin
                        errcode := e_of ;
                        exit
                      end ;
                  repeat
                    temp1 := record_search ;
                    record_search := global_search ;
                    p4 := constant (lerror) ;
                    record_search := temp1 ;
                    if lerror <> undef
                      then
                        begin
                          record_size := max_record_size ;
                          exit (2)
                        end ;
{ ignore type       if (p4^.token <> temp2) and 
                       (enum(byte(p4^.token) + sub_offset) <> temp2)
                      then
                        begin
                          errcode := e_cctc ;
                          exit (2)
                        end ;                                        }
                    if lastpack^.token <> comma
                      then
                        begin
                          if lastpack^.token <> colon
                            then
                              begin
                                errcode := e_colon ;
                                exit (2)
                              end ;
                          scan ;
                          if lastpack^.token <> leftparen
                            then
                              begin
                                errcode := e_lpar ;
                                exit (2)
                              end ;
                          field_and_stream ;
                          if errcode <> undef
                            then
                              exit (2) ;
                          if lastpack^.token <> rightparen
                            then
                              begin
                                errcode := e_rpar ;
                                exit (2)
                              end ;
                          if record_size > max_record_size
                            then
                              max_record_size := record_size ;
                          record_size := start_record_size ;
                          scan ;
                          if lastpack^.token <> semicolon
                            then
                              begin
                                record_size := max_record_size ;
                                exit
                              end
                        end
                  until false
                end
          until true
        end ;
        
      begin {tdef_record}
        repeat
          p.tk^ := recordvar ;
          if record_flag
            then
              save_record_size := record_size
            else
              begin
                record_depth := 0 ;
                global_search := last_sym
              end ;
          record_size := 0 ;
          ptrh := align(p.tk + 1) ;
          ptrh^.size := 0 ;
          ptrh^.last := nil ;
          record_depth := succ (record_depth) ;
          record_flag := true ;
          save_tpstart := tpstart ;
          save_var_active := var_active ;
          save_var_start := var_start ;
          save_last_sym := last_sym ;
          save_var_current := var_current ;
          var_start := var_active ;
          next_sym := align(ptrh+longhex(sizeof(type_record_head))) ;
          last_sym := nil ;
          field_and_stream ;
          ptrh^.last := last_sym ;
          p.tk := next_sym ;
          last_sym := save_last_sym ;
          var_active := save_var_active ;
          var_start := save_var_start ;
          tpstart := save_tpstart ;
          var_current := save_var_current ;
          if errcode <> undef
            then
              exit ;
          if lastpack^.token <> end_
            then
              begin
                errcode := e_ensm ;
                exit
              end ;
          scan ;
          ptrh^.size := record_size
        until true ;
        record_depth := pred (record_depth) ;
        if record_depth = 0
          then
            record_flag := false
          else
            record_size := save_record_size
      end ;
      
    procedure type0 ;
      begin
        case lastpack^.token of
          array_ : tdef_array ;
          file_ : tdef_file ;
          packed_ :
            begin
              scan ;
              type0
            end ;
          record_ : tdef_record ;
          set_ : tdef_set ;
          pointer : tdef_pointer ;
          text_ : tdef_text ;
          interactive_ :
            begin
              int_flag := m_int ;
              scan ;
              type0
            end ;
          device_ : tdef_device ;
          string_ : tdef_string
          else
            simp
        end
      end ;
      
    begin {typeit}
      if record_flag
        then
          begin
            search_temp := record_search ;
            record_search := global_search
          end ;
      int_flag := 0 ;
      scan ;
      type0 ;
      if record_flag
        then
          record_search := search_temp
    end ;
  
  procedure type_decl ; entry ;
    var
      p1 : ^symhead ;
      p : manypt ;
      errcode : error_type ;
    begin
      scan ;
      nesting := succ (nesting) ;
      repeat
        if ident_flag
          then
            if enter_symbol (last_ident, true, p1)
              then
                semilook (e_iddt)
              else
                begin
                  scan ;
                  if not (lastpack^.token in [equal, colon, assign])
                    then
                      semilook (e_equal)
                    else
                      begin
                        if lastpack^.token <> equal
                          then
                            replace (e_equal, equal) ;
                        p1^.idgroup := typedef ;
                        p.tk := p1 + align(sizeof(symhead)) ;
                        errcode := undef ;
                        typeit (p, errcode) ;
                        if errcode > undef
                          then
                            semilook (errcode)
                          else
                            begin
                              p.tk^ := termit ;
                              symdone(p1) ;
                              next_sym := align (p.tk + 1) ;
                              errcode := allocate (s_nospace) ;
                              heapptr := heapstart ;
                              enum_up ;
                              if lastpack^.token <> semicolon
                                then
                                  semilook (e_semi)
                            end
                      end
                end
          else
            semilook (e_id) ;
        scan
      until lastpack^.token in [begin_,const_,function_,label_,
              procedure_,type_,var_,end_] ;
      nesting := pred (nesting) ;
      point_check
    end ;
    
modend.
