module varacces {$v3,0 variable access} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function retpac (t : token_type) : ^packet ; external ;
  procedure opdot (pac : ^packet) ; external ;
  procedure push_pointer (p : ^symhead) ; external ;
  procedure uncon (p : ^packet) ; external ;
  procedure pshdat (p : ^packet) ; external ;
  function get_next (p1 : ^token_type ; first : boolean) : ^token_type ; external ;
  function outexp (var error : error_type) : ^packet ; external ;
  function get_packet (t : ^token_type) : ^packet ; external ;
  function getheap (size : longinteger) : ^packet ; external ;
  function giveit (req : tokes ; var gerror : error_type ;
                   gpac : ^packet) : ^packet ; external ;

  function varib (vpac : ^packet ; var verror : error_type ;
                  getdata : boolean ; outer : boolean) : ^packet 
                                                        ; entry ;
    var
      nextok, record_cluge : boolean ;
      vlex : byte ;
      voff : hex ;
      p1 : ^symhead ;
      p : manypt ;
      save_record_search : ^symhead ;
      save_array_lea : boolean ;
      save_with_lea : boolean ;
      save_record_flag : boolean ;
      save_record_depth : byte ;

    procedure setarl ;
      begin
        record_offset := 0 ;
        array_lea := true
      end ;
      
    procedure general (pt : boolean) ;
      begin
        repeat
          if pt
            then
              push_pointer (p1) ;
          if getdata
            then
              pshdat (p.tk)
        until true ;
        if not nextok
          then
            scan
      end ;

    procedure base_types ; forward ;

    procedure varray (afrst : boolean) ; forward ;

    procedure vdevice (dfrst : boolean) ;
      begin
        if not dfrst
          then
            setarl ;
        scan ;
        if lastpack^.token = pointer
          then
            begin
              push_pointer (p1) ;
              setarl ;
              if getdata
                then
                  hand (proc, $13)
                else
                  begin
                    opcode (c_leax) ;
                    post1 (p_idx + p_ixrx +p_ixfx) ;
                    codet_word (6)
                    {leax 6,x}
                  end ;
              p.tk := align(p.tk + 1) + 
                      longhex(sizeof(type_device_head)) ;
              p.tk := get_next (p.tk, false) ;
              if p.tk^ = arrayvar
                then
                  varray (false)
                else
                  base_types
            end
          else
            begin
              getdata := false ;
              nextok := true ;
              general (true)
            end
      end ;

    procedure vpointer (pfrst : boolean) ;
      var
        tpt : ^type_ptr register ;
      begin
        if not pfrst
          then
            setarl ;
        tpt := align (p.tk + 1) ;
        if tpt^.ptrf = nonptr
          then
            general (true)
          else
            begin
              scan ;
              if lastpack^.token <> pointer
                then
                  begin
                    nextok := true ;
                    general (true)
                  end
                else
                  begin
                    indirect := true ;
                    push_pointer (p1) ;
                    indirect := false ;
                    setarl ;
                    if tpt^.ptrf = stand
                      then
                        begin
                          p.tk := tpt + 1 ;
                          general (false)
                        end
                      else
                        begin
                          vpac := getheap (sizeof(packet)) ;
                          vpac^.pointr := tpt^.base_ptr ;
                          p.tk := tpt + longhex(sizeof(type_ptr)) ;
                          varib := varib (vpac, verror, getdata, false) ;
                          record_cluge := true
                        end
                  end
            end
      end ;

    procedure strpush (sz : hex) ;
      begin
        if getdata
          then
            begin
              hand (int, $30) ;
              datat_word (sz)
            end
      end ;

    procedure vrecord (rfrst : boolean) ;
      var
        p2 : ^type_record_head register ;
      begin
        repeat
          if not rfrst
            then
              setarl ;
          if not record_flag
            then
              record_lex := vlex ;
          record_depth := succ (record_depth) ;
          record_flag := true ;
          scan ;
          if lastpack^.token = period
            then
              begin {go into record}
                p2 := align (p.tk + 1) ;
                record_search := p2^.last ;
                push_pointer (p1) ;
                setarl ;
                scan ;
                if lastpack^.token <> vardef
                  then
                    begin
                      record_search := nil ;
                      verror := e_inac
                    end
                  else
                    begin
                      record_search := nil ;
                      varib := varib (lastpack, verror, getdata, true)
                    end ;
                record_depth := pred (record_depth) ;
                record_flag := record_depth <> 0 ;
                array_lea := false ;
                record_cluge := true
              end
            else
              begin {return record}
                record_depth := pred (record_depth) ;
                record_flag := record_depth <> 0 ;
                p2 := align (p.tk + 1) ;
                with_cluge := p2^.last ;
                push_pointer (p1) ;
                strpush (p2^.size)
              end
        until true
      end ;

    procedure save_rec ;
      begin
        save_record_search := record_search ;
        save_array_lea := array_lea ;
        save_with_lea := with_lea ;
        save_record_flag := record_flag ;
        save_record_depth := record_depth ;
        record_search := nil ;
        array_lea := false ;
        with_lea := false ;
        record_flag := false ;
        record_depth := 0
      end ;

    procedure restore_rec ;
      begin
        record_depth := save_record_depth ;
        record_flag := save_record_flag ;
        with_lea := save_with_lea ;
        array_lea := save_array_lea ;
        record_search := save_record_search
      end ;

    procedure stringindex ;
      var
        idx : hex register ;
        p3 : ^packet register ;
      begin
        repeat
          opcode (c_pshu) ;
          post1t (p_ipx) ;
          {pshu x}
          save_rec ;
          scan ;
          p3 := outexp (verror) ;
          restore_rec ;
          if verror <> undef
            then
              exit ;
          if not (p3^.token in [charvar, integvar])
            then
              begin
                verror := e_integ ;
                exit
              end ;
          if (p3^.token = charvar) or not subrange_opt
            then
              begin {inline}
                opcode (c_pulu) ;
                post1t (p_ipx) ;
                {pulu x}
                if p3^.conflag
                  then
                    begin {constant index}
                      if p3^.token = charvar
                        then
                          idx := hex(p3^.pvc_char)
                        else
                          idx := p3^.pvc_hex ;
                      opcode (c_leax) ;
                      post1 (p_idx + p_ixrx + p_ixfx) ;
                      codet_word (idx)
                      {leax offset,x}
                    end
                  else
                    begin {not constant index - inline}
                      if getdata
                        then
                          begin
                            opcode (c_ldb) ;
                            post1t (p_idx + p_ixrx + p_ixb) ;
                            {ldb b,x}
                            getdata := false
                          end
                        else
                          opcodet (c_abx)
                    end
              end
            else
              begin {subroutine}
                uncon (p3) ;
                hand (int, 0)
              end ;
          if lastpack^.token <> rightbracket
            then
              begin
                verror := e_rbrk ;
                exit
              end ;
          p.tk := getheap (2) ;
          p.tk^ := charvar ;
          general (false)
        until true
      end ;

    procedure base_types ;
      begin
        case p.tk^ of
          recordvar : vrecord (false) ;
          devicevar : vdevice (false) ;
          hexvar : vpointer (false) ;
          stringvar, setvar :
            begin
              scan ;
              if lastpack^.token = leftbracket
                then
                  stringindex
                else
                  begin
                    nextok := true ;
                    general (false)
                  end
            end
          else general (false)
        end
      end ;

    procedure varray ;
      var
        p2 : ^hex register ;
        p3 : ^packet ;
        p4 : ^packet ;
        aoff, arange, asize : hex register ;
        temp : hex ;
        subr, shift, slong : boolean ;
      begin
        repeat
          if afrst
            then
              push_pointer (p1) ;
          scan ;
          if lastpack^.token <> leftbracket
            then
              begin
                p2 := align (p.tk + 1) ;
                strpush (p2^) ;
                exit
              end ;
          repeat
            opcode (c_pshu) ;
            post1t (p_ipx) ; {pshu x}
            save_rec ;
            scan ;
            p3 := outexp (verror) ;
            restore_rec ;
            if verror <> undef
              then
                exit (2) ;
            p.tk := get_next (align(p.tk + 1) + 2, false) ;
            if p.tk^ in [subbool .. sublint]
              then
                p3 := giveit([byte(p.tk^) - sub_offset], verror, p3)
              else
                p3 := giveit([p.tk^], verror, p3) ;
            if verror <> undef
              then
                exit (2) ;
            case hex(p.tk^) << 8 + hex(p3^.token) of
              hex(subbool) << 8 + hex(boolvar),
              hex(subchar) << 8 + hex(charvar),
              hex(enumvar) << 8 + hex(enumvar) :
                begin
                  p.ch := align(p.ch + 1) ;
                  aoff := hex(p.ch^) ;
                  p.ch := p.ch + 1 ;
                  arange := hex(p.ch^) ;
                  p.ch := p.ch + 1
                end ;
              hex(subinteg) << 8 + hex(integvar) : 
                begin
                  p.int := align (p.tk + 1) ;
                  aoff := hex(p.int^) ;
                  p.int := p.int + 2 ;
                  arange := hex(p.int^) ;
                  p.int := p.int + 2
                end ;
              hex(subhex) << 8 + hex(hexvar) :
                begin
                  p.hx := align (p.tk + 1) ;
                  aoff := hex(p.hx^) ;
                  p.hx := p.hx + 2 ;
                  arange := hex(p.hx^) ;
                  p.hx := p.hx + 2
                end ;
              hex(sublint) << 8 + hex(lintvar) :
                begin
                  p.li := align (p.tk + 1) ;
                  aoff := hex(p.li^) ;
                  p.li := p.li + 4 ;
                  arange := hex(p.li^) ;
                  p.li := p.li + 4
                end ;
              hex(sublhex) << 8 + hex(lhexvar) :
                begin
                  p.lx := align (p.tk + 1) ;
                  aoff := hex(p.lx^) ;
                  p.lx := p.lx + 4 ;
                  arange := hex(p.lx^) ;
                  p.lx := p.lx + 4
                end ;
              hex(boolvar) << 8 + hex(boolvar) :
                begin
                  p.tk := p.tk + 1 ;
                  aoff := 0 ;
                  arange := 1
                end ;
              hex(charvar) << 8 + hex(charvar) :
                begin
                  p.tk := p.tk + 1 ;
                  aoff := 0 ;
                  arange := $FF
                end
              else
                begin
                  verror := e_inmd ;
                  exit (2)
                end
            end ; {case}
            p.tk := get_next (p.tk, false) ;
            p4 := get_packet (p.tk) ;
            asize := p4^.size ;
            if p3^.conflag
              then
                begin {constant index}
                  opcode (c_pulu) ;
                  post1t (p_ipx) ; {pulu x}
                  case p3^.token of
                    enumvar, boolvar, charvar :
                      begin
                        temp := hex(p3^.pvc_char) ;
                        if temp < aoff
                          then
                            verror := e_wcor
                      end ;
                    hexvar :
                      begin
                        temp := hex(p3^.pvc_hex) ;
                        if temp < aoff
                          then
                            verror := e_wcor
                      end ;
                    integvar :
                      begin
                        if p3^.pvc_integer < integer(aoff)
                          then
                            verror := e_wcor ;
                        temp := hex(p3^.pvc_integer)
                      end ;
                    lhexvar :
                      begin
                        temp := hex(p3^.pvc_longhex) ;
                        if temp < aoff
                          then
                            verror := e_wcor
                      end ;
                    lintvar :
                      begin
                        if p3^.pvc_longinteger < longinteger(aoff)
                          then
                            verror := e_wcor ;
                        temp := hex (p3^.pvc_longinteger)
                      end
                  end ;
                  temp := temp - aoff ;
                  if temp > arange
                    then
                      verror := e_wcor ;
                  if verror <> undef
                    then
                      exit (2) ;
                  temp := temp * asize ;
                  if temp <> 0
                    then
                      begin
                        opcode (c_leax) ;
                        post1 (p_idx + p_ixrx + p_ixfx) ;
                        codet_word (temp)
                        {leax offset,x}
                      end
                end {constant index}
              else
                begin {not constant}
                  if not subrange_opt and ((asize = 1) or (asize = 2) or (asize = 4))
                    then 
                      begin {use inline}
                        if p3^.token in [enumvar, charvar, boolvar]
                          then
                            begin
                              opcodet (c_clra) ;
                              if aoff <> 0
                                then
                                  begin
                                    opcode (c_subb) ;
                                    post2t (p_imm, byte(aoff))
                                    {subb #offset}
                                  end
                            end
                          else
                            if aoff <> 0
                              then
                                begin
                                  opcode (c_subd) ;
                                  post1 (p_imm) ;
                                  codet_word (aoff)
                                  {subd #offset}
                                end ;
                        if asize > 1
                          then
                            eminln (104) ;
                        if asize > 2
                          then
                            eminln (104) ;
                        opcode (c_pulu) ;
                        post1t (p_ipx) ;
                        {pulu x}
                        opcode (c_leax) ;
                        post1t (p_idx + p_ixrx + p_ixd)
                        {leax d,x}
                      end
                    else
                      if (asize < $100) and (((aoff <= 127) and (arange <= 127)) or
                                            (p3^.token in [enumvar, boolvar, charvar]))
                        then
                          begin {1 byte indexing}
                            if p3^.token = integvar
                              then
                                hand (int, $37)
                              else
                                hand (int, $32) ;
                            data_byte (byte(aoff)) ;
                            data_byte (byte(arange)) ;
                            datat_byte (byte(asize))
                          end
                        else
                          begin { 2 byte indexing}
                            if p3^.token in [enumvar, boolvar, charvar]
                              then
                                opcodet (c_clra) ;
                            if p3^.token = integvar
                              then
                                hand (int, 1)
                              else
                                hand (int, $38) ;
                            data_word (aoff) ;
                            data_word (arange) ;
                            datat_word (asize)
                          end
                end ; {not constant}
            if p.tk^ <> arrayvar {not another nested array}
              then
                exit ;
            if lastpack^.token <> comma
              then
                if lastpack^.token <> rightbracket
                  then
                    begin
                      verror := e_comma ;
                      exit (2)
                    end
                  else
                    begin
                      scan ;
                      if lastpack^.token <> leftbracket
                        then
                          begin
                            p2 := align (p.tk + 1) ;
                            strpush (p2^) ;
                            exit (2)
                          end
                        else {stay in loop}
                    end
              {stay in loop}
          until false ;
          if (p.tk^ = stringvar) and (lastpack^.token = comma)
            then
              stringindex
            else
              if lastpack^.token <> rightbracket
                then
                  begin
                    verror := e_rbrk ;
                    exit
                  end
                else
                  base_types
        until true
      end ;

    procedure vstring_set ;
      begin
        push_pointer (p1) ;
        scan ;
        if lastpack^.token = leftbracket
          then
            stringindex
          else
            begin
              nextok := true ;
              general (false)
            end
      end ;

    begin {varib}
      repeat
        verror := undef ;
        nextok := false ;
        record_cluge := false ;
        if outer
          then
            begin
              if not ident_flag
                then
                  verror := e_id
                else
                  if vpac^.token = undef
                    then
                      verror := e_ui
                    else
                      if vpac^.token <> vardef
                        then
                          verror := e_inac ;
              if verror <> undef
                then
                  exit ;
              vpac^.token := vpac^.subtoken
            end ;
        p1 := vpac^.pointr ;
        voff := p1^.offset ;
        vlex := p1^.lexlev ;
        p.tk := p1 + align(sizeof(symhead)) ;
        p.tk := get_next (p.tk, true) ;
        if p.tk^ in [valuepar .. funcret]
          then
            begin
              p.tk := align (p.tk + 1) + 4 ;
              p.tk := get_next (p.tk, false)
            end ;
        if with_lea or record_flag
          then
            record_offset := record_offset - voff
          else
            begin
              record_head := p1 ;
              record_offset := 0 ;
              case p1^.storage of
                s_stack : record_offset := voff ;
                s_absolute : record_offset := 0 - voff
              end
            end ;
        case p.tk^ of
          hexvar : vpointer (true) ;
          arrayvar : varray (true) ;
          recordvar : vrecord (true) ;
          stringvar, setvar : vstring_set ;
          devicevar : vdevice (true)
          else
            general (true)
        end ;
        if record_cluge
          then
            exit ;
        array_lea := false ;
        with_lea := false ;
        varib := get_packet (p.tk) ;
      until true
    end ;

modend.
