{$l-}
{ 5/16/89 : initial conversion to version 3
  6/7/89 : heapsize added
}
{
  buffer sizes
}
  const
    size_varq = 1024 ;      {variable definition queue}
    size_enum = 1024 ;      {enumerated type buffer}
    size_deviceq = 20 ;     {device init queue}
    size_exitq = 20 ;       {exit queue}
    size_ptrq = 1024 ;      {forward pointer queue}
    size_gotoq = 20 ;       {forward goto queue}
    size_vbuf = 512 ;       {variable accessing buffer}
    size_paramq = 128 ;     {program parameter queue}
    size_with = 16 ;        {maximum with nesting level}
    size_branch = 40 ;      {maximum boolean expression level}
    size_hash = $216 ;      {hash table max}
    size_def_point = #20 ;  {maximum deference level}
    size_static = #10 ;     {maximum nesting level for stack size}
    internal_size = $1800 ; {internal heap size}
    symtab_size = 30000 ;   {symbol table size}

    local_size = $A ;       {local stack frame size}
    
  type
    anystring = string[120] ;
    
    manypt = record
               case integer of
                 0 : (bl : ^boolean) ;
                 1 : (ch : ^char) ;
                 2 : (int : ^integer) ;
                 3 : (hx : ^hex) ;
                 4 : (lx : ^longhex) ;
                 5 : (li : ^longinteger) ;
                 6 : (rl : ^real) ;
                 7 : (en : ^enum_value) ;
                 8 : (st : ^anystring) ;
                 9 : (tk : ^token_type) ;
                10 : (pt : ^type_ptr) ;
                11 : (ph : ^proc_head) ;
               end ;
              
    hand_type = (proc, oper, func, int, dev, ibra) ;

    hand_entry = record
                   used : boolean ;
                   numb : byte
                 end ;

    hand_table = record
                   prc : array [#1..#52] of hand_entry ;
                   opr : array [#1..#48] of hand_entry ;
                   fnc : array [#1..#52] of hand_entry ;
                   int : array [#1..#48] of hand_entry ;
                   dev : array [#1..#8] of hand_entry
                 end ;

    type_gotoq = record
                   auxlabel : hex ;
                   gotooff : hex ;
                   labpt : ^symhead
                 end ;

    type_devq = record
                  devpt : ^symhead ;
                  headpt : ^type_device_head
                end ;
                
    with_type = record
                  frame_offset : hex ;
                  headpt : ^symhead
                end ;

    ftab = array [1..40] of record
                              routine : token_type ;
                              par : token_type ;
                              res : token_type ;
                              num : byte
                            end ;

  var
    first_variable : hex ; {to locate highest stack address}
    
    auto_opt,         { $a+ active}
    break_opt,        { $b+ active}
    form_feed_opt,    { command line F option active}
    halt_opt,         { command line H option active}
    list_opt,         { command line L option active}
    out_opt,          { command line O option active}
    source_opt,       { command line S option active}
    debug_opt,        { command line D option active}
    icode_opt,        { command line I option active}
    ovf_opt,          { $o+ active}
    intask,           { inside a task procedure}
    relo_opt,         { command line R option active}
    subrange_opt,     { $s+ active}
    time_opt,         { command line T option active}
    wopt              { command line W option active}
                   : boolean ;

    c_module,         { compiling a module}
    ident_flag,       { last token was identifier}
    include_active,   { include file active}
    indirect,         { use indirect addressing}
    null_state,       { null statement encountered}
    override,         { override module code restrictions}
    record_flag,      { currently in a record}
    debug_en          { d+ on - default}
                   : boolean ;

    line_up,          { line has been listed}
    error_up,         { error has been listed}
    var_occured,      { variable section has occured}
    var_access,       { code is for variable access, save in aux}
    with_flag,        { in a with statement flag}
    with_lea,         { with flag, pointer set}
    array_lea,        { array flag, pointer set}
    new_num           { statement number generation flag}
                   : boolean ;

    dyno,             { dynamic variable allocated flag}
    execute,          { current line is executable}
    cond_flag,        { if set, don't compile}
    nest_up,          { if set, nesting level is up}
    page_it           { if set, pageing command occured}
                   : boolean ;

    list_depth,       { number of lines on page}
    curr_line,        { current line (vertical spacing)}
    width,            { number of characters across page}
    lex,              { current lexical level}
    nesting,          { current statement nesting level (indent)}
    record_lex,       { record lexical level}
    register_count,   { register variable counter}
    icode_length,     { icode record length}
    enum_count,       { enumerated type value counter}
    def_next,         { deference nesting level}
    record_depth,     { record nesting depth}
    errmax,           { number of errors on current line}
    level             { expression nesting level}
                   : byte ;

  var
  
    heapstart,        { start of internal heap}
    heapptr,          { pointer into internal heap}
    lastpack          { last packet from scanner}
                   : ^packet ;

    inptr,            { pointer into input line}
    tpstart,          { start of type extension}
    tpend             { end of type extension}
                   : ^byte ;
            
  var
    sym_bottom,       { bottom of symbol table}
    next_sym,         { address to place next symbol}
    prog_param,       { next program parameter address}
    pointer_active,   { pointer into pointer queue}
    var_active,       { next usable location in variable queue}
    var_start,        { start of allowable queue}
    var_current,      { location in variable queue now on}
    enum_active       { pointer into enumerated type queue}
                   : ^symname ;

  var
    last_sym,         { last symbol entered header address}
    record_search,    { address of record to search in}
    record_head,      { address of record for accessing}
    global_search,    { outside of record search}
    with_cluge,       { returns symbol table information on records}
    hash_pt           { pointer derived from hash table}
                   : ^symhead ;

    functab           { pointer to function lookup table}
                   : ^ftab ;

    start_token       { address of token start character}
                   : longhex ;

    block_name,       { block internal name}
    internal_name,    { internal name counter}
    hash_idx,         { index into hash table}
    alloc,            { allocation (stack offset) counter}
    record_offset,    { current stack offset for variable}
    record_size,      { current record size}
    varib_address,    { absolute variable address}
    with_offset,      { with stack offset}
    max_static,       { maximum static stack space}
    heapsize          { extra size for heap }
                   : hex ;

  var
    line_number,      { listing line number}
    include_line,     { include file line number}
    errors,           { total number of errors}
    page_number,      { page number}
    list_count,       { list on/off, negatie = off}
    forward_goto,     { number of forward goto's active}
    with_depth,       { number of nested withs right now}
    false_depth,      { depth of and branch stack}
    true_depth,       { depth of or branch stack}
    device_active,    { number of devices in queue}
    exit_active,      { number of possible exits in queue}
    cond_depth        { depth of conditional compilation}
                   : integer ;

    modif1,           { first variable storage modifier}
    modif2            { second variable storage modifier}
                   : directives ;
                  
    idnt : string [40] ;          { idnt directive}
    linestring : string [4] ;     { listing line number}
    neststring : string [2] ;     { executable and nesting}
    title : string [80] ;         { page title}
    prog_name : string [20] ;     { program name}
    time : string [30] ;          { time of day}
    id_field : string [40] ;      { program id field}
    input_buf : string [120] ;    { input line buffer}
    output_buf : string [128] ;   { output line buffer}
    list_buf : string [120] ;     { listing buffer}
    icode_buf : string [128] ;    { icode buffer}
    input_name : string [120] ;    { input file name}
    output_name : string [120] ;   { output file name}
    list_name : string [120] ;     { listing file name}
    include_name : string [120] ;  { include file name}
    last_ident : string [120] ;   { last identifier searched for}
    pointer_base : string[120] ;  { name of missing pointer type }

    stddev : set of input_ .. keyboard_ ; {which devices are active}
    
    varq : array [0 .. size_varq] of byte ;
    enumbuf : array [0 .. size_enum] of byte ;
    deviceq : array [0 .. size_deviceq] of type_devq ;
    exitq : array [0 .. size_exitq] of type_label ;
    ptrq : array [0 .. size_ptrq] of byte ;
    gotoq : array [0 .. size_gotoq] of type_gotoq ;
    vbuf : array [0 .. size_vbuf] of byte ;
    paramq : array [0 .. size_paramq] of byte ;
    with_tab : array [0 .. size_with] of with_type ;
    true_tab : array [0 .. size_branch] of record
                                             lev : byte ;
                                             num : hex
                                           end ;
    false_tab : array [0 .. size_branch] of record
                                              lev : byte ;
                                              num : hex
                                            end ;
    def_point : array [#0 .. size_def_point] of ^token_type ;
    static : array [#0 .. size_static] of hex ;
    cond_stack : array [0 .. 30] of boolean ;
    h_tab : hand_table ;
    hash_tab : array [$0 .. size_hash] of ^symhead ;

    last_variable : hex ; {to locate lowest stack address}

{$ceq program}
  const
    size_input = external hex ;    { size of input descriptor}
    size_output = external hex ;   { size of output descriptor}
    size_auxout = external hex ;   { size of auxout descriptor}
    size_keyboard = external hex ; { size of keyboard descriptor}
    size_device = external hex ;   { base size of device descriptor}
    size_file = external hex ;     { base size of file descriptor}
    size_text = external hex ;     { size of text file}
{$cend}

{$l+}
