module wrif {$v3,0 while, repeat, if, for} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  procedure end_statement (e : error_type ; toke : tokes) ; external ;
  procedure insert (e : error_type ; t : token_type) ; external ;
  procedure statements (var gerror : error_type) ; external ;
  function express (var error : error_type ;
                    var lp : labpack) : ^packet ; external ;
  function get_internal : hex ; external ;
  function varib (vpac : ^packet ; var verror : error_type ;
                  getdata : boolean ; outer : boolean) : ^packet ; external ;
  procedure replace (e : error_type ; t : token_type) ; external ;
  procedure errorpt (errnum : error_type) ; external ;
  procedure vget ; external ;
  procedure uncon (p : ^packet) ; external ;
  function gimme (req : tokes ; var gerror : error_type) : ^packet ; external ;
  procedure listout (s : string[120]) ; external ;
  
  procedure out_branch (post : byte ; pname : hex) ; entry ;
    begin
      if post = p_bnd
        then
          listout ('Invalid postbyte - INTERNAL COMPILER ERROR')
        else 
          begin
            if post = p_bb
              then
                post := p_beq ;
            opcode (c_xbxx) ;
            post1 (post + p_rell) ;
            codet_word (pname)
          end
    end ;
        
  function revpost (post : byte) : byte ; entry ;
    const
      postlook = local array [p_bra .. p_ble] of byte 
        (p_bra, p_bsr, p_bls, p_bhi, p_blo, p_bhs, p_beq, p_bne,
         p_bvc, p_bvs, p_bpl, p_bmi, p_blt, p_bge, p_ble, p_bgt) ;
    begin
      if post <= p_ble
        then
          revpost := postlook[hex(post)]
      else if post = p_bb
        then
          revpost := p_bne
        else
          listout ('Invalid postbyte - INTERNAL COMPILER ERROR')
    end ;
    
  procedure out_true (level : byte) ; entry ;
    var
      i : integer ;
    begin
      for i := true_depth downto 1 do
        with true_tab[i] do
          if lev  < level
            then
              exit
            else
              begin
                opcode (c_equ) ;
                post1 (p_eqlp) ;
                codet_word (num) ;
                purge (num) ;
                true_depth := pred (true_depth)
              end
    end ;
    
  procedure out_false (level : byte) ; entry ;
    var
      i : integer ;
    begin
      for i := false_depth downto 1 do
        with false_tab[i] do
          if lev < level
            then
              exit
            else
              begin
                opcode (c_equ) ;
                post1 (p_eqlp) ;
                codet_word (num) ;
                purge (num) ;
                false_depth := pred (false_depth)
              end
    end ;
    
  procedure false_save (level : byte ; var fstack : array [0..20] of hex ;
                        var fdepth : integer) ;
    var
      i : integer ;
    begin
      fdepth := 0 ;
      for i := false_depth downto 1 do
        with false_tab[i] do
          if lev < level
            then
              exit
            else
              begin
                fdepth := succ(fdepth) ;
                fstack[fdepth] := num ;
                false_depth := pred(false_depth)
              end
    end ;
    
  procedure out_save (var fstack : array [0..20] of hex ; var fdepth : integer) ;
    var
      i : integer ;
    begin
      for i := 1 to fdepth do
        begin
          opcode (c_equ) ;
          post1 (p_eqlp) ;
          codet_word (fstack[i]) ;
          purge (fstack[i])
        end ;
      fdepth := 0
    end ;
    
  procedure while_state (var gerror : error_type) ; entry ;
    var
      lerror : error_type ;
      pname : hex register ;
      bpac : ^packet register ;
      lp1 : labpack ;
      fstack : array [0..20] of hex ;
      fdepth : integer ;
    begin
      gerror := undef ;
      pname := get_internal ;
      exit_active := exit_active + 1 ;
      exitq[exit_active].offset := alloc ;
      exitq[exit_active].internal := get_internal ;
      repeat
        repeat
          opcode (c_equ) ;
          post1 (p_eqlp) ;
          codet_word (pname) ; {lbxxxx equ *}
          scan ;
          lp1.branch := true ;
          lp1.post := p_bnd ;
          level := 1 ;
          bpac := express (lerror, lp1) ;
          if lerror <> undef
            then
              begin
                end_statement (lerror, [do_]) ;
                if lastpack^.token = do_
                  then
                    exit
                  else
                    exit(2)
              end ;
          case bpac^.token of
            boolvar :
              begin
                if false_depth > 0
                  then
                    out_branch (lp1.post, false_tab[false_depth].num)
                  else
                    out_branch (lp1.post, exitq[exit_active].internal) ;
                lp1.post := p_bnd
              end ;
            true_ : {no branch needed}
            else
              end_statement (e_itoe, [do_])
          end ;
          if lastpack^.token = do_
            then
              scan
            else
              insert (e_do, do_)
        until true ;
        out_true (level) ;
        false_save (level, fstack, fdepth) ;
        statements (lerror) ;
        opcode (c_xbxx) ;
        post1 (p_bra + p_rell) ;
        codet_word (pname) ; {bra lbxxx}
        purge (pname) ;
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (pname + 1) ;
        {lbxxx equ *}
        purge (pname + 1) ;
        out_save (fstack, fdepth)
      until true ;
      exit_active := exit_active - 1
    end ;
  
  procedure repeat_state (var gerror : error_type) ; entry ;
    var
      lerror : error_type ;
      pname, auxname : hex register ;
      bpac : ^packet register ;
      lp1 : labpack ;
    begin
      gerror := undef ;
      pname := get_internal ;
      auxname := 0 ;
      exit_active := exit_active + 1 ;
      with exitq[exit_active] do
        begin
          internal := get_internal ;
          offset := alloc
        end ;
      repeat
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (pname) ; {lbxxx equ *}
        scan ;
        repeat
          statements (lerror) ;
          repeat
            case lastpack^.token of
              until_ : exit (2) ;
              semicolon :
                begin
                  scan ;
                  exit
                end
              else
                if (lerror <> undef) or null_state
                  then
                    end_statement (e_se, [until_])
                  else
                    begin
                      insert (e_semi, semicolon) ;
                      exit
                    end
            end
          until false
        until false ;
        line ;
        scan ;
        lp1.branch := true ;
        lp1.post := p_bnd ;
        level := 1 ;
        bpac := express(lerror, lp1) ;
        if lerror <> undef
          then
            begin
              end_statement (lerror, []) ;
              exit
            end ;
        case bpac^.token of
          boolvar : 
            begin
              if false_depth > 0
                then
                  begin
                    auxname := get_internal ;
                    out_branch (revpost(lp1.post), auxname) ;
                    out_false (level) ;
                    out_branch (p_bra, pname) ;
                    opcode (c_equ) ;
                    post1 (p_eqlp) ;
                    codet_word (auxname) ;
                    purge (auxname) ;
                  end
                else
                  out_branch (lp1.post, pname)
            end ;
          true_ :
          else
            end_statement (e_itoo, [])
        end ;
        out_true (level) ;
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (pname + 1) ;
        {lbxxx equ *}
        purge (pname) ;
        purge (pname + 1)
      until true ;
      exit_active := exit_active - 1
    end ;

  procedure if_state (var gerror : error_type) ; entry ;
    const
      then_else_look = 1 ;
      then_found     = 2 ;
      else_found     = 3 ;
      get_state      = 4 ;
    label
      then_else_look, then_found, else_found, get_state ;
    var
      pname, pname2 : hex register ;
      bpac : ^packet register ;
      lerror : error_type ;
      lp1 : labpack ;
      fstack : array [0..20] of hex ;
      fdepth : integer ;
    begin
      repeat
        pname := $ffff ;
        gerror := undef ;
        scan ;
        lp1.branch := true ;
        lp1.post := p_bnd ;
        level := 1 ;
        bpac := express (lerror, lp1) ;
        if lerror <> undef
          then
            begin
then_else_look :
              end_statement (lerror, [then_, else_]) ;
              case lastpack^.token of
                then_ : goto then_found ;
                else_ : goto else_found
                else
                  exit
              end
            end ;
        case bpac^.token of
          boolvar : 
            begin
              if false_depth > 0
                then
                  pname := false_tab[false_depth].num
                else
                  pname := get_internal ;
              out_branch (lp1.post, pname)
            end ;
          true_ :
          else
            begin
              lerror := e_itoo ;
              goto then_else_look
            end
        end ;
        out_true (level) ;
        if lastpack^.token <> then_
          then
            begin
              insert (e_then, then_) ;
              goto get_state
            end ;
then_found :
        nesting := succ (nesting) ;
        scan ;
get_state :
        false_save (level, fstack, fdepth) ;
        statements (lerror) ;
        if lerror <> undef
          then
            if lastpack^.token = else_
              then
                goto else_found
              else
                exit ;
        nesting := pred (nesting) ;
        if lastpack^.token = else_
          then
            begin
else_found :
              pname2 := get_internal ;
              out_branch (p_bra, pname2) ;
              if fdepth > 0
                then
                  out_save (fstack, fdepth)
                else
                  if pname <> $ffff
                    then
                      begin
                        opcode (c_equ) ;
                        post1 (p_eqlp) ;
                        codet_word (pname) ;
                        purge (pname)
                      end ;
              pname := pname2 ;
              nesting := succ (nesting) ;
              scan ;
              statements (lerror) ;
              if lerror <> undef
                then
                  exit ;
              nesting := pred(nesting)
            end ;
        if fdepth > 0
          then
            out_save (fstack, fdepth)
          else
            if pname <> $ffff
              then
                begin
                  opcode (c_equ) ;
                  post1 (p_eqlp) ;
                  codet_word (pname) ; {lbxxx equ *}
                  purge (pname)
                end
      until true
    end ;

  procedure for_state (var gerror : error_type) ; entry ;
    const
      do_look = 1 ;
      get_state = 2 ;
    label
      do_look, get_state ;
    var
      stacksize, lab1, lab2, lab3 : hex register ;
      lerror : error_type ;
      vpac, ipac, lpac : ^packet ;
      vcheck : ^anystring ;
      facc : anystring ;
      up : boolean ;
      two, signed : boolean ;
    begin
      stacksize := 0 ;
      gerror := undef ;
      up := true ;
      repeat
        scan ;
        vpac := varib (lastpack, lerror, false, true) ;
        opcode (c_pshu) ;
        post1t (p_ipx) ;
        {pshu x}
        if lerror <> undef
          then
            begin
do_look :
              end_statement (lerror, [do_]) ;
              if lastpack^.token = do_
                then
                  goto get_state
                else
                  exit
            end ;
        case lastpack^.token of
          assign : ;
          colon, equal : replace (e_assign, assign)
          else
            begin
              lerror := e_assign ;
              goto do_look
            end
        end ;
        scan ;
        if vpac^.token in [subbool..subhex]
          then
            ipac := gimme ([enum(byte(vpac^.token) - sub_offset)], lerror)
          else
            ipac := gimme ([vpac^.token], lerror) ;
        if lerror <> undef
          then
            goto do_look ;
        uncon (ipac) ;
        signed := ipac^.token = integvar ;
        two := ipac^.token in [integvar, hexvar] ;
        if (ipac^.token <> vpac^.token) and
           (enum(byte(vpac^.token) - sub_offset) <> ipac^.token)
          then
            errorpt (e_tc)
          else
            if not (ipac^.token in [boolvar .. hexvar, enumvar])
              then
                errorpt (e_itoe) ;
        if two
          then
            begin
              opcode (c_std) ;
              post1t (p_idx + p_idxi + p_ixru + p_ixz)
              {std [0,u]}
            end
          else
            begin
              opcode (c_stb) ;
              post1t (p_idx + p_idxi + p_ixru + p_ixz)
              {stb [0,u]}
            end ;
        case lastpack^.token of
          to_ : ;
          downto_ : up := false
          else
            begin
              lerror := e_todn ;
              goto do_look
            end
        end ;
        scan ;
        if vpac^.token in [subbool..subhex]
          then
            lpac := gimme ([enum(byte(vpac^.token) - sub_offset)], lerror)
          else
            lpac := gimme ([vpac^.token], lerror) ;
        if lerror <> undef
          then
            goto do_look ;
        if lpac^.token <> ipac^.token
          then
            errorpt (e_tc) ;
        uncon (lpac) ;
        lab1 := get_internal ;
        lab2 := get_internal ;
        lab3 := get_internal ;
        exit_active := exit_active + 1 ;
        with exitq[exit_active] do
          begin
            internal := lab3 ;
            offset := alloc
          end ;
        if two
          then
            eminln (109)
          else
            eminln (108) ;
        opcode (c_xbxx) ;
        if signed
          then
            if up
              then
                post1 (p_blt + p_rell)
              else
                post1 (p_bgt + p_rell)
          else
            if up
              then
                post1 (p_blo + p_rell)
              else
                post1 (p_bhi + p_rell) ;
        codet_word (lab2) ;
        {bxx lb2}
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (lab1) ;
        {lb1 equ *}
        if two
          then
            stacksize := stacksize + 4
          else
            stacksize := stacksize + 3 ;
        alloc := alloc + stacksize ;
        if lastpack^.token <> do_
          then
            begin
              lerror := e_do ;
              goto do_look
            end ;
get_state :
        scan ;
        statements (lerror) ;
        if two
          then
            eminln (111)
          else
            eminln (110) ;
        opcode (c_xbxx) ;
        post1 (p_beq + p_rell) ;
        codet_word (lab2) ;
        {beq.s lb2}
        if up
          then
            if two
              then
                begin
                  opcode (c_addd) ;
                  post1 (p_imm) ;
                  codet_word (1) ;
                  {addd #1}
                  opcode (c_std) ;
                  post1 (p_idx + p_ixru + p_idxi + p_ixfx) ;
                  codet_word (2)
                  {std [2,u]}
                end
              else
                begin
                  opcode (c_inc) ;
                  post1 (P_idx + p_ixru + p_idxi + p_ixfx) ;
                  codet_word (1)
                  {inc [1,u]}
                end
          else
            if two
              then
                begin
                  opcode (c_subd) ;
                  post1 (p_imm) ;
                  codet_word (1) ;
                  {subd #1}
                  opcode (c_std) ;
                  post1 (p_idx + p_ixru + p_idxi + p_ixfx) ;
                  codet_word (2)
                  {std [2,u]}
                end
              else
                begin
                  opcode (c_dec) ;
                  post1 (p_idx + p_ixru + p_idxi + p_ixfx) ;
                  codet_word (1)
                  {dec [1,u]}
                end ;
        post1 (p_imm) ;
        opcode (c_xbxx) ;
        post1 (p_bra + p_rell) ;
        codet_word (lab1) ;
        {bra lb1}
        purge (lab1) ;
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (lab2) ;
        {lb2 equ *}
        purge (lab2) ;
        opcode (c_leau) ;
        post1 (p_idx + p_ixru + p_ixfx) ;
        codet_word (stacksize) ;
        {leau n,u}
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (lab3) ;
        {lb3 equ *}
        purge (lab3)
      until true ;
      alloc := alloc - stacksize ;
      exit_active := exit_active - 1
    end ;
    
modend.
