program xpc {$v3,1 main and OS interface} ({$b+}input{$b-},
                                            keyboard, output) ;
{$h48000}
{
  5/16/89 : initial conversion to level 3
  7/22/89 : oldtask flag added.
  10/11/89 : allow specification on command line of edit data buffer.
}
{$I/r0/token}
{$I/r0/error}
{$I/r0/varib}

  const
    t_none = 0 ;
    t_rover = 1 ;
    t_brange = 2 ;
    t_intovr = 3 ;
    t_extovr = 4 ;
    t_mdef = 5 ;
    t_invop = 6 ;
    t_done = 7 ;
  type
    blkbuffer = array [1..4096] of char ;
    sect = (abs, relo, dat, varb) ;
    line = string[120] ;
    lines = array [0 .. 8000] of ^line ;
    attype = record
              maxline : integer ;
              lineaddr : ^lines ;
              stopmode : integer ;
              stopcnt : integer ; 
              stops : array [0 .. 20] of record
                                           stopline, stopcol : integer
                                         end ;
              curfile : string[120]
            end ;
  var
    input_f : text ;              { input file}
    output_f : text varib entry ; { output file}
    list_f : text ;               { listing file}
    incl_f : text ;               { include file}

    actual_symtab : longhex varib entry ;
    actual_memavail : longhex varib entry ;
    
    iblock : boolean ;
    iblkbuf : ^blkbuffer ;
    iblkmax, iblkcur : ^byte ;
    incblock : boolean ;
    incblkbuf : ^blkbuffer ;
    incblkmax, incblkcur : ^byte ;
    oblock : boolean ;
    oblkbuf : ^blkbuffer varib entry ;
    oblkmax, oblkcur : ^byte varib entry ;
    relo_size : longhex ;
    relo_start : ^byte ;
    cerror : byte ;
    opath : integer varib entry ;
    overwrite : boolean ;
    osize, isize : longhex ;
    
  const
    top = entry byte 0 ; {top of form margin}
    bot = entry byte 0 ; {bottom of form margin}
    def_depth = entry byte 0 ; {default lines per page}
    def_width = entry byte 80 ; {default characters per line}
    iblkon = entry boolean true ; {enables blocking for input and include}
    oblkon = entry boolean true ; {enables blocking for output file}
    op_flag = entry boolean true ; {enabled optimizer}
    oldtask = entry boolean false ;
    maxdepth = entry integer 1 ;
    def_size = entry longhex $5000 ;
    size_input = entry hex 138 ;
    size_output = entry hex 10 ;
    size_auxout = entry hex 10 ;
    size_keyboard = entry hex 8 ;
    size_device = entry hex 6 ;
    size_file = entry hex 7 ;
    size_text = entry hex 128 ;
    xpcvers = entry string[5] '3.00' ;

    errstart = external byte ;
    handtab = external hand_table ;
    sftab = external ftab ;
     
  var
    loc : array[abs .. varb] of hex varib external ;
    
    firstvarib : boolean varib ;
    lastvarib : boolean varib external ;
    at_opt : boolean varib ;
    atvar : ^attype varib ;
    atname : string[20] varib ;
    atmod : longhex varib ;
    atline : integer varib ;
    
{$I/h/defs/os9traps}

  Function sufstrip (Fname : string [120]) : string [120] ; 
    var
      x, y : integer ;
    begin
      for x := ord(fname[0]) downto 0 do
        if (fname[x] = '/') or (x = 0)
          then
            begin
              y := index (substr(fname,x+1,120), '.') ;
              if y <> 0
                then
                  sufstrip := substr(fname,1, x + y -1)
                else
                  sufstrip := fname ;
              exit
            end
    end ;
    
  procedure parse ; external ;
  procedure scan ; external ;
  procedure opset ; external ;
  function convert (var s : string) : byte ; external ;
  procedure initrelo (rbstart, rbsize : longhex) ; external ;
  procedure writerelo ; external ;
  
  procedure initit ;
    var
      p1, p2 : ^hex register ;
    begin
{
  clear global variables
}
      p1 := addr(last_variable) ;
      p2 := addr(first_variable) ;
      repeat
        p1^ := 0 ;
        p1 := p1 + 2
      until p1 >= p2 ;
      p1 := addr(firstvarib) ;
      p2 := addr(lastvarib) ;
      repeat
        p1^ := 0 ;
        p1 := p1 + 2
      until p1 >= p2 ;
{
  set in defaults
}
      inptr := addr(input_buf) ;
      debug_en := true ;
      opath := 0 ;
      overwrite := false ;
      relo_size := def_size ;
      list_depth := def_depth ;
      width := def_width - 1 ;
      h_tab := handtab ;
      at_opt := false ;
      functab := addr(sftab) ;
      if iblkon
        then
          begin
            new (iblkbuf) ;
            new (incblkbuf)
          end ;
      if oblkon
        then
          new (oblkbuf) ;
{ 
  allocate internal heap, set empty
}
      new (heapstart : internal_size) ;
      heapptr := heapstart ;
{
  set in default file names
}
      input_name := 't' ;
      output_name := 't' ;
      list_name := 't' ;
{
  set not executable line and nest level 0
}
      neststring := ':0' ;
      idnt := '1,0' ;
    end ;
    
  procedure comopt ;
    begin
      writeln ('Command line error, format is :') ;
      writeln ('xpc [-opt] [input] [output] [listing] [title]') ;
      writeln ('Valid options are :') ;
      writeln ('D         - enable debug option') ;
      writeln ('F         - enable form feed option') ;
      writeln ('H         - enable halt option') ;
      writeln ('I         - enable icode option') ;
      writeln ('L         - enable list option') ;
      writeln ('O         - enable output option') ;
      writeln ('R         - enable relocatable object option') ;
      writeln ('S         - enable source option') ;
      writeln ('T         - enable time option') ;
      writeln ('W         - enable warning option') ;
      writeln ('Pnnn      - set page size') ;
      writeln ('Rnnn      - enable relocatable object with size') ;
      writeln ('Wnnn      - set page width') ;
      writeln ('Znnn      - set memory size') ;
      writeln ('Special file names are :') ;
      writeln ('t         - terminal') ;
      writeln ('.         - input file name with default suffix') ;
      halt (22)
    end ;
    
  procedure set_options ;
    type
      descriptor = record
                     mode : byte ;
                     err : byte ;
                     drv : longhex ;
                     elnt : integer ;
                     elmt : char ;
                     path : integer
                   end ;
    var
      i : byte register ;
      temp1, offset : byte ;
      copt : string [120] ;
      main, copy : ^descriptor register ;
      temp2 : longinteger ;
      err, attr, lang : integer ;
      
    procedure settime ;
      const
        daynames = local array [0 .. 6] of string[3] 
          ('sun','mon','tue','wed','thu','fri','sat') ;
      var
        stime, date, tickrate : longhex ;
        day : integer ;
        hour, minute, day_week, day_num, month, year : string[4] ;
      begin
        err := f_time(tickrate, day, date, stime, 0) ;
        hour := string(ord(byte(stime >> $10))) ;
        minute := string(ord(byte(stime >> 8))) ;
        if minute[0] = 1
          then
            minute := concat('0',minute) ;
        day_week := daynames[day] ;
        day_num := string(ord(byte(date))) ;
        case byte(date >> 8) of
          1 : month := 'jan' ;
          2 : month := 'feb' ;
          3 : month := 'mar' ;
          4 : month := 'apr' ;
          5 : month := 'may' ;
          6 : month := 'jun' ;
          7 : month := 'jul' ;
          8 : month := 'aug' ;
          9 : month := 'sep' ;
         10 : month := 'oct' ;
         11 : month := 'nov' ;
         12 : month := 'dec'
         else
           month := 'XXX'
        end ;
        year := string(integer(date >> $10)) ;
        time := concat(hour,':',minute,' ',day_week,' ',day_num,
                       ' ',month,' ',year)
      end ;

    begin {set_options}
      repeat
        offset := 2 ;
        copt := cline(1) ;
        if copt[0] = 0
          then
            exit ;
        if copt[1] = '-'
          then
            begin
              i := 2 ;
              while i <= copt[0] do
                begin
                  case upshift(copt[i]) of
                    'D' : debug_opt := true ;
                    'F' : form_feed_opt := true ;
                    'H' : halt_opt := true ;
                    'I' : icode_opt := true ;
                    'S' : source_opt := true ;
                    'T' : time_opt := true ;
                    'O' : out_opt := true ;
                    'L' : list_opt := true ;
                    '@', 'R', 'Z', 'P', 'W' :
                      begin
                        repeat
                          temp1 := upshift(copt[i]) ;
                          temp2 := 0 ;
                          i := i + 1 ;
                          while i <= copt[0] do
                            if copt[i] in ['0' .. '9']
                              then
                                begin
                                  temp2 := temp2 * 10 + 
                                           longinteger(copt[i] - '0') ;
                                  i := i + 1
                                end
                              else
                                exit
                        until true ;
                        i := i - 1 ;
                        case temp1 of
                          'P' : list_depth := byte(temp2) ;
                          'W' : 
                            if temp2 = 0
                              then
                                wopt := true 
                              else
                                width := byte(temp2) - 1 ;
                          'R' :
                            if temp2 = 0
                              then
                                relo_opt := true 
                              else
                                begin
                                  relo_opt := true ;
                                  relo_size := longhex(temp2) * $400
                                end ;
                          '@' :
                            if temp2 = 0
                              then
                                begin
                                  if (i + 3 <= copt[0]) and (copt[i + 1] = '"')
                                    then
                                      begin
                                        i := i + 2 ;
                                        atname := '' ;
                                        while i < copt[0] do
                                          if copt[i] = '"'
                                            then
                                              exit
                                            else
                                              begin
                                                append (atname, copt[i]) ;
                                                i := i + 1
                                              end ;
                                        lang := 0 ;
                                        halt(f_link(atname,atmod,atvar,attr,lang)) ;
                                        at_opt := true ;
                                        atline := 1 ;
                                        atvar^.stopmode := 1
                                      end
                                    else
                                      comopt
                                end
                              else
                                begin
                                  at_opt := true ;
                                  atvar := longhex(temp2) << 1 ;
                                  atline := 1 ;
                                  atvar^.stopmode := 1
                                end ;
                        end
                      end
                    else
                      comopt
                  end ;
                  i := i + 1
                end
            end
          else
            offset := 1
      until true ;
      if at_opt
        then
          begin
            offset := offset - 1 ;
            input_name := atvar^.curfile
          end
        else
          if cline(offset) <> ''
            then
              input_name := cline(offset) ;
      if out_opt or icode_opt or debug_opt or relo_opt
        then
          if cline(offset + 1) <> ''
            then
              output_name := cline(offset + 1)
            else
        else
          offset := offset - 1 ;
      if cline(offset + 2) <> ''
        then
          list_name := cline(offset + 2) ;
{
  cannot produce both icode and assembly language
}
      if ord(icode_opt) + ord(out_opt) + ord(relo_opt) > 1
        then
          comopt ;
{
process time if option set
}
      time := '' ;
      if time_opt
        then
          settime ;
{
  open input and listing files
}
      isize := 0 ;
      iblock := false ;
      if not at_opt
        then
          begin
            if input_name = '.'
              then
                input_name := 't' ;
            if upshift(input_name) = 'T'
              then
                open (input_f, input)
              else
                begin
                  {$i-}
                  reset (input_f, input_name) ;
                  if deverr (input_f) <> 0
                    then
                      begin
                        writeln ('Error ',ord(deverr(input_f)):0,
                                 ' opening ',input_name) ;
                        halt (22)
                      end ;
                  {$i+}
                  main := addr(input_f) ;
                  iblock := (main^.mode and $80 = 0) and iblkon ;
                  iblkmax := iblkbuf ;
                  iblkcur := iblkmax + 1 ;
                  if iblock
                    then
                      err := gs_size (isize, get_path(addr(input_f))) ;
                end
          end ;
      if list_name = '.'
        then
          list_name := concat(sufstrip(input_name),'.cl') ;
      if upshift(list_name) = 'T'
        then
          open (list_f, output)
        else
          begin
            if list_name = input_name
              then
                begin
                  writeln ('FILE NAME CONFLICT') ;
                  halt (22)
                end ;
            rewrite (list_f, list_name)
          end ;
{
  if and kind of output, open appropriate file
}
      oblock := false ;
      overwrite := false ;
      if out_opt or debug_opt or icode_opt or relo_opt
        then
          begin
            if output_name = '.'
              then
                output_name := concat(sufstrip(input_name),'@') ;
            if upshift(output_name) = 'T'
              then
                if out_opt
                  then
                    open (output_f, output)
                  else
                    begin
                      writeln ('CANNOT WRITE INTERMEDIATE OR RELOCATABLE CODE TO TERMINAL') ;
                      halt (22)
                    end
              else
                begin
                  if output_name[output_name[0]] = '@'
                    then
                      begin
                        output_name[0] := output_name[0] - 1 ;
                        if out_opt
                          then
                            output_name := concat(output_name, '.a')
                        else if relo_opt
                          then
                            output_name := concat(output_name, '.r')
                          else
                            output_name := concat(output_name, '.db')
                      end ;
                  if output_name = input_name
                    then
                      begin
                        writeln ('FILE NAME CONFLICT') ;
                        halt (22)
                      end ;
                  {$i-}
                  open (output_f, output_name, output) ;
                  err := ord(deverr(output_f)) ;
                  {$i+}
                  case err of
                    0 : 
                      begin
                        overwrite := true ;
                        opath := get_path(addr(output_f))
                      end ;
                    216 :
                      begin
                        if out_opt
                          then
                            osize := isize << 1
                          else
                            if relo_opt
                              then
                                osize := isize >> 1
                              else
                                osize := isize ;
                        err := i_create (output_name, osize, 3, $22, opath) ;
                        if err <> 0
                          then
                            halt (err)
                      end
                    else
                      halt (err)
                  end ;
                  oblock := not is_scf(opath) and oblkon ;
                  oblkcur := oblkbuf ;
                  oblkmax := oblkcur + $fff
                end
          end ;
      while cline(offset + 3) <> '' do
        begin
          title := concat (title,' ',cline(offset + 3)) ;
          offset := succ (offset)
        end ;
{
  if relocatable object enabled, initialize it
}
      if relo_opt
        then
          begin
            new (relo_start : relo_size) ;
            initrelo (relo_start, relo_size)
          end ;
{
  allocate symbol table, set empty
}
      actual_symtab := memavail - $1800 ;
      new (sym_bottom : actual_symtab) ;
      actual_memavail := memavail ;
      next_sym := sym_bottom ;
      last_sym := nil ;
    end ;
    
{
  move paper to top of form
}
  procedure tof ; entry ;
    begin
      if list_opt and (list_depth <> 0)
        then
          begin
            while curr_line < list_depth do
              if form_feed_opt
                then
                  begin
                    page (list_f) ;
                    exit
                  end
                else
                  begin
                    writeln (list_f) ;
                    curr_line := curr_line + 1
                  end ;
            curr_line := 0
          end
    end ;
{
  send string to listing device, taking into account
  the form margins
}
  procedure listout (s : string[120]) ; entry ;
    var
      lcnt : byte register ;
    begin
      if s[0] > width
        then
          s[0] := width ;
      if (list_depth <> 0) and list_opt and
         ((curr_line = 0) or (curr_line + bot >= list_depth))
        then
          begin
            if curr_line <> 0
              then
                tof ;
            for lcnt := 1 to top do
              writeln (list_f) ;
            page_number := succ (page_number) ;
            writeln (list_f,substr(concat('Page ',string(page_number),
                     '   OmegaSoft 6809 Cross Pascal Version',xpcvers,'   ',
                     title),1,ord(width))) ;
            if include_active
              then
                writeln (list_f, substr(concat('Source : ',include_name,
                     '   Program : ',prog_name,'  ',time),1,ord(width)))
              else
                writeln (list_f, substr(concat('Source : ',input_name,
                     '   Program : ',prog_name,'  ',time),1,ord(width)));
            writeln (list_f) ;
            curr_line := top + 3
          end ;
      curr_line := succ(curr_line) ;
      if list_opt or error_up
        then
          writeln (list_f, s)
    end ;

  procedure blkwrite (path : integer ; b : ^blkbuffer ;
                      count : longhex) ; entry ;
    var
      err : integer register ;
    begin
      err := i_write (b, count, path) ;
      if err <> 0
        then
          halt (err)
    end ;    
{
  put up error count, move paper to top of form,
  and close all files
}
  procedure terminate ; entry ;
    var
      err : integer register ;
    begin
      {$i-}
      error_up := true ;
      case errors of
        0 : 
          begin
            listout (concat('No Compilation Errors, stack = ',
                     string(max_static),' symbol table left = ',
                     string(real(sym_bottom + actual_symtab - next_sym - $80) / 1024,1),'K')) ;
            if relo_opt
              then
                listout (concat('Code : ',string(loc[relo]),
                              '  Data : ',string(loc[dat]),
                              '  Varib : ',string(loc[varb])))
          end ;
       -1 : listout ('Compilation Aborted')
        else listout (concat('Total Compilation Errors : ',
                             string(errors)))
      end ;
      tof ;
      close (input_f) ;
      if opath <> 0
        then
          begin
            if oblock and (oblkcur <> oblkbuf) and (errors = 0)
              then
                blkwrite (opath, oblkbuf, oblkcur - oblkbuf) ;
            if overwrite
              then
                begin
                  err := gs_pos(osize, opath) ;
                  err := ss_size (osize, opath)
                end ;
            err := i_close(opath)
      end ;
      close (list_f) ;
      close (incl_f) ;
      if atmod <> nil
        then
          err := f_unlink(atmod) ;
      if (errors = 0) or at_opt
        then
          halt (255)
        else
          halt (22)
    end ;
{
  if operator abort, terminate and halt
}
  procedure check_exit ;
    begin
      if break
        then
          begin
            errors := -1 ;
            terminate ;
          end
    end ;
{
  wait for operator intervention on error
}
  procedure halt_wait ;
    var
      ch : char ;
    begin
      if error_up and halt_opt
        then
          begin
            read (keyboard, ch) ;
            if upshift(ch) = 'Q'
              then
                begin
                  errors := -1 ;
                  terminate ;
                end
          end
    end ;
{
  list old input line, handling a page command if needed
}
  procedure up_line ; entry ;
    var
      s : string[120] ;
    begin
      s := input_buf ;
      s[0] := pred(s[0]) ; {purge carriage return}
      if error_up or (list_opt and (list_count >= 0))
        then
          begin
            if page_it
              then
                begin
                  tof ;
                  if list_depth = 0
                    then
                      listout (concat(linestring,neststring,' ',s))
                    else
                end
              else
                listout (concat(linestring,neststring,' ',s)) ;
            halt_wait
          end ;
      neststring [1] := ':'
    end ;
{
  open include file
}    
  procedure include_set ; entry ;
    var
      main : ^byte ;
      x : integer register ;
    begin
      include_name[0] := 0 ;
      while not (inptr^ in [',',' ','*','}',#$D]) do
        begin
          include_name := concat (include_name, inptr^) ;
          inptr := inptr + 1
        end ;
      {$i-}
      for x := length(include_name) downto 0 do
        if (include_name[x] = '/') or (x = 0)
          then
            begin
              if index(substr(include_name, x + 1, 32), '.') = 0
                then
                  append (include_name, '.i') ;
              exit
            end ;
      reset (incl_f, include_name) ;
      if deverr (incl_f) <> 0
        then
          begin
            writeln ('Error ',ord(deverr(incl_f)):0,
                     ' opening ',include_name) ;
            halt (22)
          end ;
      {$i+}
      if at_opt
        then
          atvar^.curfile := include_name ;
      main := addr(incl_f) ;
      incblock := (main^ and $80 = 0) and iblkon ;
      incblkmax := incblkbuf ;
      incblkcur := incblkmax + 1 ;
      include_active := true ;
      include_line := 0
    end ;
    
  function compare : boolean ; entry ;
    begin
      compare := upshift(sufstrip(input_name)) = upshift(sufstrip(include_name))
    end ;

  procedure aterror (x : integer) ;
    var
      ch : char ;
    begin
      up_line ;
      with atvar^ do
        if stopcnt < 20
          then
            begin
              atvar^.stopmode := 0 ;
              stopcnt := stopcnt + 1 ;
              with stops[stopcnt] do
                begin
                  if include_active
                    then
                      stopline := include_line
                    else
                      stopline := line_number ;
                  stopcol := x ;
                end ;
              if stopcnt <> 1
                then
                  if stops[stopcnt].stopline = stops[stopcnt - 1].stopline
                    then
                      if stops[stopcnt].stopcol = stops[stopcnt - 1].stopcol
                        then
                          stopcnt := stopcnt - 1
            end ;
      read (keyboard, ch) ;
      error_up := false ;
      if upshift(ch) = 'Q'
        then
          halt (255)
    end ;
{
  put up error message, only one per line
}
  procedure syserror (errnum : error_type ; chk : boolean) ; entry ;
    type
      estring = string[40] ;
    var
      k : error_type ;
      p1 : ^byte ;
      p2 : ^estring ;
      ch : char ;
    begin
      error_up := true ;
      p1 := addr (errstart) ;
      for k := e_ic to errnum do
        p1 := p1 + longhex(p1^) + 1 ;
      p2 := p1 ;
      if not (errnum in [e_fprd])
        then
          pointer_base := '' ;
      listout (concat('** ',string(integer(errnum) - integer(e_it) + 1)
                      ,' ',p2^)) ;
      errmax := succ (errmax) ;
      if not (errnum in [e_warn, e_wgsv])
        then
          begin
            errors := succ (errors) ;
            if at_opt and chk
              then
                aterror (0) ;
          end ;
      if errmax > 15
        then
          begin
            up_line ;
            errors := -1 ; 
            terminate ;
          end
    end ;
{
  put up error message and pointer to token, only
  one per line
}    
  procedure syserrorpt (errnum : error_type ; offset : integer) ; entry ;
    var
      j : integer ;
      ptstring : string[120] ;
      ch : char ;
    begin
      syserror (errnum, false) ;
      ptstring := '' ;
      if offset + 8 > ord(width)
        then
          offset := ord(width) - 8 ;
      for j := -4 to offset do
        append (ptstring,' ') ;
      listout (concat(ptstring,'*V*')) ;
      if at_opt
        then
          aterror (offset)
    end ;

  function readblk (var t : text ; b : ^blkbuffer ;
                    var p : ^byte) : boolean ;
    var
      count : longhex ;
    begin
      count := 4096 ;
      readblk := i_read (b, count, get_path(addr(t))) <> 0 ;
      p := b + count - 1
    end ;
{
  get new line of input from main file or include file
}      
  procedure new_line ;
    var
      j : integer register ;
      ch : char register ;
    begin
      line_up := false ;
      errmax := 0 ;
      if include_active
        then
          if incblock
            then
              begin
                j := 1 ;
                repeat
                  while incblkcur > incblkmax do
                    begin
                      if readblk (incl_f, incblkbuf, incblkmax)
                        then
                          begin
                            close (incl_f) ;
                            include_active := false ;
                            if at_opt
                              then
                                atvar^.curfile := input_name ;
                            exit (2)
                          end ;
                      incblkcur := incblkbuf
                    end ;
                  ch := incblkcur^ ;
                  if ch = 9
                    then
                      ch := ' ' ;
                  input_buf[j] := ch ;
                  incblkcur := incblkcur + 1 ;
                  j := j + 1 ;
                until ch = $d ;
                input_buf[0] := byte(j - 1)
              end
            else
              if eof (incl_f)
                then
                  begin
                    close (incl_f) ;
                    include_active := false ;
                    if at_opt
                      then
                        atvar^.curfile := input_name
                  end
                else
                  begin
                    readln (incl_f, input_buf) ;
                    input_buf[0] := input_buf[0] + 1 ;
                    input_buf[input_buf[0]] := $D {line terminator}
                  end ;
      if not include_active
        then
          if at_opt
            then
              begin
                if atline > atvar^.maxline
                  then
                    begin
                      syserror (e_coos, false) ;
                      atvar^.stopmode := 2 ;
                      terminate ;
                    end ;
                input_buf := atvar^.lineaddr^[atline]^ ;
                input_buf[0] := input_buf[0] + 1 ;
                input_buf[input_buf[0]] := $D ; {line terminator}
                atline := atline + 1
              end
            else if iblock
              then
                begin
                  j := 1 ;
                  repeat
                    while iblkcur > iblkmax do
                      begin
                        if readblk (input_f, iblkbuf, iblkmax)
                          then
                            begin
                              syserror (e_coos, false) ;
                              terminate ;
                            end ;
                        iblkcur := iblkbuf
                      end ;
                    ch := iblkcur^ ;
                    if ch = 9
                      then
                        ch := ' ' ;
                    input_buf[j] := ch ;
                    iblkcur := iblkcur + 1 ;
                    j := j + 1 ;
                  until ch = $d ;
                  input_buf[0] := byte(j - 1)
                end
              else
                if eof (input_f)
                  then
                    begin
                      syserror (e_coos, false) ;
                      terminate ;
                    end
                  else
                    begin
                      readln (input_f, input_buf) ;
                      input_buf[0] := input_buf[0] + 1 ;
                      input_buf[input_buf[0]] := $D {line terminator}
                    end ;
      inptr := addr(input_buf[1])
    end ;
    
  procedure codeout ; entry ;
    var
      k, j : byte register ;
    begin
      if oblock
        then
          begin
            if not out_opt
              then
                begin
                  output_buf[0] := 1 ;
                  output_buf[1] := icode_buf[0] ;
                  append (output_buf, icode_buf) ;
                  k := output_buf[0]
                end
              else
                begin
                  k := output_buf[0] + 1 ;
                  output_buf[k] := $d
                end ;
            for j := 1 to k do
              begin
                if oblkcur > oblkmax
                  then
                    begin
                      blkwrite (opath, oblkbuf, $1000) ;
                      oblkcur := oblkbuf
                    end ;
                oblkcur^ := output_buf[j] ;
                oblkcur := oblkcur + 1
              end
          end
        else
          writeln (output_f, output_buf)
    end ;

  procedure nextline ; entry ;
    begin
      if input_buf[0] <> 255
        then
          up_line ;
      check_exit ;
      new_line
    end ;
    
  procedure icodeout ; entry ;
    begin
      if relo_opt
        then
          begin
            cerror := convert (icode_buf) ;
            case cerror of
              t_none : ;
              t_done : writerelo ;
              t_invop : syserror (enum(cerror + byte(e_etnf)), true)
              else
                begin
                  syserror (enum(cerror + byte(e_etnf)), true) ;
                  terminate
                end
            end
          end
        else
          codeout
    end ;

{
  initialize, set command options, parse the program, and terminate
}
  begin {pc}
    {$i+,c+,r+}
    writeln ('OmegaSoft 6809 Cross Pascal Compiler version ',xpcvers) ;
    writeln ('Copyright 1987-1989 by Certified Software Corporation') ;
    initit ;
    opset ;
    set_options ;
    input_buf[0] := 255 ; {need new line}
    parse ;
    terminate
  end.
