Program xll {$v3,3 xll} ({$b+}input{$b-}, output) ;
{$h40000}
{
  6/6/89 : initial conversion to level 3
  6/6/89 : if map name starts with a "/", don't add
  suffix.
  10/25/90 : Remove S records, use memory buffer, add
  symbol define and save files.
}
{$l+}
{$Ixllincl}
{$l-}

  var varib entry
    file_offset : longhex ;
    mfile, sfile : text ;
    ifile : text ;
    opath : integer ;
  const
    top = entry byte 0 ;
    bot = entry byte 0 ;
    width = entry byte 80 ;
    depth = entry byte 0 ;
  var varib
    overwrite : boolean ;
    dos : boolean ;
    vectop : boolean ;

{$I/dd/defs/os9traps}

  procedure set_start ; external ;
  procedure set_end ; external ;
  procedure set_offset ; external ;
  procedure set_hole ; external ;
  procedure set_init ; external ;
  procedure load_file (lib : boolean) ; external ;
  procedure define_symbol ; external ;
  procedure save_symbol ; external ;
  procedure display_map ; external ;
  procedure hexstr (var s : string ; b : byte ; h : hex) ; external ;

  function find_sym (sym : string[8] ; tbase : ^sym_type ;
                     curr_sym : integer) : integer ; external ;

  function sufadd (dir, fname, suf : string) : string ; entry ;
    var
      x : integer ;
    begin
      for x := length(fname) downto 0 do
        if (fname[x] = '/') or (x = 0)
          then
            begin
              if index(substr(fname,x+1,80),'.') = 0
                then
                  append(fname,'.',suf) ;
              exit
            end ;
      if substr(fname, 1, 1) <> '/'
        then
          sufadd := concat(dir, fname)
        else
          sufadd := fname
    end ;

  procedure parse (var cml, token : string) ; entry ;
  {
    This procedure will return a valid modifier in 'token' extracted
    from 'cml'. Leading and trailing delimiters (Space or Comma
    characters) are ignored and removed from 'cml'.
  }
    var
      phase : (delim1,xfer,delim2,term) register ;
      toke : char register ;
      delim : boolean register ;
    begin
      token := '' ;
      phase := delim1 ;
      while (cml[0] > 0) and (phase <> term) do
        begin
          toke := cml [1] ;
          cml := substr (cml,2,80) ;
          delim := toke in [' ',','] ;
          case phase of
            delim1 :
              if not delim
                then
                  begin
                    phase := xfer ;
                    token := toke
                  end ;
            xfer :
              if delim
                then
                  phase := delim2
                else
                  token := concat (token, toke) ;
            delim2 :
              if not delim
                then
                  begin
                    phase := term ;
                    cml := concat (toke, cml)
                  end
          end
        end
    end ;

  procedure initialization ;
    var
      frcnt : byte register ;
      temp : longinteger register ;
    begin
      fill_record [0] := 250 ;
      for frcnt := 1 to 250 do
        fill_record [frcnt] := 0 ;
      for sect := relo to vsect do
        begin
          curon [sect] := false ;
          strsect[sect] := 0 ;
          endset[sect] := false
        end ;
      mod_loaded := [] ;
      max_symbol := 0 ;
      max_module := 0 ;
      with in_mod[0] do
        begin
          name := 'DEFINED' ;
          coff := 0 ;
          doff := 0 ;
          voff := 0 ;
        end ;
      start_exec.l := 0 ;
      exec_set := false ;
      dsect_set := false ;
      endexc := false ;
      overwrite := false ;
      pass1 := true ;
      done := false ;
      fopt := false ;
      vectop := false ;
      badlink := false ;
      dos := false ;
      mapwidth := ord(width) - 1 ;
      mname := 'T' ;
      holecnt := 0 ;
      indir := '' ;
      memsize := 0 ;
      max_pline := ord(depth) ;
      cfadr := addr (input) ;
      comon := false ;
      curr_mod_num := 0 ;
      initon := false ;
      new(combase : comax + $80) ;
      comstore := combase ;
      new (iblkbuf) ;
      temp := longinteger((memavail - $1400) div
                   longhex(sizeof(sym_entry))) ;
      if temp > table_max
        then
          table_end := table_max
        else
          table_end := integer(temp) ;
      new(symbol:(table_end + 1) * sizeof(sym_entry))
    end ; { initialize }
    
  procedure write_output ; entry ;
    var
      j : byte register ;
      loc1, temp : hex register ;
      adr : wordbytes ;
      pt : ^byte register ;
    begin
      temp := loc[sect] ;
      loc1 := hex(out_buf[0]) ;
      if (not pass1) and (loc1 > 0)
        then
          begin
            pt := longhex(loc[sect]) + membase - lowest ;
            if (pt < membase) or (pt + longhex(loc1) > membase + memsize)
              then
                if not endexc
                  then
                    begin
                      writeln ('END ADDRESS EXCEEDED') ;
                      endexc := true ;
                      badlink := true
                    end
                  else
              else
                begin
                  for j := 1 to out_buf[0] do
                    begin
                      pt^ := out_buf[j] ;
                      pt := pt + 1
                    end 
                end ;
            loc[sect] := loc[sect] + loc1 ;
            out_buf[0] := 0 ;
          end
    end ; { write_output }

  procedure fill (hex_value : longhex) ; entry ;
    var
      frcnt : longhex register ;
    begin
      write_output ;
      while (hex_value > 0) and (hex_value < $7FFF) do
        begin
          if hex_value > $F2
            then
              frcnt := $F2
            else
              frcnt := hex_value ;
          hex_value := hex_value - frcnt ;
          out_buf := fill_record ;
          out_buf [0] :=  char(frcnt) ;
          write_output
        end
    end ;

  procedure allocate ;
    var
      i : integer register ;
      j : integer register ;
      xdiff, second : hex register ;
      zero : boolean ;
      
    procedure getvalid (var strt : hex ; size : hex) ;
      var
        max : hex ;
        i : integer register ;
        good : boolean register ;
      begin
        if size <> 0
          then
            size := size - 1 ;
        max := strt + size ;
        repeat
          good := true ;
          for i := 1 to holecnt do
            with holetab[i] do
              begin
                if (max >= hstart) and (max <= hend) or
                   (strt >= hstart) and (strt <= hend) or
                   (strt <= hstart) and (max >= hstart)
                  then
                    begin
                      good := false ;
                      strt := hend + 1 ;
                      max := strt + size ;
                      if strt < hend
                        then
                          begin
                            writeln ('Allocation error') ;
                            exit (2)
                          end ;
                      exit
                    end
              end
        until good
      end ;
      
    begin
      highest := 0 ;
      second := 0 ;
      zero := true ;
      loc[relo] := strsect[relo] ;
      for i := 1 to curr_mod_num do
        if i in mod_loaded
          then
            with in_mod[i] do
              begin
                second := loc[relo] ;
                if mcur[relo]
                  then
                    if mplus[relo] = 0
                      then
                        loc[relo] := mmask[relo] + strsect[relo]
                      else
                        begin
                          xdiff := loc[relo] and mmask[relo] ;
                          if xdiff <> 0 
                            then
                              loc[relo] := loc[relo] + mplus[relo]
                                                     - xdiff
                        end ;
                getvalid(loc[relo], csize) ;
                coff := loc[relo] ;
                loc[relo] := loc[relo] + csize ;
                if csize <> 0
                  then
                    zero := false
              end ;
      if zero and (loc[relo] = strsect[relo])
        then
          loc[relo] := loc[relo] + 1 ;
      if not dsect_set
        then
          if vectop
            then
              strsect[dsect] := second
            else
              strsect[dsect] := loc[relo] ;
      loc[dsect] := strsect[dsect] ;
      for i := 1 to curr_mod_num do
        if i in mod_loaded
          then
            with in_mod[i] do
              begin
                if mcur[dsect]
                  then
                    if mplus[dsect] = 0
                      then
                        loc[dsect] := mmask[dsect] + strsect[dsect]
                      else
                        begin
                          xdiff := loc[dsect] and mmask[dsect] ;
                          if xdiff <> 0
                            then
                              loc[dsect] := loc[dsect] + mplus[dsect]
                                                     - xdiff
                        end ;
                getvalid(loc[dsect], dsize) ;
                doff := loc[dsect] ;
                loc[dsect] := loc[dsect] + dsize
              end ;
      loc[vsect] := strsect[vsect] ;
      for i := 1 to curr_mod_num do
        if i in mod_loaded
          then
            with in_mod[i] do
              begin
                if mcur[vsect]
                  then
                    if mplus[vsect] = 0
                      then
                        loc[vsect] := mmask[vsect] + strsect[vsect]
                      else
                        begin
                          xdiff := loc[vsect] and mmask[vsect] ;
                          if xdiff <> 0
                            then
                              loc[vsect] := loc[vsect] + mplus[vsect]
                                                       - xdiff
                        end ;
                voff := loc[vsect] ;
                loc[vsect] := loc[vsect] + vsize
              end ;
      if strsect[relo] < strsect[dsect]
        then
          lowest := strsect[relo]
        else
          lowest := strsect[dsect] ;
      for j := 1 to max_symbol do
        with symbol^[j] do
          with in_mod[modnum] do
            case status of
              relo : value := value + coff ;
              dsect : value := value + doff ;
              vsect : value := value + voff
            end ;
      if not endset[relo]
        then
          endsect[relo] := loc[relo] - 1 ;
      if not endset[dsect]
        then
          endsect[dsect] := loc[dsect] - 1 ;
      endsect[vsect] := loc[vsect] - 1 ;
      if endsect[relo] > highest
        then
          highest := endsect[relo] ;
      if endsect[dsect] > highest
        then
          highest := endsect[dsect]
    end ;

  procedure validate ;
    var
      parity : byte register ;
      err : hex ;
      modsize : longhex ;
      crc : longhex ;
      p1 : ^hex register ;
      p2 : ^byte register ;
      i : integer ;
    begin
      if endexc
        then
          return ;
      p1 := membase ;
      if p1^ <> $87cd
        then
          return ;
      crc := $FFFFFF ;
      p2 := p1 ;
      parity := 0 ;
      for i := 0 to 7 do
        begin
          parity := parity eor p2^ ;
          p2 := p2 + 1
        end ;
      p2^ := not parity ;
      p1 := membase + 2 ;
      modsize := longhex(p1^) ;
      err := f_crc (membase, crc, modsize - 3) ;
      p2 := membase + modsize - 3 ;
      p2^ := not byte(crc >> 16) ;
      p2 := p2 + 1 ;
      p2^ := not byte(crc >> 8) ;
      p2 := p2 + 1 ;
      p2^ := not byte(crc)
    end ;
    
  procedure open_output ;
    var
      pt : ^byte register ;
      fo : longinteger ;
      type_id : hex ;
      i, err : integer ;
      count : longhex ;
    begin
      if pass1
        then
          begin
            allocate ;
            curr_mod_num := 0 ;
            pass1 := false ;
            file_offset := highest - lowest ;
            oname := old_com ;
            overwrite := false ;
            err := i_open (oname, 3, opath) ;
            case err of
              0 : overwrite := true ;
              216 :
                begin
                  err := i_create(oname, file_offset, 3, $22, opath) ;
                  if err <> 0
                    then
                      halt (err) ;
                end
              else
                halt (err)
            end ;
            memsize := file_offset + 1 ;
            err := ss_size (memsize, opath) ;
            if err <> 0
              then
                begin
                  writeln ('Cannot create file') ;
                  halt (err)
                end ;
            writeln ('File size is ',longinteger(memsize):0, ' bytes') ;
            err := f_srqmem(membase, memsize) ;
            if err <> 0
              then
                begin
                  writeln ('Cannot make memory buffer') ;
                  halt (err)
                end ;
            if initon
              then
                begin
                  writeln ('Initializing output buffer') ;
                  pt := membase ;
                  fo := memsize ;
                  while fo > 0 do
                    begin
                      pt^ := initvalue ;
                      fo := fo - 1 ;
                      pt := pt + 1
                    end
                end ;
            curon[relo] := false ;
            curon[dsect] := false ;
            curon[vsect] := false ;
            comon := true ;
            comstore := combase
          end
        else 
          begin
            write_output ;
            sect := relo ;
            if endset[relo] and not endexc
              then
                fill (endsect[relo] - loc[relo] + 1) ;
            sect := dsect ;
            if endset[dsect]
              then
                fill (endsect[dsect] - loc[dsect] + 1) ;
            comon := false ;
            write_output ;
            if dos
              then
                validate ;
            err := i_seek (0, opath) ;
            count := memsize ;
            err := i_write (membase, count, opath) ;
            err := i_close (opath)
          end
    end ;

  procedure open_input ; entry ;
    begin
      parse (com_buf, ifname) ;
      ifname := sufadd(indir, ifname,'r') ;
      reset (ifile, ifname) ;
      iblkmax := iblkbuf ;
      iblkcur := iblkmax + 1
    end ;
    
  function readblk (var t : text ; b : ^blkbuffer ;
                    var p : ^byte) : boolean ;
    var
      count : longhex ;
    begin
      count := 4096 ;
      readblk := i_read (b, count, get_path(addr(t))) <> 0 ;
      p := b + count - 1
    end ;
    
  function get_rec : boolean ; entry ;
    type
      rectype = string[251] ;
    var
      ch : char register ;
      j, reclth : byte register ;
      spt : ^rectype ;
    begin
      j := 0 ;
      get_rec := false ;
      repeat
        while iblkcur > iblkmax do
          begin
            if readblk (ifile, iblkbuf, iblkmax)
              then
                begin
                  get_rec := true ;
                  exit (2)
                end ;
            iblkcur := iblkbuf
          end ;
        if j = 0
          then
            if iblkcur + longhex(iblkcur^) <= iblkmax
              then
                begin
                  spt := iblkcur ;
                  inrec := spt^ ;
                  iblkcur := iblkcur + longhex(inrec[0] + 1) ;
                  exit
                end
              else
                begin
                  inrec[0] := iblkcur^ ;
                  reclth := iblkcur^
                end
          else
            inrec[j] := iblkcur^ ;
        iblkcur := iblkcur + 1 ;
        j := j + 1
      until j > reclth
    end ;

  procedure open_map ; entry ;
    var
      x : integer ;
    begin
      devinit (mfile) ;
      case upshift(mname) of
        'T' : open (mfile, output)
        else
          begin
            if substr(mname, 1, 1) <> '/'
              then
                for x := length(mname) downto 0 do
                  if (mname[x] = '/') or (x = 0)
                    then
                      begin
                        if index(substr(mname, x + 1, 80), '.') = 0
                          then
                            append (mname, '.mp') ;
                        exit
                      end ;
            rewrite (mfile,mname)
          end
      end
    end ;
    
  procedure fetch_loop ;
    begin
      write ('?') ;
      if comon
        then
          begin
            com_buf := comstore^ ;
            comstore := comstore + longhex(com_buf[0] + 1)
          end
        else
          repeat
            if eof
              then
                begin
                  writeln ('Linker EXIT missing') ;
                  halt (18)
                end ;
            readln (com_buf) ;
            if upshift(substr(com_buf,1,4)) = '*LL:'
              then
                com_buf := substr(com_buf, 5, 80)
          until (com_buf[0] > 0) and (com_buf[1] <> '*') ;
      if comon or ((cfadr^ and $80) = 0)
        then
          writeln (com_buf) ;
      if pass1
        then
          begin
            comstore^ := com_buf ;
            comstore := comstore + longhex(com_buf[0] + 1) ;
            if comstore > (combase + comax)
              then
                begin
                  writeln ('Command buffer overflow') ;
                  halt (22)
                end
          end ;
      cbl := ord(com_buf[0]) ;
      parse (com_buf, comnd) ;
      old_com := com_buf ;
      com_buf := upshift (com_buf) ;
      comnd := upshift(comnd) ;
      sect := relo ;
      if cbl >= 2
        then
          begin
            if comnd[2] = '.'
              then
                begin
                  case comnd[1] of
                    'D' : sect := dsect ;
                    'V' : sect := vsect
                    else
                      sect := relo
                  end ;
                  comnd := substr(comnd,3,80)
                end ;
            case substr(comnd,1,2) of
              'ST' : set_start ;
              'EN' : set_end ;
              'AL' : set_offset ;
              'LO' : load_file (false);
              'LI' : load_file (true);
              'DE' : define_symbol ;
              'SA' : save_symbol ;
              'OB' : open_output ;
              'DO' : dos := true ;
              'MA' : 
                if pass1
                  then
                    writeln ('NOT VALID DURING PASS 1')
                  else
                    display_map ;
              'EX' : done := true ;
              'VE' : vectop := true ;
              'HO' : set_hole ;
              'IN' : set_init
              else writeln ('INVALID COMMAND')
            end
          end
        else writeln ('INVALID COMMAND')
    end ; { fetch_loop }
 
  procedure comopt ;
    begin
      writeln ('Command line error, format is :') ;
      writeln ('xll [-opt] [map]') ;
      writeln ('Valid options are :') ;
      writeln ('D"dir"  - default directory for relocatable object files') ;
      writeln ('F       - enable form feed option') ;
      Writeln ('Pnnn    - set page size') ;
      writeln ('Wnnn    - set map width') ;
      writeln ('Special file names are :') ;
      writeln ('t       - terminal') ;
      Halt (22)
    end ;

  procedure set_options ;
    var
      i, temp1, temp2 : byte register ;
      offset : byte register ;
      copt : string[120] ;
    begin
      repeat
        offset := 2 ;
        copt := cline(1) ;
        if copt[0] = 0
          then
            exit ;
        if copt[1] = '-'
          then
            begin
              i := 2 ;
              while i <= copt[0] do
                begin
                  case upshift(copt[i]) of
                    'P', 'W' : 
                      begin
                        temp1 := upshift(copt[i]) ;
                        repeat
                          temp2 := 0 ;
                          i := i + 1 ;
                          while i <= copt[0] do
                            if copt[i] in ['0' .. '9']
                              then
                                begin
                                  temp2 := temp2 * 10 +
                                           (copt[i] - '0') ;
                                  i := i + 1
                                end
                              else
                                exit
                        until true ;
                        i := i - 1 ;
                        case temp1 of
                          'P' : max_pline := ord(temp2) ;
                          'W' : mapwidth := ord(temp1) - 1
                        end
                      end ;
                    'F' : fopt := true ;
                    'D' :
                      begin
                        i := i + 2 ;
                        while i <= copt[0] do
                          if copt[i] = '"'
                            then
                              exit
                            else
                              begin
                                append (indir, copt[i]) ;
                                i := i + 1
                              end
                      end
                    else
                      comopt
                  end ;
                  i := i + 1
                end
            end
          else
            offset := 1
      until true ;
      if cline(offset) <> ''
        then
          mname := cline(offset) 
    end ;
    
  begin
    {$I+,C+}
    writeln ('OmegaSoft 6809 Cross Linker version 3.00');
    writeln ('Copyright 1987-1990 by Certified Software Corporation') ;
    initialization ;
    set_options ;
    while not (break or done) do
      fetch_loop ;
    writeln ('Heap left : ',string(longinteger(memavail) div 1024),'K') ;
    if memsize <> 0
      then
        halt(f_srtmem(membase, memsize)) ;
    if badlink
      then
        halt (22)
  end. { rload }
