Module xll0 {$v3,1 xll0} (input, output) ;
{
  6/6/89 : initial conversion to level 3
  10/25/90 : Define and save symbol commands added.
}
{$Ixllincl}
  var varib external 
    mfile, sfile : text ;
    ifile : text ;
  const
    top = external byte ;
    bot = external byte ;
    slet = local array [section] of char
            ('U','A','C','D','V') ;

  function find_sym (sym : string [8] ; tbase : ^sym_type ;
                     curr_sym : integer) : integer ; external ;
         { find_sym will attempt to locate 'sym' in table 'tbase'
           searching till entry 'curr_sym' in the table and will
           return the table index if found, or 0 if not found }
          
  function get_rec : boolean ; external ;
  procedure parse (var cml, token : string) ; external ;
  procedure write_output ; external ;
  procedure open_input ; external ;
  procedure open_map ; external ;
  function sufadd (dir, fname, suf : string) : string ; external ;
  
  procedure tof ;
    begin
      if (max_pline > 0) and (pline <> 0)
        then
          begin
            while pline < max_pline do
              if fopt
                then
                  begin
                    page (mfile) ;
                    exit
                  end
                else
                  begin
                    writeln (mfile) ;
                    pline := succ (pline)
                  end ;
            pline := 0 
          end
    end ;
 
  procedure skiptop ;
    var
      lcnt : integer {$ceq nine} register {$cend} ;
    begin
      if (max_pline <> 0)
        then
          begin
            tof ;
            pline := ord (top) ;
            for lcnt := 1 to pline do
              writeln (mfile)
          end
    end ;
    
  function strhex (var s : string ; b : byte) : hex ;
    var
      p : ^byte register ;
      trick : record
                case boolean of
                     false : (b1, b2 : byte) ;
                     true : (hx : hex)
                 end ;
    begin
      p := addr(s[b]) ;
      trick.b1 := p^ ;
      p := p + $1L ;
      trick.b2 := p^ ;
      strhex := trick.hx
    end ;
    
  procedure hexstr (var s : string ; b : byte ; h : hex) ; entry ;
    var
      p : ^byte register ;
      trick : record
                case boolean of
                  false : (b1, b2 : byte) ;
                  true : (hx : hex)
              end ;
    begin
      p := addr (s[b]) ;
      trick.hx := h ;
      p^ := trick.b1 ;
      p := p + $1L ;
      p^ := trick.b2
    end ;
    
  procedure display_map ; entry ;
    var
      opstr : string [20] ;
 
    procedure map_u ;
      var
        j, number_bad, count : integer register ;
      begin
        number_bad := 0 ; 
        count := 0 ;
        for j := 1 to max_symbol do
          with symbol^[j] do
            if status = undef
              then
                begin
                  number_bad := succ (number_bad) ;
                  write (mfile,name:-10) ;
                  count := succ (count) ;
                  if count > 6 
                    then
                      begin
                        count := 0 ;
                        writeln (mfile)
                      end
                end ;
        if count <> 0
          then
            writeln (mfile) ;
        if number_bad = 0 
          then
            writeln (mfile,'NO UNDEFINED SYMBOLS')
          else
            writeln (mfile,number_bad:0,' UNDEFINED SYMBOLS')  ;
        pline := pline + (number_bad + 5) div 6 + 1
      end ;
 
    procedure map_s ;
      var
        jj : integer register ;
        count, discard : integer register ;
      begin
        writeln (mfile,'CODE  SIZE=',endsect[relo]-strsect[relo]+1:4,
           '  START=', strsect[relo]:4,'  END=',endsect[relo]:4) ;
        writeln (mfile,'DATA  SIZE=',endsect[dsect]-strsect[dsect]+1:4,
           '  START=', strsect[dsect]:4,'  END=',endsect[dsect]:4);
        writeln (mfile,'VARIB SIZE=',endsect[vsect]-strsect[vsect]+1:4,
           '  START=', strsect[vsect]:4,'  END=',endsect[vsect]:4) ;
        count := 0 ;
        discard := 0 ;
        for jj := 1 to max_module do
          if jj in mod_loaded 
            then
              count := succ (count)
            else
              discard := succ(discard) ;
        writeln (mfile,'SYMBOL TABLE USAGE: USED=',max_symbol:0,
                        ' OF ', table_end:0) ;
        writeln (mfile,'MODULE TABLE USAGE: USED=',count:0,
                        ' OF ', max_module:0,', DISCARDED=',discard:0) ;
        pline := pline + 4 ;
      end ;

    procedure map_m ;
      var
        jj : integer register ;
        count : integer register ;
      begin
        writeln (mfile, 'NAME    CODE  DATA  VARIB  VER REV  DESCRIPTION') ;
        count := 0 ;
        for jj := 1 to max_module do
          begin
            if break
              then
                exit ;
            with in_mod[jj] do
              if jj in mod_loaded
                then
                  begin
                    count := succ (count) ;
                    write (mfile, name:-8, coff:-6, doff:-6, voff:-7,
                           ord(vers):3, ord(rev):4,'  ') ;
                    if mapwidth > 36
                      then
                        write (mfile, substr(desc, 1, mapwidth - 36)) ;
                    writeln (mfile)
                  end
          end ;
        pline := pline + count + 2
      end ;

    procedure map_d ;
      var
        jj : integer register ;
        count, k : integer register ;
      begin
        writeln (mfile,'DEFINED SYMBOLS') ;
        pline := succ (pline) ;
          for jj := 0 to max_module do
            begin
              if break
                then
                  exit ;
              if (jj = 0) or (jj in mod_loaded)
                then
                  begin
                    if (pline + 3 + ord (bot)) >= max_pline
                      then
                        skiptop ;
                    writeln (mfile);
                    writeln (mfile,'MODULE NAME: ',in_mod[jj].name) ;
                    pline := pline + 2 ;
                    count := 0 ;
                    for k := 1 to max_symbol do
                      with symbol^[k] do
                        if modnum = jj
                          then
                            begin
                              write (mfile,name:10,' ',slet[status],value:5) ;
                              count := succ (count) ;
                              if count > 3
                                then
                                  begin
                                    count := 0 ;
                                    writeln (mfile) ;
                                    pline := succ (pline) ;
                                    if (pline + ord(bot)) >= max_pline
                                      then
                                        skiptop
                                  end
                            end ;
                    if count <> 0
                      then
                        begin
                          writeln (mfile) ;
                          pline := succ (pline)
                        end
                  end
            end
      end ;

    begin { display_map }
      if upshift(comnd) = 'MAPOUT'
        then
          mname := old_com
        else
          begin
            open_map ;
            opstr := substr (comnd, 4 ,4) ;
            pline := 0 ;
            skiptop ;
            while length (opstr) <> 0 do
              begin
                case opstr [1] of
                  'S' : map_s ;
                  'D' : map_d ;
                  'U' : map_u ;
                  'M' : map_m ;
                  'F' :
                    begin
                      map_u ;
                      map_s ;
                      map_m ;
                      map_d
                    end
                end { case } ;
                opstr := substr (opstr,2,80)
              end ; { while }
            tof ;
            close (mfile)
          end
    end ;
    
  procedure set_start ; entry ;
    begin
      if not pass1
        then
          return ;
      strsect[sect] := hex(com_buf) ;
      if sect = dsect
        then
          dsect_set := true
    end ;

  procedure set_end ; entry ;
    begin
      if not pass1
        then
          return ;
      endset[sect] := true;
      endsect[sect] := hex(com_buf) 
    end ;
 
  procedure set_offset ; entry ;
    var
      value : hex register ;
    begin
      if com_buf[0] = 0
        then
          curon[sect] := false
        else
          case com_buf[1] of
            '/','\' :
              begin
                value := hex (substr (com_buf,2,20));
                curmask[sect] := 0 ; 
                curplus[sect] := 1 ;
                while not odd (value) do
                  begin
                    value := value >> 1 ;
                    curmask[sect] := curmask[sect] or curplus[sect] ;
                    curplus[sect] := curplus[sect] << 1
                  end;
                curon[sect] := true
              end
            else
              begin
                curon[sect] := true ;
                curmask[sect] := hex(com_buf) ;
                curplus[sect] := 0 { flag abs offset }
              end
          end
    end ;

  procedure insert (symname : string [8] ; modoff : hex ;
                    istat : section ) ;
    var
      jj : integer register ;
 
    procedure def_mess (deftype : string [9]) ;
      begin
        writeln (deftype,'DEFINED SYMBOL ',symname,' IN MODULE ',
                 in_mod[curr_mod_num].name) ;
        badlink := true
      end ;

    begin
      jj := find_sym (symname,symbol,max_symbol) ;
      if pass1
        then
          if jj = 0
            then
              if max_symbol >= table_end
                then
                  begin
                    writeln ('FATAL ERROR - SYMBOL TABLE OVERFLOW') ;
                    halt (22)
                  end
                else
                  begin
                    max_symbol := succ(max_symbol) ;
                    jj := max_symbol ;
                    with symbol^ [jj] do
                      begin
                        name := symname ;
                        status := istat ;
                        if istat <> undef
                          then
                            begin
                              modnum := curr_mod_num ;
                              value := modoff
                            end
                          else
                            modnum := 0
                      end
                  end
            else
              if (istat <> undef) and (symbol^[jj].status = undef)
                then
                  with symbol^[jj] do
                    begin
                      ref_satisfied := true ;
                      modnum := curr_mod_num ;
                      value := modoff ;
                      status := istat
                    end 
                else
        else
          if jj <> 0
            then
              if istat = undef
                then
                  if symbol^[jj].status <> undef
                    then
                      begin
                        rel_offset := symbol^[jj].value ;
                        rel_abs := symbol^[jj].status = abso
                      end
                    else
                      def_mess ('UN')
                else
                  if (curr_mod_num <> 0) and (symbol^[jj].modnum <> curr_mod_num)
                    then
                      def_mess ('MULTIPLY ')
                    else
            else
              def_mess ('UN')
    end ;

  procedure newmod (mname : string [8] ; mdesc : string [60] ;
                    mvers, mrev : byte) ;
    var
      desired_loc, xdiff : hex register ;
    begin
      old_max_sym := max_symbol ;
      ref_satisfied := false;
      curr_mod_num := succ (curr_mod_num) ;
      if curr_mod_num > mod_end
        then
          begin
            writeln ('FATAL ERROR - MODULE TABLE OVERFLOW') ;
            halt (22)
          end ;
      if pass1
        then
          begin
            max_module := succ (max_module) ;
            mod_loaded := mod_loaded + [curr_mod_num] ;
            with in_mod[curr_mod_num] do
              begin
                name := mname ;
                vers := mvers ;
                rev := mrev ;
                desc := mdesc ;
                for sect := relo to vsect do
                  begin
                    mcur[sect] := curon[sect] ;
                    mplus[sect] := curplus[sect] ;
                    mmask[sect] := curmask[sect]
                  end
              end
          end
    end ;
    
  procedure load_file (lib : boolean ) ; entry ;
    var
      tilt : boolean ;
      esd_max : integer ;
      name : string [8] ;
      
    procedure next_esd (esd_offset : hex ; esd_abso : boolean) ;
      begin
        if not pass1
          then
            begin
              esd_tab [esd_max] := esd_offset ;
              esd_abs [esd_max] := esd_abso ;
              esd_max := succ (esd_max)
            end
      end ;
      
    procedure size_record ;
      begin
        if pass1
          then
            begin
              in_mod[curr_mod_num].csize := strhex (inrec, 2) ;
              in_mod[curr_mod_num].dsize := strhex (inrec, 4) ;
              in_mod[curr_mod_num].vsize := strhex (inrec, 6)
            end
          else
            begin
              next_esd (in_mod[curr_mod_num].coff, false) ;
              next_esd (in_mod[curr_mod_num].doff, false) ;
              next_esd (in_mod[curr_mod_num].voff, false)
            end
      end ;
 
    procedure end_skip ;
      begin
        while inrec[1] <> 6 do
          if get_rec
            then
              exit
      end ;
 
    procedure xref_record ;
      var
        i : byte register ;
      begin
        i := 2 ;
        while i < inrec[0] do
          begin
            insert (substr(inrec,ord(i+1),ord(inrec[i])),0,undef) ;
            next_esd (rel_offset, rel_abs) ;
            i := i + inrec[i] + 1
          end
      end ;
      
    procedure xdef_record ;
      var
        i : byte register ;
      begin
        i := 2 ;
        while i < inrec[0] do
          begin
            insert(substr(inrec,ord(i+4),ord(inrec[i+3])),
                   strhex(inrec, i + 1),enum(inrec[i] + byte(abso)));
            i := i + inrec[i + 3] + 4
          end
      end ;
      
    procedure prog_text ;
      begin
        if pass1
          then
            if lib and not ref_satisfied
              then
                begin
                  max_symbol := old_max_sym ;
                  mod_loaded := mod_loaded - [curr_mod_num]  ;
                  end_skip
                end 
              else
                end_skip
          else { pass = 2 }
            begin
              write_output ;
              sect := enum(inrec[2] + byte(abso)) ;
              rec_offset := strhex(inrec, 3) ;
              if sect = relo
                then
                  loc[relo] := rec_offset +
                               in_mod[curr_mod_num].coff
                else
                  loc[dsect] := rec_offset +
                                in_mod[curr_mod_num].doff ;
              out_buf := substr(inrec,5,ord(inrec[0])-4)
            end
      end ; { prog_text }
 
    procedure reloc_rec ;
      var
        sec_char : char ;
        i : byte register ;
        flg, offset, esd : byte ;
        value, reladr : hex register ;
      begin
        case sect of
          relo : sec_char := 'C' ;
          dsect : sec_char := 'D' ;
          vsect : sec_char := 'V'
        end ;
        i := 2 ;
        while i < inrec[0] do
          begin
            reladr := strhex(inrec, i) ;
            offset := chr(hex(reladr - rec_offset)) + 1 ;
            value := strhex(out_buf, offset) ;
            i := i + 2 ;
            repeat
              flg := inrec[i] ;
              if (flg and 2) = 0
                then
                  value := value + esd_tab[ord(inrec[i + 1])]
                else
                  value := value - esd_tab[ord(inrec[i + 1])] ;
              i := i + 2
            until flg > $7F ;
            hexstr (out_buf, offset, value)
          end
      end ; { reloc_rec }

    begin
      repeat
        if break
          then
            halt (22) ;
        tilt := false ;
        open_input ;
        repeat
          if get_rec
            then
              exit ;
          if inrec[0] > 0
            then
              begin
                case inrec[1] of
                  5 : reloc_rec ;
                  4 : prog_text ;
                  3 : xdef_record ;
                  2 : xref_record ;
                  1 : size_record ;
                  0 :
                    begin
                      newmod (substr(inrec,5,ord(inrec[4])),
                              substr(inrec,ord(inrec[4] + 6),
                                     ord(inrec[inrec[4] + 5])),
                              inrec[2], inrec[3]) ;
                      esd_max := 1 ;
                      out_buf[0] := 0 ;
                      if not (curr_mod_num in mod_loaded)
                        then
                          end_skip 
                    end ;
                  6 :
                    begin
                      write_output ;
                      if not (pass1 or exec_set) and
                             (inrec[0] > 1)
                        then
                          begin
                            exec_set := true ;
                            start_exec.l := strhex(inrec, 2) +
                                            in_mod[curr_mod_num].coff
                          end
                    end
                  else 
                    tilt := true
                end
              end ;
        until false ;
        close (ifile) ;
        if tilt
          then
            begin
              writeln (ifname,' HAS INVALID FORMAT') ;
              badlink := true
            end
      until length (com_buf) = 0
    end ;

  procedure define_symbol ; entry ;
    var
      name, value : string[8] ;
      fname, s : string ;
      dfile : text ;
      cnt : integer ;
      sct : section ;
    begin
      if not pass1
        then
          return ;
      parse (com_buf, fname) ;
      {$I-}
      fname := sufadd ('', fname, 'sm') ;
      reset (dfile, fname) ;
      if deverr (dfile) <> 0
        then
          begin
            writeln (fname, ' Not found') ;
            return
          end ;
      {$i+}
      cnt := 0 ;
      while not eof(dfile) do
        begin
          cnt := cnt + 1 ;
          readln (dfile, s) ;
          parse (s, name) ;
          parse (s, value) ;
          case s[1] of
            'A' : sct := abso ;
            'C' : sct := relo ;
            'D' : sct := dsect ;
            'V' : 
              begin
                sct := vsect ;
                if name = 'VARIBEND'
                  then
                    begin
                      if hex(value) > strsect[vsect]
                        then
                          strsect[vsect] := hex(value) ;
                      name := ''
                    end
              end ;
            else  sct := undef
          end ;
          if name <> ''
            then
              insert (name, hex(value), sct)
        end ;
      close (dfile) ;
      writeln (cnt:0,' Symbols read')
    end ;

  procedure save_symbol ; entry ;
    var
      dfile : text ;
      cnt : integer ;
      fname : string ;
      j, k : integer ;
    begin
      if pass1
        then
          return ;
      parse (com_buf, fname) ;
      fname := sufadd ('', fname, 'sm') ;
      {$i-}
      rewrite (dfile, fname) ;
      if deverr(dfile) <> 0
        then
          begin
            writeln ('Could not create ',fname) ;
            return
          end ;
      cnt := 0 ;
      for j := 1 to max_module do
        if j in mod_loaded
          then
            for k := 1 to max_symbol do
              with symbol^[k] do
                if modnum = j
                  then
                    begin
                      writeln (dfile, name, ' ', string(value),' ',slet[status]) ;
                      cnt := cnt + 1
                    end ;
      close (dfile) ;
      writeln (cnt:0,' Symbols written')
    end ;

  procedure set_hole ; entry ;
    var
      h1, h2 : string[10] ;
    begin
      if pass1
        then
          begin
            parse (com_buf, h1) ;
            parse (com_buf, h2) ;
            if holecnt >= holemax
              then
                writeln ('Hole table full')
              else
                begin
                  holecnt := holecnt + 1 ;
                  with holetab[holecnt] do
                    begin
                      hstart := hex(h1) ;
                      hend := hex(h2)
                    end
                end
          end
    end ;
    
  procedure set_init ; entry ;
    begin
      initvalue := byte(hex(com_buf)) ;
      initon := true
    end ;
Modend.
