Program xra {$v3,0 xra} ({$b+}input{$b-},keyboard, output) ;
{$h32000}
{
  5/18/89 : initial conversion to level 5
  10/15/89 : allow specification on command line of edit data buffer.
}
{$l+}
{$Ixraincl}
{$l-}

  type
    blkbuffer = array [1..4096] of char ;
    e_line = string[120] ;
    e_lines = array[0 .. 8000] of ^e_line ;
    attype = record
              maxline : integer ;
              lineaddr : ^e_lines ;
              stopmode : integer ;
              stopcnt : integer ;
              stops : array [0 .. 20] of record
                                          stopline, stopcol : integer
                                         end ;
              curfile : string[120]
             end ;
  const
    { patchable stuff }
    top = entry byte 0 ;
    bot = entry byte 0 ;
    width = entry byte 80 ;
    depth = entry byte 0 ;
    xraversion = entry string[5] '3.00' ;
    
  var
    nfile, ifile, lfile : text varib entry ;
    ofile : device [2] of string[251] varib entry ;
    iblock : boolean ;
    iblkbuf : ^blkbuffer ;
    iblkmax, iblkcur : ^byte ;
    incblock : boolean ;
    incblkbuf : ^blkbuffer ;
    incblkmax, incblkcur : ^byte ;
    main : ^byte ;
    mainj : integer register ;
    mainch : char register ;
    at_opt : boolean varib ;
    atvar : ^attype varib ;
    atname : string[20] varib ;
    atmod : longhex varib ;
    atline, err : integer varib ;

{$I/dd/defs/os9traps}
{ assembly language routines }
function find_op (var operation : string[8]; var opcode : hex ;
                  var group : oper_group) : boolean ; external;
function find_sym (tabadr : ^sym_format; var sym : string[8];
                   curr_sym : integer) : integer ; external ;
function parse_line (var inl, lab, oprat, oprnd : string) : integer ; external ;
{ routines in other modules }

procedure tof ; external ;
procedure format_line ; external ;
procedure has_label ; external ;
procedure setup_output ; external ;
procedure flush_object ; external ;
procedure instructions ; external ;
procedure finish_output ; external ;
procedure writestr (str_to_prnt : string[160]) ; external ;
procedure get_line ; external ;
procedure store_macro ; external ;
procedure open_macro ; external ;
procedure psuedoops ; external ;

{
  this function will strip a string of it's suffix
}
  function sufstrip (fname : string[60]) : string[60] ;
    var
      x, y : integer ;
    begin
      for x := length(fname) downto 0 do
        if (fname[x] = '/') or (x= 0)
          then
            begin
              y := index(substr(fname,x+1,32),'.') ;
              if y <> 0
                then
                  sufstrip := substr(fname,1, x + y -1)
                else
                  sufstrip := fname ;
              exit
            end
    end ;
    
{  code called at start of pass one and pass two}
procedure pass_init ; entry ;
  begin
    sect := prg ;        loc[prg] := 0 ;      loc[dat] := 0 ;
    end_pass := false ;  loc[abs] := 0 ;      incl_line := 0 ;
    err_cnt := 0 ;       line_cnt := 0 ;      list := true ;
    warn_opt := true ;   include := false ;   enabled := true ;
    reloc_idx := 0 ;     loc[varb] := 0 ;
    gen_label := 0 ;     list_on := true ;
    line_num := true ;   if_depth := 0 ;
    list_cnt := 1
  end ;

{ code called at start of pass one only }
procedure init ; entry ;
  var
    temp : longinteger register ;
  begin
    pass_2 := false ;
    pass_init ;
    title := '' ;        out_buf := '' ;       moddesc := '' ;
    out_opt := false ;   list_opt := false ;   ex_offset := 0 ;
    ex_set := false ;    won := false ;        fopt := false ;      
    disaster := false ;  pline := 0 ;          at_opt := false ;
    ifname := 't' ;      blank := '                    ' ;
    version := 0 ;       revision := 0 ;       modname := '' ;
    curr_sym := 1 ;      page_cnt := 0 ;       max_pline := ord(depth) ;
    max_char := ord(width - 1) ;               hopt := false ;
    lfname := 't' ;      ofname := 't' ;
    topt := false ;      macro_def := false ;  if_stack[0] := true ;
    macro_expansion := false ;
    new (iblkbuf) ;
    atmod := nil ;
    new (incblkbuf) ;
    temp := longinteger((memavail - 1024) div align(sizeof(sym_describe))) ;
    if temp > max_sym
      then
        sym_end := max_sym
      else
        sym_end := integer(temp) ;
    new (sym_tab:longhex(sym_end + 1) * align(sizeof(sym_describe))) ;
    macro_end := addr (sym_tab^[sym_end + 1]) ;
    sym_tab^ [first_sym].sym_nam := '*'
  end ;

{ command line error - give options }
procedure comopt ; entry ;
  begin
    writeln ('Command line error, format is :') ;
    writeln ('xra [-opt] [input] [output] [listing]') ;
    writeln ('Valid options are :') ;
    Writeln ('O       - enable output option') ;
    Writeln ('L       - enable listing option') ;
    Writeln ('F       - enable form feed option') ;
    writeln ('H       - enable halt option') ;
    Writeln ('W       - enable warning option') ;
    writeln ('T       - enable time option') ;
    Writeln ('Pnnn    - set page size') ;
    Writeln ('Wnnn    - set page width') ;
    writeln ('Znnn    - set memory size') ;
    writeln ('Special file names are :') ;
    writeln ('t       - terminal') ;
    writeln ('.       - input file name with default suffix') ;
    halt (255)
  end ;

{ process command line }
procedure set_options ; entry ;
  var
    i : byte register ;
    temp1, offset : byte ;
    copt : string [120] ;
    vtemp : byte ;
    temp2 : longinteger ;
    err, attr, lang : integer ;
    
    procedure settime ;
      const
        daynames = local array [0 .. 6] of string[3] 
          ('sun','mon','tue','wed','thu','fri','sat') ;
      var
        stime, date, tickrate : longhex ;
        err, day : integer ;
        hour, minute, day_week, day_num, month, year : string[4] ;
      begin
        err := f_time(tickrate, day, date, stime, 0) ;
        hour := string(ord(byte(stime >> $10))) ;
        minute := string(ord(byte(stime >> 8))) ;
        if minute[0] = 1
          then
            minute := concat('0',minute) ;
        day_week := daynames[day] ;
        day_num := string(ord(byte(date))) ;
        case byte(date >> 8) of
          1 : month := 'jan' ;
          2 : month := 'feb' ;
          3 : month := 'mar' ;
          4 : month := 'apr' ;
          5 : month := 'may' ;
          6 : month := 'jun' ;
          7 : month := 'jul' ;
          8 : month := 'aug' ;
          9 : month := 'sep' ;
         10 : month := 'oct' ;
         11 : month := 'nov' ;
         12 : month := 'dec'
         else
           month := 'XXX'
        end ;
        year := string(integer(date >> $10)) ;
        time := concat(hour,':',minute,' ',day_week,' ',day_num,
                       ' ',month,' ',year)
      end ;
    
  begin {set options}
    repeat
      offset := 2 ;
      copt := cline(1) ;
      if copt[0] = 0
        then
          exit ;
      if copt[1] = '-'
        then
          begin
            i := 2 ;
            while i <= copt[0] do
              begin
                case upshift(copt[i]) of
                  'F' : fopt := true ;
                  'H' : hopt := true ;
                  'O' : out_opt := true ;
                  'L' : list_opt := true ;
                  'T' : topt := true ;
                  'Z', 'P', 'W', '@' :
                    begin
                      repeat
                        temp1 := upshift(copt[i]) ;
                        temp2 := 0 ;
                        i := i + 1 ;
                        while i <= copt[0] do
                          if copt[i] in ['0' .. '9']
                            then
                              begin
                                temp2 := temp2 * 10 +
                                         longinteger(copt[i] - '0') ;
                                i := i + 1
                              end
                            else
                              exit
                      until true ;
                      i := i - 1 ;
                      case temp1 of
                        'P' : max_pline := integer(temp2) ;
                        'W' : 
                          if temp2 = 0
                            then
                              won := true
                            else
                              max_char := integer(temp2) - 1 ;
                        '@' :
                          if temp2 = 0
                            then
                              begin
                                if (i + 3 <= copt[0]) and (copt[i + 1] = '"')
                                  then
                                    begin
                                      i := i + 2 ;
                                      atname := '' ;
                                      while i < copt[0] do
                                        if copt[i] = '"'
                                          then
                                            exit
                                          else
                                            begin
                                              append (atname, copt[i]) ;
                                              i := i + 1
                                            end ;
                                      lang := 0 ;
                                      halt(f_link(atname,atmod,atvar,attr,lang)) ;
                                      at_opt := true ;
                                      atline := 1 ;
                                      atvar^.stopmode := 1
                                    end
                                  else
                                    comopt
                              end
                            else
                              begin
                                at_opt := true ;
                                atvar := longhex(temp2) << 1 ;
                                atline := 1 ;
                                atvar^.stopmode := 1
                              end
                      end
                    end
                  else
                    comopt
                end ;
                i := i + 1
              end
          end
        else
          offset := 1
    until true ;
    if at_opt
      then
        begin
          offset := offset - 1;
          ifname := atvar^.curfile
        end
    else if cline(offset) <> ''
      then
        ifname := cline(offset) ;
    if out_opt
      then
        if cline(offset + 1) <> ''
          then
            ofname := cline(offset + 1)
          else
      else
        offset := offset - 1 ;
    if cline(offset + 2) <> ''
      then
        lfname := cline(offset + 2) ;
{
  open input and listing file
}
    iblock := false ;
    if not at_opt
      then
        begin
          if ifname = '.'
            then
              ifname := 't' ;
          if upshift(ifname) = 'T'
            then
              open (ifile, input)
            else
              begin
                {$i-}
                reset (ifile, ifname) ;
                if deverr (ifile) <> 0
                  then
                    begin
                      writeln ('Error ',ord(deverr(ifile)):0,' opening ',ifname) ;
                      halt (22)
                    end ;
                {$I+}
                main := addr(ifile) ;
                iblock := (main^ and $80 = 0) ;
                iblkmax := iblkbuf ;
                iblkcur := iblkmax + 1
              end 
        end ;
    if lfname = '.'
      then
        lfname := concat(sufstrip(ifname),'.al') ;
    case upshift(lfname) of
      'T' : open (lfile, output)
      else
        begin
          if lfname = ifname
            then
              begin
                writeln ('FILE NAME CONFLICT') ;
                halt (22)
              end ;
          rewrite (lfile, lfname)
        end
    end ;
{
  if have an output file, open it
}
    if out_opt
      then
        begin
          if ofname = '.'
            then
              ofname := concat(sufstrip(ifname),'.r') ;
          if upshift(ofname) = 'T'
            then
              begin
                writeln ('CANNOT WRITE OUTPUT TO TERMINAL') ;
                halt (22)
              end ;
          if ofname = ifname
            then
              begin
                writeln ('FILE NAME CONFLICT') ;
                halt (22)
              end ;
          rewrite (ofile, ofname)
        end ;
{
  handle time
}
    time := '' ;
    if topt
      then
        settime
  end ;
  
  procedure error (err : integer) ; entry ;
    const
      errstart = external hex ;
    type
      message = string[40] ;
    var
      i : integer register ;
      pb : ^byte ;
      ps : ^message register ;
      ch : char ;
    begin
      if pass_2 and not line_err
        then
          begin
            line_err := true ;
            pb := addr(errstart) ;
            for i := 2 to err do
              pb := pb + hex(pb^) + 1 ;
            ps := pb ;
            writestr (concat('*** error ',string(err),' *** ',ps^)) ;
            err_cnt := succ (err_cnt) ;
            if at_opt
              then
                begin
                  format_line ;
                  with atvar^ do
                    if stopcnt < 20
                      then
                        begin
                          atvar^.stopmode := 0 ;
                          stopcnt := stopcnt + 1 ;
                          with stops[stopcnt] do
                            begin
                              if include
                                then
                                  stopline := incl_line
                                else
                                  stopline := line_cnt ;
                              stopcol := 0
                            end ;
                        end ;
                  read (keyboard, ch) ;
                  if upshift(ch) = 'Q'
                    then
                      halt (255)
                end
          end ;
    end;
  
  procedure halt_wait ; entry ;
    var
      ch : char ;
    begin
      if hopt
        then
          begin
            read (keyboard, ch) ;
            if upshift(ch) = 'Q'
              then
                disaster := true
          end
    end ;
  
  function readblk (var t : text ; b : ^blkbuffer ;
                    var p : ^byte) : boolean ;
    var
      count : longhex ;
    begin
      count := 4096 ;
      readblk := i_read (b, count, get_path(addr(t))) <> 0 ;
      p := b + count - 1
    end ;
    
{ bring in code from file }
procedure incl_psuedo ; entry ;
  var
    x : integer register ;
  begin
    if include
      then
        error (34)
      else
        begin
          include := true ;
          incl_line := 0 ;
          nfname := operand ;
          {$i-}
          for x := length(nfname) downto 0 do
            if (nfname[x] = '/') or (x = 0)
              then
                begin
                  if index(substr(nfname, x + 1, 32), '.') = 0
                    then
                      append (nfname, '.i') ;
                  exit
                end ;
          reset (nfile, nfname) ;
          if deverr (nfile) <> 0
            then
              begin
                writeln ('Error ',ord(deverr(nfile)):0,' opening ',nfname) ;
                halt (22)
              end ;
          {$i+}
          if at_opt
            then
              atvar^.curfile := nfname ;
          main := addr(nfile) ;
          incblock := (main^ and $80 = 0) ;
          incblkmax := incblkbuf ;
          incblkcur := incblkmax + 1
        end
  end ;
  
begin { main }
  {$i+,c+}
  init ;
  set_options ;
  writeln ('OmegaSoft 6809 Cross Assembler version ',xraversion) ;
  writeln ('Copyright 1987-1989 by Certified Software Corporation') ;
  repeat { assemble one line of code }
    disaster := break ;
    if macro_expansion
      then
        get_line
      else
        begin
          if include
            then
              begin
                incl_line := succ(incl_line) ;
                if incblock
                  then
                    begin
                      mainj := 1 ;
                      repeat
                        while incblkcur > incblkmax do
                          begin
                            if readblk (nfile, incblkbuf, incblkmax)
                              then
                                begin
                                  close (nfile) ;
                                  include := false ;
                                  exit (2)
                                end ;
                            incblkcur := incblkbuf
                          end ;
                        mainch := incblkcur^ ;
                        if mainch = 9
                          then
                            mainch := ' ' ;
                        in_line[mainj] := mainch ;
                        incblkcur := incblkcur + 1 ;
                        mainj := mainj + 1
                      until mainch = $d ;
                      in_line[0] := byte(mainj - 2)
                    end
                  else
                    if eof (nfile)
                      then
                        begin
                          close (nfile) ;
                          include := false ;
                          incl_line := 0
                        end
                      else
                        readln (nfile,in_line)
              end ;
          if not include
            then
              begin
                line_cnt := succ (line_cnt);
                if at_opt
                  then
                    begin
                      if atline > atvar^.maxline
                        then
                          begin
                            error (19) ;
                            in_line := ' END' ;
                            atvar^.stopmode := 2
                          end ;
                      in_line := atvar^.lineaddr^[atline]^ ;
                      atline := atline + 1
                    end
                else if iblock
                  then
                    begin
                      mainj := 1 ;
                      repeat
                        while iblkcur > iblkmax do
                          begin
                            if readblk (ifile, iblkbuf, iblkmax)
                              then
                                begin
                                  error (19) ;
                                  in_line := ' END' ;
                                  mainj := 6 ;
                                  exit (2)
                                end ;
                            iblkcur := iblkbuf
                          end ;
                        mainch := iblkcur^ ;
                        if mainch = 9
                          then
                            mainch := ' ' ;
                        in_line[mainj] := mainch ;
                        iblkcur := iblkcur + 1 ;
                        mainj := mainj + 1
                      until mainch = $d ;
                      in_line[0] := byte(mainj - 2)
                    end
                  else
                    if eof (ifile)
                      then
                        begin
                          error (19) ;
                          in_line := ' END'
                        end
                      else
                        readln (ifile, in_line)
              end
        end ;
    line_err := false ;
    sym_tab^ [first_sym].sym_addr := loc[sect] ;
    case sect of
      abs : 
        sym_tab^ [first_sym].sym_type := [encountered,absolute] ;
      prg :
        sym_tab^ [first_sym].sym_type := [encountered,relative] ;
      varb :
        sym_tab^ [first_sym].sym_type := [encountered,vsect]
      else
        sym_tab^ [first_sym].sym_type := [encountered,dsect]
    end ;
    cl_i := 0 ;
    oldloc := loc[sect] ;
    oldsec := sect ;
    if macro_def
      then
        store_macro
      else
        begin
          comment := (in_line[0] > 0) and (in_line[1] = '*') ;
          if not comment
            then
              begin
{ parse line into four fields, plus whatever is left }
                left_start := parse_line (in_line, alabel,  operation,
                                          operand) ;
                leftover := substr (in_line, left_start, 120) ;
                listopnd := operand ;
{ look for size specifier on operation }
                oplook := upshift(operation) ;
                if (length (alabel) > 0) and enabled
                  then
                    has_label ;
                if length (oplook) > 0
                  then
                    if find_op (oplook, opcode_out, addr_mode)
                      then
                        if enabled
                          then
                            instructions
                          else
                            if addr_mode = psuedo
                              then
                                case opcode_out of
                                  1,$d..$14,$24,$25 : psuedoops
                                  else
                                    list_on := not macro_expansion
                                end
                              else
                                list_on := not macro_expansion
                      else
                        if enabled
                          then
                            begin
                              tab_sym := find_sym(sym_tab, oplook, curr_sym);
                              if tab_sym <> 0
                                then
                                  if macro in sym_tab^[tab_sym].sym_type
                                    then
                                      open_macro
                                    else
                                      error (11)
                                else
                                  error (11)
                            end
                          else
                            list_on := not macro_expansion
              end ; { of not comment line }
          if (out_buf[0] > 220) or (reloc_idx >= max_ref - 10)
            then
              flush_object ;
          if pass_2 and ((list and list_opt) or line_err)
            then
              format_line ;
          line_num := true ;
          if macro_done
            then
              begin
                macro_done := false ;
                macro_expansion := false
              end ;
          if end_pass and not pass_2
            then
              begin
                if out_opt
                  then
                    setup_output ;
                pass_2 := true ;
                pass_init ;
                if upshift(ifname) <> 'T'
                  then
                    if at_opt
                      then
                        begin
                          atline := 1 ;
                          atvar^.stopmode := 1
                        end
                      else
                        begin
                          reset (ifile, ifname) ;
                          main := addr(ifile) ;
                          iblock := (main^ and $80 = 0) ;
                          iblkmax := iblkbuf ;
                          iblkcur := iblkmax + 1
                        end ;
                close (nfile)
              end
        end
  until end_pass and pass_2 or disaster ;
  if out_opt
    then
      finish_output ;
  line_err := true;
  writestr (concat ('Errors : ', string(ord(err_cnt)), 
                    '   Code : ', string(loc[prg]),  
                    '   Data : ', string(loc[dat]),
                    '   Varib : ', string(loc[varb]),
                    '   Table : ', string(curr_sym - 1),   
                    ' of ', string(sym_end))) ;
  tof ;
  close (lfile);
  close (ifile) ;
  if atmod <> nil
    then
      err := f_unlink(atmod) ;
  if (err_cnt <> 0) and not at_opt
   then
     halt (22)
end.
