Module xra0 {$v3,0 xra0} ;
{$l-}
{
  5/18/89 : initial conversion to level 3
}
{$Ixraincl}

  var
    ofile : device of string[251] varib external ;
    lfile : text varib external ;
  const
    reg_value = local array [registers] of hex 
                (0,0,1,2,3,4,5,8,9,$a,$b) ;
    push_pull = local array [registers] of hex 
                (0,6,$10,$20,$40,$40,$80,2,4,1,8) ;

{ routines in other modules }
function parse_line (var ln, lab, oprat, oprnd : string)
                                           : integer ; external ;
function comma (var in_str : string[120]) : string ; external ;
procedure error (err : integer) ; external ;
procedure warning (err : integer) ; external ;
procedure format_line ; external ;
procedure set_sym (set_dp : boolean) ; external ;
procedure incl_psuedo ; external ;
procedure ttl_psuedo ; external ;
procedure page_psuedo ; external ;
procedure code_psuedo ; external ;
procedure data_psuedo ; external ;
procedure abs_psuedo ; external ;
procedure varb_psuedo ; external ;
procedure ifxx_psuedo ; external ;
procedure idnt_psuedo ; external ;
procedure xdef_psuedo ; external ;
procedure xref_psuedo ; external ;
function hexstr (h : hex) : string[2] ; external ;
procedure emit_word (value : hex) ; external ;
procedure emit_byte (value : hex ; ok_eject : boolean) ; external ;
procedure express (expr : string[120] ; var rex_type : s_type ;
                   mark_x, mark_r : boolean) ; external ;
procedure comp_rel (var cr_str : string ; long : boolean) ; external ;
procedure mark_ref (index : integer ; plus : boolean) ; external ;
procedure mark_rel (plus : byte) ; external ;
function find_reg (var sym : string) : registers ; external ;
function get_rr (var ops : string) : hex ; external ;
procedure flush_object ; external ;
procedure fcb_psuedo ; external ;
procedure fcc_psuedo ; external ;
procedure fdb_psuedo ; external ;
procedure end_psuedo ; external ;
procedure rmb_psuedo ; external ;
procedure bsz_psuedo ; external ;
procedure fail_psuedo ; external ;
procedure else_psuedo ; external ;
procedure endc_psuedo ; external ;
procedure spc_psuedo ; external ;
{$l+}
procedure set_sym_end;
  begin
    sym_end := integer ((current_macro - addr(sym_tab^[first_sym])) div
                 align(sizeof(sym_describe)))
  end ;

procedure macro_psuedo ; entry ;
  begin
    if macro_def
      then
        error (27)
      else
        begin
          macro_def := true ;
          if length (alabel) = 0
            then
              error (21)
            else
              with sym_tab^[tab_sym] do
                if multdef in sym_type
                  then
                    error (30)
                  else
                    if not pass_2
{ in pass 1 store macro definition on taop of symbol tab }
                      then
                        begin
                          sym_type := sym_type - [relative] + [macro] ;
                          sym_addr := 0 ;
                          esd_num := 0 ;
                          macro_line := addr (sym_tab^[curr_sym + 1]) ;
                          macro_size := 0
                        end
        end
  end ;

procedure endm_psuedo ; entry ;
  var
    i : byte ;
    temp : ^string80 ;
    line_size : hex ;
  begin
    if not macro_def
      then
        error (28)
      else
        begin
          macro_def := false ;
          if not pass_2
            then
              if addr(sym_tab^[curr_sym + 1])+ macro_size > macro_end
                then
                  begin
                    disaster := true ;
                    writeln (lfile, 'FATAL ERROR - Macro table full')
                  end
                else
                  begin
                    macro_end := macro_end - macro_size ;
                    macro_line := addr (sym_tab^[curr_sym + 1]) ;
                    sym_tab^[tab_sym].sym_addr := macro_end ;
                    temp := macro_end ;
                    for i := #1 to sym_tab^[tab_sym].esd_num do
                      begin
                        line_size := hex (macro_line^[0]) + $1 ;
                        temp^ := macro_line^ ;
                        macro_line := macro_line + line_size ;
                        temp := temp + line_size
                      end ;
                    current_macro :=  macro_end and $FFFFFFFE ;
                    set_sym_end
                  end
        end
  end ;

procedure mexit_psuedo ; entry ;
  begin
    if not macro_expansion
      then
        error (28)
      else
        begin
          current_macro := current_macro + align(sizeof(macro_stack)) ;
          set_sym_end ;
          macro_done := true
        end
  end ;

procedure store_macro ; entry ;
  var
    line_size : hex ;
  begin
{ parse line into four fields, plus whatever is left }
    left_start := parse_line (in_line, alabel, operation, operand) ;
    leftover := substr (in_line, left_start, 120) ;
    listopnd := operand ;
    case upshift (operation) of
      'END'  :
        begin
          writeln (lfile, 'FATAL ERROR - END directive inside macro') ;
          disaster := true
        end ;
      'ENDM' : endm_psuedo
    end ;
    if not pass_2
      then
        if macro_def
          then
            if macro_line + hex (in_line[0]) + $1 <= macro_end
              then
                with sym_tab^[tab_sym] do
{ esd_num holds the total number of lines per macro definition }
                  if esd_num < #255
                    then
                      begin
                        line_size := hex (in_line[0]) + $1 ;
                        macro_size := macro_size + line_size ;
                        esd_num := esd_num + #1 ;
                        macro_line^ := in_line ;
                        macro_line := macro_line + line_size
                      end
                    else
              else
                begin
                  disaster := true ;
                  writeln (lfile, 'FATAL ERROR - macro definition table full')
                end
          else
      else
        begin
          list_on := list and list_opt ;
          format_line
        end
  end ;

procedure get_line ; entry ;
  var
    para_num : byte ;
    para_idx : integer ;
    temp, leftstr, rightstr : string[120] ;

  function get_para (var s : string[120] ; field : byte) : string[120];
    var
      m1, m2, m3, i : integer ;

    begin
      m2 := 0 ;
      repeat
        m1 := m2 + 1 ;
{ eat leading blanks }
        while (s[m1] = ' ') and (m1 <= ord(s[0])) do
          m1 := m1 + 1 ;
{ skip to next delimitor }
        m2 := m1 ;
        m3 := m1 ;
        if s[m1] <> '<'
          then
            begin
              while (s[m3] <> ',') and (m3 <= ord (s[0])) do
                m3 := m3 + 1 ;
              m2 := m3
            end
          else
            begin
              m1 := m1 + 1 ;
              m3 := m1 ;
              while not ((s[m3] = '>') and (s[m3 + 1] = ',')) and
              (m3 < ord (s[0])) do
                m3 := m3 + 1 ;
              m2 := m3 ;
              while (s[m2] <> ',') and (m2 <= ord(s[0])) do
                m2 := m2 + 1
            end ;
        field := field - #1
      until field = #0 ;
      get_para := substr (s, m1, m3 - m1)
    end ;

  begin
    in_line := '' ;
    with current_macro^ do
      begin
        in_line := current_line^ ;
        para_idx := index (in_line, '\') ;
        while (para_idx <> 0) do
          begin
            leftstr := substr (in_line, 1, para_idx - 1) ;
            rightstr := substr (in_line, para_idx + 2, 120) ;
            para_num := upshift (in_line[para_idx + 1]) ;
            if para_num = '@'
              then
                in_line := concat (leftstr, '.',
                       substr(string(gen_label + 1000), 2, 3), rightstr)
              else
                begin
                  case para_num of
                    '1' .. '9' : para_num := para_num - '0' ;
                    'A' .. 'Z' : para_num := para_num - '0' - #7
                  end ;
                  if (para_num >= #1) and (para_num <= #36)
                    then
                      begin
                        temp := get_para (macro_parameters, para_num) ;
                        in_line := concat (leftstr, temp, rightstr) ;
                      end
                    else
                      error (29)
                end ;
            para_idx := index (in_line, '\')
          end ;
        current_line := current_line + longhex(current_line^[0])+ $1 ;
        lines_left := lines_left - #1 ;
        if lines_left = #0
          then
            begin
              current_macro := current_macro + align(sizeof(macro_stack)) ;
              macro_done := true
            end
      end ;
    if pass_2
      then
        line_num := false ;
  end ;

procedure open_macro ; entry ;
  begin
    if addr(sym_tab^[curr_sym + 1]) >
       current_macro - align(sizeof(macro_stack))
      then
        begin
          disaster := true ;
          writeln (lfile, 'FATAL ERROR - macro expansion table overflow')
        end
      else
        begin
          gen_label := gen_label + 1 ;
          macro_expansion := true ;
          macro_done := false ;
          current_macro := current_macro - align(sizeof(macro_stack)) ;
          set_sym_end ;
          with sym_tab^[tab_sym] do
            with current_macro^ do
              begin
                current_line := sym_addr ;
                if esd_num > #0
                  then
                    lines_left := esd_num
                  else
                    begin
                      current_macro :=
                      current_macro - align(sizeof(macro_stack)) ;
                      macro_done := true
                    end
              end
        end ;
    if macro_expansion and not macro_done
      then
        macro_parameters := operand
  end ;
{l-}
procedure addr_set ; entry ;
  begin
    if (operand[0] = 0) and (addr_mode <> inherent)
      then
        begin
          error (9);{ operand not specified }
          addr_mode := err_oper
        end;
    stemp := operand [1] ;
    if addr_mode = ext_imm_ind
      then
        if stemp = '#'
          then
            addr_mode := immediate
          else
            addr_mode := ext_ind ;
    if addr_mode = ext_ind
      then
        if (index (operand, ',') <> 0) or (stemp = '[')
          then
            addr_mode := indexed 
          else
            addr_mode := extended ;
    case addr_mode of
      indexed :
        opcode_out := opcode_out or $20 ;
      extended :
        if stemp = '<'
          then
            begin
              addr_mode := direct ;
              operand := substr (operand,2,80) ;
              if opcode_out and $80 = $0
                then
                  opcode_out := opcode_out and $ffbf
                else
                  opcode_out := opcode_out or $10
            end
          else
            opcode_out := opcode_out or $30
    end ; {case}
    if opcode_out > $ff
      then
        emit_word (opcode_out)
      else
        emit_byte (opcode_out,true)
  end ;
 
procedure direct_addr ; entry ;
  begin
    express (operand, ret_type, false, false);
    if (ret_type <> absolute) or (hex_value > $ff)
      then
        error (14) ;
    emit_byte (hex_value, true)
  end;

procedure extended_addr ; entry ;
  begin
    warning (2) ;
    express (operand, ret_type, true,true);
    if ret_type = sym_err
      then
        error (8) ;
    emit_word (hex_value)
  end;
 
procedure indexed_addr ; entry ;
  var
    btemp : boolean ;
    indirect, post_byte, rr : hex ;
    strlen : byte ;
    reg : registers ;
    stemp : string[6] ;
 
  procedure accum_offset ;
    begin { accumulator offset from r }
      case reg of
        a : post_byte := $86 ;
        b : post_byte := $85 ;
        d : post_byte := $8b
        else
          error (5)
      end ; { case }
      rr := get_rr (operand) ;
      if rr = $ffff
        then
          error (2)
    end ;
 
  procedure constant_index ;
    begin { n,r }
      if not (ret_type in [absolute, xref, dsect, vsect])
        then
          error (13) ;
      if ret_type <> absolute
        then
          known := false ;
      if ((hex_value < $10) or (hex_value >= $fff0))
             and (indirect = $0) and known
        then
          post_byte := hex_value and $1f
        else
          if ((hex_value < $80) or (hex_value >= $ff80)) and known
            then
              begin
                post_byte := $88 ;
                after_post := off_8
              end
            else
              begin
                post_byte := $89 ;
                after_post := off_16
              end ;
          rr := get_rr (operand) ;
          if rr = $ffff
            then
              error (5)
    end ;

  procedure auto_index ;
    begin
      if index (operand, '+') > 1
        then
          begin
            stemp := operand[1];
            rr := get_rr (stemp);
            operand := substr (operand, 2, 80);
            case operand of
              '+' :
                if indirect = $00
                  then
                    post_byte := $80
                  else
                    error (1) ;
              '++' :
                post_byte := $81
              else
                error (1)
            end { of case }
          end
        else
          if substr (operand, 1, 1) <> '-'
            then
              error (1)
            else
              begin
                if substr (operand,1, 2) = '--'
                  then
                    begin
                      post_byte := $83 ;
                      operand := substr (operand,3,80)
                    end
                  else
                    if indirect <> $0
                      then
                        error (1)
                      else
                        begin
                          post_byte := $82 ;
                          operand := substr (operand, 2, 80)
                        end ;
                rr := get_rr (operand) ;
                if rr = $ffff
                  then
                    error (5)
              end
    end ; { auto_indexed }

  begin { addr_indexed }
    btemp := substr (operand, 1, 1) <> '<';
    if not btemp
      then
        operand := substr (operand,2,80) ;
    if operand[#0] = #0
      then
        operand := ' ' ;
    strlen := operand[#0] ;
    if (operand[1] = '[') and (operand[strlen] = ']')
      then
        begin
          indirect := $10;
          operand := substr (operand, 2, ord(strlen) - 2);
          strlen := operand[#0]
        end
      else
        indirect := $0 ;
     if index (operand, ',') = 0
       then
         if indirect <> $0
           then
             begin { mode = [n] }
               warning (7) ;
               emit_byte ($9f, true) ;
               express (operand, ret_type, true, true) ;
               if ret_type = sym_err
                 then
                   error (8) ;
               emit_word (hex_value)
             end
           else
             error (13)
       else
         begin { ',' in operand }
           field := comma (operand) ;
           if upshift(operand) = 'PCR'
             then
               begin
                 emit_byte ($8c or hex(btemp) or indirect,true);
                 comp_rel (field,btemp)
               end
             else
               begin
                 after_post := no_off;
                 express (field, ret_type, false, false);
                 if (hex_value <> $0) or (ret_type <> absolute) { or not known ????? }
                   then
                     begin
                       reg := find_reg (field) ;
                       if reg <> no_reg
                         then
                           accum_offset
                         else
                           constant_index
                     end
                   else 
                     begin { field = '' }
                       rr := get_rr (operand) ;
                       if rr <> $ffff
                         then
                           post_byte := $84 {?????}
                         else
                           auto_index
                     end ;
                 post_byte := post_byte or indirect or rr;
                 emit_byte (post_byte, true);
                 if ret_type = xref
                   then
                     begin
                       if symidx <> 0
                         then
                           mark_ref (symidx, true) ;
                       if altidx <> 0
                         then
                           mark_ref (altidx, false)
                     end ;
                 case ret_type of
                   dsect : mark_rel (2) ;
                   vsect : mark_rel (3)
                 end ;
                 case after_post of
                   off_8 : emit_byte (hex_value, true);
                   off_16 : emit_word (hex_value)
                 end { of case }
               end { of operand <> 'pcr' }
         end { ',' in operand }
  end ; { addr_indexed }
 
procedure immediate_addr ; entry ;
  begin
    if operand[#0] < #2
      then
        error (9)
      else
        if operand [1] <> '#'
          then
            error (13)
          else
            begin
              operand := substr (operand,2,80) ;
              express (operand, ret_type,true,true) ;
              if ret_type = sym_err
                then
                  error (8) ;
              if ret_type <> absolute
                then
                  warning (3) ;
              case upshift(operation[length(operation)]) of
                'D','S','U','X','Y' :
                  emit_word (hex_value)
                else
                  begin
                    if (hex_value > $ff) and (hex_value < $ff80)
                      then
                        error (14) ;
                    if ret_type = xref
                      then
                        error (23) ;
                    emit_byte (hex_value, true)
                  end
              end { case }
            end
  end ; { addr_immediate }

procedure rel_addr ; entry ;
  begin
    comp_rel (operand, upshift(operation[1]) = 'L')
  end ;
 
procedure reg_2_addr ; entry ;
  var
    r1, r2 : registers ;
    post_byte : hex ;
  begin
    field := comma(operand);
    r1 := find_reg (field);
    r2 := find_reg (operand);
    if ((r1 in [d..pc]) and (r2 in [d..pc]))
    or ((r1 in [a..dpr]) and (r2 in [a..dpr]))
      then
        post_byte := reg_value [r1] * $10 + reg_value [r2]
      else
        error (6) ;
    emit_byte (post_byte, true)
  end;
 
procedure reg_list_addr ; entry ;
  var
    reg : registers ;
    post_byte : hex ;
  begin
    post_byte := $00;
    while operand[#0] <> #0 do
      begin
        field := comma (operand);
        reg := find_reg (field);
        if field = operation [4]
          then
            error (4) ;
        if reg = no_reg
          then
            error (3)
          else
            post_byte := post_byte or push_pull [reg]
      end;
    emit_byte (post_byte, true)
  end ;
  
procedure finish_output ; entry ;
  begin
    flush_object ;
    if ex_set
      then
        write (ofile, concat(#6,hexstr(ex_offset)))
      else
        write (ofile, concat(#6)) ;
    close (ofile)
  end;

procedure psuedoops ; entry ;
  begin
   {$q+}
    case opcode_out of
      $0 : rmb_psuedo ;
      $1 : end_psuedo ;
      $2 : set_sym (false) ; {equ}
      $3 : fcb_psuedo ;
      $4 : fcc_psuedo ;
      $5 : fdb_psuedo ;
      $6 : idnt_psuedo ;
      $7 : 
        begin
          list_cnt := list_cnt + 1 ;
          list := list_cnt > 0
        end ;
      $8 : incl_psuedo ;
      $9 : ttl_psuedo ;
      $a : xdef_psuedo ;
      $b : xref_psuedo ;
      $c : page_psuedo ;
      $d..$14 : ifxx_psuedo ;
      $15 : 
        begin
          list_cnt := list_cnt - 1 ;
          list :=list_cnt > 0
        end ;
      $16 : spc_psuedo ;
      $17 : abs_psuedo ;
      $18 : code_psuedo ;
      $19 : data_psuedo ;
      $20 : varb_psuedo ;
      $21 : macro_psuedo ;
      $22 : mexit_psuedo ;
      $23 : endm_psuedo ;
      $24 : else_psuedo ;
      $25 : endc_psuedo ;
      $26 : bsz_psuedo ;
      $27 : set_sym (true) {set}
    end  { case }
{$q-}
  end ;

procedure instructions ; entry ;
  begin
    if addr_mode = psuedo
      then
        psuedoops
    else if sect <> prg
      then
        error (25)
      else
        begin
          addr_set ;
          case addr_mode of
            indexed : indexed_addr ;
            reg_list : reg_list_addr ;
            immediate : immediate_addr ;
            relad : rel_addr ;
            inherent :
              begin
                leftover := concat(' ',operand,leftover) ;
                listopnd := ''
              end ;
            direct : direct_addr ;
            extended : extended_addr ;
            reg_2 : reg_2_addr
          end
        end
  end ;
  
Modend.
