Module ra1 {$v3,1 ra1} ;
{
  5/19/89 : initial conversion to level 3
}
{$Ixraincl}
  var
    lfile : text varib external ;
  const
    top = external byte ;
    bot = external byte ;
    xraversion = external string[5] ;

{routines in other modules}
function comma (var in_str : string[120]) : string ; external ;
function valid_symbol (var sym : string) : boolean ; external ;
function get_sign (var in_str : string) : integer ; external ;
function find_sym (tabadr : ^sym_format ; var sym : string ;
                    curr_sym : integer) : integer ; external ;
procedure flush_object ; external ;
function hexstr (l : hex) : string[2] ; external ;
procedure halt_wait ; external ;
procedure error (err : integer) ; external ;
procedure mark_rel (plus : integer) ; external ;
procedure mark_ref (index : integer ; plus : boolean) ; external ;

procedure tof ; entry ;
  begin
    if list_opt and (max_pline > 0)
      then
        begin
          while pline < max_pline do
            if fopt
              then
                begin
                  page (lfile) ;
                  exit
                end
              else
                begin
                  writeln (lfile) ;
                  pline := succ (pline)
                end ;
          pline := 0
        end
  end ;

procedure writestr (str_to_prnt : string[160]) ; entry ;
  var
    lcnt : byte register ;
  begin
    if length(str_to_prnt) > max_char
      then
        str_to_prnt [0] := byte(max_char) ;
    if (max_pline <> 0) and list_opt and
       ((pline = 0) or (pline + ord(bot) >= max_pline))
      then
        begin
          if pline <> 0
            then
              tof ;
          for lcnt := 1 to top do
            writeln (lfile) ;
          page_cnt := succ (page_cnt);
          writeln (lfile,substr(concat('Page ',string(page_cnt),
                   '   OmegaSoft 6809 Cross Assembler Version ',xraversion,
                   '   ', time),1,ord(max_char))) ;
          writeln (lfile,substr(concat('Source : ',ifname,'  ',
                     'Title : ',title),1,ord(max_char))) ;
          writeln (lfile);
          pline := ord(top) + 3
        end;
    pline := succ (pline);
    if list_opt or line_err
      then
        writeln (lfile,str_to_prnt)
  end;

procedure warning (err : integer) ; entry ;
  var
    message : string [40] ;
  begin
    if pass_2 and won and warn_opt and not line_err
      then
        begin
          line_err := true ;
          case err of
            1 : message := 'long branch not required' ;
            2 : message := 'extended addressing' ;
            3 : message := 'non absolute immediate addressing'
          end ;
          writestr (concat('*** warning ',string(err),' *** ',message))
        end
  end ;

procedure emit_byte (value : hex ; flush_ok : boolean) ; entry ;
  begin
    if pass_2
      then
        begin
          if cl_i < max_cl
            then
              begin
                cl_i := succ (cl_i) ;
                code_line [cl_i] := byte(value)
              end ;
          if out_opt
            then
              begin
                if out_buf[0] = 0
                  then
                    record_start := loc[sect] ;
                out_buf[0] := out_buf[0] + 1 ;
                out_buf[out_buf[0]] := byte(value) ;
                if flush_ok
                  then
                    if (out_buf[0] > 230) or (reloc_idx >= max_ref - 6)
                      then
                        flush_object
            end
        end;
    loc[sect] := loc[sect] + 1
  end;

procedure emit_word (value : hex) ; entry ;
  begin
    emit_byte (value >> 8, false) ;
    emit_byte (value, true)
  end ;

procedure insert_sym (var name : string ; adr : hex;
                      set_tp : set of s_type) ; entry ;
  begin
    curr_sym := succ (curr_sym);
    if curr_sym >= sym_end 
      then
        begin
          line_err := true ;
          writestr ('*** FATAL ERROR - SYMBOL TABLE FULL') ;
          disaster := true
        end
      else
        with sym_tab^ [curr_sym] do
          begin
            sym_nam := upshift(name) ;
            sym_type := set_tp ;
            sym_addr := adr
          end
  end;

procedure express (expr : string[120] ; var rex_type: s_type;
                  mark_x,mark_r : boolean); entry ;
  var
    match : boolean ;
    j : integer ;
    last_sign, curr_sign : char;
    i : integer; 
    ex_val, r_term : hex ;
    i_ptr : ^sym_describe;
    term : string[20] ; 
  begin
    symidx := 0 ;
    altidx := 0 ;
    xrel := 0 ;
    known := true;
    ex_val := 0;
    last_sign := '+';
    rex_string := '' ;
    rex_type := absolute;
    while expr[0] <> 0 do
      begin
        r_term := 0;
        i := get_sign (expr);
        if i = 0
          then
            begin
              curr_sign := ' ';
              term := expr;
              expr[0] := 0
            end
          else
            begin
              term := substr (expr, 1, i-1);
              if term[0] = 0
                then
                  term := '0' ;
              curr_sign := expr[i] ;
              if curr_sign = '!' { operator prefix }
                then
                  begin
                    i := succ (i) ;
                    case expr[i] of
                      '+' : curr_sign := '!' ;
                      '.' : curr_sign := '&' ;
                      'X' : curr_sign := '^' ;
                      '<', '>' : curr_sign := expr[i]
                    end
                  end ;
              expr := substr (expr, i + 1, 80)
            end;
        if valid_symbol (term) or (term = '*')
          then 
            begin
              term := upshift(term) ;
              i := find_sym (sym_tab,term, curr_sym);
              if i = 0
                then
                  begin
                    insert_sym (term, 0, [forward]) ;
                    i := curr_sym
                  end ;
              i_ptr := addr (sym_tab^[i]);
              match := false;
              for j := 0 to max_match do
                if (l_match[j] = rex_type) and (r_match[j] in 
                      i_ptr^.sym_type) and (s_match[j] = last_sign)
                  then
                    begin
                      match := true;
                      case j of
                        0, 4 :
                        {xref - rel, xref - dsect}
                          if xrel <> 0
                            then
                              match := false
                            else
                              if j = 0
                                then
                                  xrel := $ff {-psct}
                                else
                                  xrel := $fe {-dsct} ;
                        24 :
                          if symidx <> 0
                            then
                              match := false
                            else
                              symidx := i ;
                        1 .. 3, 35 :
                          if altidx <> 0
                            then
                              match := false
                            else
                              altidx := i
                      end ;
                      rex_type := res_match[j]
                    end;
              if match
                then
                  r_term := hex(i_ptr^.sym_addr)
                else
                  rex_type := sym_err ;
              if (rex_type = forward) and pass_2
                then
                  rex_type := sym_err ;
              if pass_2 and not (encountered in i_ptr^.sym_type)
                then
                  known := false
            end
          else { not valid symbol }
            {$c-}
            case term [1] of
              '$' :
                begin
                  r_term := hex (substr(term,2,80)) ;
                  if conversion
                    then
                      rex_type := sym_err
                end ;
              '''' :
                begin
                  r_term := 0 ;
                  rex_string := '' ;
                  case term[0] of
                    1 : r_term := $20 ;
                    2 : r_term := hex(term[2])
                    else
                      begin
                        j := 2 ; {skip first character}
                        while j <= length(term) do
                          begin
                            if term[j] <> ''''
                              then
                                begin
                                  append (rex_string, term[j]) ;
                                  r_term := r_term << 8 + hex(term[j])
                                end
                              else
                                if term[j + 1] = '''' {double '}
                                  then
                                    begin
                                      j := j + 1 ; {skip '}
                                      append (rex_string, '''') ;
                                      r_term := r_term << 8 + $27
                                    end
                                  else
                                    exit ;
                            j := j + 1
                          end
                      end
                  end
                end ;
              '%' :
                begin
                  r_term := 0 ;
                  for j := 2 to length(term) do
                    case term[j] of
                      '0' : r_term := r_term << 1 ;
                      '1' : r_term := r_term << 1 + 1
                      else
                        begin
                          rex_type := sym_err ;
                          exit
                        end
                    end
                end
              else
                begin
                  r_term := hex(integer(term)) ;
                  if conversion
                    then
                      rex_type := sym_err
                end
            end; { of case }
            {$c+}
            case last_sign of
              ' ','+' : ex_val := ex_val + r_term ;
              '-' : ex_val := ex_val - r_term ;
              '<' : ex_val := ex_val << r_term ;
              '>' : ex_val := ex_val >> r_term ;
              '&' : ex_val := ex_val and r_term ;
              '!' : ex_val := ex_val or r_term ;
              '^' : ex_val := ex_val eor r_term ;
              '*' : ex_val := ex_val * r_term ;
              '/' : ex_val := ex_val div r_term
            end ;
            last_sign := curr_sign
      end ; { while length }
    if (symidx <> 0) and mark_x and (rex_type <> absolute)
      then
        mark_ref (symidx, true) ;
    if (altidx <> 0) and mark_x and (rex_type <> absolute) 
      then
        mark_ref (altidx, false) ;
    if mark_r
      then
        case rex_type of
          relative : mark_rel (1) ;
          dsect : mark_rel (2) ;
          vsect : mark_rel (3)
        end ;
    if mark_r and (xrel <> 0)
      then
        mark_rel (xrel) ;
    if rex_type = sym_err
      then
        hex_value := 0
      else
        hex_value := ex_val
  end ;

{ start absolute section at indicated address }
procedure abs_psuedo ; entry ;
  begin
    flush_object ;
    if operand[0] <> 0
      then
        begin
          express (operand, ret_type, false, false) ;
          if ret_type <> absolute
            then
              error (18) ;
          loc[abs] := hex_value
        end ;
    sect := abs
  end ;
  
{ start of relocatable section }
procedure code_psuedo ; entry ;
  begin
    flush_object ;
    sect := prg
  end ;

{ start of data section }
procedure data_psuedo ; entry ;
  begin
    flush_object ;
    sect := dat
  end ;

{ start of varib section }
procedure varb_psuedo ; entry ;
  begin
    flush_object ;
    sect := varb
  end ;

{ operation has a label, check symbol table }
procedure has_label ; entry ;
  var
    temp : s_type ;
    labtemp : string[8] ;
  begin
    case sect of
      abs : temp := absolute ;
      prg : temp := relative ;
      dat : temp := dsect ;
      varb : temp := vsect
    end ;
    if not valid_symbol(alabel)
      then
        error (10)
      else
        begin
          labtemp := upshift(alabel) ;
          tab_sym := find_sym (sym_tab, labtemp, curr_sym) ;
          if tab_sym <> 0
            then
{ symbol already in memory }
              with sym_tab^[tab_sym] do
                if not (forward in sym_type)
                  then
                    if (encountered in sym_type) and
                    not (setable in sym_type)
                    or ((setable in sym_type) and
                    (upshift(operation) <> 'SET'))
                      then
                        begin
                          sym_type := sym_type + [multdef] ;
                          error (22)
                        end
                      else
                        if pass_2
                          then
                            begin
                              sym_type := sym_type + [encountered] ;
                              if (temp in sym_type) and
                              not (equ in sym_type) and
                              not (setable in sym_type) and
                              (sym_addr <> loc[sect])
                                then
                                  error (35)
                            end
                          else
                  else
{ change type from forward to relative }
                    begin
                      sym_type := sym_type - [forward] + [temp];
                      sym_addr := loc[sect]
                    end
            else
{ symbol not in table, insert as relative or dsect}
              begin
                insert_sym (alabel, loc[sect], [temp]) ;
                tab_sym := curr_sym
              end
        end
  end ;

{ set symbol to absolute value }
procedure set_sym (set_op : boolean) ; entry ;
  begin
    if alabel[0] = 0
      then
        error (21)
      else
        begin
          express (operand, ret_type, false, false) ;
          if not (ret_type in [absolute, relative, dsect, vsect])
            then
              error (23)
            else
              if not pass_2
                then
{ on pass one set in absolute and its value }
                  with sym_tab^[tab_sym] do
                    if not (multdef in sym_type)
                      then
                        begin
                          sym_type := sym_type -
                          [forward, absolute, relative, vsect, dsect] ;
                          if set_op
                            then
                              sym_type := sym_type + [ret_type, setable]
                            else
                              sym_type := sym_type + [ret_type, equ] ;
                          sym_addr := hex_value
                        end
                      else
                else
{ in pass two, display its value }
                  begin
                    if set_op
                      then
                        sym_tab^[tab_sym].sym_addr := hex_value ;
                    code_line[1] := chr(hex_value >> 8) ;
                    code_line[2] := chr(hex_value) ;
                    cl_i := 2
                  end
        end
  end ;
  
{ set page title }
procedure ttl_psuedo ; entry ;
  begin
    case pass_2 of
      false :
        if length (title) = 0
          then
            title := substr (concat (operand, leftover), 1, 120) ;
      true :
        begin
          title := substr (concat (operand, leftover), 1, 120) ;
          list_on := false
        end
    end
  end ;

{ move to next page }
procedure page_psuedo ; entry ;
  begin
    if pass_2 and ((list and list_opt) or line_err)
      then
        tof ;
    list_on := false
  end ;

{ conditional assembly }
procedure ifxx_psuedo ; entry ;
  var
    left : string [120] ;
    compare : longinteger register ;
  begin
    if_depth := if_depth + 1 ;
    if if_depth > 30
      then
        error (33)
      else
        begin
          express (comma(operand), ret_type, false, false) ;
          compare := integer(hex_value) ;
          if ret_type <> absolute
            then
              error (23) ;
          case opcode_out of
            $d  : enabled := compare =  0 ;
            $e  : enabled := compare >= 0 ;
            $f  : enabled := compare > 0 ;
            $10 : enabled := compare <= 0 ;
            $11 : enabled := compare <  0 ;
            $12 : enabled := compare <> 0 ;
            $13, $14 :
              begin
                left := rex_string ;
                express (operand, ret_type, false, false) ;
                if ret_type <> absolute
                  then
                    error (23) ;
                if opcode_out = $14
                  then
                    enabled := left = rex_string
                  else
                    enabled := left <> rex_string
              end
          end ;
          if if_stack[if_depth - 1]
            then
              if_stack[if_depth] := enabled
            else
              begin
                if_stack[if_depth] := false ;
                enabled := false
              end
        end ;
    list_on := not macro_expansion
  end ;
  
{ end of file }
procedure end_psuedo ; entry ;
  begin
    if operand[0] > 0
      then
        begin
          express (operand, ret_type, false, false) ;
          if ret_type = relative
            then
              begin
                ex_offset := hex_value ;
                ex_set := true
              end
            else
              error (36)
        end ;
    end_pass := true
  end ;

{ terminate one level of conditional assembly }
procedure endc_psuedo ; entry ;
  begin
    if if_depth = 0
      then
        error (52)
      else
        if_depth := if_depth - 1 ;
    enabled := if_stack[if_depth] ;
    list_on := not macro_expansion
  end ;

procedure fail_psuedo ; entry ;
  begin
    error (31)
  end ;

procedure spc_psuedo ; entry ;
  var
    count, i : integer register ;
  begin
    if pass_2 and list and list_opt
      then
        begin
          count := integer (operand) ;
          if conversion
            then
              count := 1 ;
          for i := count downto 1 do
            begin
              if pline + ord(bot) >= max_pline
                then
                  exit ;
              writestr ('')
            end ;
          list_on := false
        end
  end ;

procedure else_psuedo ; entry ;
  begin
    if if_depth = 0
      then
        error (32)
      else
        if if_stack[if_depth - 1]
          then
            begin
              if_stack[if_depth] := not enabled ;
              enabled := not enabled
            end ;
    list_on := not macro_expansion
  end ;

{ format listing line for printing }
procedure format_line ; entry ;
  const
    labelfield = 9 ;
    opndfield = 12 ;
    operationfield = 8 ;
  var
    i : integer register ;
    section : char ;
    pad : string [4] ;
  begin
    case oldsec of
      abs : section := 'A' ;
      prg : section := 'C' ;
      dat : section := 'D' ;
      varb : section := 'V'
    end ;
    pad := '    ' ;
    if line_num
      then
        if include and (incl_line <> 0)
          then
            begin
              prnt_line := string (incl_line) ;
              pad[1] := 'I'
            end
          else
            prnt_line := string (line_cnt)
      else
        prnt_line := '' ;
    pad[0] := 4 - prnt_line[0] ;
    prnt_line := concat (pad, prnt_line, ' ') ;
    prnt_line := concat (prnt_line, section, ':', string(oldloc), ' ') ;
    for i := 1 to cl_i do
      prnt_line := concat (prnt_line,
                          substr(string(hex(code_line[i])),3,2)) ;
    for i := cl_i + 1 to max_cl do
      prnt_line := concat (prnt_line, '  ') ;
    if comment
      then
        prnt_line := concat (prnt_line, ' ', in_line)
      else
        begin
          while (leftover[0] > 0) and (leftover[1] = ' ') do
            leftover := substr (leftover, 2, 120) ;
          i := opndfield - length(listopnd) ;
          if i < 0
            then
              i := 0 ;
          prnt_line := concat (prnt_line, ' ', alabel, substr (blank, 1,
            ord(labelfield - alabel[0])),  operation,  substr (blank, 1,
            ord(operationfield - operation[0])), listopnd,  
            substr (blank, 1, ord(i + 1)), leftover) 
        end ;
    cl_i := 0 ;
    if line_err or list_on
      then
        writestr (prnt_line) ;
    if line_err
      then
        halt_wait ;
    line_num := true ;
    list_on := true
  end ;

Modend.
