Module ra2 {$v3,0 ra2} ;
{
  5/19/89 : initial conversion to level 3
}
{$Ixraincl}
 var
    ofile : device of string[251] varib external ;

{ routines in other modules }
procedure error (err : integer) ; external ;
procedure warning (err : integer) ; external ;
procedure emit_byte (value : hex ; flush_ok : boolean) ; external ;
procedure emit_word (value : hex) ; external ;
procedure writestr (str_to_prnt : string[160]) ; external ;
procedure express (expr : string[120] ; var rex_type : s_type ;
                   mark_x, mark_r : boolean) ; external ;
function find_sym (tabadr : ^sym_format ; var sym : string[8] ;
                   curr_sym : integer) : integer ; external ;
procedure insert_sym (var name : string ; adr : hex ;
                      set_tp : set of s_type) ; external ;
  
function comma (var str : string[120]) : string ; entry ;
  var
    i : integer register ;
  begin
    i := index (str, ',') ;
    if i = 0
      then
        i := 120 ;
    comma := substr (str, 1, i - 1) ;
    str := substr (str, i + 1, 120)
  end ;
  
function hexstr (value : hex) : string [2] ; entry ;
  type
    s = string[2] ;
  var
    spt : ^s register ;
    trick : record
              b1, b2 : byte ;
              h : hex
            end ;
  begin
    trick.b2 := 2 ;
    trick.h := value ;
    spt := addr (trick) + 1 ;
    hexstr := spt^
  end ;

procedure flush_object ; entry ;
  var
    flag : byte register ;
    i, id : integer register ;
    last : boolean register ;
    temp : string[2] ;
    
  procedure flush_relocation ;
    begin
      if out_buf[0] <> 0
        then
          write (ofile, concat(#5, out_buf)) ;
      out_buf[0] := 0
    end ;
    
  begin
    if out_buf[0] <> 0
      then
        begin
          write (ofile, concat(#4, byte(sect), hexstr(record_start), 
                                              out_buf)) ;
          out_buf[0] := 0 ;
          i := 1 ;
          while i <= reloc_idx do
            begin
              temp := hexstr(refs[i].ref_addr) ;
              append(out_buf, temp) ;
              repeat
                last := false ;
                with refs[i] do
                  begin
                    id := ref_id ;
                    if id > 0 { + }
                      then
                        flag := 0
                      else
                        begin { - }
                          flag := 2 ;
                          id := -id
                        end ;
                    if (refs[i].ref_addr <> refs[i+1].ref_addr) or
                       (i = reloc_idx)
                      then
                        begin
                          flag := flag or $80 ;
                          last := true
                        end ;
                    out_buf := concat(out_buf, flag, chr(id)) ;
                    i := i + 1
                  end
              until last ;
              if out_buf [0] > 230
                then
                  flush_relocation
            end ;
          flush_relocation ;
          reloc_idx := 0
        end
  end ;
  
procedure rmb_psuedo ; entry ;
  begin
    express (operand, ret_type, false, false) ;
    if ret_type <> absolute
      then
        error (18)
      else
        begin
          flush_object ;
          loc[sect] := loc[sect] + hex_value ;
        end
  end ;
  
{ define constant block }
procedure bsz_psuedo ; entry ;
  var
    h, lnth : hex register ;
  begin
    if (sect = abs) or (sect = varb)
      then
        error (25)
      else
        begin
{ get length of block }
          express (operand, ret_type, false, false) ;
          if ret_type <> absolute
            then
              error (18)
            else
              begin
                lnth := hex_value ;
                for h := 1 to hex_value do
                  emit_byte (0, true)
              end
        end
  end ;
  
procedure fcb_psuedo ; entry ;
  begin
    repeat
      express (comma(operand), ret_type, false, false) ;
      if ret_type <> absolute
        then
          error (16) ;
      emit_byte (hex_value, true)
    until operand = ''
  end ;
  
procedure fdb_psuedo ; entry ;
  begin
    repeat
      express (comma(operand), ret_type, true, true) ;
      if ret_type = sym_err
        then
          error (17) ;
      emit_word (hex_value)
    until operand = ''
  end ;
  
procedure fcc_psuedo ; entry ;
  var
    fcchar : char ;
    stop : boolean ;
    delim : byte ;
    i, strlen : integer ;
  begin
    operand := concat (operand, leftover) ;
    leftover := '' ;
    listopnd := operand ;
    strlen := length(operand) ;
    if strlen < 3 
      then
        error (15)
      else
        begin
          i := 1 ;
          stop := false ;
          delim := operand [1] ;
          while (i <= strlen) and not stop do
            begin
              fcchar := operand [i] ;
              if not (fcchar in ['0'..'9'])
                then
                  begin
                    stop := true ;
                    if fcchar <> ','
                      then
                        begin
                          i := 2 ;
                          while (operand[i] <> delim) and (i <strlen) do
                            begin
                              emit_byte (hex(operand[i]),true) ;
                              i := succ (i)
                            end ;
                          if operand [i] <> delim 
                            then
                              error (212)
                        end
                      else
                        begin
                          operand := substr(operand,ord(i+1),
                                integer(substr(operand,1,i-1))) ;
                          for i := 1 to length(operand) do
                            emit_byte (hex(operand[i]),true)
                        end
                  end
                else
                  i := succ (i)
            end
        end
  end ;
  
  
{ setup identification record variables }
procedure idnt_psuedo ; entry ;
    
  function getnum (field : string[120]) : byte ;
    begin
      express(field, ret_type, false, false) ;
      if ret_type <> absolute
        then
          error (18) ;
      getnum := chr(hex_value)
    end ;
    
  begin
    if alabel[0] = 0
      then
        error (9)
      else
        begin
          with sym_tab^[tab_sym] do
            begin
              sym_type := [sym_err] ; { make sure is not used }
              modname := sym_nam
            end ;
          version := getnum (comma(operand)) ;
          revision := getnum (operand) ;
          moddesc := substr(leftover,2,120)
        end
  end ;
    
procedure xdef_psuedo ; entry ;
  var
    i : integer register ;
    stemp : string[8] ;
  begin
    while operand[0] <> 0 do
      begin
        stemp := upshift(comma(operand)) ;
        i := find_sym (sym_tab, stemp, curr_sym) ;
        if i = 0
          then
            insert_sym (stemp, 0, [xdef,forward])
          else
            with sym_tab^[i] do
              begin
                sym_type := sym_type + [xdef] ;
                if ([sym_err, xref] * sym_type) <> []
                  then
                    error (24)
              end
      end
  end ;
  
procedure xref_psuedo ; entry ;
  var
    i : integer register ;
    stemp : string[8] ;
  begin
    while operand[0] <> 0 do
      begin
        stemp := upshift(comma(operand)) ;
        i := find_sym (sym_tab, stemp, curr_sym) ;
        if i = 0
          then
            begin
              insert_sym (stemp, 0, [xref]) ;
              i := curr_sym
            end
          else
            with sym_tab^[i] do
              if xdef in sym_type
                then
                  error (24)
                else
                  begin
                    sym_type := sym_type - [forward] + [xref] ;
                    if pass_2
                      then
                        sym_type := sym_type + [encountered]
                  end ;
        with sym_tab^[i] do
          sym_addr := 0 ;
      end
  end ;
  
procedure mark_rel (plus : integer) ; entry ;
  begin
    if pass_2 and out_opt
      then
        begin
          reloc_idx := succ (reloc_idx) ;
          with refs [reloc_idx] do
            begin
              ref_addr := loc[sect] ;
              ref_id := plus
            end
        end
  end ;
  
procedure mark_ref (index : integer ; plus : boolean) ; entry ;
  begin
    if pass_2 and out_opt
      then
        begin
          reloc_idx := succ(reloc_idx) ;
          with refs[reloc_idx] do
            begin
              ref_addr := loc[sect] ;
              ref_id := ord(sym_tab^[index].esd_num) ;
              if not plus
                then
                  ref_id := -ref_id
            end
        end
  end ;

procedure comp_rel (var cr_str : string; long : boolean) ; entry ;
  var
    null_str : string [1] ;
  begin
    null_str[0] := 0 ;
    express (cr_str, ret_type, long, false);
    if not (ret_type in [absolute,relative,dsect,xref])
      then
        error (13) ;
    if long
      then
        begin
          if pass_2
            then
              begin
                if ret_type = dsect
                  then
                    mark_rel (2) ;
                if ret_type in [absolute,xref,dsect]
                  then
                    mark_rel (-1) {subtract code section}
              end ;
          hex_value := hex_value - loc[sect] - 2 ;
          emit_word (hex_value) ;
          if (ret_type = absolute) and not known
            then
              error (8) ;
          if ((hex_value < $80) or (hex_value > $ff81))
            and (ret_type <> xref)
            then
              warning (1)
        end
      else
        begin
          hex_value := hex_value - succ(loc[sect]) ;
          if ((hex_value > $7f) and (hex_value < $ff80))
                or (ret_type in [absolute,xref,dsect])
            then
              error (12) ;
          emit_byte (hex_value, true)
        end
  end;
 
function find_reg (var ops : string) : registers ; entry ;
  begin
    find_reg := no_reg ;
    if ops[0] = 1
      then
        case upshift(ops[1]) of
          'D' : find_reg := d ;
          'X' : find_reg := x ;
          'Y' : find_reg := y ;
          'U' : find_reg := u ;
          'A' : find_reg := a ;
          'B' : find_reg := b ;
          'S' : find_reg := s
        end
    else if ops[0] = 2
      then
        case upshift(ops) of
          'PC' : find_reg := pc ;
          'CC' : find_reg := ccr ;
          'DP' : find_reg := dpr
        end
  end ;
      
function get_rr (var ops : string) : hex; entry ;
  var
    r : registers ;
  begin
    r := find_reg (ops);
    if r in [x..s]
      then
        get_rr := hex((ord(r) - ord(x)) << 5)
      else
        get_rr := $ffff
  end;
  
procedure setup_output ; entry ;
  var
    i : integer register ;
    num : byte register ;
                
  procedure flush_esd (b : byte) ;
    begin
      if out_buf[0] <> 0
        then
          write (ofile, concat (b, out_buf)) ;
      out_buf[0] := 0
    end ;      
    
  begin
    write (ofile, concat(#0, version, revision, modname[0], modname,
           moddesc[0], moddesc)) ;
    write (ofile, concat(#1, hexstr(loc[prg]),hexstr(loc[dat]),
                             hexstr(loc[varb]))) ;
    out_buf[0] := 0 ;
    num := 3 ;
    for i := 2 to curr_sym do
      with sym_tab^[i] do
        begin
          if xref in sym_type
            then
              begin
                if num = 255
                  then
                    begin
                      writestr('*** FATAL ERROR - ESD TABLE FULL') ;
                      disaster := true
                    end ;
                num := succ (num) ;
                esd_num := num ;
                append(out_buf, sym_nam[0], sym_nam)
              end ;
          if out_buf[0] > 220
            then
              flush_esd (2)
        end ;
    flush_esd (2) ;
    for i := 2 to curr_sym do    
      with sym_tab^[i] do
        begin
          if xdef in sym_type
            then
              begin
                if absolute in sym_type
                  then
                    append(out_buf, #0)
                  else
                    if dsect in sym_type
                      then
                        append(out_buf, #2)
                      else
                        if vsect in sym_type
                          then
                            append(out_buf, #3)
                          else
                            append(out_buf, #1) ;
                out_buf := concat (out_buf, hexstr(hex(sym_addr)),
                           sym_nam[0], sym_nam)
              end ;
          if out_buf[0] > 220
            then
              flush_esd (3)
        end ;
    flush_esd (3)
  end ;    


function not_sym (ch : char) : boolean ; external ;

function valid_symbol (var sym : string) : boolean ; entry ;
  var
    i : byte register ;
  begin
    valid_symbol := true ;
    if sym[0] > 0
      then
        begin
          i := upshift(sym[1]) ;
          case i of
            '.','A'..'Z' :
              for i := 2 to sym[0] do
                if not_sym (sym[i]) 
                  then
                    begin
                      valid_symbol := false ;
                      exit
                    end ;
            else
              valid_symbol := false
          end
        end
      else
        valid_symbol := false
  end ;
  
function issign (ch : char) : boolean ; external ;

function get_sign (var str : string) : integer ; entry ;
  var
    i : integer register ;
    ch : char register ;
    instr : boolean register ;
  begin
    get_sign := 0 ;
    instr := false ;
    if str[1] = '*'
      then
        if str[0] > 1
          then
            get_sign := 2
          else
      else
        for i := 1 to length(str) do
          begin
            ch := str[i] ;
            if instr {inside a string literal}
              then
                if ch = ''''
                  then
                    if i <> length(str)
                      then
                        if str[i + 1] = ''''
                          then
                            i := i + 1 {skip character}
                          else
                            instr := false
                      else
                        instr := false
                  else
              else
                if issign (ch)
                  then
                    begin
                      get_sign := i ;
                      exit
                    end
                  else
                    if ch = ''''
                      then
                        instr := true
          end
  end ;
  
Modend.
