 nolist
*
* 6/26/89 : r$task added.
* 6/29/89 : r$toff and r$tcb1 added
*
echeck equ 1 error checking on
*
* common ascii characters
*
cr equ $d carriage return
lf equ $a line feed
ff equ $c form feed
space equ $20 space
*
* runtime error codes
*
 abs 4
*
e$over rmb 1 overflow
e$trnc rmb 1 truncation error
e$zdiv rmb 1 divide by zero
e$ilsr rmb 1 invalid argument for square root or log
e$dyno rmb 1 dynamic length assign error
e$arry rmb 1 array index invalid
e$stin rmb 1 string index invalid
e$subr rmb 1 subrange error
e$setr rmb 1 set element out of range
e$icon rmb 1 integer conversion error
e$hcon rmb 1 hex conversion error
e$rcon rmb 1 real conversion error
e$bcon rmb 1 boolean conversion error
e$opcl rmb 1 device open/closed incorrect
e$eof rmb 1 device hit eof
e$hpov rmb 1 heap overflow
e$dsov rmb 1 data stack overflow
e$ssov rmb 1 system stack overflow
*
* runtime stack offsets
*
 abs -10
r$rdwr rmb 2 read/write device address
r$lsp rmb 1 spare from local or global
r$toff equ r$lsp in global this is start of tasking block
r$eflg rmb 1 error flag from local or global
r$glob rmb 2 global pointer from local or global
r$slim rmb 2 system stack limit from global
r$dlim rmb 2 not used in local
r$tcb1 equ r$dlim in global this is start task 1's tcb
r$hplm rmb 2 heap limit from global
r$hppt rmb 2 heap pointer from global
r$conv rmb 1 conversion error from global
r$rang rmb 1 range error from global
r$parm rmb 2 address of parameter area from global
r$inp rmb 2 standard input address
r$out rmb 2 standard output address
r$aux rmb 2 standard auxout address
r$key rmb 2 standard keyboard address
r$hpst rmb 2 long heap free link start
r$slnk equ r$dlim static link from local
r$dlnk equ r$slim dynamic link from local
*
* runtime error flag mask bits
*
r$erng equ 1 range error mask bit (1 = enabled)
r$eioe equ 2 i/o error mask bit (1 = enabled)
r$econ equ 4 conversion error mask bit (1 = enabled)
r$task equ $80 tasking if set
*
* device descriptor field offsets
*
 abs 0
*
p$mode rmb 1 mode
p$err rmb 1 error status
p$drv rmb 2 address of device driver
p$elnt rmb 2 element length 
p$elmt rmb 1 start of element
*
* device descriptor mode bit definitions
*
* bits 0,1
*
m$clos equ 0 device is closed
m$in equ 1 open for input
m$out equ 2 open for output
m$updt equ 3 open for update
*
* bit 2
*
m$text equ 4 is text device
*
* bit 3
*
m$val equ 8 element is valid for read
*
* bit 4
*
m$bk equ $10 break occurred on device
*
* bit 5
*
m$eof equ $20 current element is eof
*
* bit 6
*
m$eoln equ $40 current element is eoln
*
* bit 7
*
m$int equ $80 device is interactive
*
* device driver offsets
*
o$init equ 0 initialize device
o$xfot equ 3 transfer data to device
o$xfin equ 6 transfer data from device
o$set equ 9 setup device
*
* parameter(s) to/from device drivers
*
* o$init :  x points to descriptor
*           a contains mode
*
* o$xfot :  x points to descriptor
*           a contains writeln flag (1 = true)
*
* o$xfin :  x points to descriptor
*
* o$set  :  x points to descriptor
*           a contains function code
*
* setup function codes
*
 abs 0
*
st$brk rmb 1 break check
*    no other parameters
*
st$opn rmb 1 open
*    y points to file name (terminated by cr)
*    b has flag byte
*
st$cre rmb 1 create
*    y points to file name (terminated by cr)
*    b has flag byte
*
st$cls rmb 1 close
*    no other parameters
*
st$del rmb 1 delete
*    y points to file name (terminated by cr)
*
st$sek rmb 1 seek
*    y points to 32 bit byte address
*
st$pag rmb 1 page
*    no other parameters
*
st$stat rmb 1 status
*    y points to parameter
*
 code
 list
