program target {$v3,1 target system debugger} ({$b+}input{$b-}, output, keyboard) ;
  type
    ret_type = (none, asbrk, pabrk, rerr, progend, ptrace, syserr,
                hosterr, comab) ;

    comrec = record
               lth : byte ;
               case com : byte of
                 'A', 'N', 'R', 'T', 'Z', '0' : () ;
                 'B' : (b_adr : hex ;
                        case integer of
                        1 : (b_dat : array [#0 .. #63] of byte) ;
                        2 : (b_word : hex)) ;
                 'C' : (case integer of
                        1 : (c_dat : array [#0 .. #63] of byte) ;
                        2 : (c_word : hex)) ;
                 'D' : (d_adr : hex ;
                        d_cnt : byte) ;
                 'E' : (e_sel : char) ;
                 'F' : (f_cc, f_a, f_b, f_dp : byte ;
                        f_x, f_y, f_u, f_s, f_pc : hex) ;
                 'H' : (gh_regs : array [#0 .. #10] of hex) ;
                 'I' : (i_value : hex ;
                        i_regsel : byte) ;
                 'K' : (k_loc : hex ;
                        k_num : byte) ;
                 'L' : (l_cnt : array [#1 .. #16] of integer) ;
                 'M' : (m_num : byte ;
                        m_poll : boolean ;
                        m_loc : hex ;
                        m_cnt : integer) ;
                 'O' : (o_from, o_too : hex ;
                        o_dat : array [#1 .. #16] of byte ;
                        o_text : boolean ;
                        o_maxpat : byte) ;
                 'P' : (p_cnt : integer ;
                        p_ltren : boolean) ;
                 'Q' : (q_base, q_heap, q_prog, q_sys_lim, q_sys_strt : hex ;
                        q_ltren : boolean) ;
                 'S' : (s_plast : hex ;
                        s_errval : byte ;
                        s_retval : ret_type ;
                        s_aval : boolean ;
                        s_ltrcnt : byte ;
                        s_ptrcnt : byte) ;
                 'U' : (u_adr : hex) ;
                 'V' : (v_from, v_too, v_dest : hex) ;
                 'W' : (w_radr : hex ;
                        w_vnum : integer) ;
                 'X' : (x_num : byte) ;
                 'Y' : (y_ladr, y_padr : hex ;
                        y_pexit : boolean) ;
                 '1' : (one_txt : boolean) ;
                 '2' : (two_char : char ;
                        two_done : boolean ;
                        two_str : string[64]) ;
                 '3' : (three_ln : boolean ;
                        three_str : string[64]) ;
                 '7' : (sev_on : boolean)
             end ;

    reg_type = record
                 cc, a, b, dp : byte ;
                 x, y, u, pc, s : hex
               end ;

    pbrk_tab = array [#0 .. #17] of record
                                      brkloc : ^hex ;
                                      brkcnt : integer
                                    end ;
                      
    trace_tab = array [#0 .. #49] of ^hex ;
    
    ptrace_tab = array [#0 .. #49] of record
                                        ploc : hex ;
                                        is_exit : boolean
                                      end ;
                                      
    exc_type = array [1 .. 6] of hex ;
    
  const
    irqlink = false ;
  var
    crack, crreject, cr1, cr2, cr3 : comrec ;
    i, count : byte ;
    start_adr : ^byte ;
    exc_blk : ^exc_type ;
    s : string ;
  var varib entry
    sys_save : record
                 pc, u, s : hex
               end ;
    retval : ret_type ;
    errval : byte ;
    crashu : boolean ;
    user : boolean ;
    st_trace : integer ;
    ltrace : trace_tab ;
    ltrcnt : byte ;
    pbreak : pbrk_tab ;
    plast : ^hex ;
    proctr : ptrace_tab ;
    ptrcnt : byte ;
    ltren : boolean ;
    inrec, outrec : string[120] ;
    abreak : array [#0 .. #8] of record
                                    abaddr : ^byte ;
                                    abdata : byte
                                 end ;
    abrkval : boolean ;
    regs : reg_type ;
    memsize, ramstart, ramend : ^byte ;
  var
    jmplow, jmphigh : ^byte data external ;
    auxstrt, auxend, globsave : hex pcr ;
    vecstart : hex pcr ;
    
{ IMPORT FROM TARGET 6 }
  procedure catch ; external ;
  procedure throw ; external ;
  procedure set_exc ; external ;
  procedure gopasc (program_start, heap_start, sys_limit,
                    sys_start, global_base : hex) ; external ;
  procedure proca ; external ;
  
{ IMPORT FROM LINKCODE }
  procedure encode (var source : comrec ; 
                    var destination : string[120]) ; external ; 
  function decode (var source : string[120] ; 
                   var destination : comrec) : boolean ; external ;

{ IMPORT FROM IODRIVER }
  procedure usr_out ; external ;
  procedure usr_in ; external ;
  procedure usr_key ; external ;

  procedure putrecord (var cr : comrec) ;
    var
      s : string[120] ;        
    begin
      encode (cr, s) ;
      writeln (s)
    end ;
    
  function getrecord (var cr : comrec) : boolean ; entry ;
    var
      s : string[120] ;
    begin
      readln (s) ;
      if decode (s, cr)
        then
          getrecord := false
      else if cr.com = 'Z'
        then
          begin
            retval := none ;
            throw
          end
        else
          getrecord := true
    end ;
    
  procedure get_ack ;
    begin
      putrecord (cr1) ;
      repeat
        if getrecord (cr3)
          then
            case cr3.com of
              'A' : exit ;
              'T' : putrecord (cr1)
              else
                begin
                  retval := none ;
                  throw
                end
            end
          else
            putrecord (crreject)
      until false
    end ;

  procedure copy (f, t : ^byte ; cnt : integer) ;
    var
      i : integer ;
    begin
      for i := 1 to cnt do
        begin
          t^ := f^ ;
          t := t + $1 ;
          f := f + $1
        end
    end ;
    
  procedure find ;
    var
      found : boolean ;
      ch : byte ;
      start, last : ^byte ;
      patnum : byte ;
    begin
      repeat
        start := cr2.o_from ;
        while start <= cr2.o_too do
          begin
            found := true ;
            last := start ;
            for patnum := #1 to cr2.o_maxpat do
              begin
                ch := last^ ;
                if cr2.o_text
                  then
                    ch := upshift(ch and #$7f) ;
                if ch <> cr2.o_dat[patnum]
                  then
                    begin
                      found := false ;
                      exit
                    end ;
                last := last + $1
              end ;
            if found
              then
                begin
                  cr1.lth := #3 ;
                  cr1.com := 'U' ;
                  cr1.u_adr := start ;
                  get_ack ;
                  exit (2)
                end ;
            start := start + $1
          end ;
        cr1.lth := #3 ;
        cr1.com := 'U' ;
        cr1.u_adr := nil ;
        get_ack
      until true 
    end ;
    
  procedure block_move ;
    var
      source, dest : ^byte ;
    begin
      if cr2.v_dest > cr2.v_from
        then
          begin
            dest := cr2.v_dest + cr2.v_too - cr2.v_from ;
            for source := cr2.v_too downto cr2.v_from do
              begin
                dest^ := source^ ;
                dest := dest - $1
              end
          end
        else
          begin
            dest := cr2.v_dest ;
            for source := cr2.v_from to cr2.v_too do
              begin
                dest^ := source^ ;
                dest := dest + $1
              end
          end ;
      putrecord (crack)
    end ;
    
  procedure clear (p1, p2 : ^byte) ;
    begin
      ! ldx 2,y
      ! clr 0,x+
      ! cmpx 0,y
      ! bls *-4
    end ;
    
  begin
    {$i+}
    memsize := memavail - $400 ;
    new (ramstart : memsize) ;
    ramend := ramstart + memsize ;
    crack.lth := #1 ;
    crack.com := 'A' ;
    crreject.lth := #1 ;
    crreject.com := 'T' ;
    user := false ;
    retval := none ;
    errval := 0 ;
    for i := #0 to #17 do
      pbreak[i].brkloc := nil ;
    for i := #0 to #8 do
      abreak[i].abaddr := nil ;
    exc_blk := vecstart + $2 ;
    set_exc ;
    catch ;
{$cne irqlink}
    irqon ;
{$celse}
    irqoff ;
{$cend}
    if retval <> none
      then
        begin
          cr1.lth := #8 ;
          cr1.com := 'S' ;
          cr1.s_retval := retval ;
          cr1.s_errval := errval ;
          cr1.s_plast := plast ;
          cr1.s_aval := abrkval ;
          cr1.s_ltrcnt := ltrcnt ;
          cr1.s_ptrcnt := ptrcnt ;
          retval := none ;
          for i := #0 to #17 do
            pbreak[i].brkloc := nil ;
          for i := #0 to #8 do
            abreak[i].abaddr := nil ;
          get_ack ;
        end ;
    repeat
      repeat
        if getrecord (cr2)
          then
            exit ;
        putrecord (crreject)
      until false ;
      case cr2.com of
        'A' : putrecord (crack) ;
        'B' :
          with cr2 do
            begin
              putrecord (crack) ;
              start_adr := b_adr ;
              for i := #0 to lth - #4 do
                begin
                  start_adr^ := b_dat[i] ;
                  start_adr := start_adr + $1
                end 
              end ;
        'D' :
          with cr2 do
            begin
              start_adr := d_adr ;
              cr1.lth := d_cnt + 1 ;
              for i := #0 to d_cnt - 1 do
                begin
                  cr1.c_dat[i] := start_adr^ ;
                  start_adr := start_adr + $1
                end ;
              cr1.com := 'C' ;
              get_ack
            end ;
        'E' :
          begin
            cr1.com := 'F' ;
            cr1.lth := #15 ;
            cr1.f_cc := regs.cc ;
            cr1.f_a := regs.a ;
            cr1.f_b := regs.b ;
            cr1.f_dp := regs.dp ;
            cr1.f_x := regs.x ;
            cr1.f_y := regs.y ;
            cr1.f_u := regs.u ;
            cr1.f_s := regs.s ;
            cr1.f_pc := regs.pc ;
            get_ack
          end ;
        'I' :
          with cr2 do
            begin
              case i_regsel of
                0 : regs.cc := byte(i_value) ;
                1 : regs.a := byte(i_value) ;
                2 : regs.b := byte(i_value) ;
                3 : regs.dp := byte(i_value) ;
                4 : regs.x := i_value ;
                5 : regs.y := i_value ;
                6 : regs.u := i_value ;
                7 : regs.s := i_value ;
                8 : regs.pc := i_value ;
                9 :
                  begin
                    regs.a := byte(i_value >> $8) ;
                    regs.b := byte(i_value)
                  end
              end ;
              putrecord (crack)
            end ;
        'K' :
          with abreak[cr2.k_num] do
            begin
              abaddr := cr2.k_loc ;
              abdata := abaddr^ ;
              abaddr^ := $3f ; {swi}
              putrecord (crack)
            end ;
        'M' :
          if cr2.m_poll
            then
              begin
                for i := #1 to #16 do
                  cr1.l_cnt[i] := pbreak[i].brkcnt ;
                cr1.lth := #33 ;
                cr1.com := 'L' ;
                get_ack
              end
            else
              begin
                pbreak[cr2.m_num].brkloc := cr2.m_loc ;
                pbreak[cr2.m_num].brkcnt := cr2.m_cnt ;
                putrecord (crack)
              end ;
        'N' :
          begin
            cr1.lth := 23 ;
            cr1.com := 'H' ;
            cr1.gh_regs[0] := ramstart ;
            cr1.gh_regs[1] := ramend ;
            cr1.gh_regs[2] := addr (jmphigh) ;
            cr1.gh_regs[3] := addr (jmplow) ;
            cr1.gh_regs[4] := addr (regs) ;
            cr1.gh_regs[5] := addr(usr_out) ;
            cr1.gh_regs[6] := addr(usr_in) ;
            cr1.gh_regs[7] := addr(usr_key) ;
            cr1.gh_regs[8] := auxstrt ;
            cr1.gh_regs[9] := auxend ;
            cr1.gh_regs[10] := globsave ;
            get_ack ;
            regs.pc := ramstart ;
            regs.cc := 0 ;
            regs.s := ramend ;
            regs.dp := 0
          end ; 
        'O' : find ;
        'P' :
          begin
            ltren := cr2.p_ltren ;
            st_trace := cr2.p_cnt ;
            proca
          end ;
        'Q' : 
          begin
            for i := #0 to #49 do
              begin
                ltrace[i] := nil ;
                proctr[i].ploc := nil
              end ;
            ltrcnt := #0 ;
            ptrcnt := #0 ;
            st_trace := 0 ;
            ltren := cr2.q_ltren ;
            gopasc (cr2.q_prog, cr2.q_heap, cr2.q_sys_lim, cr2.q_sys_strt, cr2.q_base)
          end ;
        'R' : putrecord (crack) ;
        'T' : putrecord (cr1) ;
        'V' : block_move ;
        'W' : 
          begin
            exc_blk^[cr2.w_vnum] := cr2.w_radr ;
            putrecord (crack)
          end ;
        'X' :
          begin
            cr1.lth := #6 ;
            cr1.com := 'Y' ;
            cr1.y_ladr := ltrace[cr2.x_num] ;
            cr1.y_padr := proctr[cr2.x_num].ploc ;
            cr1.y_pexit := proctr[cr2.x_num].is_exit ;
            get_ack
          end ;
        '0' :
          begin
            clear (ramstart, ramend) ;
            clear (auxstrt, auxend) ;
            putrecord (crack)
          end ;
        '7' :
          if cr2.sev_on
            then
              irqon
            else
              irqoff
      end
    until false
  end.
