{$l-}
{
  Copyright 1985,1989 by Certified Software Corporation
}
  const
    cntrl = #$1F ;
    linelth = 80 ;
    lastline = 50 ;
    varstart = $18 ;
    datstart = $0 ;
            
  type
    string80 = string ;
    macline = string80 ;

    int_type = record
                active : boolean ;
                define : boolean ;
                intname : hex ;
                modoff : hex
               end ;
              
    sect = (abs, relo, dat, varb, special, esd) ;
    
    ext_type = record
                 active : boolean ;
                 defined : boolean ;
                 value : hex ;
                 module : byte ;
                 section : sect ;
                 name : string[9] {only 8 characters max}
               end ;

    esd_type = record
                 address : hex ;
                 module : byte ;
                 esdnum : byte ;
                 flag : byte
               end ;

    reg_type = record
                 cc, a, b, dp : byte ;
                 x, y, u, pc, s : hex
               end ;
              
    info_type = (d_proc_start, d_ext_proc, d_proc_end, d_varib,
                 d_line, d_module, d_program, d_lex) ;

    dbt_type = record
                  link : ^dbt_type ;
                  case info : info_type of
                    d_proc_start : (proc_block : hex ;
                                    param_size : hex ;
                                    proc_loc : hex ;
                                    proc_name : string) ;
                    d_proc_end : (proc_eblock : hex ;
                                  proc_end : hex ;
                                  proc_ename : string) ;
                    d_line : (linenum : integer ;
                              lineloc : hex) ;
                    d_module, d_program : (modloc : hex ;
                                           modname : string) ;
                    d_varib : (var_rec : string) ;
                    d_ext_proc : (proc_xblock : hex ;
                                  param_xsize : hex ;
                                  dummy : hex ;
                                  proc_xname : string) ;
                    d_lex : (lex : byte)
               end ;

    pbrk_tab = array [0 .. 17] of record
                                    brkloc : hex ;
                                    brkcnt : integer ;
                                    mac : byte
                                  end ;
                      
    trace_tab = array [0 .. 49] of hex ;
    
    ptrace_tab = array [0 .. 49] of record
                                      ploc : hex ;
                                      is_exit : boolean
                                    end ;
                                      
    ret_type = (none, asbrk, pabrk, rerr, progend, ptrace, syserr,
                hosterr, comab) ;
              
    exc_type = array [1..9] of longhex ; {host}
    
    exc9_type = array [1..6] of hex ; {target}
    
    token_type = (
                  deferred,  {0}
                  boolvar,   {1}
                  charvar,   {2}
                  integvar,  {3}
                  hexvar,    {4}
                  lhexvar,   {5}
                  lintvar,   {6}
                  realvar,   {7}
                  enumvar,   {8}
                  subbool,   {9}
                  subchar,   {A}
                  subinteg,  {B}
                  subhex,    {C}
                  sublhex,   {D}
                  sublint,   {E}
                  arrayvar,  {F}
                  stringvar, {10}
                  setvar,    {11}
                  recordvar, {12}
                  devicevar, {13}
                  textvar,   {14}
                  valuepar,  {15}
                  varibpar,  {16}
                  funcret,   {17}
                  ident,     {18}
                  constdef,  {19}
                  typedef,   {1A}
                  vardef,    {1B}
                  labeldef,  {1C}
                  funcdef,   {1D}
                  procdef,   {1E}
                  undef      {1F}
                 ) ;
                
    storage_type = (
                    s_stack,      {fixed offset from stack mark}
                    s_external,   {offset from stack mark via xref}
                    s_absolute,   {at absolute address}
                    s_direct,     {at direct page absolute}
                    s_data_ext,   {in data section in another module}
                    s_data,       {in data section}
                    s_varib_ext,  {in varib section in another module}
                    s_varib,      {in varib section}
                    s_pcr,        {relative to PC via xref}
                    s_stddev,     {initialized standard device}
                    s_nospace,    {no space at all}
                    s_recoff      {record offset}
                   ) ;
                  
    blklist = record
                link : ^blklist ;
                list : array [1 .. 8] of
                          record
                            first, last : integer ;
                            offset : integer
                          end ;
                       foff : longhex
              end ;

    comrec = record
               lth : byte ;
               case com : byte of
                 'A', 'N', 'R', 'T', 'Z', '0' : () ;
                 'B' : (b_adr : hex ;
                        case integer of
                        1 : (b_dat : array [0 .. 63] of byte) ;
                        2 : (b_word : hex)) ;
                 'C' : (case integer of
                        1 : (c_dat : array [0 .. 63] of byte) ;
                        2 : (c_word : hex)) ;
                 'D' : (d_adr : hex ;
                        d_cnt : byte) ;
                 'E' : (e_sel : char) ;
                 'F' : (f_cc, f_a, f_b, f_dp : byte ;
                        f_x, f_y, f_u, f_s, f_pc : hex) ;
                 'H' : (gh_regs : array [0 .. 10] of hex) ;
                 'I' : (i_value : hex ;
                        i_regsel : byte) ;
                 'K' : (k_loc : hex ;
                        k_num : byte) ;
                 'L' : (l_cnt : array [1 .. 16] of integer) ;
                 'M' : (m_num : byte ;
                        m_poll : boolean ;
                        m_loc : hex ;
                        m_cnt : integer) ;
                 'O' : (o_from, o_too : hex ;
                        o_dat : array [#1 .. #16] of byte ;
                        o_text : boolean ;
                        o_maxpat : byte) ;
                 'P' : (p_cnt : integer ;
                        p_ltren : boolean) ;
                 'Q' : (q_base, q_heap, q_prog, q_sys_lim, q_sys_strt : hex ;
                        q_ltren : boolean) ;
                 'S' : (s_plast : hex ;
                        s_errval : byte ;
                        s_retval : ret_type ;
                        s_aval : boolean ;
                        s_ltrcnt : byte ;
                        s_ptrcnt : byte) ;
                 'U' : (u_adr : hex) ;
                 'V' : (v_from, v_too, v_dest : hex) ;
                 'W' : (w_radr : hex ;
                        w_vnum : integer) ;
                 'X' : (x_num : byte) ;
                 'Y' : (y_ladr, y_padr : hex ;
                        y_pexit : boolean) ;
                 '1' : (one_txt : boolean) ;
                 '2' : (two_char : char ;
                        two_done : boolean ;
                        two_str : string[64]) ;
                 '3' : (three_ln : boolean ;
                        three_str : string[64]) ;
                 '7' : (sev_on : boolean)
             end ;
  var
    adall, adlines : set of 0 .. 59 ;
    width, depth, curline, curx, topline, st_trace, brk_line, brk_mod : integer ;
    linkerr, linkcnt, totalerr, maxvec : integer ;
    sel, maxchar, ltrcnt, brk_lex, ptrcnt : byte ;
    comstr : string [linelth] ;
    from, too, offset, contents, plast, progstart, brk_block, dcaddr : hex ;
    escaped, procval, autolist, wait, linkirq, ltren, abrkval : boolean ;
    inname, outname : string ;
    comline : string[252] ;
    infile, outfile, comlink : text ;
    ltrace : trace_tab ;
    pbreak : pbrk_tab ;
    brk_proc : ^dbt_type ;
    proctr : ptrace_tab ;
    macs : array [#0 .. #20] of ^macline ;
    maccnt : integer ;
    macpnt, maccur : ^macline ;
    mbuf_start, mbuf_cur, mbuf_end : ^macline ;
    exc9_blk : ext_type ; {target}
    dummy : string ;
    t_ramend, t_auxstrt, t_auxend, t_jmphigh, t_jmplow, t_vector : hex ;
    regs : reg_type ;
    t_regbase, t_output, t_input, t_keyboard : hex ;

    loadblk : array[boolean] of record
                                  blkptr : ^blklist ;
                                  idx : integer ;
                                  lastused : boolean ;
                                  buf : array[0 .. 2047] of char
                                end ;

    mod_tab : array [0 .. 100] of record
                                    name : string[17] ;
                                    filename : string[40] ;
                                    start, finish : hex ;
                                    dsize, vsize : hex ;
                                    dbstart, dbend : ^dbt_type ;
                                    blks : ^blklist ;
                                   end ;

  var varib {$cne program} entry {$celse} external {$cend}
    state_save : record
                   pc, a6, a7 : longhex
                 end ;
    noecho : boolean ;
    int_start, int_end, int_cur : ^int_type ;
    cur_off, cur_adr, code_start, code_limit, var_loc, var_max : hex ;
    dat_base, dat_loc, dat_max, t_ramstart, t_globsave : hex ;
    ext_start, ext_cur : ^ext_type ;
    cur_sect : sect ;
    esd_start, esd_limit : ^esd_type ;
    dbt_start, dbt_cur, dbt_end, dbt_last, dbt_smod : ^dbt_type ;
    crack, cr1, cr2, cr3, crreject, crzap : comrec ;
    compath, cur_mod : integer ;
    abreak : array [0 .. 8] of record
                                 adr : hex ;
                                 mac : byte
                               end ;
    
{$l+}
