program xtdb {$v3,1 cross target debugger} (output,keyboard,{$b+}input{$b-}) ;
{
  7/21/89 : initial conversion to level 3
  7/26/89 : added 1 and 2 records to handle target I/O on request
  to facilitate files for I/O.
}
{
  Copyright (C) 1987, 1989 by Certified Software Corporation
}
{$l+}
{$I/dd/defs/crtdrive}
{$I/dd/defs/os9types}
{$Itdbincl}
{$l-}
  const
    versnum = entry array [1..2] of char ('D', 'A') ;
    portdef = entry string[20] '/td' ;
    link_dly = entry integer 2 ;
    link_retry = entry integer 3 ;
    traptab = entry array [0 .. 15] of boolean 
              (true, false, false, false, false, false, false, false,
               false, false, false, false, false, false, false, false) ;
    
  var varib
    conf : file of config ;
    mode : (fmode, pmode, amode) ;
    comsel, oldcom : string ;
    acc : string[200] ;
    setfile : text ;
    setflag : boolean ;
    crtflag : byte ;
    retval : ret_type ;
    errval : byte ;
    crashu : boolean ;
    nolist : boolean ;
    portname : string[32] ;
    doclear : boolean ;
    crtpt : ^config entry ;
    ticrate, sdate, stime, prevsec : longhex ;
    sday, err : integer ;
    echopath : integer entry ;
    inpt : ^tdesc ;
    
{$I/dd/defs/os9traps}

{ IMPORT FROM XTDB6 }
  procedure catch ; external ;
  procedure throw ; external ;
  
{ IMPORT FROM XTDB1 }
  procedure parse (var cml, token : string) ; external ;
  procedure as_dis ; external ;
  
{ IMPORT FROM XTDB2 }
  procedure init_asm ; external ;
  procedure abreak_hand ; external ;
  procedure aproc_trace ; external ;
  procedure aset_break ; external ;
  procedure block_move ; external ;
  procedure calc ; external ;
  procedure change_reg ; external ;
  procedure dump_mem ; external ;
  procedure find ; external ;
  procedure init_mem ; external ;
  procedure mem_mod (rd : boolean) ; external ;
  procedure set_offset ; external ;
  procedure aproc_temp ; external ;
  procedure arem_break ; external ;
  procedure astat ; external ;
  procedure update_breaks ; external ;

{ IMPORT FROM XTDB3 }
  procedure link_modules ; external ;
  procedure f_status (fromp : boolean) ; external ;
  function close_filer : boolean ; external ;
  procedure check_var ; external ;
  procedure check_param ; external ;
  procedure set_vector (def : boolean) ; external ;
  procedure load_icode ; external ;
  procedure load_relo ; external ;
  
{ IMPORT FROM XTDB4 }  
  procedure pset_break ; external ;
  procedure go ; external ;
  procedure number ; external ;
  procedure pproc_trace ; external ;
  procedure pproc_temp ; external ;
  procedure prem_break ; external ;
  procedure pstat ; external ;
  procedure trace_state ; external ;
  procedure trace_proc ; external ;
  procedure pbreak_hand ; external ;
  procedure ptrace_hand ; external ;
  function lineof (p : hex ; val : boolean) : string[30] ; external ;
  procedure list ; external ;
  procedure irqset (on : boolean) ; external ;
  procedure fileset ; external ;
    
{ IMPORT FROM XTDB5 }
  procedure change_var ; external ;
  procedure disp_var (struct : boolean) ; external ;

{ IMPORT FROM LINKCODE }
  procedure encode (var source : comrec ; 
                    var destination : string[120]) ; external ; 
  function decode (var source : string[120] ; 
                   var destination : comrec) : boolean ; external ;

  function getline : string ; entry ;
    var
      s : string ;
    begin
      if maccnt <> 0
        then
          begin
            s := maccur^ ;
            maccur := maccur + longhex(s[0] + 1) ;
            if s = '#'
              then
                begin
                  maccnt := maccnt - 1 ;
                  maccur := macpnt ;
                  if maccnt <> 0
                    then
                      begin
                        s := maccur^ ;
                        maccur := maccur + longhex(s[0] + 1) ;
                        writeln (comstr)
                      end
                end
              else
                writeln (s)
          end ;
      if maccnt = 0
        then
          readln (s) ;
      getline := s
    end ;
    
  procedure putrecord (var cr : comrec) ; entry ;
    var
      s : string[200] ;
    begin
      linkcnt := linkcnt + 1 ;
      encode (cr, s) ;
      writeln (comlink, s) ;
      wait := (cr.com = 'P') or (cr.com = 'Q')
    end ;

  procedure get_ack ; forward ;

  function getrecord (var cr : comrec) : boolean ; entry ;
    var
      s : string[200] ;
      cnt : longhex ;
      i, breakflag : integer ;
      timer, err : integer ;
      ch : char ;
    begin
      breakflag := 0 ;
      timer := 0 ;
      err := f_time (ticrate, sday, sdate, prevsec, 0) ;
      repeat
        if not wait
          then
            begin
              err := f_time (ticrate, sday, sdate, stime, 0) ;
              if stime and $ff <> prevsec and $ff
                then
                  begin
                    prevsec := stime ;
                    timer := timer + 1 ;
                    if timer > link_dly
                      then
                        return (false)
                  end
            end ;
        cnt := gs_ready (compath) ;
        if cnt <> 0
          then
            begin
              err := i_read (addr(acc[acc[0]+1]), cnt, compath) ;
              acc[0] := acc[0] + byte(cnt) ;
              if err <> 0
                then
                  begin
                    writeln ('TARGET/HOST I/O LINK ERROR=',err:0) ;
                    acc := '' ;
                    if not wait
                      then
                        return (false)
                  end
            end ;
        i := index(acc, #$d) ;
        if i <> 0
          then
            begin
              linkcnt := linkcnt + 1 ;
              s := substr(acc, 1, i - 1) ;
              acc := substr(acc, i + 1, 200 - i) ;
              timer := 0 ;
              if decode (s, cr)
                then
                  begin
                    if not wait
                      then
                        return (false) {bad}
                  end
                else
                  begin
                    case cr.com of
                      'S' :
                        begin
                          retval := cr.s_retval ;
                          errval := cr.s_errval ;
                          plast := cr.s_plast ;
                          abrkval := cr.s_aval ;
                          ltrcnt := cr.s_ltrcnt ;
                          ptrcnt := cr.s_ptrcnt ;
                          putrecord (crzap) ;
                          while gs_ready(compath) <> 0 do
                            begin
                              cnt := 1 ;
                              err := i_read(addr(ch), cnt, compath)
                            end ;
                          regs.s := 0 ;
                          throw
                        end ;
                      'Z' :
                        begin
                          writeln ('Link failure, Zap received') ;
                          retval := none ;
                          return (true)
                        end ;
                      '1' :
                        if wait
                          then
                            if cr.one_txt
                              then
                                begin
                                  if inname <> ''
                                    then
                                      begin
                                        inpt^.mode := inpt^.mode or 4 ;
                                        if eof(infile)
                                          then
                                            begin
                                              close (infile) ;
                                              writeln ('Input file empty, further input comes from keyboard') ;
                                              inname := ''
                                            end
                                          else
                                            readln (infile, s)
                                      end ;
                                  if inname = ''
                                    then
                                      readln (s) ;
                                  repeat
                                    cr1.com := '2' ;
                                    cr1.two_str := substr(s, 1, 64) ;
                                    s := substr(s, 65, 135) ;
                                    cr1.lth := cr1.two_str[0] + 4 ;
                                    cr1.two_done := s = '' ;
                                    putrecord (cr1) ;
                                    wait := true
                                  until s = ''
                                end
                              else
                                begin
                                  if inname <> ''
                                    then
                                      begin
                                        inpt^.mode := inpt^.mode and $fb ;
                                        if eof(infile)
                                          then
                                            begin
                                              close (infile) ;
                                              writeln ('Input file empty, further input comes from keyboard') ;
                                              inname := ''
                                            end
                                          else
                                            read (infile, cr1.two_char)
                                      end ;
                                  if inname = ''
                                    then
                                      read (keyboard, cr1.two_char) ;
                                  cr1.lth := 2 ;
                                  cr1.com := '2' ;
                                  putrecord (cr1) ;
                                  wait := true
                                end
                          else
                            write (comlink, #3) ;
                      '3' :
                        begin
                          if cr.three_str <> ''
                            then
                              if outname <> ''
                                then
                                  write (outfile, cr.three_str)
                                else
                                  write (cr.three_str) ;
                          if cr.three_ln
                            then
                              if outname <> ''
                                then
                                  writeln (outfile)
                                else
                                  writeln
                        end
                      else if not wait
                        then
                          return (true)
                    end
                  end
            end ;
        if wait
          then
            begin
              if break
                then
                  case breakflag of
                    0 .. 2 : 
                      begin
                        write (comlink, #3) ;
                        breakflag := breakflag + 1
                      end ;
                    else
                      begin
                        retval := comab ;
                        throw
                      end
                  end  ;
            end 
        else if break
          then
            begin
              retval := comab ;
              throw
            end
      until false ;
    end ;

  procedure getanswer (expect : char) ;
    var
      oldwait : boolean ;
    begin
      linkerr := 0 ;
      repeat
        if getrecord (cr2)
          then
            if cr2.com = expect
              then
                exit
              else
                if cr2.com = 'T'
                  then
                    begin
                      linkerr := linkerr + 1 ;
                      if linkerr > link_retry
                        then
                          begin
                            writeln ('Link failure, excessive rejects') ;
                            throw
                          end
                        else
                          putrecord(cr3)
                    end
                  else
                    begin
                      putrecord (crzap) ;
                      linkerr := linkerr + 1 ;
                      repeat
                      until not getrecord(cr2) ; {purge incoming records}
                      if linkerr > link_retry
                        then
                          begin
                            writeln ('Link failure, expecting ',expect,' received ',cr2.com) ;
                            throw
                          end ;
                      putrecord(cr3)
                    end
          else
            begin
              linkerr := linkerr + 1 ;
              if linkerr > link_retry
                then
                  begin
                    writeln ('Link failure, excessive checksum or timeout errors') ;
                    throw
                  end
                else
                  begin
                    oldwait := wait ;
                    putrecord(crreject) ;
                    wait := oldwait
                  end
            end
      until false ;
      totalerr := totalerr + linkerr
    end ;
    
  procedure response (expect : char) ; entry ;
    begin
      cr3 := cr1 ;
      putrecord (cr3) ;
      getanswer (expect) ;
      putrecord (crack)
    end ;
  
  procedure get_ack ; entry ;
    begin
      cr3 := cr1 ;
      putrecord (cr3) ;
      getanswer ('A')
    end ;

  function sufadd (fname : string ; suf : string[2]) : string ;
    var
      x : integer ;
    begin
      for x := length(fname) downto 0 do
        if (fname[x] = '/') or (x = 0)
          then
            begin
              if index (substr(fname,x + 1, 32),'.') = 0
                then
                  sufadd := concat(fname,'.',suf)
                else
                  sufadd := fname ;
              exit
            end
    end ;
    
  procedure open_icode (var fi : file of byte ; var fname : string) ; entry ;
    begin
      {$i+}
      fname := sufadd (fname, 'db') ;
      reset (fi, fname) ;
      {$i-}
    end ;
    
  procedure open_relo (var fr : file of byte ; var fname : string) ; entry ;
    begin
      {$i+}
      fname := sufadd (fname, 'r') ;
      reset (fr, fname) ;
      {$i-}
    end ;
    
  procedure setsuffix (var fname : string) ; entry ;
    begin
      fname := sufadd (fname, 'p')
    end ;

  procedure error (err : string) ; entry ;
    begin
      noecho := true ;
      crt_xy (0,depth) ;
      noecho := false ;
      writeln ;
      writeln (err) ;
      maccnt := 0 ;
      setflag := false ;
      throw
    end ;
    
  procedure ahelp ;
    begin
      writeln ('ASSEMBLY DEBUG MODE MENU') ;
      writeln ('As from             assemble, disassemble at from') ;
      writeln ('Br {loc[;mac]}      breakpoint at loc, execute macro = mac') ;
      writeln ('BM from to dest     block move from-to to dest') ;
      writeln ('CA expression       calculate value') ;
      writeln ('Ch register         change register') ;
      writeln ('Du from [to]        display memory (dump)') ;
      writeln ('Fi from to pattern  find pattern') ;
      writeln ('He                  help') ;
      writeln ('In from to value    initialize memory from-to to value') ;
      writeln ('L [line]            list source code') ;
      writeln ('Mm loc              memory display and change') ;
      writeln ('MS loc              memory set') ;
      writeln ('Of loc              set code offset') ;
      writeln ('PA                  change to pascal debug mode') ;
      writeln ('Pt [loc]            proceed to temporary breakpoint') ;
      writeln ('Qu                  quit debugger') ;
      writeln ('Re {loc}            remove breakpoints') ;
      writeln ('St                  status - register display') ;
      writeln ('$command line       operating system command') ;
    end ;
    
  procedure phelp ;
    begin
      writeln ('PASCAL DEBUG MODE MENU') ;
      writeln ('As                  change to assembly debug mode') ;
      writeln ('Br {line[/cnt][;mac]}') ;
      writeln ('   set breakpoint, counter = cnt, execute macro = mac') ;
      writeln ('Ch variable         change variable') ;
      writeln ('Di variable         display variable') ;
      writeln ('DS variable         display variable as structure') ;
      writeln ('Ec [path]           set echo path') ;
      writeln ('Fi [<path] [>path]  files for target input/output') ;
      writeln ('Go [line]           go from start, temporary breakpoint') ;
      writeln ('He                  help') ;
      if not linkirq
        then
          writeln ('I[+|-]          IRQ enable/disable') ;
      writeln ('L[+|-| line]        list source code') ;
      writeln ('MD N                define macro N') ;
      writeln ('Me N [cnt]          execute macro N cnt times') ;
      writeln ('Nu name             display procedure line numbers') ;
      writeln ('PR [cnt]            proceed, trace cnt statements') ;
      writeln ('Pt [line]           procced to temporary breakpoint') ;
      writeln ('Qu                  quit debugger') ;
      writeln ('Re {line}           remove breakpoints') ;
      writeln ('St [M][R][S]        status, optional module, register, and symbol dump') ;
      writeln ('SV                  set vectors into target') ;
      writeln ('T[+|-]              line trace storage enable/disable') ;
      writeln ('TS [nn]             display last nn statements executed') ;
      writeln ('TP [nn]             display last nn procedures executed') ;
      writeln ('$command line       operating system command') ;
    end ;
    
  procedure fhelp ;
    begin
      writeln ('FILE MODE MENU') ;
      writeln ('As {file name}      load assembly language .ro files') ;
      writeln ('Ch                  check inter-module references') ;
      writeln ('Ec [path]           set echo path') ;
      writeln ('He                  help') ;
      writeln ('Ic {file name}      load icode files') ;
      writeln ('Li                  link modules') ;
      writeln ('Pa                  change to pascal debug mode') ;
      writeln ('St [M][S]           status, optional module and symbol dump') ;
      writeln ('SV n name           set vector number n') ;
      writeln ('Qu                  quit debugger') ;
      writeln ('$command line       operating system command') ;
    end ;
    
  procedure comopt ;
    begin
      writeln ('Command line error, format is :') ;
      writeln ('xtdb [-opt] [command file]') ;
      writeln ('Valid options are :') ;
      writeln ('n         - set terminal number (first option only)') ;
      writeln ('Tn        - set terminal number') ;
      writeln ('Dn        - set data size in K') ;
      writeln ('En        - set external table size in K') ;
      writeln ('I         - enable initialize target RAM option') ;
      writeln ('Mn        - set macro buffer size in K') ;
      writeln ('Zn        - set total size in K') ;
      writeln ('P[=]"port"- set port name') ;
      halt (22)
    end ;

  procedure set_options ;
    var
      temp1, offset : byte register ;
      temp2 : integer register ;
      copt : string[120] ;
      tnum, errcnt, delay : integer ;
      dbt_size, ext_size, dat_size, bufsize, mac_size : longhex ;
      err, i, j, k : integer ;
      cnt : longhex ;
      ch : char ;
    begin
      for temp1 := 0 to 20 do
        macs[temp1] := nil ;
      repeat
        if memavail < $2000
          then
            begin
              writeln ('Insufficient memory') ;
              halt (22)
            end ;
        offset := 2 ;
        ext_size := memavail >> 5 ;
        dat_size := 512 ;
        mac_size := 1024 ;
        tnum := -1 ;
        portname := portdef ;
        doclear := false ;
        copt := cline(1) ;
        acc := '' ;
        if copt = ''
          then
            exit ;
        if copt[1] = '-'
          then
            begin
              i := 2 ;
              while i <= length(copt) do
                begin
                  case upshift(copt[i]) of
                    '0' .. '3' : tnum := ord(copt[i] - '0') ;
                    'I' : doclear := true ;
                    'D','E','T','M','Z' :
                      begin
                        repeat
                          temp1 := upshift(copt[i]) ;
                          temp2 := 0 ;
                          i := i + 1 ;
                          while i <= length(copt) do
                            if copt[i] in ['0' .. '9']
                              then
                                begin
                                  temp2 := temp2 * 10 + 
                                        ord(copt[i] - '0') ;
                                  i := i + 1
                                end
                              else
                                exit
                        until true ;
                        i := i - 1 ;
                        case temp1 of
                          'D' : dat_size := longhex(temp2) * $400 ;
                          'E' : ext_size := longhex(temp2) * $400 ;
                          'M' : mac_size := longhex(temp2) * $400 ;
                          'T' :
                            begin
                              tnum := temp2 ;
                              if not (tnum in [0 .. 3])
                                then
                                  comopt
                            end
                        end
                      end ;
                    'P' : 
                      begin
                        repeat
                          i := i + 1 ;
                          if i >= length(copt)
                            then
                              comopt
                        until copt[i] = '"' ;
                        portname := '' ;
                        i := i + 1 ;
                        while copt[i] <> '"' do
                          begin
                            if i >= length(copt)
                              then
                                comopt ;
                            append (portname, copt[i]) ;
                            i := i + 1
                          end
                      end
                    else
                      comopt
                  end ;
                  i := i + 1
                end
            end
          else
            offset := 1
      until true ;
      setflag := false ;
      err := crt_open (tnum, width, depth, crtpt) ;
      if err <> 0
        then
          begin
            writeln ('There is no information for your terminal') ;
            halt (22)
          end ;
      adlines := [] ;
      adall := [] ;
{
    find out which entries are valid for keyboard inputs
}
      for j := 0 to 59 do
        with crtpt^.kcodes[j] do
          begin
            if kcode in [kquit,kesc,kbs,kup,kdown,kcr,krep,khup,khdown]
              then
                adall := adall + [j] ;
            if kcode in [kesc,kbs,kcr,kldel]
              then
                adlines := adlines + [j]
          end ;
      maxchar := chr (width) ;
{
    open command file if present
}
      if cline(offset) <> ''
        then
          begin
            reset (setfile, upshift(cline(offset))) ;
            setflag := true
          end ;
      writeln ('OmegaSoft 6809 Cross Target Debugger version 3A00') ;
      writeln ('Copyright 1987, 1989 Certified Software Corporation') ;
{
    initialize path to target
}
      {$i+}
      open (comlink, portname, update) ;
      write (comlink, #$11) ;
      compath := get_path (addr(comlink)) ;
      while gs_ready(compath) <> 0 do
        begin
          cnt := 1 ;
          err := i_read (addr(ch), cnt, compath) ; {purge input buffer}
        end ;
      crack.lth := 1 ;
      crack.com := 'A' ;
      crreject.lth := 1 ;
      crreject.com := 'T' ;
      crzap.lth := 1 ;
      crzap.com := 'Z' ;
      putrecord (crzap) ;
      totalerr := 0 ;
      linkcnt := 0 ;
      linkerr := 0 ;
      {$i-}
      errcnt := 3 ;
      writeln ('Atempting communication through ',portname) ;
      catch ;
      errcnt := errcnt - 1 ;
      if errcnt = 0
        then
          begin
            writeln ('Communication not established through ',portname) ;
            halt (22)
          end ;
      cr1 := crack ;
      get_ack ;
      cr1.lth := 1 ;
      cr1.com := 'N' ;
      response ('H') ;
      t_ramstart := cr2.gh_regs[0] ;
      t_ramend := cr2.gh_regs[1] ;
      t_jmphigh := cr2.gh_regs[2] ;
      t_jmplow := cr2.gh_regs[3] ;
      t_regbase := cr2.gh_regs[4] ;
      t_output := cr2.gh_regs[5] ;
      t_input := cr2.gh_regs[6] ;
      t_keyboard := cr2.gh_regs[7] ;
      t_auxstrt := cr2.gh_regs[8] ;
      t_auxend := cr2.gh_regs[9] ;
      t_globsave := cr2.gh_regs[10] ;
      writeln ('Communication established through ',portname) ;
      writeln ('Ram in target from ',t_ramstart:4,' to ',t_ramend:4) ;
      if t_auxstrt <> t_auxend
        then
          begin
            writeln ('External Ram from ',t_auxstrt:4,' to ',t_auxend:4) ;
            t_ramstart := t_auxstrt ;
            t_ramend := t_auxend
          end ;
      if doclear
        then
          begin
            writeln ('Clearing target RAM') ;
            cr1.lth := 1 ;
            cr1.com := '0' ;
            get_ack
          end ;
{
  setup buffers
}
      dat_size := align(dat_size) ;
      ext_size := align(ext_size) ;
      if dat_size > $7ff0
        then
          dat_size := $7ff0 ; {32k max}
      if dat_size < $100
        then
          dat_size := $100 ;
      if ext_size < $100
        then
          ext_size := $100 ;
      new (mbuf_start : mac_size) ;
      mbuf_cur := mbuf_start ;
      mbuf_end := mbuf_start + mac_size ;
      bufsize := align(memavail - $1000) ;
      new (dbt_start : bufsize) ;
      dbt_cur := dbt_start ;
      dbt_last := nil ;
      var_max := $7FF0 ;
      var_loc := varstart ;
      esd_limit := dbt_start + bufsize ;
      esd_start := esd_limit ;
      ext_start := esd_start - ext_size ;
      ext_cur := ext_start ;
      int_start := ext_start - $400 ;
      int_cur := int_start ;
      int_end := int_start + $3FF ;
      dbt_end := int_start ;
      dat_base := datstart + t_ramstart + (t_jmphigh - t_jmplow) + 4 ;
      dat_loc := dat_base ;
      dat_max := hex(dat_size) + dat_base ;
      cur_adr := dat_max + 4 ;
      code_start := cur_adr ;
      code_limit := t_ramend - 100 ;
      for i := 0 to 17 do
        pbreak[i].brkloc := 0 ;
      if code_limit <= code_start
        then
          begin
            writeln ('No code area in target') ;
            halt (22)
          end ;
      loadblk[false].blkptr := nil ;
      loadblk[false].lastused := false ;
      loadblk[true].blkptr :=nil ;
      loadblk[true].lastused := false ;
      inname := '' ;
      outname := '' ;
      inpt := addr(infile) ;
    end ;

  procedure def_mac ;
    var
      ctemp : string ;
      num : byte register ;
      mp : ^macline ;
    begin
      parse (comstr, ctemp) ;
      {$c-}
      num := byte(hex(ctemp)) ;
      if conversion or (num > 20) or (num < 1)
        then
          error ('Macro number out of range') ;
      writeln ('Enter commands, terminate with #') ;
      mp := mbuf_cur ;
      repeat
        write ('[M] ') ;
        readln (comstr) ;
        if mp + longhex(comstr[0] + 1) >= mbuf_end
          then
            error ('Macro buffer overflow') ;
        mp^ := comstr ;
        mp := mp + longhex(comstr[0] + 1)
      until comstr = '#' ;
      macs[num] := mbuf_cur ;
      mbuf_cur := mp
    end ;
    
  procedure exec_mac ;
    var
      ctemp : string ;
      num : byte register ;
      cnt : integer register ;
    begin
      {$c-}
      parse (comstr, ctemp) ;
      num := byte(hex(ctemp)) ;
      if conversion or (num > 20) or (num < 1)
        then
          error ('Macro number out of range') ;
      parse (comstr, ctemp) ;
      if ctemp = ''
        then
          cnt := 1
        else
          begin
            cnt := integer(ctemp) ;
            if conversion or (cnt < 1)
              then
                error ('Invalid count')
          end ;
      if macs[num] = nil
        then
          error ('Macro not defined') ;
      maccnt := cnt ;
      macpnt := macs[num] ;
      maccur := macpnt
    end ;
    
  procedure opsys ;
    var
      k, type_id, err, cerr : integer ;
      i : integer register ;
      modname : string[32] ;
    begin
      if comsel[0] > 1
        then
          comstr := concat(substr(comsel,2,80),' ',comstr) ;
      if upshift(substr(comstr, 1, 3)) = 'CHD'
        then
          begin
            for k := 4 to length(comstr) do
              if comstr[k] <> ' '
                then
                  exit ;
            err := i_chgdir (substr(comstr,k, 80), 3) ;
            if err <> 0
              then
                f_perr (err, 0)
          end
        else
          begin
            type_id := 0 ;
            modname := 'shell' ;
            for i := 101 to 127 do
              if cline(i) = ''
                then
                  exit
              else if substr(cline(i),1,6) = 'SHELL='
                then
                  begin
                    modname := substr(cline(i),7,32) ;
                    exit
                  end ;
            err := os9exec (comstr, cline(0), modname, 0, 3, 0, type_id) ;
            if err <> 0
              then
                f_perr (err, 0)
              else
                begin
                  err := f_wait (cerr, type_id) ;
                  if err <> 0
                    then
                      f_perr (err, 0)
                  else if cerr <> 0
                    then
                      f_perr (cerr,0)
                    else
                      writeln
                end
          end
    end ;

  procedure checklist ;
    begin
      if autolist and (mode = pmode) and not nolist
        then
          begin
            comstr := '' ;
            list
          end ;
      nolist := false
    end ;
    
  procedure buserror ; entry ;
    begin
      retval := hosterr ;
      errval := 102 ;
      throw
    end ;
    
  procedure addrerror ; entry ;
    begin
      retval := hosterr ;
      errval := 103 ;
      throw
    end ;

  procedure echo ;
    var
      s : string ;
      err : integer ;
      echofile : text varib ;
    begin
      close (echofile) ;
      echopath := 0 ;
      if comstr = ''
        then
          writeln ('Echo off')
        else
          begin
            rewrite (echofile, comstr) ;
            err := ord(deverr(echofile)) ;
            if err <> 0
              then
                writeln ('Error number ',err:0,' opening ',comstr)
              else
                begin
                  writeln ('Echo on') ;
                  echopath := get_path(addr(echofile))
                end
          end
    end ;
    
{
  main program
}
  begin { db }
    echopath := 0 ;
    noecho := false ;
    autolist := false ;
    set_options ;
    init_asm ;
    cur_mod := 0 ;
    brk_mod := 0 ;
    mod_tab[0].name := 'Define' ;
    retval := none ;
    offset := 0 ;
    comline := '' ;
    mode := fmode ;
    procval := false ;
    ltren := false ;
    maxvec := 0 ;
    oldcom[0] := 0 ;
    maccnt := 0 ;
    progstart := 0 ;
    dcaddr := 0 ;
    catch ;
    regs.s := 0 ; {regs not valid}
    case retval of
      none : ;
      asbrk : 
        begin
          mode := amode ;
          retval := none ;
          dummy := lineof(plast,true) ;
          abreak_hand ;
          update_breaks
        end ;
      pabrk :
        begin
          mode := pmode ;
          retval := none ;
          pbreak_hand ;
          update_breaks
        end ;
      ptrace :
        begin
          mode :=pmode ;
          retval := none ;
          ptrace_hand ;
          update_breaks
        end ;
      progend : 
        begin
          mode := pmode ;
          procval := false ;
          brk_mod := 0 ;
          retval := none ;
          maccnt := 0 ;
          writeln ;
          writeln ('NORMAL PASCAL PROGRAM TERMINATION')
        end ;
      comab :
        begin
          mode := pmode ;
          retval := none ;
          procval := false ;
          maccnt := 0 ;
          putrecord (crzap) ;
          writeln ;
          writeln ('Communications aborted') ;
        end ;
      rerr :
        begin
          update_breaks ;
          mode := pmode ;
          retval := none ;
          if not (errval in [25,26])
            then
              procval := false ;
          maccnt := 0 ;
          writeln ;
          case errval of
             4 : write ('Overflow') ;
             5 : write ('Truncation error') ;
             6 : write ('Divide by zero') ;
             7 : write ('Invalid Sqrt or log argument') ;
             8 : write ('Dynamic length assign error') ;
             9 : write ('Invalid array index') ;
            10 : write ('Invalid string index') ;
            11 : write ('Subrange error') ;
            12 : write ('Set element out of range') ;
            13 : write ('Integer conversion error') ;
            14 : write ('Hex conversion error') ;
            15 : write ('Real conversion error') ;
            16 : write ('Boolean conversion error') ;
            17 : write ('Device open/closed incorrect') ;
            18 : write ('Device hit EOF') ;
            19 : write ('Heap overflow') ;
            20 : write ('Data Stack overflow') ;
            21 : write ('System Stack overflow') ;
            22 : write ('Incorrect program operation') ;
            23 : write ('Other exception') ;
            24 : write ('Non-existant floating point routine called') ;
            25 : write ('Recoverable operator abort') ;
            27 : write ('Non-recoverable operator abort - reset target') ;
            28 : write ('Non-existant tasking routine called') ;
            30 : write ('Invalid Task ID') ;
            31 : write ('Invalid Task Priority') ;
            32 : write ('Not currently tasking') ;
            33 : write ('Tasking Initialization error') ;
            34 : write ('Zero Await Count') ;
            35 : write ('Task system stack overflow') ;
            36 : write ('Task data stack overflow') ;
            40 : write ('SWI3 encountered') ;
            41 : write ('SWI2 encountered') ;
            42 : write ('Unitialized FIRQ encountered') ;
            43 : write ('Unitialized IRQ encountered') ;
            44 : write ('Unitialized NMI encountered') ;
            45 : write ('Illegal instruction') ;
            else write ('system error')
          end ;
          writeln (' at line number ',lineof(plast,true))
        end ;
      syserr :
        begin
          writeln ;
          case errval of
            102 : write ('Bus error') ;
            103 : write ('Address error') ;
          end ;
          writeln (' in target debugger')
        end ;
      hosterr :
        begin
          writeln ;
          case errval of
            102 : write ('Bus error') ;
            103 : write ('Address error') ;
          end ;
          writeln (' in debugger (host)')
        end ;
    end ;
    repeat
      checklist ;
      noecho := true ;
      crt_clrline (depth) ;
      noecho := false ;
      case mode of
        fmode : write ('[F] ') ;
        amode : write ('[A] ') ;
        pmode : write ('[P] ')
      end ;
      if break
        then
          setflag := false ;
      if setflag
        then
          begin
            repeat
              if eof(setfile)
                then
                  begin
                    setflag := false ;
                    close (setfile) ;
                    exit
                  end
                else
                  begin
                    readln (setfile, comstr) ;
                    if upshift(substr(comstr,1,4)) = '*DB:'
                      then
                        comstr := substr(comstr, 5, 80)
                  end
            until (comstr[0] > 0) and (comstr[1] <> '*') ;
            if setflag
              then
                writeln (comstr)
          end ;
      if not setflag
        then
          comstr := getline ;
      if comstr[0] = 0
        then
          comstr := oldcom ;
      if maccnt = 0
        then
          oldcom := comstr ;
      parse (comstr, comsel) ;
      comsel := upshift(comsel) ;
      if comsel[0] = 0
        then
          comsel := ' ' ;
      if comsel[0] = 1
        then
          comsel := concat(comsel,' ') ;
      case mode of
        fmode :
          case comsel[1] of
            'P' : 
              if close_filer
                then
                  mode := pmode ;
            'Q' : exit ;
            'L' : link_modules ;
            'A' : load_relo ;
            'I' : load_icode ;
            'C' : 
              begin
                check_var ;
                check_param
              end ;
            'E' : echo ;
            'S' : 
              if comsel[2] = 'V'
                then
                  set_vector (true)
                else
                  f_status (false) ;
            '~' : mode := amode ;
            '$' : opsys ;
            ' ' :
            else
              fhelp
          end ;
        amode :
          case comsel[1] of
            'A' : as_dis ;
            'B' :
              if comsel[2] = 'M'
                then
                  block_move
                else
                  aset_break ;
            'C' :
              if comsel[2] = 'A'
                then
                  calc
                else
                  change_reg ;
            'D' : dump_mem ;
            'F' : find ;
            'I' : init_mem ;
            'L' : list ;
            'M' : mem_mod (comsel[2] <> 'S') ;
            'O' : set_offset ;
            '$' : opsys ;
            'P' :
              if comsel[2] = 'A'
                then
                  mode := pmode
                else
                  aproc_temp ;
            'Q' : exit ;
            'R' : arem_break ;
            'S' : 
              begin
                writeln ;
                astat
              end ;
            ' ' :
            else
              ahelp
          end ;
        pmode :
          case comsel[1] of
            'A' : mode := amode ;
            'B' : pset_break ;
            'C' : change_var ;
            'D' : disp_var (comsel[2] = 'S') ;
            'E' : echo ;
            'F' : fileset ;
            'G' : 
              begin
                setflag := false ;
                go
              end ;
            'H' : phelp ;
            'L' :
              case comsel[2] of
                '+' : autolist := true ;
                '-' : autolist := false
                else
                  begin
                    list ;
                    nolist := true
                  end
              end ;
            'I' : 
              if linkirq
                then
                  phelp
                else
                  irqset (comsel[2] = '+') ;
            'M' :
              if comsel[2] = 'D'
                then
                  def_mac
                else
                  exec_mac ;
            'N' : number ;
            '$' : opsys ;
            'P' :
              if comsel[2] = 'R'
                then
                  pproc_trace
                else
                  pproc_temp ;
            'Q' : exit ;
            'R' : prem_break ;
            'S' : 
              if comsel[2] = 'V'
                then
                  set_vector (false)
                else
                  pstat ;
            'T' :
              case comsel[2] of
                '+' : ltren := true ;
                '-' : ltren := false ;
                'S' : trace_state ;
                'P' : trace_proc
                else
                  phelp
              end ;
            ' ' :
            else
              phelp
          end
      end
    until false ;
    if echopath <> 0
      then
        begin
          comstr := '' ;
          echo
        end ;
    crt_clrscr ;
    crt_close ;
    {$i-}
    close (infile) ;
    close (outfile)
  end.
