module xtdb1 {$v3,0 low level support} (output,keyboard,{$b+}input{$b-}) ;
{
  7/22/89 : initial conversion to level 3
}
{$I/dd/defs/crtdrive}
{$Itdbincl}

  type
    disparam = record
                  off : hex ;
                  dcaddr : hex ;
                  dbparm : longhex ;
                  offsup, objsup, tabsup : boolean
               end ;
    stab_t = array [0 .. 3] of record
                                 grp : array [0 .. 3] of char ;
                                 off : hex
                               end ;
                                
  var varib
    disloc : hex ;
    dislocs : array[0 .. lastline+1] of hex ;
    disp : disparam ;
    crtpt : ^config external ;
  const
    stab = external stab_t ;
    db_brk = external hex ;
    db_ps = external hex ;
    db_pe = external hex ;
    
{ TRAP HANDLER ENTRY POINTS }
  procedure asm (var in_line : string ; var newloc : hex ; 
                 var err : boolean ; buffer : longhex) ; trap 10 0 ;
  procedure dis (var result : string[120] ; var dloc : hex ;
                 var dispar : disparam ; buffer : longhex) ; trap 10 1 ;

{ IMPORT FROM XTDB }
  procedure error (err : string) ; external ;
  procedure response (expect : char) ; external ;
  procedure get_ack ; external ;

{ IMPORT FROM XTDB4 }
  function lineadr (spec : string) : hex ; external ;
    
  procedure topos (x, y : integer) ; entry ;
    begin
      crt_xy (x, y - topline)
    end ;
    
  procedure toclear (line : integer) ; entry ;
    begin
      crt_clrline (line - topline)
    end ;

  procedure outline (l : integer) ;
    var
      outstring : string[120] ;
      dbpar : record
                stabpt : ^stab_t ;
                db_brk, db_ps, db_pe, t_ramstart : hex
              end ;
    begin
      toclear (l) ;
      disloc := dislocs[l] ;
      cr1.lth := 4 ;
      cr1.com := 'D' ;
      cr1.d_adr := disloc ;
      cr1.d_cnt := 32 ;
      response ('C') ;
      with disp do
        begin
          off := offset ;
          offsup := false ;
          objsup := false ;
          tabsup := false ;
          dbparm := addr(dbpar) ;
          dbpar.stabpt := addr(stab) ;
          dbpar.db_brk := db_brk ;
          dbpar.db_ps := db_ps ;
          dbpar.db_pe := db_pe ;
          dbpar.t_ramstart := t_ramstart
        end ;
      dis (outstring, disloc, disp, addr(cr2.c_dat)) ;
      write (outstring) ;
      dislocs[l + 1] := disloc
    end ;
    
  procedure scrolldown ; entry ;
    begin
      writeln ;
      topline := succ(topline) ;
      outline (topline+depth)
    end ;
    
  procedure scrollup ; entry ;
    var
      i : integer register ;
    begin
      if crtpt^.dcodes[dup] <> ''
        then
          begin
            topline := pred(topline) ;
            crt_xy (0,0) ;
            crt_codes (dup) ;
            outline(topline)
          end
        else
          begin
            topline := topline - depth >> 1 ;
            if topline < 1
              then
                topline := 1 ;
            crt_clrscr ;
            for i := topline to topline + depth do
              outline (i)
          end
    end ;
    
  procedure movedown ; entry ;
    var
      i : integer register ;
    begin
      if curline < lastline
        then
          begin
            curline := succ(curline) ;
            if curline > topline + depth
              then
                scrolldown
          end
        else
          begin
            for i := 1 to lastline + 1 do
              dislocs[i - 1] := dislocs[i] ;
            if curline = topline + depth
              then
                begin
                  topline := pred(topline) ;
                  scrolldown
                end
          end ;
      topos (curx,curline)
    end ;
    
  procedure moveup ; entry ;
    begin
      if curline > 1
        then
          begin
            curline := pred (curline) ;
            if curline < topline
              then
                scrollup
          end  ;
      topos (curx,curline)
    end ;
    
  function getchar (var special : set of 0 .. 59) : char ; entry ;
    var
      y : byte register ;
      x : integer register ;
      tmp : char ;
      valid : set of 0 .. 59 ;
    begin
      repeat
        y := 1 ;
        valid := special ;
        read (keyboard, tmp) ; {get first character}
        repeat
          for x := 0 to 59 do
            if x in valid
              then
                with crtpt^.kcodes[x] do
                  if (kstr[0] >= y) and (upshift(kstr[y]) = upshift(tmp))
                    then
                      if kstr[0] = y
                        then
                          begin
                            tmp := byte(kcode) ;
                            y := 0 ;
                            exit (2)
                          end
                        else
                    else
                      valid := valid - [x] ;
          if valid = []
            then
              exit ;
          read (keyboard, tmp) ; {get next}
          y := y + 1
        until false
      until tmp > $1f ;
      getchar := tmp
    end ;
 
  procedure linein (max : byte; var special : set of 0 .. 59) ; entry ;
    var
      ch : char register ;
      x : byte register ;
 
    procedure killline ;
      var
        y : byte register ;
      begin
        for y := 1 to comstr[0] do
          crt_backup ;
        comstr[0] := 0
      end ;
 
    begin
      comstr := '' ;
      escaped := false ;
      repeat
        ch := getchar (special) ;
        case enum(ch) of
          kesc :
            begin
              escaped := true ;
              exit
            end ;
          kcr :
            exit ;
          kbs :
            if comstr[0] > 0
              then
                begin
                  comstr[0] := pred(comstr[0]) ;
                  crt_backup
                end ;
          kldel : killline ;
          enum(0) .. enum(cntrl) , enum($7f) .. enum($ff) : ;
          else
            if comstr[0] < max
              then
                begin
                  write (ch) ;
                  comstr := concat (comstr,ch)
                end ;
        end
      until false
    end ;

  procedure parse (var cml, token : string) ; entry ;
  {
    This procedure will return a valid modifier in 'token' extracted
    from 'cml'. Leading and trailing delimiters (Space or Comma
    characters) are ignored and removed from 'cml'.
  }
    var
      phase : (delim1,xfer,delim2,term) ;
      toke : char ;
      delim : boolean ;
    begin
      token := '' ;
      phase := delim1 ;
      while (cml[#0] > #0) and (phase <> term) do
        begin
          toke := cml [1] ;
          cml := substr (cml,2,250) ;
          delim := toke in [' ',','] ;
          case phase of
            delim1 :
              if not delim
                then
                  begin
                    phase := xfer ;
                    token := toke
                  end ;
            xfer :
              if delim
                then
                  phase := delim2
                else
                  token := concat (token, toke) ;
            delim2 :
              if not delim
                then
                  begin
                    phase := term ;
                    cml := concat (toke, cml)
                  end
          end
        end
    end ;
 
  function getlhex (var value : longhex) : boolean ; entry ;
    var
      ctemp : string [20] ;
    begin
      {$c- so can use conversion function}
      if length (comstr) > 0
        then
          begin
            parse (comstr, ctemp) ;
            value := longhex (ctemp) ;
            getlhex := conversion
          end
        else
          getlhex := true
    end ;

  function gethex (var value : hex) : boolean ; entry ;
    var
      ctemp : string [20] ;
    begin
      {$c- so can use conversion function}
      if length (comstr) > 0
        then
          begin
            parse (comstr, ctemp) ;
            value := hex (ctemp) ;
            gethex := conversion
          end
        else
          gethex := true
    end ;
    
  function getint (var value : integer) : boolean ; entry ;
    var
      ctemp : string [20] ;
    begin
      {$c- so can use conversion function}
      if length (comstr) > 0
        then
          begin
            parse (comstr, ctemp) ;
            value := integer (ctemp) ;
            getint := conversion
          end
        else
          getint := true
    end ;
    
  procedure insert ;
    var
      l : integer register ;
      i : byte register ;
      oldloc : hex ;
      globerror : boolean ;
      s : string [120] ;
    begin
      repeat
        s := '' ;
        for i := byte(curx) to maxchar - #1 do
          append (s, ' ') ;
        write (s) ;
        topos (curx, curline) ;
        linein (maxchar - #1 - byte(curx), adlines) ;
        disloc := dislocs[curline] ;
        oldloc := disloc ;
        asm (comstr, disloc, globerror, addr(cr1.b_dat)) ;
        cr1.com := 'B' ;
        cr1.b_adr := oldloc ;
        cr1.lth := byte(disloc-oldloc + 3) ;
        get_ack ;
        outline (curline) ;
        if escaped or (curline = lastline)
          then
            exit ;
        movedown
      until false ;
      for l := curline + 1 to topline + depth do
        outline (l) ;
      topos (curx, curline)
    end ;
    
  procedure asmdis (aloc : hex) ;
    begin
      noecho := true ;
      writeln ;
      curx := 28 ;
      disloc := aloc ;
      disp.dcaddr := $ffff ;
      topline := 1 - depth ;
      curline := 1 ;
      dislocs[curline] := disloc ;
      outline (curline) ;
      topos (curx,curline) ;
      repeat
        sel := getchar(adall) ;
        case sel of
          byte(kup) : moveup ;
          byte(kdown) : movedown ;
          byte(krep) : insert ;
          byte(kquit) : exit ;
          byte(khup) :
            for sel := #1 to byte(depth) >> #1 do
              moveup ;
          byte(khdown) :
            for sel := #1 to byte(depth) >> #1 do
              movedown
        end
      until false ;
      writeln ;
      noecho := false 
    end ;
    
  procedure as_dis ; entry ;
    var
      adr : hex ;
      i : integer register ;
      ctemp : string[20] ;
    begin
      if length(comstr) = 0
        then
          error ('Parameter required') ;
      parse (comstr, ctemp) ;
      if index(ctemp, '.') <> 0
        then
          begin
            adr := lineadr(ctemp) ;
            if adr = 0
              then
                error ('Invalid line number')
          end
        else
          begin
            adr := hex(ctemp) + offset ;
            if conversion
              then
                error ('Invalid address')
          end ;
      asmdis (adr)
    end ;
Modend.
