Module xtdb2 {$v3,0 assembly debugging} (output, keyboard, input) ;
{
  7/22/89 : initial conversion to level 3
}    
{$Itdbincl}
  type
    disparam = record
                  off : hex ;
                  dcaddr : hex ;
                  dbparm : longhex ;
                  offsup, objsup, tabsup : boolean
               end ;
    
{ IMPORT FROM XTDB }
  procedure error (err : string) ; external ;
  procedure response (expect : char) ; external ;
  procedure get_ack ; external ;
  function getline : string ; external ;
  
{ IMPORT FROM XTDB1 }
  function gethex (var value : hex) : boolean ; external ;
  function getlhex (var value : longhex) : boolean ; external ;
  function getint (var value : integer) : boolean ; external ;
  procedure parse (var cml, token : string) ; external ;
    
{ TRAP HANDLERS }
  procedure dis (var result : string[120] ; var dloc : hex ;
                 var dispar : disparam ; buffer : longhex) ; trap 10 1 ;
  
  procedure mem_mod (rd : boolean) ; entry ;
    var
      move : boolean register ;
    begin
      if gethex (from)
        then
          error ('error in address') ;
      repeat
        write (from:-5) ;
        if rd
          then
            begin
              cr1.lth := 4 ;
              cr1.com := 'D' ;
              cr1.d_adr := from ;
              cr1.d_cnt := 1 ;
              response ('C') ;
              write (hex(cr2.c_dat[0]) << 8:2,' ')
            end ;
        comstr := getline ;
        if comstr = '/'
          then
            exit ;
        if comstr = '^'
          then
            from := from - 1
          else
            begin
              move := true ;
              if comstr <> ''
                then
                  begin
                    if comstr[1] = '.'
                      then
                        begin
                          move := false ;
                          comstr := substr(comstr,2,20)
                        end ;
                    if comstr <> ''
                      then
                        begin
                          if (comstr [1] = '''') or (comstr [1] = '"')
                            then
                              begin
                                if length (comstr) > 1
                                  then
                                    contents := hex(comstr[2])
                                  else
                                    contents := $20 ;
                                if comstr [1] = '"'
                                  then
                                    contents := contents + $80
                              end
                            else
                              if gethex (contents)
                                then
                                  error ('invalid number') ;
                          cr1.lth := 4 ;
                          cr1.com := 'B' ;
                          cr1.b_adr := from ;
                          cr1.b_dat[0] := byte(contents) ;
                          get_ack
                        end ;
                  end ;
              if move
                then
                  from := from + 1
            end
      until false
    end ;

  procedure dump_mem ; entry ;
    var
      h, h1 : hex ;
      l : hex ;
      ch_line : string [16] ;
      d_line : string[80] ;
      ch : char ;
      j : integer register ;
      count : hex register ;
    begin
      if gethex (from)
        then
          error ('error in address') ;
      if gethex (too)
        then
          too := from + $FF ;
      if from > too
        then
          error ('error in range') ;
      write ('addr') ;
      h := from ;
      for h1 := 0 to $f do
        write ('  ',(h + h1) << $C:1) ;
      writeln ;
      l := from ;
      while l <= too do
        begin
          if break
            then
              exit ;
          count := too - l + 1 ;
          if count > $10
            then
              count := $10 ;
          cr1.lth := 4 ;
          cr1.com := 'D' ;
          cr1.d_cnt := byte(count) ;
          cr1.d_adr := l ;
          response ('C') ;
          d_line := concat(string(l),' ') ;
          ch_line := '' ;
          for j := 0 to integer(count) - 1 do
            begin
              ch := cr2.c_dat[j] ;
              d_line := concat(d_line, substr(string(hex(ch)),3,2),' ') ;
              ch := ch and $7f ;
              if (ch < $20) or (ch = $7f)
                then
                  ch := '.' ;
              append (ch_line, ch)
            end ;
          writeln (d_line,' ':integer($10 - count) * 3,ch_line) ;
          l := l + count
        end
    end ;
 
  procedure init_mem ; entry ;
    var
      l : hex ;
      count : hex register ;
      j : integer register ;
    begin
      if gethex (from) or gethex (too) or gethex (contents)
        then
          error ('error in address') ;
      if from > too
        then
          error ('error in range') ;
      l := from ;
      while l <= too do
        begin
          count := too - l + 1 ;
          if count > 64
            then
              count := 64 ;
          cr1.lth := byte(count) + 3 ;
          cr1.com := 'B' ;
          cr1.b_adr := l ;
          for j := 0 to integer(count) - 1 do
            cr1.b_dat[j] := byte(contents) ;
          get_ack ;
          l := l + count
        end
    end ;
    
  procedure set_offset ; entry ;
    begin
      if gethex (offset)
        then
          begin
            offset := 0 ;
            error ('error in base address, set to zero')
          end
    end ;

  procedure find ; entry ;
    var
      found, txt : boolean ;
      ch : byte ;
      start, last : ^byte ;
      patnum, count : integer ;
      maxpat : byte ;
    begin
      if gethex(from) or gethex(too)
        then
          error ('error in address') ;
      if from > too
        then
          error ('error in range') ;
      maxpat := 0 ;
      txt := false ;
      patnum := index (comstr,'''') ;
      if patnum <> 0
        then
          begin
            txt := true ;
            for count := patnum + 1 to length (comstr) do
              begin
                if maxpat = 16
                  then
                    exit ;
                maxpat := succ (maxpat) ;
                cr1.o_dat[maxpat] := upshift(comstr[count])
              end
          end
        else
          while (not gethex(contents)) and (maxpat < 16) do
            begin
              maxpat := succ (maxpat) ;
              cr1.o_dat[maxpat] := char (contents)
            end ;
      if maxpat > 0
        then
          begin
            writeln ('    addr') ;
            cr1.lth := 23 ;
            cr1.com := 'O' ;
            cr1.o_from := from ;
            cr1.o_too := too ;
            cr1.o_text := txt ;
            cr1.o_maxpat := maxpat ;
            response ('U') ;
            repeat
              if cr2.u_adr = 0
                then
                  exit ;
              writeln (cr2.u_adr:-5) ;
              cr1.o_from := cr2.u_adr + 1 ;
              response ('U')
            until false
          end
    end ;
    
  procedure calc ; entry ;
    var
      last , first : longhex ;
      ctemp : string [10] ;
    begin
      if getlhex (first)
        then
          error ('error in value') ;
       parse (comstr,ctemp) ;
       if getlhex (last)
         then
           error ('error in value') ;
       if ctemp = '+'
         then
           writeln (' sum =',first+last:9)
         else
           writeln (' difference =',first-last:9)
    end ;

  procedure block_move ; entry ;
    begin
      if gethex (cr1.v_from) or gethex(cr1.v_too) or gethex(cr1.v_dest)
        then
          error ('error in address') ;
      if cr1.v_from > cr1.v_too
        then
          error ('error in range') ;
      cr1.lth := 7 ;
      cr1.com := 'V' ;
      get_ack
    end ;
    
  procedure copy (f, t : ^byte ; cnt : integer) ; entry ;
    var
      i : integer register ;
    begin
      for i := 1 to cnt do
        begin
          t^ := f^ ;
          t := t + 1 ;
          f := f + 1
        end
    end ;
    
  procedure getregs ; entry ;
    begin
      cr1.lth := 0 ;
      cr1.com := 'E' ;
      response ('F') ;
      copy (addr(cr2.f_cc), addr(regs.cc), 14) ;
    end ;
     
  procedure astat ; entry ;
    var
      disloc : hex ;
      k : byte register ;
      disp : disparam ;
      outstring : string[120] ;
      
    function check_bit (sym : char ; bit : byte) : char ;
      begin
        if regs.cc and (1 << bit) <> 0
          then
            check_bit := sym
          else
            check_bit := '.'
      end ;
      
    begin {astat}
      if regs.s = 0
        then
          getregs ;
      disloc := regs.pc ;
      writeln ('PC=',regs.pc:-5,regs.pc-offset:-5,'CCR=',hex(regs.cc) << $8:2,' ',
          check_bit ('E', 7), check_bit ('F', 6), check_bit ('H', 5),
          check_bit ('I', 4), check_bit ('N', 3), check_bit ('Z', 2),
          check_bit ('V', 1), check_bit ('C', 0), 
          ' DPR=',hex(regs.dp) << 8:2, ' OFFSET=',offset:4) ;
      writeln ('D=',hex(regs.a) << 8 + hex(regs.b):-5,
               'X=',regs.x:-5, 'Y=',regs.y:-5,'U=',regs.u:-5,'S=',regs.s:4) ;
      cr1.lth := 4 ;
      cr1.com := 'D' ;
      cr1.d_adr := disloc ;
      cr1.d_cnt := 8 ;
      response ('C') ;
      with disp do
        begin
          off := offset ;
          offsup := false ;
          objsup := false ;
          tabsup := false ;
          dcaddr := $ffff ;
          dbparm := nil
        end ;
      dis (outstring, disloc, disp, addr(cr2.c_dat)) ;
      writeln (outstring)
    end ;
    
  procedure change_reg ; entry ;
    var
      word : boolean register ;
      regad : ^byte ;
      regadw : ^hex ;
      regnum : byte ;
    begin
      getregs ;
      regadw := nil ;
      regad := nil ;
      case upshift(comstr) of
        'CC' :
          begin
            regad := addr(regs.cc) ;
            regnum := 0
          end ;
        'A' : 
          begin
            regad := addr(regs.a) ;
            regnum := 1
          end ;
        'B' :
          begin
            regad := addr(regs.b) ;
            regnum := 2 ;
          end ;
        'D' :
          begin
            regadw := addr(regs.a) ;
            regnum := 9
          end ;
        'DP' :
          begin
            regad := addr(regs.dp) ;
            regnum := 3
          end ;
        'X' :
          begin
            regadw := addr(regs.x) ;
            regnum := 4
          end ;
        'Y' :
          begin
            regadw := addr(regs.y) ;
            regnum := 5
          end ;
        'U' :
          begin
            regadw := addr(regs.u) ;
            regnum := 6
          end ;
        'S' :
          begin
            regadw := addr(regs.s) ;
            regnum := 7
          end ;
        'PC' :
          begin
            regadw := addr(regs.pc) ;
            regnum := 8
          end
        else
          error ('invalid register')
      end ;
      if regadw = nil
        then
          write ('=',hex(regad^) << 8:2,' ')
        else
          begin
            if regnum = 9
              then
                write ('=',hex(regs.a) << 8 + hex(regs.b):-5)
              else
                write ('=',regadw^:-5) ;
            regad := regadw
          end ;
      write (' new value : ') ;
      comstr := getline ;
      if comstr <> ''
        then
          begin
            if gethex(contents)
              then
                error ('error in value') ;
            if regadw = nil
              then
                regad^ := byte(contents)
            else if regnum = 9
              then
                begin
                  regs.a := byte(contents >> 8) ;
                  regs.b := byte(contents)
                end
              else
                regadw^ := contents ;
            cr1.lth := 4 ;
            cr1.com := 'I' ;
            cr1.i_value := contents ;
            cr1.i_regsel := regnum ;
            get_ack
          end ;
    end ;
    
  procedure init_asm ; entry ;
    var
      k : integer register ;
    begin
      regs.cc := 0 ;
      regs.dp := 0 ;
      regs.a := 0 ;
      regs.b := 0 ;
      regs.x := 0 ;
      regs.s := code_limit ;
      regs.u := regs.s - 256 ;
      regs.y := regs.u ;
      regs.pc := code_start ;
      for k := 0 to 8 do
        abreak[k].adr := 0
    end ;
    
  procedure set_breaks ; entry ;
    var
      k : integer register ;
    begin
      cr1.lth := 4 ;
      cr1.com := 'K' ;
      for k := 0 to 8 do
        if abreak[k].adr <> 0
          then
            begin
              cr1.k_loc := abreak[k].adr ;
              cr1.k_num := byte(k) ;
              get_ack
            end ;
      cr1.lth := 7 ;
      cr1.com := 'M' ;
      for k := 0 to 16 do
        if pbreak[k].brkloc <> 0
          then
            begin
              cr1.m_loc := pbreak[k].brkloc ;
              cr1.m_cnt := pbreak[k].brkcnt ;
              cr1.m_num := byte(k) ;
              cr1.m_poll := false ;
              get_ack
            end
    end ;
    
  procedure update_breaks ; entry ;
    var
      k : integer register ;
    begin
      pbreak[0].brkloc := 0 ;
      abreak[0].adr := 0 ;
      cr1.lth := 3 ;
      cr1.com := 'M' ;
      cr1.m_poll := true ;
      response ('L') ;
      for k := 1 to 16 do
        pbreak[k].brkcnt := cr2.l_cnt[k]
    end ;
    
  procedure aset_break ; entry ;
    var
      m : byte register ;
      j, k : integer register ;
      full : boolean register ;
      ctemp : string ;
    begin
      ctemp := comstr ;
      if comstr = ''
        then
          begin {display active breakpoints}
            for k := 1 to 8 do
              if abreak[k].adr <> 0
                then
                  writeln ('LOC=',abreak[k].adr:-5,abreak[k].adr-offset:-5,
                           ' MACRO=',ord(abreak[k].mac):0)
          end
        else
          while ctemp <> '' do
            begin
              parse (ctemp, comstr) ;
              j := index (comstr, ';') ;
              if j = 0
                then
                  m := 0
                else
                  begin
                    {$c-}
                    m := byte(integer(substr(comstr, j + 1, 2))) ;
                    if conversion or (m < 1) or (m > 20)
                      then
                        error ('Invalid macro') ;
                    if macs[m] = nil
                      then
                        error ('Macro not defined') ;
                    comstr := substr(comstr, 1, j - 1)
                  end ;
              if gethex (contents)
                then
                  error ('error in address') ;
              contents := contents + offset ;
              full := true ;
              for k := 1 to 8 do
                if (abreak[k].adr = 0) or (abreak[k].adr = contents)
                  then
                    begin
                      abreak[k].mac := m ;
                      abreak[k].adr := contents ;
                      full := false ;
                      exit
                    end ;
              if full
                then
                  error ('breakpoint table full')
            end
    end ;
      
  procedure arem_break ; entry ;
    var
      k : integer register ;
      ch : char ;
    begin
      if comstr = ''
        then
          begin
            write (' REMOVE ALL BREAKPOINTS? (*Y/N) ') ;
            read (keyboard, ch) ;
            writeln (ch) ;
            if upshift(ch) <> 'N'
              then
                for k := 1 to 8 do
                  abreak[k].adr := 0
          end
        else
          while comstr <> '' do
            begin
              if gethex (contents)
                then
                  error ('error in address') ;
              contents := contents + offset ;
              for k := 1 to 8 do
                if abreak[k].adr = contents
                  then
                    abreak[k].adr := 0 ;
            end
    end ;
    
  procedure aproc_temp ; entry ;
    begin
      if not procval
        then
          error ('proceed not valid, must do go first') ;
      if not gethex (from)
        then
          begin
            abreak[0].adr := from + offset ;
            abreak[0].mac := 0
          end ;
      set_breaks ;
      cr1.lth := 4 ;
      cr1.com := 'P' ;
      cr1.p_cnt := 0 ;
      cr1.p_ltren := ltren ;
      response ('S')
    end ;
    
  procedure abreak_hand ; entry ;
    var
      k : integer register ;
    begin
      writeln ;
      writeln ('ASSEMBLY BREAKPOINT ENCOUNTERED AT') ;
      astat ;
      if not abrkval
        then
          error ('Invalid breakpoint') ;
      for k := 0 to 8 do
        if abreak[k].adr = regs.pc
          then
            begin
              abreak[0].adr := 0 ;
              if abreak[k].mac <> 0
                then
                  begin
                    maccnt := 1 ;
                    macpnt := macs[abreak[k].mac] ;
                    maccur := macpnt
                  end ;
              exit
            end
    end ;
    
Modend.
