module xtdb3 {$v1,5 filer commands} (output,keyboard,{$b+}input{$b-}) ;
{$Itdbincl}
  var
    vectors : array [1..10] of record
                                 radr : hex ;
                                 vnum : integer
                               end varib ;
    versfnd : boolean varib entry ;
    reclth : byte varib entry ;
    un_scan : ^ext_type varib ;
    

{ IMPORT FROM XTDB }
  procedure error (err : string) ; external ;
  procedure open_icode (var fi : file of byte ; var fname : string) ; external ;
  procedure open_relo (var fr : file of byte ; var fname : string) ; external ;
  procedure get_ack ; external ;
  procedure response (expect : char) ; external ;

{ IMPORT FROM XTDB1 }
  procedure parse (var cml, token : string) ; external ;

{ IMPORT FROM CVRT0}
  procedure block_init(path : hex ; buf_start : ^hex) ; external ;
  procedure convert (var cerror : byte ; rbuf : ^longhex) ; external ;

  procedure load_icode ; entry ;
    const
      t_none = 0 ;
      t_cover = 1 ;
      t_brange = 2 ;
      t_intovr = 3 ;
      t_done = 4 ;
      t_extovr = 5 ;
      t_varovr = 6 ;
      t_dbovr = 7 ;
      t_pterr = 8 ;
      t_vers = 9 ;
      t_datovr = 10 ;
      t_invop = 11 ;
      t_mdef = 12 ;
    type
      symname = string [16] ;
      descriptor = record
                     mode : byte ;
                     err : byte ;
                     drv : longhex ;
                     elnt : integer ;
                     elmt : char ;
                     path : integer ;
                   end ;
    
    var
      old_limit : hex register ;
      fname : string[40] ;
      temp : string[40] ;
      fi : file of byte ;
      cerror : byte ;
      copy : ^descriptor ;
      labnum, old_var, old_dat : hex register ;
      pdb : ^dbt_type ;
      ex : ^ext_type ;
      p1 : ^symname ;
      p2, p3 : ^byte ;
      buf_start : ^hex ;
    begin
      copy := addr(fi) ;
      new (buf_start:1024) ;
      while comstr <> '' do
        begin
          parse (comstr, temp) ;
          fname := temp ;
          open_icode (fi, fname) ;
          if cur_mod = 99
            then
              begin
                writeln ('Maximum module limit exceeded at file ',fname);
                exit
              end ;
          cur_mod := cur_mod + 1 ;
          with mod_tab[cur_mod] do
            begin
              name := substr(temp, 1, 16) ;
              filename := temp ;
              old_var := var_loc ;
              old_dat := dat_loc ;
              start := cur_adr ;
              cur_off := cur_adr ;
              int_cur := int_start ;
              dbstart := dbt_cur ;
              dbt_smod := dbt_cur ;
              cur_sect := relo ;
              old_limit := code_limit ;
              writeln ('Loading icode file ',fname) ;
              versfnd := false ;
              reclth := 0 ;
              block_init(copy^.path,buf_start) ;
              convert (cerror, nil) ;
              code_limit := old_limit ;
              finish := cur_adr - 1 ;
              dbend := dbt_cur ;
              vsize := var_loc - old_var ;
              dsize := dat_loc - old_dat ;
              close (fi) ;
{ look for .. series, remove from table and patch debugger table}
              ex := ext_start ;
              while ex < ext_cur do
                begin
                  if ex^.active
                    then
                      if substr(ex^.name,1,2) = '..'
                        then
                          begin
                            ex^.active := false ;
                            pdb := dbstart ;
                            while (pdb < dbend) and (pdb <> nil) do
                              begin
                                if pdb^.info = d_varib
                                  then
                                    begin
                                      p1 := addr(pdb^.var_rec) + 1 ;
                                      p2 := p1 + longhex(p1^[0] + 8) ;
                                      p3 := p2 + 3 ;
                                      if (p2^ in [s_varib,s_data]) and
                                         (p3^ <> 0)
                                        then
                                          begin
                                            p2 := p2 + 1 ;
                                            p3 := p2 + 1 ;
                                            labnum := hex(substr(
                                               ex^.name,3,4)) ;
                                            if (p2^ = byte(labnum>>8))
                                              and (p3^ = byte(labnum))
                                              then
                                                begin
                                                  p2^ := byte(ex^.value
                                                              >> 8) ;
                                                  p3^ := byte(ex^.value);
                                                  p3 := p3 + 1 ;
                                                  p3^ := 0 ; {no longer internal name}
                                                  exit
                                                end
                                          end
                                    end ;
                                pdb := pdb^.link
                              end
                          end ;
                  ex := ex + align(sizeof(ext_type))
                end ;
              pdb := dbstart ;
              while (pdb < dbend) and (pdb <> nil) do
                begin
                  if (pdb^.info = d_module) or (pdb^.info = d_program)
                    then
                      begin
                        name := substr(pdb^.modname,1,16) ;
                        if (progstart = nil) and (pdb^.info = d_program)
                          then
                            progstart := pdb^.modloc ;
                        exit
                      end ;
                  pdb := pdb^.link
                end
            end ;
          case cerror of
            t_done : ;
            t_none : writeln ('Unexplained conversion problem ') ;
            t_cover : writeln ('Code overflow') ;
            t_brange : writeln ('Out of range branch') ;
            t_intovr : writeln ('Internal label table overflow') ;
            t_extovr : writeln ('External label table overflow') ;
            t_varovr : writeln ('Variable section overflow') ;
            t_dbovr : writeln ('Debugger table overflow') ;
            t_pterr : writeln ('Pointer update error') ;
            t_datovr : writeln ('Data section overflow') ;
            t_invop : writeln ('Invalid inline assembly code') ;
            t_mdef : writeln ('Multiply defined external symbol') ;
            else
              halt (cerror)
          end
        end ;
      release (buf_start)
    end ;

  function std_search(srch : string[8]) : hex ;
    type
      stab_t = array [0 .. 3] of record
                                   grp : array [0 .. 3] of char ;
                                   off : hex
                                 end ;
                                  
      grp_t = array [0 .. 52] of record
                                   num : hex ;
                                   roff : hex
                                 end ;

    var
      i, j : integer register ;
      h : hex register ;
      gt : ^grp_t ;
      ex : ^ext_type ;
    const
      stab = external stab_t ;
    begin
      std_search := $ffff ;
      if srch[0] = 5
        then
          begin
{ look for standard runtime routine }
            for i := 0 to 3 do
              with stab[i] do
                repeat
                  for j := 1 to 3 do
                    if upshift(grp[j]) <> srch[j]
                      then
                        exit (2) ;
                  gt := addr (stab[i]) + longhex(off) ;
                  {$c-}
                  h := hex(substr(srch,4,1)) << 4 ;
                  if conversion
                    then
                      exit (2) ; {cannot be std runtime}
                  h := h + hex(substr(srch,5,1)) ;
                  if conversion
                    then
                      exit (2) ;
                  for j := 0 to 52 do
                    with gt^[j] do
                      if num = $ffff
                        then
                          exit (3) {out of table}
                        else
                          if num = h
                            then
                              begin
                                std_search := roff ;
                                exit (3)
                              end
                until true
          end ;
    end ;
    
  procedure load_relo ; entry ;
    type
      descriptor = record
                     mode : byte ;
                     err : byte ;
                     drv : longhex ;
                     elnt : integer ;
                     elmt : char ;
                     path : integer ;
                   end ;
      recrecord = string[252] ;
    var
      fr : file of byte ;
      rec, rec1 : recrecord ;
      rec_start : hex ;
      code_size, var_size, dat_size : hex ;
      esdcur : byte ;
      objsect : byte ;
      esdtab : array [#0 .. #100] of hex ;
      fname : string [40] ;
      temp : string[40] ;
      copy : ^descriptor ;
      blockpt : ^recrecord ;
      buf_start : ^hex ;
      rerror : byte ;
      blocktemp : ^longhex ;
      
    function getword (var buf : string[252] ; offset : byte) : hex ;
      begin
        getword := hex(buf[offset]) << 8 +
                   hex(buf[offset + 1])
      end ;
      
    procedure write_output ;
      var
        pb : hex register ;
        ps : ^byte register ;
        i : byte register ;
        j : integer register ;
      begin
        if objsect = 1 {code}
          then
            pb := rec_start + cur_adr
          else
            pb := rec_start + dat_loc ;
        ps := addr(rec1[1]) ;
        while rec1[0] > 0 do
          begin
            i := rec1[0] ;
            if i > 64
              then
                i := 64 ;
            for j := 0 to ord(i) - 1 do
              begin
                cr1.b_dat[j] := ps^ ;
                ps := ps + 1
              end ;
            cr1.lth := i + 2 ;
            cr1.com := 'B' ;
            cr1.b_adr := pb ;
            get_ack ;
            rec1[0] := rec1[0] - i ;
            pb := pb + hex(i)
          end
      end ;
      
    function size_rec : boolean ;
      begin
        size_rec := false ;
        code_size := getword (rec, 2) ;
        if cur_adr + code_size > code_limit
          then
            begin
              writeln ('Code overflow') ;
              size_rec := true
            end
          else
            begin
              dat_size := getword(rec, 4) ;
              var_size := getword(rec, 6) ;
              if var_loc + var_size > var_max
                then
                  begin
                    writeln ('Variable section overflow') ;
                    size_rec := true
                  end
                else
                  if dat_loc + dat_size > dat_max
                    then
                      begin
                        writeln ('Data section overflow') ;
                        size_rec := true
                      end
                        else
                          begin
                            esdtab[0] := 0 ;
                            esdtab[1] := cur_adr ;
                            esdtab[2] := dat_loc ;
                            esdtab[3] := var_loc ;
                            esdcur := 3
                          end
            end
      end ;
      
    procedure exit_rec ;
      begin
        cur_adr := cur_adr + code_size ;
        var_loc := var_loc + var_size ;
        dat_loc := dat_loc + dat_size ;
        with mod_tab[cur_mod] do
          begin
            finish := cur_adr - 1 ;
            dsize := dat_size ;
            vsize := var_size ;
            dbstart := nil ;
            dbend := nil
          end
      end ;

    function xref_rec : boolean ;
      var
        srch : string [9] ;
        ex : ^ext_type ;
        empty : ^ext_type ;
      begin
        xref_rec := false ;
        rec := substr(rec,2,250) ;
        while rec[0] > 0 do
          begin
            repeat
              esdcur := esdcur + 1 ;
              srch := substr (rec, 2, ord(rec[1])) ;
              rec := substr (rec, ord(rec[1]) + 2, 250 - ord(rec[1])) ;
{look in standard runtime}
              esdtab[esdcur] := std_search(srch) ;
              if esdtab[esdcur] <> $ffff
                then
                  exit ;
{ look in external table }
              ex := ext_start ;
              empty := nil ;
              while ex < ext_cur do
                begin
                  if ex^.active
                    then
                      if ex^.defined
                        then
                          if upshift(ex^.name) = srch
                            then
                              begin
                                esdtab[esdcur] := ex^.value ;
                                exit (2)
                              end
                            else
                        else
                    else
                      empty := ex ;
                  ex := ex + align(sizeof(ext_type))
                end
            until true ;
            if esdtab[esdcur] = $ffff
              then
                begin
                  if empty = nil
                    then
                      begin
                        ex := ext_cur ;
                        ext_cur := ext_cur + align(sizeof(ext_type)) ;
                        if ext_cur >= esd_start
                          then
                            begin
                              writeln ('Externals table overflow') ;
                              xref_rec := true ;
                              exit
                            end
                      end
                    else
                      ex := empty ;
                  ex^.active := true ;
                  ex^.defined := false ;
                  ex^.name := srch ;
                  ex^.value := $8000 + hex(esdcur) ;
                  ex^.module := byte(cur_mod) ;
                  ex^.section := esd
                end
          end
      end ;
        
    function xdef_rec : boolean ;
      var
        ex : ^ext_type register ;
      begin
        xdef_rec := false ;
        rec := substr(rec, 2, 250) ;
        while rec[0] > 0 do
          begin
            ex := ext_start ;
            while ex < ext_cur do
              if not ex^.active
                then
                  exit
                else
                  ex := ex + align(sizeof(ext_type)) ;
            if ex = ext_cur
              then
                ext_cur := ext_cur + align(sizeof(ext_type)) ;
            if ext_cur >= esd_start
              then
                begin
                  writeln ('Externals table overflow') ;
                  xdef_rec := true ;
                  exit
                end ;
            ex^.active := true ;
            ex^.defined := true ;
            ex^.name := substr(rec,5,ord(rec[4])) ;
            ex^.value := getword(rec, 2) ;
            ex^.module := byte(cur_mod) ;
            case rec[1] of
              0 : ex^.section := abs ;
              1 :
                begin
                  ex^.section := relo ;
                  ex^.value := ex^.value + cur_adr
                end ;
              2 :
                begin
                  ex^.section := dat ;
                  ex^.value := ex^.value + dat_loc
                end ;
              3 :
                begin
                  ex^.section := varb ;
                  ex^.value := ex^.value + var_loc
                end
            end ;
            rec := substr(rec, ord(rec[4]) + 5, 245 - ord(rec[4]))
          end
      end ;
      
    procedure obj_rec ;
      begin
        write_output ;
        rec1 := substr(rec, 5, 245) ;
        rec_start := getword (rec, 3) ;
        objsect := rec[2]
      end ;
      
    function relo_rec : boolean ;
      var
        i, flg : byte register ;
        reladr : hex ;
        offset : byte register ;
        value : hex ;
        esdidx : byte ;
        esdval : hex ;
        checkit : boolean ;
      begin
        relo_rec := false ;
        i := 2 ;
        while i < rec[0] do
          begin
            reladr := getword (rec, i) ;
            offset := char(reladr - rec_start) + 1 ;
            value := hex(rec1[offset]) << 8 + hex(rec1[offset + 1]) ;
            i := i + 2 ;
            checkit := true ;
            repeat
              flg := rec[i] ;
              esdidx := rec[i + 1] ;
              esdval := esdtab[esdidx] ;
              if esdval = $ffff
                then
                  begin
                    checkit := false ;
                    esd_start := esd_start - align(sizeof(esd_type)) ;
                    if esd_start <= ext_cur
                      then
                        begin
                          writeln ('Externals table overflow') ;
                          relo_rec := true ;
                          exit
                        end ;
                    with esd_start^ do
                      begin
                        if objsect = 1 {relo}
                          then
                            address := reladr + cur_adr
                          else
                            address := reladr + dat_loc ;
                        module := byte(cur_mod) ;
                        esdnum := esdidx ;
                        flag := flg
                      end
                  end
                else
                  begin
                    if flg and 2 = 0
                      then
                        value := value + esdval
                      else
                        value := value - esdval
                  end ;
              i := i + 2
            until flg > $7f ;
            rec1[offset] := char(value >> 8) ;
            rec1[offset + 1] := char(value)
          end
      end ;
      
    begin {load_relo}
      new (buf_start : 1024) ;
      while comstr <> '' do
        begin
          parse (comstr, fname) ;
          temp := fname ;
          open_relo (fr, fname) ;
          copy := addr(fr) ;
          block_init (copy^.path, buf_start) ;
          writeln ('Loading relocatable object file ',fname) ;
          repeat
            blocktemp := addr(blockpt) ;
            rerror := 0 ;
            convert (rerror, blocktemp) ;
            if rerror <> 0
              then
                exit ;
            rec := blockpt^ ;
            if rec[0] > 0
              then
                case rec[1] of
                  0 : 
                    begin
                      if cur_mod = 99
                        then
                          begin
                            writeln ('Maximum module limit exceeded') ;
                            exit (2)
                          end ;
                      cur_mod := cur_mod + 1 ;
                      with mod_tab[cur_mod] do
                        begin
                          name := substr(rec,5,ord(rec[4])) ;
                          filename := temp ;
                          start := cur_adr
                        end ;
                      rec1[0] := 0
                    end ;
                  1 :
                    if size_rec
                      then
                        exit (2) ;
                  2 :
                    if xref_rec
                      then
                        exit (2) ;
                  3 :
                    if xdef_rec
                      then
                        exit (2) ;
                  4 : obj_rec ;
                  5 :
                    if relo_rec
                      then
                        exit (2) ;
                  6 :
                    begin
                      write_output ;
                      exit_rec
                    end
                end
          until false ;
          close (fr)
        end ;
      release (buf_start)
    end ;

  function get_un : ^ext_type ;
    begin
      get_un := nil ;
      while un_scan < ext_cur do
        if un_scan^.active and not un_scan^.defined
          then
            begin
              get_un := un_scan ;
              un_scan := un_scan + align(sizeof(ext_type)) ;
              exit
            end
          else
            un_scan := un_scan + align(sizeof(ext_type))
    end ;

  function close_filer : boolean ; entry ;
    type
      symname = string[16] ;
      symaddr = array [0 .. 3] of byte ;
    var
      pdb : ^dbt_type ;
      p3 : ^symname ;
      p4 : ^byte ;
      p5 : ^symaddr ;
      ex : ^ext_type ;
      temp : hex ;
    begin
      repeat
        close_filer := true ;
        un_scan := ext_start ;
        if get_un <> nil
          then
            begin
              close_filer := false ;
              writeln ('Undefined external symbols present, cannot proceed') ;
              exit
            end ;
        pdb := dbt_start ;
        while (pdb <> nil) and (pdb < dbt_cur) do
          begin
            if pdb^.info = d_varib
              then
                begin
                  p3 := addr(pdb^.var_rec) + 1 ;
                  p4 := p3 + longhex(p3^[0] + 8) ;
                  if p4^ in [s_external,s_data_ext..s_varib,s_pcr]
                    then
                      begin
                        p5 := p4 + 1 ;
                        if (p5^[0] = 0) and (p5^[1] = 0) and
                           (p5^[2] = 0) and (p5^[3] = 0)
                          then
                            begin
                              close_filer := false ;
                              writeln ('Undefined debugger symbols present, cannot proceed') ;
                              exit (2)
                            end
                      end
                end ;
            pdb := pdb^.link
          end ;
        if progstart = nil
          then
            if cur_mod <> 0
              then
                progstart := mod_tab[1].start
              else
                begin
                  close_filer := false ;
                  writeln ('No program loaded, cannot proceed') ;
                  exit
                end ;
        cr1.lth := 7 ;
        cr1.com := 'V' ;
        cr1.v_from := t_jmplow ;
        cr1.v_too := t_jmphigh - 1 ;
        cr1.v_dest := t_ramstart ;
        get_ack ; {move in jump table}
        ex := ext_start ;
        while ex < ext_cur do
          begin
            if ex^.active
              then
                if ex^.defined
                  then
                    begin
                      temp := std_search(upshift(ex^.name)) ;
                      if (temp <> $ffff) and (temp <> 0)
                        then
                          begin
                            cr1.lth := 5 ;
                            cr1.com := 'B' ;
                            cr1.b_adr := temp + 1 + t_ramstart ;
                            cr1.b_word := ex^.value ;
                            get_ack
                          end
                    end ;
            ex := ex + align(sizeof(ext_type))
          end
      until true ;
      cr1.lth := 1 ;
      cr1.com := 'E' ;
      response ('F') ;
      linkirq := (cr2.f_cc and $10) <> 0
    end ;

  procedure f_status (fromp : boolean) ; entry ;
    type
      symname = string[16] ;
      symaddr = array [0 .. 3] of byte ;
    var
      p : ^ext_type ;
      x : integer register ;
      dbsz, dbused, cdsz, cdused, exsz, exused, vrsz, vrused, dtsz, dtused : real ;
      linksz, linkerr : real ;
      pdb : ^dbt_type ;
      p3 : ^symname ;
      p4 : ^byte ;
      p5 : ^symaddr ;
      fnd : boolean register ;
      stop : boolean register ;
    begin
      stop := false ;
      comstr := upshift(comstr) ; 
      if index(comstr, 'M') <> 0
        then
          begin
            writeln ('module name      code start  code end    data size   varib size') ;
            for x := 1 to cur_mod do
              with mod_tab[x] do
                writeln (name:-17,start:-12,finish:-12,dsize:-12,vsize:4) ;
          end ;
      writeln ;
      if index(comstr, 'S') <> 0
        then
          begin
            if ext_start < ext_cur
              then
                begin
                  writeln ('Externals :') ;
                  writeln ('Symbol   Value    Section Module') ;
                  p := ext_start ;
                  while p < ext_cur do
                    begin
                      if break
                        then
                          begin
                            stop := true ;
                            exit
                          end ;
                      if p^.active
                        then
                          begin
                            write (p^.name:-9,p^.value:-5) ;
                            case p^.section of
                              abs, special : write ('abs':-8) ;
                              relo : write ('relo':-8) ;
                              dat : write ('data':-8) ;
                              varb : write ('varib':-8) ;
                              esd : write ('esd':-8)
                            end ;
                            write (mod_tab[ord(p^.module)].name) ;
                            if not p^.defined
                              then
                                write (' *UNDEFINED*') ;
                            writeln
                          end ;
                      p := p + align(sizeof(ext_type))
                    end
                end ;
            if fromp
              then
                return ;
            fnd := false ;
            pdb := dbt_start ;
            while (pdb <> nil) and (pdb < dbt_cur) do
              begin
                if stop
                  then
                    exit ;
                if pdb^.info = d_varib
                  then
                    begin
                      p3 := addr(pdb^.var_rec) + 1 ;
                      p4 := p3 + longhex(p3^[0] + 8) ;
                      if p4^ in [s_external,s_data_ext..s_varib,s_pcr]
                        then
                          begin
                            p5 := p4 + 1 ;
                            if (p5^[0] = 0) and (p5^[1] = 0) and
                               (p5^[2] = 0) and (p5^[3] = 0)
                              then
                                begin
                                  if not fnd
                                    then
                                      begin
                                        fnd := true ;
                                        writeln ('Undefined debugger symbols');
                                        x := 0
                                      end ;
                                  write (p3^:-17) ;
                                  x := x + 1 ;
                                  if x = 4
                                    then
                                      begin
                                        writeln ;
                                        x := 0
                                      end
                                end
                          end
                    end ;
                pdb := pdb^.link
              end
          end ;
      if fromp
        then
          return ;
      writeln ;
      writeln ('Section            Used        Allowed') ;
      dbsz := real(dbt_end - dbt_start) + 0.0001 ;
      dbused := real(dbt_cur - dbt_start) ;
      cdsz := real(code_limit - code_start) + 0.0001 ;
      cdused := real(cur_adr - code_start) ;
      exsz := real(esd_limit - ext_start) + 0.0001 ;
      exused := exsz - real(esd_start - ext_cur) ;
      vrsz := real(var_max) + 0.0001 ;
      vrused := real(var_loc) ;
      dtsz := real(dat_max - dat_base) + 0.0001 ;
      dtused := real(dat_loc - dat_base) ;
      linksz := real(linkcnt) + 0.0001 ;
      linkerr := real(totalerr) ;
      writeln ('Link errors':-18,linkerr/linksz*100:5:2,'%':-8) ;
      writeln ('Debugger table':-18,dbused/dbsz*100:5:2,'%':-8,
               dbsz/1024:5:1,'K') ;
      writeln ('User code area':-18,cdused/cdsz*100:5:2,'%':-8,
               cdsz/1024:5:1,'K') ;
      writeln ('Externals table':-18,exused/exsz*100:5:2,'%':-8,
               exsz/1024:5:1,'K') ;
      writeln ('Data sect':-18,dtused/dtsz*100:5:2,'%':-8,
               dtsz/1024:5:1,'K') ;
      writeln ('Varib sect':-18,vrused/vrsz*100:5:2,'%':-8,
               vrsz/1024:5:1,'K')
    end ;

  procedure sendbyte (p : hex ; b : byte) ;
    begin
      cr1.lth := 6 ;
      cr1.com := 'B' ;
      cr1.b_adr := p ;
      cr1.b_dat[0] := b ;
      get_ack
    end ;
    
  procedure sendword (p : hex ; h : hex) ;
    begin
      cr1.lth := 5 ;
      cr1.com := 'B' ;
      cr1.b_adr := p ;
      cr1.b_word := h ;
      get_ack
    end ;
    
  function getbyte (p : hex) : byte ;
    begin
      cr1.lth := 4 ;
      cr1.com := 'D' ;
      cr1.d_adr := p ;
      cr1.d_cnt := 1 ;
      response ('C') ;
      getbyte := cr2.c_dat[0]
    end ;
    
  function getword (p : hex) : hex ;
    begin
      cr1.lth := 4 ;
      cr1.com := 'D' ;
      cr1.d_adr := p ;
      cr1.d_cnt := 2 ;
      response ('C') ;
      getword := cr2.c_word
    end ;

  procedure link_modules ; entry ;
    type
      symname = string[16] ;
      symaddr = array [0 .. 1] of byte ;
    var
      un, look : ^ext_type ;
      p1 : hex ;
      p2 : hex ;
      p3 : ^longhex ;
      val : hex ;
      noff : hex register ;
      pdb : ^dbt_type ;
      p13 : ^symname ;
      p14 : ^byte ;
      p15 : ^symaddr ;
      x : byte register ;
      stop : boolean register ;
      es : ^esd_type ;
      uname : string[8] ;
      
    begin
      un_scan := ext_start ;
      un := get_un ;
      stop := false ;
      while un <> nil do
        begin
          if break
            then
              begin
                stop := true ;
                exit
              end ;
          look := ext_start ;
          uname := upshift(un^.name) ;
          while look < ext_cur do
            begin
              if look^.defined then
              if look^.name[0] = uname[0] then
              if (look^.name[1] eor uname[1]) and $df = 0 then
              if upshift(look^.name) = uname
                then
                  if un^.section = esd
                    then
                      begin
                        es := esd_start ;
                        un^.active := false ;
                        x := byte(un^.value) ;
                        while es < esd_limit do
                          begin
                            if un^.module = es^.module
                              then
                                if x = es^.esdnum
                                  then
                                    begin
                                      cr1.lth := 4 ;
                                      cr1.com := 'D' ;
                                      cr1.d_adr := es^.address ;
                                      cr1.d_cnt := 2 ;
                                      response ('C') ;
                                      if es^.flag and 2 = 0
                                        then
                                          cr1.b_word := cr2.c_word + look^.value
                                        else
                                          cr1.b_word := cr2.c_word - look^.value ;
                                      cr1.lth := 5 ;
                                      cr1.com := 'B' ;
                                      cr1.b_adr := es^.address ;
                                      get_ack
                                    end ;
                            es := es + align(sizeof(esd_type))
                          end ;
                        exit
                      end
                    else
                      begin
                        p1 := un^.value ; {resolve address}
                        un^.active := false ; {remove from table}
                        repeat
                          noff := getword(p1) ; {offset to next}
                          if look^.section in [relo, dat]
                            then
                              begin
                                val := look^.value - p1 - 2 ;
                                p2 := p1 - 1 ; {point at opcode}
                                x := getbyte(p2) ;
                                sendword(p1, val) ;
                              end
                            else {varib/data section}
                              sendword(p1, look^.value) ;
                          if noff = 0
                            then
                              exit ;
                          p1 := p1 + noff
                        until false ;
                        exit
                      end ;
              look := look + align(sizeof(ext_type))
            end ;
          un := get_un
        end ;
      pdb := dbt_start ;
      while (pdb <> nil) and (pdb < dbt_cur) do
        begin
          if stop
            then
              exit ;
          if pdb^.info = d_varib
            then
              begin
                p13 := addr(pdb^.var_rec) + 1 ;
                p14 := p13 + longhex(p13^[0] + 8) ;
                if p14^ in [s_external,s_data_ext .. s_varib,s_pcr]
                  then
                    begin
                      p15 := p14 + 1 ;
                      if (p15^[1] = 0) and (p15^[1] = 0)
                        then
                          begin
                            look := ext_start ;
                            uname := upshift(substr(p13^,1,8)) ;
                            while look < ext_cur do
                              begin
                                if look^.defined then
                                if look^.name[0] = uname[0] then
                                if (look^.name[1] eor uname[1]) and $df = 0 then
                                if upshift(look^.name) = uname
                                  then
                                    begin
                                      p14 := addr(look^.value) ;
                                      p15^[0] := p14^ ;
                                      p14 := p14 + 1 ;
                                      p15^[1] := p14^ ;
                                      exit
                                    end ;
                                look := look + align(sizeof(ext_type))
                              end
                          end
                    end
              end ;
          pdb := pdb^.link
        end ;
    end ;

  procedure set_vector (def : boolean) ; entry ;
    var
      ex : ^ext_type ;
      ctemp : string ;
      found : boolean register ;
      i : integer ;
    begin
      if def
        then
          begin
            parse (comstr, ctemp) ;
            {$c-}
            cr1.w_vnum := integer(ctemp) ;
            if conversion or (i < 1) or (i > 6)
              then
                error ('Invalid vector number') ;
            parse (comstr, ctemp) ;
            ctemp := upshift(ctemp) ;
            if ctemp[0] = 0
              then
                error ('Routine name required') ;
            ex := ext_start ;
            found := false ;
            while ex < ext_cur do
              begin
                if ex^.active and ex^.defined
                  then
                    if upshift(ex^.name) = ctemp
                      then
                        begin
                          found := true ;
                          cr1.w_radr := ex^.value ;
                          exit
                        end ;
                ex := ex + align(sizeof(ext_type))
              end ;
            if not found
              then
                error ('Routine not found')
              else
                begin
                  if maxvec < 20
                    then
                      begin
                        maxvec := maxvec + 1 ;
                        with vectors[maxvec] do
                          begin
                            radr := cr1.w_radr ;
                            vnum := cr1.w_vnum
                          end
                      end ;
                  cr1.lth := 5 ;
                  cr1.com := 'W' ;
                  get_ack
                end
          end
        else
          for i := 1 to maxvec do
            with vectors[i] do
              begin
                cr1.w_radr := radr ;
                cr1.w_vnum := vnum ;
                cr1.lth := 5 ;
                cr1.com := 'W' ;
                get_ack
              end
    end ;
    
  procedure match (start, finish : integer ; blk : hex ; p : ^byte ; 
                     s, ps : string [16]) ;
    type
      symname = string[16] ;
    var
      k : byte register ;
      j : integer ;
      dbp, dbe : ^dbt_type ;
      p1 : ^symname ;
      p2, p3, p4 : ^byte ;
      block : hex ;
      
    procedure report (errnum : integer) ;
      begin
        if ps = ''
          then
            error(concat('*',string(errnum),'*Check variable ',s,
                         ' in module ', mod_tab[j].name))
          else
            error(concat('*',string(errnum),'*Check parameter ',s,
                  ' in procedure ',ps, ' in module ',mod_tab[j].name))
      end ;
      
    begin
      for j := start to finish do
        begin
          dbp := mod_tab[j].dbstart ;
          dbe := mod_tab[j].dbend ;
          while (dbp <> nil) and (dbp < dbe) do
            begin
              if dbp^.info = d_varib
                then
                  begin
                    p1 := addr(dbp^.var_rec) + 1 ;
                    p2 := p1 + longhex(p1^[0] + 5) ;
                    if s[0] = p1^[0] then
                    if (s[1] eor p1^[1]) and $df = 0 then
                    if upshift (s) = upshift(p1^)
                      then
                        begin
                          p3 := p2 + 1 ;
                          block := hex(p2^) << 8 + hex(p3^) ;
                          if block = blk
                            then
                              begin
                                p3 := p3 + 1 ;
                                p2 := p3 + 1 ;
                                if (p3^ = byte(vardef)) and
                                   (p^ <> byte(s_recoff)) and
                                 (p2^ in [s_stack,s_absolute])
                                  then
                                    begin
                                      p4 := p ;
                                      if p2^ <> p4^
                                        then
                                          report(1) ;
                                      p4 := p4 + 1 ;
                                      p3 := p2 + 1 ;
                                      if p2^ in [s_stack, s_absolute]
                                        then
                                          for k := 0 to 1 do
                                            begin
                                              if p4^ <> p3^
                                                then
                                                  report(2) ;
                                              p4 := p4 + 1 ;
                                              p3 := p3 + 1
                                            end
                                        else
                                          begin
                                            p4 := p4 + 2 ;
                                            p3 := p3 + 2
                                          end ;
                                      p4 := p4 + 1 ;
                                      p3 := p3 + 1 ; {skip intname flag}
                                      if p4^ <> p3^
                                        then
                                          report(3) ;
                                      if p4^ in [valuepar .. funcret]
                                        then
                                          begin
                                            p4 := p4 + 1 ;
                                            p3 := p3 + 1 ;
                                            if p4^ <> p3^
                                              then
                                                report(3)
                                          end
                                    end
                              end
                        end
                  end ;
              dbp := dbp^.link
            end
        end
    end ;

  procedure check_var ; entry ;
    type
      symname = string[16] ;
    var
      j : integer register ;
      dbp, dbe : ^dbt_type ;
      p1 : ^symname ;
      p2, p3 : ^byte ;
      block : hex ;
    begin
      for j := 1 to cur_mod do
        begin
          dbp := mod_tab[j].dbstart ;
          dbe := mod_tab[j].dbend ;
          while (dbp <> nil) and (dbp < dbe) do
            begin
              if break
                then
                  exit (2) ;
              if dbp^.info = d_varib
                then
                  begin
                    p1 := addr(dbp^.var_rec) + 1 ;
                    p2 := p1 + longhex (p1^[0] + 5) ;
                    p3 := p2 + 1 ;
                    block := hex(p2^ ) << 8 + hex(p3^) ;
                    if block = $ffff
                      then
                        begin
                          p3 := p3 + 1 ;
                          p2 := p3 + 1 ;
                          if p3^ = byte(vardef)
                            then
                              if p2^ in [s_stack,s_absolute]
                                then
                                  match (j + 1, cur_mod, 
                                         block, p2, p1^, '')
                        end
                  end ;
              dbp := dbp^.link
            end
        end
    end ;

  procedure check_param ; entry ;
    type
      symname = string [16] ;
    var
      i, j : integer register ;
      block : hex register ;
      dbp, dbe, sbp, sbe, vbp : ^dbt_type ;
      p1 : ^symname ;
      p2, p3 : ^byte ;
    begin
      for j := 1 to cur_mod do
        begin
          dbp := mod_tab[j].dbstart ;
          dbe := mod_tab[j].dbend ;
          while (dbp <> nil) and (dbp < dbe) do
            begin
              if break
                then
                  exit (2) ;
              if dbp^.info <= d_ext_proc
                then
                  for i := j + 1 to cur_mod do
                    begin
                      sbp := mod_tab[i].dbstart ;
                      sbe := mod_tab[i].dbend ;
                      while (sbp <> nil) and (sbp < sbe) do
                        begin
                          if sbp^.info <= d_ext_proc
                            then
                              if sbp^.proc_name[0] = dbp^.proc_name[0] then
                              if (sbp^.proc_name[1] eor dbp^.proc_name[1]) and $df = 0 then
                              if upshift(sbp^.proc_name) = upshift(dbp^.proc_name)
                                then
                                  begin {have matching procs}
                                    if sbp^.info = dbp^.info
                                      then
                                        if sbp^.info = d_proc_start
                                          then
              error(concat('Duplicate entry, procedure ',sbp^.proc_name))
                                          else
                                            exit ;
                                    vbp := mod_tab[j].dbstart ;
                                    while (vbp <> nil) and (vbp < dbe) do
                                      begin
                                        if vbp^.info = d_varib
                                          then
                                            begin
                                              p1 := addr(vbp^.var_rec) +
                                                            1 ;
                                              p2 := p1 + longhex(p1^[0] +
                                                           5) ;
                                              p3 := p2 + 1 ;
                                              block := hex(p2^) << 8 +
                                                       hex(p3^) ;
                                              if block = dbp^.proc_block
                                                then
                                                  begin
                                                    p3 := p3 + 1 ;
                                                    p2 := p3 + 1 ;
                                                    if p3^ = byte(vardef)
                                                      then
                                                        begin
                                                          p3 := p3 + 6;
                                                          if p3^ in
                                                             [valuepar
                                                              .. funcret]
                                                            then
                      match (i, i, sbp^.proc_block,p2,p1^,dbp^.proc_name)
                                                        end
                                                  end
                                            end ;
                                        vbp := vbp^.link
                                      end
                                  end ;
                          sbp := sbp^.link
                        end
                    end ;
              dbp := dbp^.link
            end
        end
    end ;

Modend.
