module xtdb4 {$v3,1 pascal debugging} (output,keyboard,{$b+}input{$b-}) ;
{
  7/22/89 : initial conversion to level 3
  7/26/89 : add support for handling target I/O through files.
}
{$I/dd/defs/crtdrive}
{$I/dd/defs/os9traps}
{$Itdbincl}
  var
    crtpt : ^config varib external ;

{ IMPORT FROM XTDB6 }
  procedure catch ; external ;
  procedure throw ; external ;
  procedure proca ; external ;
  
{ IMPORT FROM XTDB3 }
  procedure f_status (fromp : boolean) ; external ;

{ IMPORT FROM XTDB2 }
  procedure astat ; external ;
  procedure getregs ; external ;
  procedure set_breaks ; external ;
  
{ IMPORT FROM XTDB1 }
  procedure parse (var cml, token : string) ; external ;
  function getint (var value : integer) : boolean ; external ;
  
{ IMPORT FROM XTDB }
  procedure error (err : string) ; external ;
  procedure response (expect : char) ; external ;
  procedure get_ack ; external ;
  procedure setsuffix (var fname : string) ; external ;
  
  function lineadr (spec : string) : hex ; entry ;
    var
      modnum, x, num, i : integer register ;
      dbp, last : ^dbt_type ;
      srch : string[17] ;
    begin
      repeat
        lineadr := 0 ;
        modnum := 0 ;
        i := index (spec, '.') ;
        if i <= 1
          then
            begin
              modnum := brk_mod ;
              if modnum = 0
                then
                  modnum := 1 ;
              if i = 1
                then
                  spec := substr(spec, 2, 10)
            end
          else
            begin
              srch := upshift(substr(spec,1, i - 1)) ;
              spec := substr(spec, i + 1, 10) ;
              for x := 1 to cur_mod do
                if upshift(mod_tab[x].name) = srch
                  then
                    begin
                      modnum := x ;
                      exit
                    end
            end ;
        if modnum = 0
          then
            exit ;
        {$c-}
        num := integer(spec) ;
        if conversion
          then
            exit ;
        dbp := mod_tab[modnum].dbstart ;
        last := mod_tab[modnum].dbend ;
        while (dbp < last) and (dbp <> nil) do
          begin
            if dbp^.info = d_line
              then
                if dbp^.linenum = num
                  then
                    begin
                      lineadr := dbp^.lineloc ;
                      exit (2)
                    end ;
            dbp := dbp^.link
          end
      until true
    end ;
    
  procedure go ; entry ;
    var
      comtemp : string [252] ;
      i : byte register ;
      loc : hex ;
      
    begin
      parse (comstr, comtemp) ;
      if comtemp[0] <> 0
        then
          begin
            loc := lineadr(comtemp) ;
            if loc = 0
              then
                error ('Not a valid line number') ;
          end
        else
          loc := 0 ;
      {$i-}
      close (infile) ;
      close (outfile) ;
      if inname <> ''
        then
          begin
            reset (infile, inname) ;
            if deverr(infile) <> 0
              then
                error (concat('Error number ',string(ord(deverr(infile))),
                       ' opening ',inname)) ;
          end ;
      if outname <> ''
        then
          begin
            rewrite (outfile, outname) ;
            if deverr (outfile) <> 0
              then
                error (concat('Error number ',string(ord(deverr(infile))),
                       ' opening ',outname))
          end ;
      pbreak[0].brkloc := loc ;
      pbreak[0].brkcnt := 0 ;
      pbreak[0].mac := 0 ;
      set_breaks ;
      procval := true ;
      brk_mod := 0 ;
      writeln ('STARTING PASCAL PROGRAM') ;
      cr1.lth := 12 ;
      cr1.com := 'Q' ;
      cr1.q_sys_lim := t_ramend - 300 ;
      cr1.q_sys_strt := t_ramend ;
      cr1.q_base := cr1.q_sys_lim - var_loc - 50 ;
      cr1.q_heap := cur_adr ;
      cr1.q_prog := progstart ;
      cr1.q_ltren := ltren ;
      response ('S')
    end ;
    
  function lineof (p : hex ; val : boolean) : string[30] ; entry ;
    var
      x : integer register ;
      dbp, last : ^dbt_type ;
      blex : byte register ;
      bmod, bline : integer register ;
      bblock : hex register ;
      bproc : ^dbt_type ;
    begin
      lineof := 'Invalid line number' ;
      bmod := 0 ;
      bblock := $ffff ;
      blex := 1 ;
      for x := 1 to cur_mod do
        if (p >= mod_tab[x].start) and (p <= mod_tab[x].finish)
          then
            with mod_tab[x] do
              begin
                bmod := x ;
                dbp := dbstart ;
                last := dbend ;
                while (dbp < last) and (dbp <> nil) do
                  begin
                    case dbp^.info of
                      d_line :
                        if dbp^.lineloc = p
                          then
                            begin
                              lineof := concat(name,'.',
                                          string(dbp^.linenum)) ;
                              bline := dbp^.linenum ;
                              exit (2)
                            end ;
                      d_proc_start :
                        begin
                          bblock := dbp^.proc_block ;
                          bproc := dbp
                        end ;
                      d_proc_end :
                        begin
                          blex := pred(blex) ;
                          bblock := $ffff {global}
                        end ;
                      d_lex : blex := dbp^.lex
                    end ;
                    dbp := dbp^.link
                  end
              end ;
      if val
        then
          begin
            brk_mod := bmod ;
            brk_lex := blex ;
            brk_line := bline ;
            brk_block := bblock ;
            brk_proc := bproc
          end
    end ;
    
  procedure pbreak_hand ; entry ;
    var
      k : integer register ;
    begin
      writeln ;
      writeln ('Pascal breakpoint at line number ',lineof(plast,true)) ;
      for k := 0 to 16 do
        if pbreak[k].brkloc = plast
          then
            begin
              if pbreak[k].mac <> 0
                then
                  begin
                    maccnt := 1 ;
                    macpnt := macs[pbreak[k].mac] ;
                    maccur := macpnt
                  end ;
              exit
            end
    end ;
    
  procedure ptrace_hand ; entry ;
    begin
      writeln ;
      writeln ('Statement trace at line number ',lineof(plast,true))
    end ;
    
  procedure number ; entry ;
    var
      dbp : ^dbt_type ;
      ctemp : string ;
      l : byte register ;
    begin
      l := 1 ;
      parse (comstr, ctemp) ;
      if ctemp[0] = 0
        then
          error ('Parameter required') ;
      ctemp := upshift(ctemp) ;
      dbp := dbt_start ;
      while (dbp <> nil) and (dbp < dbt_cur) do
        begin
          case dbp^.info of
            d_proc_start :
              begin
                l := l + 1 ;
                if upshift(dbp^.proc_name) = ctemp
                  then
                    while (dbp < dbt_cur) and (dbp <> nil) do
                      begin
                        if dbp^.info = d_line
                          then
                            begin
                              writeln (lineof(dbp^.lineloc,false)) ;
                              exit (2)
                            end ;
                        dbp := dbp^.link
                      end 
              end ;
            d_proc_end : l := l - 1 ;
            d_line :
              if l = 1
                then
                  if ctemp = 'PROGRAM'
                    then
                      begin
                        writeln (lineof(dbp^.lineloc,false)) ;
                        exit
                      end
          end ;
          dbp := dbp^.link
        end
    end ;
    
  procedure pproc_trace ; entry ;
    var
      cnt : integer ;
    begin
      if not procval
        then
          error ('Proceed not valid, must do go first') ;
      if getint (cnt)
        then
          st_trace := 1
        else
          st_trace := cnt ;
      set_breaks ;
      cr1.lth := 4 ;
      cr1.com := 'P' ;
      cr1.p_cnt := st_trace ;
      cr1.p_ltren := ltren ;
      response ('S')
    end ;
    
  procedure pproc_temp ; entry ;
    var
      loc : hex ;
      ctemp : string[10] ;
    begin
      if not procval
        then
          error ('Proceed not valid, must do go first') ;
      parse (comstr, ctemp) ;
      if ctemp[0] <> 0
        then
          begin
            loc := lineadr (ctemp) ;
            if loc = 0
              then
                error ('Not a valid line number') ;
          end
        else
          loc := 0 ;
      pbreak[0].brkloc := loc ;
      pbreak[0].brkcnt := 0 ;
      pbreak[0].mac := 0 ;
      set_breaks ;
      cr1.lth := 4 ;
      cr1.com := 'P' ;
      cr1.p_cnt := 0 ;
      cr1.p_ltren := ltren ;
      response ('S')
    end ;
    
  procedure pset_break ; entry ;
    var
      m : byte register ;
      x, i, cnt : integer register ;
      ctemp : string ;
      loc : hex register ;
    begin
      if comstr[0] = 0
        then
          begin
            for x := 1 to 16 do
              with pbreak[x] do
                begin
                  if brkloc = 0
                    then
                      exit ;
                  writeln ('Line number = ',lineof(brkloc,false),
                           ' count = ',brkcnt:0, ' macro = ',ord(mac):0)
                end
          end
        else
          while comstr[0] <> 0 do
            begin
              parse (comstr, ctemp) ;
              i := index (ctemp,';') ;
              if i = 0
                then
                  m := 0
                else
                  begin
                    {$c-}
                    m := byte(integer(substr(ctemp, i + 1, 2))) ;
                    if conversion or (m < 1) or (m > 20)
                      then
                        error ('Invalid macro') ;
                    if macs[m] = nil
                      then
                        error ('Macro not defined') ;
                    ctemp := substr(ctemp, 1, i - 1)
                  end ;
              i := index (ctemp,'/') ;
              if i = 0
                then
                  cnt := 0
                else
                  begin
                    {$c-}
                    cnt := integer(substr(ctemp,i + 1, 10)) ;
                    if conversion
                      then
                        error ('Invalid count') ;
                    ctemp := substr(ctemp, 1, i - 1)
                  end ;
              loc := lineadr(ctemp) ;
              if loc = 0
                then
                  error ('Line number not found') ;
              for x := 1 to 17 do
                with pbreak[x] do
                  begin
                    if x = 17
                      then
                        error ('Breakpoint table full') ;
                    if brkloc = loc
                      then
                        begin
                          brkcnt := cnt ;
                          mac := m ;
                          exit
                        end ;
                    if brkloc = 0
                      then
                        begin
                          brkloc := loc ;
                          brkcnt := cnt ;
                          mac := m ;
                          pbreak[x + 1].brkloc := 0 ;
                          exit
                        end
                  end
            end
    end ;
    
  procedure prem_break ; entry ;
    var
      x : integer register ;
      loc : hex register ;
      ctemp : string ;
      ch : char ;
    begin
      if comstr[0] = 0
        then
          begin
            write (' REMOVE ALL BREAKPOINTS? (*Y/N) ') ;
            read (keyboard, ch) ;
            writeln (ch) ;
            if upshift(ch) <> 'N'
              then
                for x := 1 to 16 do
                  pbreak[x].brkloc := 0 ;
          end
        else
          begin
            while comstr[0] <> 0 do
              begin
                parse (comstr, ctemp) ;
                loc := lineadr(ctemp) ;
                if loc = 0
                  then
                    error ('Line number not found') ;
                for x := 1 to 16 do
                  if pbreak[x].brkloc = loc
                    then
                      begin
                        for x := x to 15 do
                          pbreak[x] := pbreak[x + 1] ;
                        pbreak[16].brkloc := 0 ;
                        exit
                      end
              end
          end
    end ;
    
  procedure irqset (on : boolean) ; entry ;
    begin
      cr1.lth := 2 ;
      cr1.com := '7' ;
      cr1.sev_on := on ;
      get_ack
    end ;

  procedure pstat ; entry ;
    var
      x : byte register ;
      p : hex ;
    begin
      getregs ;
      cr1.com := 'D' ;
      cr1.lth := 4 ;
      cr1.d_adr := regs.y - 6 ;
      cr1.d_cnt := 2 ;
      response ('C') ;
      cr1.com := 'D' ;
      cr1.lth := 4 ;
      cr1.d_adr := cr2.c_word + 2 ;
      response ('C') ;
      p := cr2.c_word ;
      comstr := upshift(comstr) ;
      f_status (true) ;
      if brk_mod <> 0
        then
          begin
            writeln ('Current module = ',mod_tab[brk_mod].name) ;
            if brk_block <> $ffff
              then
                writeln ('In procedure ',brk_proc^.proc_name) ;
            writeln ('Current line number = ',lineof(plast,false)) ;
            writeln ('Current lexical level = ',ord(brk_lex):0) ;
            writeln ('Current heap/stack left = ',regs.u - p:4) ;
            if (inname <> '') or (outname <> '')
              then
                begin
                  if inname <> ''
                    then
                      write ('Input redirected to ',inname,'  ') ;
                  if outname <> ''
                    then
                      write ('Output redirected to ',outname) ;
                  writeln
                end ;
          end ;
      if index(comstr,'R') <> 0
        then
          astat
    end ;
    
  procedure trace_state ; entry ;
    var
      scan : byte register ;
      ctemp : string ;
      i, num : integer register ;
      actual : integer ;
    begin
      scan := ltrcnt ;
      parse (comstr, ctemp) ;
      if ctemp = ''
        then
          num := 10
        else
          begin
            {$c-}
            num := integer(ctemp) ;
            if conversion
              then
                error ('Invalid count')
          end ;
      actual := 0 ;
      cr1.lth := 2 ;
      cr1.com := 'X' ;
      for i := 1 to num do
        begin
          scan := scan - 1 ;
          if scan = 255
            then
              scan := 49 ;
          cr1.x_num := scan ;
          response ('Y') ;
          if cr2.y_ladr = 0
            then
              begin
                scan := scan + 1 ;
                if scan = 50
                  then
                    scan := 0 ;
                exit
              end ;
          actual := actual + 1
        end ;
      for i := 1 to actual do
        begin
          cr1.x_num := scan ;
          response ('Y') ;
          writeln (lineof(cr2.y_ladr,false)) ;
          scan := scan + 1 ;
          if scan = 50
            then
              scan := 0
        end
    end ;
    
  procedure trace_proc ; entry ;
    var
      scan : byte register ;
      ctemp : string ;
      i, num : integer register ;
      dbp : ^dbt_type ;
      found : boolean register ;
      actual : integer ;
    begin
      scan := ptrcnt ;
      parse (comstr, ctemp) ;
      if ctemp = ''
        then
          num := 10
        else
          begin
            {$c-}
            num := integer(ctemp) ;
            if conversion
              then
                error ('Invalid count')
          end ;
      actual := 0 ;
      cr1.lth := 2 ;
      cr1.com := 'X' ;
      for i := 1 to num do
        begin
          scan := scan - 1 ;
          if scan = 255
            then
              scan := 49 ;
          cr1.x_num := scan ;
          response ('Y') ;
          if cr2.y_padr = 0
            then
              begin
                scan := scan + 1 ;
                if scan = 50
                  then
                    scan := 0 ;
                exit
              end ;
          actual := actual + 1
        end ;
      for i := 1 to actual do
        begin
          found := false ;
          dbp := dbt_start ;
          cr1.x_num := scan ;
          response ('Y') ;
          with cr2 do
            begin
              while (dbp < dbt_cur) and (dbp <> nil) do
                begin
                  if y_pexit
                    then
                      if dbp^.info = d_proc_end
                        then
                          if dbp^.proc_end = y_padr
                            then
                              begin
                                found := true ;
                                exit
                              end
                            else
                        else
                    else
                      if dbp^.info = d_proc_start
                        then
                          if dbp^.proc_loc = y_padr
                            then
                              begin
                                found := true ;
                                exit
                              end ;
                  dbp := dbp^.link
                end ;
              if found
                then
                  begin
                    write ('Procedure/Function ') ;
                    if y_pexit
                      then
                        writeln (dbp^.proc_ename,' exited')
                      else
                        writeln (dbp^.proc_name,' entered')
                  end
                else
                  error ('Invalid entry in trace table')
            end ;
          scan := scan + 1 ;
          if scan = 50
            then
              scan := 0
        end
    end ;

  procedure fileset ; entry ;
    var
      i : integer ;
      s : string ;
    begin
      inname := '' ;
      outname := '' ;
      i := index(comstr, '<') ;
      if i <> 0
        then
          begin
            s := substr(comstr, i + 1, 80) ;
            i := index(s, ' ') ;
            if i = 0
              then
                i := 80 ;
            inname := substr(s, 1, i - 1)
          end ;
      i := index(comstr, '>') ;
      if i <> 0
        then
          begin
            s := substr(comstr, i + 1, 80) ;
            i := index(s, ' ') ;
            if i = 0
              then
                i := 80 ;
            outname := substr(s, 1, i - 1)
          end ;
    end ;

  procedure list ; entry ;
    var
      lfile : file of char ;
      blksel, bufoff : integer ;
      i, goal : integer ;
      temp : string[40] ;
      s : string[120] ;
      x, y : integer ;
      curline, firstline : integer ;
      fileoffset : longhex ;
      count : longhex ;
      loadsel, newline : boolean ;
      dbp, last : ^dbt_type ;
      flag : char ;
      numtemp : string[20] ;
      main : ^integer ;
      curblk : ^blklist ;

    procedure readblock ;
      var
        err : integer ;
      begin
        count := 2048 ;
        err := i_read (addr(loadblk[loadsel].buf), count, main^) ;
        if err <> 0
          then
            begin
              autolist := false ;
              close (lfile) ;
              error (concat('I/O error ',string(err),' in file ',temp))
            end ;
        if count <> 2048
          then
            begin
              loadblk[loadsel].buf[integer(count)] := $1a ;
              count := count + 1
            end ;
        if count = 0
          then
            begin
              autolist := false ;
              close (lfile) ;
              error ('End of file')
            end 
      end ;
    
    procedure moveoff ;
      begin
        bufoff := bufoff + 1 ;
        if bufoff = 2048
          then
            begin
              bufoff := 0 ;
              loadsel := not loadsel ;
              blksel := blksel + 1 ;
              if blksel = 9
                then
                  begin
                    blksel := 1 ;
                    curblk := curblk^.link
                end ;
              if (loadblk[loadsel].blkptr <> curblk) or
                 (loadblk[loadsel].idx <> blksel)
                then
                  begin
                    crt_clrline (i) ;  
                    write ('Reading file ',temp) ;
                    reset (lfile, temp) ;
                    seek (lfile, curblk^.foff + longhex(blksel - 1) * 2048) ;
                    readblock ;
                    close (lfile) ;
                    crt_clrline (i) ;
                    loadblk[loadsel].blkptr := curblk ;
                    loadblk[loadsel].idx := blksel
                  end
            end
      end ;
      
    begin
      noecho := true ;
      if comstr <> ''
        then
          begin
            temp := comstr ;
            if index(temp, '.') = 0
              then
                if brk_mod <> 0
                  then
                    temp := concat(mod_tab[brk_mod].name,'.',temp)
                  else
                    temp := concat(mod_tab[1].name,'.',temp)
          end
        else
          if brk_mod <> 0
            then
              temp := lineof(plast,false)
            else
              temp := concat(mod_tab[1].name,'.1') ;
      i := index(temp,'.') ;
      if i = 0
        then
          error ('Format must be module.line') ;
      goal := integer(substr(temp,i + 1,5)) ;
      if conversion
        then
          error ('Invalid line number') ;
      temp := upshift(substr(temp,1,i - 1)) ;
      x := 0 ;
      for y := 1 to cur_mod do
        if upshift(mod_tab[y].name) = temp
          then
            begin
              x := y ;
              exit
            end ;
      if x = 0
        then
          error ('Module not found') ;
      temp := mod_tab[x].filename ;
      curline := 0 ;
      dbp := mod_tab[x].dbstart ;
      last := mod_tab[x].dbend ;
      setsuffix (temp) ;
      curblk := mod_tab[x].blks ;
      main := addr(lfile) + 10 ;
      if curblk = nil
        then
          begin
            repeat
              reset (lfile, temp) ;
              if deverr(lfile) <> 0
                then
                  begin
                    autolist := false ;
                    error (concat('Could not open ',temp)) ;
                  end ;
              loadsel := loadblk[false].lastused ;
              loadblk[loadsel].lastused := false ;
              write ('Analyzing file ',temp,', standby') ;
              fileoffset := 0 ;
              new (curblk) ;
              mod_tab[x].blks := curblk ;
              newline := true ;
              curblk^.list[1].offset := -1 ;
              for i := 1 to 8 do
                curblk^.list[i].first := 0 ;
              curblk^.link := nil ;
              blksel := 1 ;
              curline := 0 ;
              curblk^.foff := fileoffset ;
              readblock ;
              bufoff := 0 ;
              repeat
                if bufoff >= integer(count)
                  then
                    begin
                      curblk^.list[blksel].last := curline ;
                      readblock ;
                      blksel := blksel + 1 ;
                      if blksel = 9
                        then
                          begin
                            new (curblk^.link) ;
                            curblk := curblk^.link ;
                            fileoffset := fileoffset + 16384 ;
                            curblk^.foff := fileoffset ;
                            curblk^.link := nil ;
                            blksel := 1 ;
                            for i := 1 to 8 do
                              curblk^.list[i].first := 0
                          end ;
                      curblk^.list[blksel].offset := -1 ;
                      bufoff := 0
                    end ;
                if newline
                  then
                    begin
                      curline := curline + 1 ;
                      if curblk^.list[blksel].offset = -1
                        then
                          begin
                            curblk^.list[blksel].offset := bufoff ;
                            curblk^.list[blksel].first := curline
                          end ;
                      newline := false
                    end ;
                case loadblk[loadsel].buf[bufoff] of
                  $d : newline := true ;
                  $1a : 
                    begin
                      curblk^.list[blksel].last := curline ;
                      exit (2)
                    end
                end ;
                bufoff := bufoff + 1
              until false
            until true ;
            close (lfile) ;
          end ; {blks = nil}
      firstline := goal - 5 ;
      if firstline <= 0
        then
          firstline := 1 ;
      curblk := mod_tab[x].blks ;
      blksel := 1 ;
      repeat
        if curblk^.list[blksel].first = 0
          then
            begin
              autolist := false ;
              error ('Past end of file')
            end ;
        if (firstline <= curblk^.list[blksel].last) and
           (firstline >= curblk^.list[blksel].first)
          then
            exit ; {found correct block}
        blksel := blksel + 1 ;
        if blksel = 9
          then
            begin
              blksel := 1 ;
              curblk := curblk^.link ;
              if curblk = nil
                then
                  begin
                    autolist := false ;
                    error ('Past end of file')
                  end
            end
      until false ;
      if (loadblk[false].blkptr = curblk) and (loadblk[false].idx = blksel)
        then
          loadsel := false
      else if (loadblk[true].blkptr = curblk) and (loadblk[true].idx = blksel)
        then
          loadsel := true
        else
          begin
            reset (lfile, temp) ;
            if deverr(lfile) <> 0
              then
                begin
                  autolist := false ;
                  error (concat('Error opening file ',temp)) ;
                end ;
            seek (lfile, curblk^.foff + longhex(blksel - 1) * 2048) ;
            loadsel := loadblk[false].lastused ;
            readblock ;
            close (lfile) ;
            loadblk[loadsel].blkptr := curblk ;
            loadblk[loadsel].idx := blksel
          end ;
      loadblk[loadsel].lastused := true ;
      {block now in memory}
      curline := curblk^.list[blksel].first ;
      bufoff := curblk^.list[blksel].offset ;
      while curline <> firstline do
        if loadblk[loadsel].buf[bufoff] = $d 
          then
            begin
              bufoff := bufoff + 1 ;
              curline := curline + 1
            end
          else
            bufoff := bufoff + 1 ;
      {now have first displayable line}
      for i := 0 to 10 do
        begin
          crt_clrline (i) ;
          s := '' ;
          repeat
            case loadblk[loadsel].buf[bufoff] of
              $d :
                begin
                  moveoff ;
                  exit
                end ;
              $1a : exit (2)
              else
                append (s, loadblk[loadsel].buf[bufoff])
            end ;
            moveoff
          until false ;
          flag := ':' ;
          while (dbp < last) and (dbp <> nil) do
            begin
              if dbp^.info = d_line
                then
                  if dbp^.linenum = curline
                    then
                      begin
                        flag := '*' ;
                        exit
                      end
                    else
                      if dbp^.linenum > curline
                        then
                          exit ;
              dbp := dbp^.link
            end ;
          numtemp := string(curline) ;
          while numtemp[0] < 4 do
            numtemp := concat(' ',numtemp) ;
          if curline = goal
            then
              begin
                if crtpt^.dcodes[dhalf] = ''
                  then
                    numtemp[1] := '>' ;
                crt_codes (dhalf) ;
                write (numtemp) ;
                crt_codes (dfull) ;
                numtemp := ''
              end ;
          s := substr(concat(numtemp,flag,' ',s),1, width-4) ;
          writeln (s) ;
          curline := curline + 1
        end ;
      crt_xy (0, depth) ;
      noecho := false
    end ;
    
Modend.
