module xtdb5 {$v3,0 display and change variables} (output,keyboard, {$b+}input{$b-}) ;
{
  7/22/89 : initial conversion to level 3
}
{$Itdbincl}

  type
    lhextype = array [0 .. 3] of byte ;
    hextype = array [0 .. 1] of byte ;
    any_type = record
                 case integer of
                   0 : (adr : hex) ;
                   1 : (badr : ^boolean) ;
                   2 : (cadr : ^char) ;
                   3 : (iadr : ^integer) ;
                   4 : (hadr : ^hex) ;
                   5 : (lhadr : ^longhex) ;
                   6 : (liadr : ^longinteger) ;
                   7 : (radr : ^real) ;
                   8 : (sadr : ^string80) ;
                   9 : (ladr : longhex)
               end ;
  var varib
    any : any_type ;
    last_dbt : ^dbt_type ;
    cstring : string[252] ;
    
{ IMPORT FROM XTDB }
  procedure error (err : string) ; external ;
  procedure get_ack ; external ;
  procedure response (expect : char) ; external ;
  function getline : string ; external ;
  
{ IMPORT FROM XTDB1 }
  procedure parse (var cml, token : string) ; external ;
  
{ IMPORT FROM XTDB2 }
  procedure getregs ; external ;
  
  function toamd (r : real) : real ;
    var
      x : record
            case integer of
              1 : (rl : real) ;
              2 : (lx : longhex)
          end ;
      l1, l2, l3 : longhex register ;
    begin
      x.rl := r ;
      if r = 0
        then
          toamd := 0
        else
          begin
            l1 := x.lx and $80000000 ; {sign}
            l2 := x.lx and $7f800000 ; {exponent}
            l3 := x.lx and $007fffff ; {mantissa}
            l2 := ((l2 << 1) - $7E000000) and $7f000000 ;
            l3 := l3 or $00800000 ;
            x.lx := l1 or l2 or l3 ;
            toamd := x.rl
          end
    end ;
    
  function fromamd (r : real) : real ;
    var
      x : record
            case integer of
              1 : (rl : real) ;
              2 : (lx : longhex)
          end ;
      l1, l2, l3 : longhex register ;
    begin
      x.rl := r ;
      if r = 0
        then
          fromamd := 0
        else
          begin
            l1 := x.lx and $80000000 ; {sign}
            l2 := x.lx and $7f000000 ; {exponent}
            l3 := x.lx and $00ffffff ; {mantissa}
            l2 := l2 >> 1 ;
            if l2 >= $20000000
              then
                l2 := l2 - $01000000
              else
                l2 := l2 + $3f000000 ;
            l2 := l2 and $7f800000 ;
            l3 := l3 and $007fffff ;
            x.lx := l1 or l2 or l3 ;
            fromamd := x.rl
          end
    end ;
    
  function getnumeric : string ; entry ;
    var
      s : string ;
    begin
      repeat
        while cstring = '' do
          cstring := getline ;
        parse (cstring, s) ;
        if s <> ''
          then
            exit ;
      until false ;
      getnumeric := s
    end ;
    
  function indirect (adr : hex) : hex ;
    begin
      cr1.lth := 4 ;
      cr1.com := 'D' ;
      cr1.d_adr := adr ;
      cr1.d_cnt := 2 ;
      response ('C') ;
      indirect := cr2.c_word
    end ;
    
  procedure putbytes (fadr : ^byte ; tadr : hex ; size : byte) ;
    var
      j : integer register ;
      count : byte register ;
    begin
      while size <> 0 do
        begin
          if size <= 64
            then
              count := size
            else
              count := 64 ;
          cr1.lth := count + 3 ;
          cr1.com := 'B' ;
          cr1.b_adr := tadr ;
          for j := 0 to ord(count) - 1 do
            begin
              cr1.b_dat[j] := fadr^ ;
              fadr := fadr + 1
            end ;
          get_ack ;
          size := size - count ;
          tadr := tadr + hex(count)
        end
    end ;
    
  procedure getbytes (tadr : ^byte ; fadr : hex ; size : byte) ;
    var
      count : byte register ;
      j : integer register ;
    begin
      while size <> 0 do
        begin
          if size <= 64
            then
              count := size
            else
              count := 64 ;
          cr1.lth := 4 ;
          cr1.com := 'D' ;
          cr1.d_adr := fadr ;
          cr1.d_cnt := count ;
          response ('C') ;
          for j := 0 to ord(count) - 1 do
            begin
              tadr^ := cr2.c_dat[j] ;
              tadr := tadr + 1
            end ;
          size := size - count ;
          fadr := fadr + hex(count)
        end
    end ;
    
  function getlhex (var p : ^lhextype) : longhex ;
    begin
      getlhex :=  longhex(p^[0]) << $18 + longhex(p^[1]) << $10 +
                  longhex(p^[2]) << 8 + longhex(p^[3]) ;
      p := p + 4
    end ;
    
  function gethex (var p : ^hextype) : hex ;
    begin
      gethex := hex(p^[0]) << 8 + hex(p^[1]) ;
      p := p + 2
    end ;
    
  function get_next (pc : ^byte ; var pe : ^byte ; first : boolean)
                                  : ^byte ;
    type
      def_stack = array [#0 .. #20] of record
                                         dpc, dpe : ^byte
                                       end ;

      varrec = string ;
      header = array [0 .. 4] of byte ;
    var
      def_next : byte varib ;
      def_point : def_stack varib ;
      p2, p5 : ^byte ;
      cpc, p3 : ^header ;
      p1, npc : ^dbt_type ;
      p4 : ^varrec ;
    begin
      if first
        then
          def_next := 0 ;
      repeat
        get_next := pc ;
        if pc > pe
          then
            if def_next = 0
              then
                error ('Debugger backtrack error')
              else
                begin
                  pc := def_point[def_next].dpc ;
                  pe := def_point[def_next].dpe ;
                  def_next := pred(def_next)
                end
          else
            if pc^ = 0 {deference}
              then
                begin
                  def_next := succ(def_next) ;
                  def_point[def_next].dpc := pc + 5 ;
                  def_point[def_next].dpe := pe ;
                  cpc := pc ;
                  p1 := mod_tab[brk_mod].dbstart ;
                  p2 := mod_tab[brk_mod].dbend ;
                  npc := nil ;
                  while (p1 < p2) and (p1 <> nil) do
                    begin
                      if p1^.info = d_varib
                        then
                          begin
                            p3 := addr (p1^.var_rec[1]) ;
                            p3 := p3 + longhex(p3^[0]) ;
                            if (p3^[3] = cpc^[3]) and (p3^[4] = cpc^[4]) and
                               (p3^[1] = cpc^[1]) and (p3^[2] = cpc^[2])
                              then
                                begin
                                  p5 := p3 + 7 ;
                                  if enum(p5^) = typedef
                                    then
                                      begin
                                        npc := p1 ;
                                        exit
                                      end
                                end
                          end ;
                      p1 := p1^.link
                    end ;
                  if npc = nil
                    then
                      error ('Internal deference error') ;
                  last_dbt := npc ;
                  p4 := addr (npc^.var_rec) ;
                  pe := p4 + longhex(p4^[0]) ;
                  pc := p4 + longhex(p4^[1] + 13)
                end
              else
                exit
      until false
    end ;

  procedure search (s : string ; var pc, pe : ^byte ; first, stop : longhex) ;
    type
      tbl_type = record
                   var_block : hex ;
                   var_tbl : ^dbt_type ;
                   var_par_size : hex ;
                   var_lex : byte
                 end ;
      symname = string ;
      symadr = array [0 .. 3] of byte ;
    var
      hstart : longhex ;
      dbp, dbe : ^dbt_type varib ;
      last : ^tbl_type ;
      p1 : ^symname ;
      p2, p3 : ^byte ;
      ps : ^storage_type ;
      pa : ^symadr ;
      p4, p5 : ^token_type ;
      offset : hex register ;
      sympt : longhex ;
      recbase : longhex ;
      curlex : byte register ;
      locstack : hex ;
    begin
      if regs.s = 0
        then
          getregs ;
      recbase := any.adr ;
      mark (hstart) ;
      if brk_mod = 0
        then
          error ('No variables accessible') ;
      dbp := mod_tab[brk_mod].dbstart ;
      dbe := mod_tab[brk_mod].dbend ;
      new (last) ;
      last^.var_block := 0 ;
      last^.var_tbl := nil ;
      last^.var_lex := 1 ;
      last^.var_par_size := 0 ;
      curlex := 1 ;
      while (dbp <> nil) and (dbp < dbe) do
        begin
          case dbp^.info of
            d_varib :
              begin
                p1 := addr(dbp^.var_rec) + 1 ;
                if upshift (p1^) = upshift(s)
                  then
                    begin
                      pa := p1 + longhex(p1^[0] + 1) ;
                      p2 := pa + 4 ;
                      if stop <> nil
                        then
                          sympt := getlhex(pa)
                        else
                          sympt := nil ;
                      p3 := p2 + 1 ;
                      p4 := p3 + 1 ;
                      p5 := p4 + 1 ;
                      if (p4^ = vardef) and (sympt <= stop) and
                         (dbp >= first) and not
                         ((first = nil) and (p5^ = s_recoff))
                        then
                          begin
                            new (last) ;
                            last^.var_block := hex(p2^) << 8 + hex(p3^);
                            last^.var_tbl := dbp ;
                            last^.var_lex := curlex
                          end
                    end
              end ;
            d_proc_end, d_ext_proc :
              begin
                if last^.var_block = dbp^.proc_eblock
                  then
                    begin
                      release (last) ;
                      last := last - align(longhex(sizeof(tbl_type)))
                    end ;
                if dbp^.info = d_proc_end
                  then
                    curlex := pred(curlex)
              end ;
            d_proc_start :
              begin
                if dbp^.proc_block = last^.var_block
                  then
                    last^.var_par_size := dbp^.param_size ;
                if dbp^.proc_block = brk_block
                  then
                    exit
              end ;
            d_lex : curlex := dbp^.lex
          end ;
          dbp := dbp^.link
        end ;
      if last^.var_tbl <> nil
        then
          begin
            pc := addr(last^.var_tbl^.var_rec) ;
            pe := pc + longhex(pc^) ;
            pc := pc + 1 ;
            ps := pc + longhex(pc^ + 8) ;
            pc := ps + 1 ;
            offset := gethex(pc) ;
            pc := pc + 1 ; {skip internal name flag}
            if first <> nil
              then
                any.adr := any.adr + (0 - offset)
              else
                case ps^ of
                  s_external, s_varib_ext, s_varib :
                    any.adr := offset + indirect(regs.y - 6) ;
                  s_stack, s_recoff :
                    if last^.var_block = $ffff
                      then
                        any.adr := offset + indirect(regs.y - 6)
                      else
                        begin
                          locstack := regs.y ;
                          if enum(pc^) in [valuepar..funcret]
                            then
                              last^.var_lex := last^.var_lex + 1 ;
                          {compensate for location of lex entry}
                          for curlex := 1 to brk_lex - last^.var_lex do
                            begin
                              locstack := locstack - 4 ;
                              locstack := indirect (locstack)
                            end ;
                          if enum(pc^) in [valuepar..funcret]
                            then
                              begin
                                if enum(pc^) = funcret
                                  then
                                    any.adr := 0
                                  else
                                    any.adr := offset ;
                                any.adr := any.adr + last^.var_par_size + locstack ;
                                if enum(pc^) = varibpar
                                  then
                                    any.adr := indirect (any.adr) ;
                                pc := pc + 1
                              end
                            else
                              any.adr := offset + locstack
                        end ;
                  s_pcr, s_absolute, s_data, s_data_ext : any.adr := offset ;
                end
          end
        else
          error ('Variable not found') ;
      last_dbt := last^.var_tbl ; {for record sub-search}
      release (hstart)
    end ;

  function get_size (p : ^byte) : hex ;
    begin
      case enum(p^) of
        boolvar, charvar, subbool, subchar, enumvar : 
          get_size := 1;
        integvar, hexvar, subinteg, subhex : 
          get_size := 2 ;
        lintvar, lhexvar, realvar, sublint, sublhex :
          get_size := 4 ;
        arrayvar, recordvar, devicevar : 
          begin
            p := p + 1 ;
            get_size := gethex(p)
          end ;
        stringvar, setvar : 
          begin
            p := p + 1 ;
            get_size := hex(p^)
          end
      end
    end ;

  procedure varib (src : string ; var pc, pe : ^byte) ;
    var
      idxopen : boolean ;
      p : record
            case integer of
              0 : (bl : ^boolean) ;
              1 : (ch : ^char) ;
              2 : (int : ^integer) ;
              3 : (hx : ^hex) ;
              4 : (lx : ^longhex) ;
              5 : (li : ^longinteger) ;
              6 : (rl : ^real) ;
              7 : (tk : ^token_type)
          end ;
      name : string ;
      last : longhex ;
      i, j : integer register ;
      idx : hex register ;
      chartemp : token_type ;
      recsrch : ^dbt_type ;
      
    procedure vparse (var src, name : string) ;
      var
        i : integer register ;
      begin
        name := src ;
        src := '' ;
        if name[0] <> 0
          then
            if name[1] in ['[','^','.']
              then
                name := substr(name,2,80) ;
        for i := 1 to length(name) do
          if name[i] in ['[','^','.']
            then
              begin
                src := substr(name,i,80-i) ;
                name := substr(name,1,i-1) ;
                exit
              end
      end ;

    begin
      idxopen := false ;
      vparse (src, name) ;
      search (substr(name,1,80), pc, pe, nil, nil) ;
      pc := get_next (pc, pe, true) ;
      repeat
        case enum(pc^) of
          recordvar :
            if substr(src,1,1) = '.'
              then
                begin
                  pc := pc + 3 ;
                  last := getlhex(pc) ;
                  vparse (src, name) ;
                  search (substr(name,1,80),pc,pe,last_dbt,last) ;
                  pc := get_next(pc, pe, false)
                end
              else
                exit ;
          arrayvar :
            begin
              if (substr(src,1,1) = '[')
                then
                  idxopen := true
                else
                  if (substr(src,1,1) = ',') and idxopen
                    then
                    else
                      exit ;
              i := index(substr(src,2,80),',') ;
              j := index(substr(src,2,80),']') ;
              if ((i > j) or (i = 0)) and (j <> 0)
                then
                  i := j ;
              if i = 0
                then
                  error ('array index error') ;
              i := i + 1 ;
              name := substr(src,2, i - 2) ;
              if src[i] = ']'
                then
                  begin
                    idxopen := false ;
                    src := substr(src,i + 1, 80 - i)
                  end
                else
                  src := substr(src,i, 80 - i) ;
              pc := pc + 3 ;
              recsrch := last_dbt ;
              pc := get_next (pc, pe, false) ;
              last_dbt := recsrch ;
              p.ch := pc + 1 ;
              idx := hex('0') ; {clear conversion flag}
              case enum(pc^) of
                boolvar, subbool : idx := hex(boolean(name)) ;
                subchar, charvar :
                  if name[1] = ''''
                    then
                      idx := hex(name[2])
                    else
                      idx := hex(name) ;
                integvar,subinteg,lintvar,sublint,enumvar :
                  idx := hex(integer(name)) ;
                hexvar,subhex,lhexvar,sublhex :
                  idx := hex(name)
              end ;
              if conversion
                then
                  error ('Invalid array index') ;
              case enum(pc^) of
                subbool, subchar, enumvar :
                  begin
                    idx := idx - hex(p.ch^) ;
                    p.ch := p.ch + 2
                  end ;
                subinteg, subhex :
                  begin
                    idx := idx - gethex(p.ch) ;
                    p.ch := p.ch + 2
                  end ;
                sublint, sublhex :
                  begin
                    idx := idx - hex(getlhex(p.ch)) ;
                    p.ch := p.ch + 4
                  end
              end ;
              pc := p.ch ;
              pc := get_next (pc, pe, false) ;
              any.adr := any.adr + get_size(pc) * idx
            end ;
          stringvar :
            begin
              if (substr(src,1,1) <> '[') and not
                   ((substr(src,1,1) = ',') and idxopen)
                then
                  exit ;
              i := index(src,']') ;
              if i = 0
                then
                  error ('Invalid string index') ;
              name := substr(src,2,i - 2) ;
              src := substr(src,i + 1, 80 -i) ;
              i := integer(name) ;
              if conversion
                then
                  error ('Invalid string index') ;
              any.adr := any.adr + hex(i) ;
              chartemp := charvar ;
              pc := addr(chartemp) ;
              pe := pc
            end ;
          devicevar :
            if substr(src,1,1) = '^'
              then
                begin
                  pc := pc + 3 ;
                  pc := get_next(pc, pe, false) ;
                  src := substr(src,2,80) ;
                  any.adr := any.adr + 6
                end
              else
                exit ;
          hexvar :
            if substr(src,1,1) = '^'
              then
                begin
                  pc := pc + 1 ;
                  case pc^ of
                    0 : pc := get_next(pc, pe, false) ;
                    1 : pc := pc + 1 ; {pointing to base type}
                    2 : error ('Not a pointer')
                  end ;
                  src := substr(src,2,80) ;
                  any.adr := indirect(any.adr)
                end
              else
                exit
          else
            exit
        end
      until false
    end ;

  procedure change_var ; entry ;
    var
      pc : ^token_type ;
      pe : ^byte ;
      itemp : integer ;
      cbuf : string[2] ;
      htemp : hex ;
      atemp : any_type ;
      tdata : longhex ;
      size : byte register ;
      
    procedure change_string ;
      var
        pl : ^byte ;
        s : string[10] ;
        k, val : byte register ;
        newstring : string[252] ;
      begin
        pl := pc + 1 ;
        cstring := getline ;
        if cstring[1] = ''''
          then
            begin
              cstring := substr(cstring,2,250) ;
              if cstring[0] >= pl^
                then
                  begin
                    cstring[0] := pl^ - 1 ;
                    writeln ('String truncated') ;
                  end ;
              newstring := cstring
            end
          else
            begin
              val := byte(hex(getnumeric)) ;
              if conversion or (val > pl^)
                then
                  error ('Invalid string length') ;
              newstring[0] := val ;
              for k := 1 to val do
                begin
                  val := byte(hex(getnumeric)) ;
                  if conversion
                    then
                      error ('Invalid hex byte') ;
                  newstring[k] := val
                end
            end ;
        putbytes (addr(newstring), any.adr, newstring[0] + 1)
      end ;
      
    procedure change_set ;
      type
        set_type = set of 0 .. 1007 ;
      var
        newset : set_type ;
        select, s : string ;
        element : integer ;
      begin
        getbytes(addr(newset), any.adr, 1) ;
        getbytes(addr(newset) + 1, any.adr + 1, newset[0]) ;
        repeat
          writeln ('1) add elements') ;
          writeln ('2) remove elements') ;
          writeln ('3) make empty set') ;
          writeln ('CR) done') ;
          write ('Enter selection : ') ;
          select := getline ;
          case select of
            '1', '2' :
              begin
                cstring := getline ;
                while cstring <> '' do
                  begin
                    parse (cstring, s) ;
                    if s <> ''
                      then
                        begin
                          case s[1] of
                            '''' : 
                              element := ord(s[2]) ;
                            '$' : 
                              element := integer(hex(substr(s,2,4))) ;
                            '0'..'9' :
                              element := integer(s)
                            else
                              element := -1
                          end ;
                          if select = '1'
                            then
                              newset := newset + [element]
                            else
                              newset := newset - [element]
                        end
                  end 
              end ;
            '3' : newset := [] ;
            '' : exit
          end
        until false ;
        putbytes (addr(newset), any.adr, newset[0] + 1)
      end ;
      
    procedure change_structure ;
      var
        h : hex ;
      begin
        cstring := getline ;
        repeat
          h := hex(getnumeric) ;
          if conversion
            then
              exit ;
          putbytes(addr(h) + 1, any.adr, 1) ;
          any.adr := any.adr + 1
        until false
      end ;
      
    begin {change_var}
      atemp.ladr := addr(tdata) ;
      varib (comstr, pc, pe) ;
      if pc^ in [boolvar .. sublint]
        then
          write ('Enter new value : ') ;
      size := 0 ;
      with atemp do
        case pc^ of
          boolvar, subbool :
            begin
              badr^ := boolean(getnumeric) ;
              if conversion
                then
                  error ('Invalid boolean') ;
              size := 1
            end ;
          charvar, subchar, textvar :
            begin
              cbuf := getline ;
              if cbuf[1] = ''''
                then
                  cadr^ := cbuf[2]
                else
                  begin
                    htemp := hex(cbuf) ;
                    if conversion
                      then
                        error ('Invalid hex byte') ;
                    cadr^ := byte(htemp)
                  end ;
              size := 1
            end ; 
          integvar, subinteg :
            begin
              iadr^ := integer(getnumeric) ;
              if conversion
                then
                  error ('Invalid integer') ;
              size := 2
            end ;
          hexvar, subhex :
            begin
              hadr^ := hex(getnumeric) ;
              if conversion
                then
                  error ('Invalid hex') ;
              size := 2
            end ;
          lhexvar, sublhex :
            begin
              lhadr^ := longhex(getnumeric) ;
              if conversion
                then
                  error ('Invalid longhex') ;
              size := 4
            end ;
          lintvar, sublint :
            begin
              liadr^ := longinteger(getnumeric) ;
              if conversion
                then
                  error ('Invalid longinteger') ;
              size := 4
            end ;
          realvar :
            begin
              radr^ := toamd(real(getnumeric)) ;
              if conversion
                then
                  error ('Invalid real') ;
              size := 4
            end ;
          enumvar :
            begin
              itemp := integer(getnumeric) ;
              if conversion or (itemp < 0) or (itemp > 255)
                then
                  error ('Invalid enumerated') ;
              cadr^ := byte(itemp) ;
              size := 1
            end ;
          stringvar : change_string ;
          setvar : change_set ;
          arrayvar, recordvar, devicevar : change_structure
        end ;
      if size <> 0
        then
          putbytes (atemp.ladr, any.adr, size)
    end ;
    
  procedure dump_mem ; external ;
    
  procedure disp_var (struct : boolean) ; entry ;
    var
      pc : ^token_type ;
      pe : ^byte ;
      regflag : byte ;
      tdata : longhex ;
      atemp : any_type ;
  
    procedure disp_string ;
      var
        k, x : byte register ;
        bad : boolean register ;
        curs : string[252] ;
      begin
        bad := false ;
        getbytes(addr(curs), any.adr, 1) ;
        getbytes(addr(curs) + 1, any.adr + 1, curs[0]) ;
        for k := 1 to curs[0] do
          if not(curs[k] in [' '..'~'])
            then
              begin
                bad := true ;
                exit
              end ;
        if bad
          then
            begin
              writeln ('Contains non-printable characters, length = ',
                                          length(curs):0) ;
              x := 0 ;
              for k := 1 to curs[0] do
                begin
                  write ('$',hex(curs[k]) << 8:2,' ') ;
                  x := x + 1 ;
                  if x = 16
                    then
                      begin
                        writeln ;
                        x := 0
                      end
                end
            end
          else
            write ('''',curs,'''')
      end ;
      
    procedure disp_set ;
      type
        set_type = set of 0 .. 1007 ;
      var
        j : byte register ;
        i : integer register ;
        curs : set_type ;
      begin
        getbytes(addr(curs), any.adr, 1) ;
        getbytes(addr(curs) + 1, any.adr + 1, curs[0]) ;
        writeln ;
        pc := pc + 2 ;
        pc := get_next(pc, pe, false) ;
        j := 0 ;
        for i := 0 to ord(curs[0]) * 8 - 1 do
          if i in curs
            then
              begin
                case enum(pc^) of
                  boolvar, subbool : write(boolean(i):6) ;
                  charvar, subchar :
                    if chr(i) in [' '..'~']
                      then
                        write ('   ''',chr(i))
                      else
                        write ('  $',hex(i) << 8:2) ;
                  subinteg, sublint, enumvar : write (i:6) ;
                  subhex, sublhex : write (hex(i):6)
                end ;
                j := j + 1 ;
                if j = 10
                  then
                    begin
                      writeln ;
                      j := 0
                    end
              end ;
        if j <> 0
          then
            writeln
      end ;
      
    procedure disp_structure ;
      begin
        writeln ;
        comstr := concat(string(any.adr),' ',
                         string(any.adr + get_size(pc) - 1)) ;
        dump_mem
      end ;
      
    begin {disp_var}
      atemp.ladr := addr (tdata) ;
      varib (comstr, pc, pe) ;
      write (comstr, ' = ') ;
      if struct
        then
          disp_structure
        else
          with atemp do
            case pc^ of
              boolvar, subbool : 
                begin
                  getbytes(atemp.ladr, any.adr, 1) ;
                  write (badr^:-5)
                end ;
              charvar, subchar, textvar :
                begin
                  getbytes (atemp.ladr, any.adr, 1) ;
                  if cadr^ in [' '..'~']
                    then
                      write ('''',cadr^,''' ') ;
                  write ('$', hex(cadr^) << 8:2)
                end ;
              integvar, subinteg : 
                begin
                  getbytes(atemp.ladr, any.adr, 2) ;
                  write (iadr^:0)
                end ;
              hexvar, subhex : 
                begin
                  getbytes(atemp.ladr, any.adr, 2) ;
                  write (hadr^:4)
                end ;
              lhexvar, sublhex : 
                begin
                  getbytes(atemp.ladr, any.adr, 4) ;
                  write (lhadr^:8)
                end ;
              lintvar, sublint : 
                begin
                  getbytes(atemp.ladr, any.adr, 4) ;
                  write (liadr^:0)
                end ;
              realvar : 
                begin
                  getbytes(atemp.ladr, any.adr, 4) ;
                  write (fromamd(radr^):-16)
                end ;
              enumvar : 
                begin
                  getbytes(atemp.ladr, any.adr, 1) ;
                  write (ord(cadr^):0, ' $',substr(string(hex(cadr^)),3,2))
                end ;
              stringvar : disp_string ;
              setvar : disp_set ;
              arrayvar, recordvar, devicevar : disp_structure
            end ;
      writeln
    end ;
    
modend.
