module cwe {$v3,0 case, with, exit} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  procedure end_statement (e : error_type ; toke : tokes) ; external ;
  procedure insert (e : error_type ; t : token_type) ; external ;
  procedure statements (var gerror : error_type) ; external ;
  function outexp (var error : error_type) : ^packet ; external ;
  function get_internal : hex ; external ;
  procedure errorpt (errnum : error_type) ; external ;
  procedure uncon (p : ^packet) ; external ;
  function varib (vpac : ^packet ; var verror : error_type ;
                  getdata : boolean ; outer : boolean) : ^packet ; external ;
  function aconstant (var cerror : error_type) : ^packet ; external ;
  function constant (var cerror : error_type) : ^packet ; external ;
  function labout (h : hex) : string[4] ; external ;
  procedure opdot (pac : ^packet) ; external ;
  function giveit (req : tokes ; var gerror : error_type ;
                   gpac : ^packet) : ^packet ; external ;
                  
  procedure case_state (var gerror : error_type) ; entry ;
    const
      of_look = 1 ;
      of_found = 2 ;
      new_con = 3 ;
      multi_con1 = 4 ;
      multi_con2 = 5 ;
      multi_con3 = 6 ;
      colon_look = 7 ;
      colon_found = 8 ;
      semi_else = 9 ;
      case_else = 10 ;
      case_end = 11 ;
      e_case_else = 12 ;
      e_case_end = 13 ;
    label
      of_look, of_found, new_con, multi_con1, multi_con2, multi_con3,
      colon_look, colon_found, semi_else, case_else, case_end,
      e_case_else, e_case_end ;
    var
      epac, cpac : ^packet register ;
      lerror : error_type ;
      cmptyp : token_type ;
      two, signed : boolean ;
      stringcmp, cmulti, lrange : boolean ;
      stringsize : hex register ;
      ts : string[1] ;
      p1 : ^anystring ;
      temp1, lcurr, lsub, lend : hex ;

    procedure multi ;
      begin
        if not cmulti
          then
            begin
              lcurr := get_internal ;
              cmulti := true
            end
      end ;

    procedure crange ;
      begin
        opcode (c_xbxx) ;
        if signed
          then
            post1 (p_ble + p_rell)
          else
            post1 (p_bls + p_rell) ;
        codet_word (lcurr) ;
        {bls lcurr or ble lcurr}
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (lsub) ;
        {lsub equ *}
        purge (lsub)
      end ;

    begin {case_state}
      gerror := undef ;
      scan ;
      repeat
        epac := outexp (lerror) ;
        if lerror <> undef
          then
            begin
of_look :
              end_statement (lerror, [of_]) ;
              if lastpack^.token = of_
                then
                  goto of_found
                else
                  goto semi_else
            end ;
        uncon (epac) ;
        cmptyp := epac^.token ;
        two := cmptyp in [integvar, hexvar] ;
        signed := cmptyp = integvar ;
        stringcmp := cmptyp = stringvar ;
        if not (cmptyp in [boolvar .. lintvar, enumvar, stringvar])
          then
            errorpt (e_itoe) ;
        if stringcmp
          then
            begin
              if epac^.pointr <> nil
                then
                  stringsize := epac^.size
                else
                  stringsize := 127 ;
              hand (int, $27) ;
              datat_byte (byte(stringsize)) ;
              alloc := alloc + stringsize
            end ;
        if lastpack^.token <> of_
          then
            begin
              lerror := e_of ;
              goto of_look ;
e_case_else : goto case_else ;
e_case_end :  goto case_end
            end ;
of_found :
        lend := get_internal ;
        nesting := succ (nesting) ;
new_con :
        cmulti := false ;
multi_con1 :
        lrange := false ;
multi_con2 :
        scan ;
        case lastpack^.token of
          end_ : goto case_end ;
          otherwise_, else_ : goto case_else
        end ;
multi_con3 :
        cpac := aconstant(lerror) ;
        if lerror <> undef
          then
            begin
colon_look :
              end_statement (lerror, [colon]) ;
              if lastpack^.token = colon
                then
                  goto colon_found
                else
                  goto semi_else
            end ;
        if (cmptyp <> cpac^.token) and not
           ((cmptyp = stringvar) and (cpac^.token = charvar))
          then
            cpac := giveit ([cmptyp], lerror, cpac) ;
        
        if lerror <> undef
          then
            errorpt (lerror) ;
        if stringcmp
          then
            begin
              hand (int, $28) ;
              if cpac^.token = charvar
                then
                  begin {make char into string}
                    ts[0] := 1 ;
                    ts[1] := cpac^.pvc_char ;
                    cpac^.pvc_string := addr(ts)
                  end ;
              data_byte (cpac^.pvc_string^[0]) ;
              datast (cpac^.pvc_string^)
            end
          else {not string}
            begin
              if two
                then
                  opcode (c_cmpd)
                else
                  opcode (c_cmpb) ;
              opdot (cpac)
            end ;
        if lastpack^.token = subrange
          then
            begin
              if stringcmp
                then
                  begin
                    lerror := e_inst ;
                    goto colon_look
                  end ;
              multi ;
              if lrange
                then
                  begin
                    lerror := e_colon ;
                    goto colon_look
                  end ;
              lrange := true ;
              lsub := get_internal ;
              opcode (c_xbxx) ;
              if signed
                then
                  post1 (p_blt)
                else
                  post1 (p_blo) ;
              codet_word (lsub) ;
              {blo.s lsub or blt.s lsub}
              goto multi_con2
            end ; {subrange}
        if lastpack^.token = comma
          then
            begin
              multi ;
              if lrange
                then
                  begin
                    crange ;
                    goto multi_con1
                  end ;
              opcode (c_xbxx) ;
              post1 (p_beq + p_rell) ;
              codet_word (lcurr) ;
              {beq lcurr}
              goto multi_con1
            end ; {comma}
        if lastpack^.token <> colon
          then
            begin
              lerror := e_colon ;
              goto colon_look
            end ;
colon_found :
        if lrange
          then
            begin
              crange ;
              opcode (c_xbxx) ;
              post1 (p_bra + p_rell)
            end
          else
            begin
              opcode (c_xbxx) ;
              post1 (p_bne + p_rell)
            end ;
        temp1 := lcurr ;
        lcurr := get_internal ;
        codet_word (lcurr) ;
        {bne newlcurr or bra newlcurr}
        if cmulti
          then
            begin
              opcode (c_equ) ;
              post1 (p_eqlp) ;
              codet_word (temp1) ;
              {oldcurr equ *}
              purge (temp1)
            end ;
        scan ;
        statements (lerror) ;
        if lerror <> undef
          then
            begin
semi_else :
              case lastpack^.token of
                semicolon : goto new_con ;
                otherwise_, else_ : goto e_case_else ;
                end_ : goto e_case_end
                else
                  exit
              end
            end ;
        if lastpack^.token = end_
          then
            begin
              opcode (c_equ) ;
              post1 (p_eqlp) ;
              codet_word (lcurr) ;
              {lcurr equ *}
              purge (lcurr) ;
              goto e_case_end
            end ;
        opcode (c_xbxx) ;
        post1 (p_bra + p_rell) ;
        codet_word (lend) ;
        {bra lend}
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (lcurr) ;
        {lcurr equ *}
        purge (lcurr) ;
        case lastpack^.token of
          semicolon : goto new_con ;
          otherwise_, else_ : goto e_case_else
        end ;
        insert (e_ensm, semicolon) ;
        goto multi_con3 ;
case_else :
        scan ;
        statements (lerror) ;
        if lerror <> undef
          then
            if lastpack^.token = end_
              then
                goto e_case_end
              else
                exit ;
        repeat
          if lastpack^.token = semicolon
            then
              scan ;
          if lastpack^.token = end_
            then
              goto e_case_end ;
          end_statement (e_ensm, [])
        until false ;
case_end :
        opcode (c_equ) ;
        post1 (p_eqlp) ;
        codet_word (lend) ;
        {lend equ *}
        purge (lend) ;
        if stringcmp
          then
            begin
              opcode (c_leau) ;
              post1 (p_idx + p_ixru + p_ixfx) ;
              codet_word (stringsize) ;
              {leau #size,u}
              alloc := alloc - stringsize
            end ;
        nesting := pred(nesting) ;
        scan
      until true
    end ;

  procedure with_state (var gerror : error_type) ; entry ;
    const
      do_look = 1 ;
      get_state = 2 ;
      cleanup = 3 ;
    label
      do_look, get_state, cleanup ;
    var
      symcount : hex register ;
      vpac : ^packet register ;
      lerror : error_type ;
    begin
      gerror := undef ;
      symcount := 0 ;
      repeat
        scan ;
        vpac := varib(lastpack, lerror, false, true) ;
        if lerror <> undef
          then
            begin
do_look :
              end_statement (lerror, [do_]) ;
              if lastpack^.token = do_
                then
                  goto get_state
                else
                  goto cleanup
            end ;
        if vpac^.token <> recordvar
          then
            begin
              lerror := e_inac ;
              goto do_look
            end ;
        if with_depth >= size_with
          then
            begin
              lerror := e_vqf ;
              goto do_look
            end ;
        symcount := succ(symcount) ;
        alloc := alloc + 2 ;
        with_depth := succ(with_depth) ;
        with with_tab[with_depth] do
          begin
            frame_offset := alloc ;
            headpt := with_cluge
          end ;
        opcode (c_pshu) ;
        post1t (p_ipx)
        {pshu x}
      until lastpack^.token <> comma ;
      if lastpack^.token <> do_
        then
          begin
            lerror := e_do ;
            goto do_look
          end ;
get_state :
      scan ;
      statements (lerror) ;
cleanup :
      with_depth := with_depth - integer(symcount) ;
      alloc := alloc - symcount << 1 ;
      opcode (c_leau) ;
      post1 (p_idx + p_ixru + p_ixfx) ;
      codet_word (symcount << 1) ;
      {leau n,u}
    end ;

  procedure exit_state (var gerror : error_type) ; entry ;
    var
      cpac : ^packet register ;
      level : integer register ;
    begin
      gerror := undef ;
      repeat
        scan ;
        if lastpack^.token = leftparen
          then
            begin
              cpac := constant (gerror) ;
              if (cpac^.token <> integvar) or (gerror <> undef)
                then
                  begin
                    end_statement (e_integ, []) ;
                    exit
                  end ;
              if lastpack^.token <> rightparen
                then
                  begin
                    end_statement (e_rpar, []) ;
                    exit
                  end ;
              scan ;
              level := cpac^.pvc_integer
            end
          else
            level := 1 ;
        if level > exit_active
          then
            begin
              end_statement (e_eool, []) ;
              exit
            end ;
        with exitq[exit_active + 1 - level] do
          begin
            if alloc <> offset
              then
                begin
                  opcode (c_leau) ;
                  post1 (p_idx + p_ixru + p_ixfx) ;
                  codet_word (alloc-offset)
                  {leau n,u}
                end ;
            opcode (c_xbxx) ;
            post1 (p_bra + p_rell) ;
            codet_word (internal)
          end
      until true
    end ;

modend.
